#pragma once

#include "Effect.h"
#include "Protocol.h"
#include "User.h"
#include "ItemManager.h"

#define MAX_EFFECT		300
#define MAX_EFFECT_LIST 32

#define EFFECT_RANGE(x) (((x)<0)?0:((x)>=MAX_EFFECT)?0:1)

enum eEffectNumber
{
	EFFECT_GREATER_DAMAGE = 1,
	EFFECT_GREATER_DEFENSE = 2,
	EFFECT_ELF_BUFFER = 3,
	EFFECT_MANA_SHIELD = 4,
	EFFECT_GREATER_CRITICAL_DAMAGE = 5,
	EFFECT_INFINITY_ARROW = 6,
	EFFECT_BP_RECOVERY = 7,
	EFFECT_GREATER_LIFE = 8,
	EFFECT_GREATER_MANA = 9,
	EFFECT_BLESS_POTION = 10,
	EFFECT_SOUL_POTION = 11,
	EFFECT_DISABLE_MAGIC = 12,
	EFFECT_CASTLE_GATE_STATE = 13,
	EFFECT_GUILD_STATE1 = 14,
	EFFECT_GUILD_STATE2 = 15,
	EFFECT_GUILD_STATE3 = 16,
	EFFECT_GUILD_STATE4 = 17,
	EFFECT_INVISIBILITY = 18,
	EFFECT_GUILD_STATE5 = 19,
	EFFECT_CASTLE_CROWN_STATE = 20,
	EFFECT_CRYWOLF_STATE1 = 21,
	EFFECT_CRYWOLF_STATE2 = 22,
	EFFECT_CRYWOLF_STATE3 = 23,
	EFFECT_CRYWOLF_STATE4 = 24,
	EFFECT_CRYWOLF_STATE5 = 25,
	EFFECT_CRYWOLF_STATE6 = 26,
	EFFECT_CRYWOLF_NPC_TRANSPARENCY = 27,
	EFFECT_GAME_MASTER = 28,
	EFFECT_SEAL_OF_ASCENSION1 = 29,
	EFFECT_SEAL_OF_WEALTH1 = 30,
	EFFECT_SEAL_OF_SUSTENANCE1 = 31,
	EFFECT_ORDER_OF_SPEED = 32,
	EFFECT_ORDER_OF_SUBLIMATION = 33,
	EFFECT_ORDER_OF_PROTECTION = 34,
	EFFECT_HALLOWEEN1 = 35,
	EFFECT_HALLOWEEN2 = 36,
	EFFECT_HALLOWEEN3 = 37,
	EFFECT_HALLOWEEN4 = 38,
	EFFECT_HALLOWEEN5 = 39,
	EFFECT_SEAL_OF_ASCENSION2 = 40,
	EFFECT_SEAL_OF_WEALTH2 = 41,
	EFFECT_SEAL_OF_SUSTENANCE2 = 42,
	EFFECT_SEAL_OF_MOVEMENT = 43,
	EFFECT_SCROLL_OF_QUICK = 44,
	EFFECT_SCROLL_OF_DEFENSE = 45,
	EFFECT_SCROLL_OF_WRATH = 46,
	EFFECT_SCROLL_OF_MAGIC_DAMAGE = 47,
	EFFECT_SCROLL_OF_LIFE = 48,
	EFFECT_SCROLL_OF_MANA = 49,
	EFFECT_ELIXIR_OF_STRENGTH = 50,
	EFFECT_ELIXIR_OF_DEXTERITY = 51,
	EFFECT_ELIXIR_OF_VITALITY = 52,
	EFFECT_ELIXIR_OF_ENERGY = 53,
	EFFECT_ELIXIR_OF_LEADERSHIP = 54,
	EFFECT_POISON = 55,
	EFFECT_ICE = 56,
	EFFECT_ICE_ARROW = 57,
	EFFECT_FIRE_SLASH = 58,
	EFFECT_PHYSI_DAMAGE_IMMUNITY = 59,
	EFFECT_MAGIC_DAMAGE_IMMUNITY = 60,
	EFFECT_STERN = 61,
	EFFECT_MAGIC_DEFENSE = 62,
	EFFECT_MONSTER_PHYSI_DAMAGE_IMMUNITY = 63,
	EFFECT_MONSTER_MAGIC_DAMAGE_IMMUNITY = 64,
	EFFECT_ORDER_OF_RESTRAINT = 65,
	EFFECT_CRYWOLF_STATE8 = 66,
	EFFECT_CRYWOLF_STATE9 = 67,
	EFFECT_CRYWOLF_STATE10 = 68,
	EFFECT_CRYWOLF_STATE11 = 69,
	EFFECT_CRYWOLF_STATE12 = 70,
	EFFECT_DAMAGE_REFLECT = 71,
	EFFECT_SLEEP = 72,
	EFFECT_BLIND = 73,
	EFFECT_NEIL = 74,
	EFFECT_SAHAMUTT = 75,
	EFFECT_LESSER_DAMAGE = 76,
	EFFECT_LESSER_DEFENSE = 77,
	EFFECT_CHERRY_BLOSSOM1 = 78,
	EFFECT_CHERRY_BLOSSOM2 = 79,
	EFFECT_CHERRY_BLOSSOM3 = 80,
	EFFECT_SWORD_POWER = 81,
	EFFECT_MAGIC_CIRCLE = 82,
	EFFECT_SWORD_SLASH = 83,
	EFFECT_LIGHTNING_STORM = 84,
	EFFECT_RED_STORM = 85,
	EFFECT_FROZEN_STAB = 86,
	EFFECT_SEAL_OF_LIFE = 87,
	EFFECT_SEAL_OF_MANA = 88,
	EFFECT_SCROLL_OF_BATTLE = 89,
	EFFECT_SCROLL_OF_STRENGTH = 90,
	EFFECT_CHUCK_NORRIS = 91,
	EFFECT_CHRISTMAS2 = 92,
	EFFECT_CHRISTMAS3 = 93,
	EFFECT_CHRISTMAS4 = 94,
	EFFECT_CHRISTMAS5 = 95,
	EFFECT_CHRISTMAS6 = 96,
	EFFECT_CHRISTMAS7 = 97,
	EFFECT_DUEL_ARENA_WATCH = 98,
	EFFECT_TALISMAN_OF_GUARDIAN = 99,
	EFFECT_TALISMAN_OF_PROTECTION = 100,
	EFFECT_MASTER_SEAL_OF_ASCENSION = 101,
	EFFECT_MASTER_SEAL_OF_WEALTH = 102,
	EFFECT_GLADIATORS_GLORY = 103,
	EFFECT_SEAL_OF_STRENGTH = 104,
	EFFECT_DOUBLE_GOER_DELETE = 105,
	EFFECT_PK_PENALTY = 106,
	EFFECT_MUBLUE_TIRED = 107,
	EFFECT_MUBLUE_EXHAUST = 108,
	EFFECT_PARTY_EXPERIENCE_BONUS = 112,
	EFFECT_MAX_AG_BOOST_AURA = 113,
	EFFECT_MAX_SD_BOOST_AURA = 114,
	EFFECT_MUBLUE_MINIMUMVITALITY = 115,
	EFFECT_MUBLUE_LOWVITALITY = 116,
	EFFECT_MUBLUE_MEDIUMVITALITY = 117,
	EFFECT_MUBLUE_HIGHVITALITY = 118,
	EFFECT_PCS_MARK7 = 119,
	EFFECT_HACKTOOL_PENALTY = 120,
	EFFECT_SCROLL_OF_HEALING = 121,
	EFFECT_HAWK_FIGURINE = 122,
	EFFECT_GOAT_FIGURINE = 123,
	EFFECT_OAK_CHARM = 124,
	EFFECT_MAPLE_CHARM = 125,
	EFFECT_GOLDEN_OAK_CHARM = 126,
	EFFECT_GOLDEN_MAPLE_CHARM = 127,
	EFFECT_WORN_HORSESHOE = 128,
	EFFECT_GREATER_IGNORE_DEFENSE_RATE = 129,
	EFFECT_FITNESS = 130,
	EFFECT_GREATER_DEFENSE_SUCCESS_RATE = 131,
	EFFECT_DECREASE_DEFENSE_RATE = 132,
	EFFECT_MASTER_CAST_INVINCIBILITY = 133,
	EFFECT_IRON_DEFENSE = 134,
	EFFECT_GREATER_LIFE_ENHANCED = 135,
	EFFECT_GREATER_LIFE_MASTERED = 136,
	EFFECT_BLEEDING = 137,
	EFFECT_MAGIC_CIRCLE_IMPROVED = 138,
	EFFECT_MAGIC_CIRCLE_ENHANCED = 139,
	EFFECT_MANA_SHIELD_MASTERED = 140,
	EFFECT_FROZEN_STAB_MASTERED = 141,
	EFFECT_BLESS = 142,
	EFFECT_INFINITY_ARROW_IMPROVED = 143,
	EFFECT_BLIND_IMPROVED = 144,
	EFFECT_DRAIN_LIFE_ENHANCED = 145,
	EFFECT_ICE_STORM_ENHANCED = 146,
	EFFECT_EARTH_PRISON = 147,
	EFFECT_GREATER_CRITICAL_DAMAGE_MASTERED = 148,
	EFFECT_GREATER_CRITICAL_DAMAGE_EXTENDED = 149,
	EFFECT_SWORD_POWER_IMPROVED = 150,
	EFFECT_SWORD_POWER_ENHANCED = 151,
	EFFECT_SWORD_POWER_MASTERED = 152,
	EFFECT_GREATER_DEFENSE_SUCCESS_RATE_IMPROVED = 153,
	EFFECT_GREATER_DEFENSE_SUCCESS_RATE_ENHANCED = 154,
	EFFECT_FITNESS_IMPROVED = 155,
	EFFECT_MONK_IGNORE_ENEMY_DEFENSE_STR = 156,
	EFFECT_FIREING_DAMAGE = 157,
	EFFECT_FREEZING_DAMAGE = 158,
	EFFECT_POISON_ARROW = 159,
	EFFECT_POISON_ARROW_IMPROVED = 160,
	EFFECT_BLESS_IMPROVED = 161,
	EFFECT_LESSER_DAMAGE_IMPROVED = 162,
	EFFECT_LESSER_DEFENSE_IMPROVED = 163,
	EFFECT_FIRE_SLASH_ENHANCED = 164,
	EFFECT_IRON_DEFENSE_IMPROVED = 165,
	EFFECT_BLOOD_HOWLING = 166,
	EFFECT_BLOOD_HOWLING_IMPROVED = 167,
	EFFECT_MONK_IGNORE_ENEMY_DEFENSE_ENHANCED = 168,
	EFFECT_PENETRATE_ARMOR = 169,
	EFFECT_PENTAGRAM_JEWEL_HALF_SD = 174,
	EFFECT_PENTAGRAM_JEWEL_HALF_MP = 175,
	EFFECT_PENTAGRAM_JEWEL_HALF_SPEED = 176,
	EFFECT_PENTAGRAM_JEWEL_HALF_HP = 177,
	EFFECT_PENTAGRAM_JEWEL_STUN = 178,
	EFFECT_ARCA_FIRETOWER = 0xB3,
	EFFECT_ARCA_WATERTOWER = 0xB4,
	EFFECT_ARCA_EARTHTOWER = 0xB5,
	EFFECT_ARCA_WINDTOWER = 0xB6,
	EFFECT_ARCA_DARKNESSTOWER = 0xB7,
	EFFECT_ARCA_DEATHPENALTY = 0xB8,
	EFFECT_PENTAGRAM_JEWEL_SLOW = 186,
	EFFECT_TALISMAN_OF_ASCENSION1 = 190,
	EFFECT_TALISMAN_OF_ASCENSION2 = 191,
	EFFECT_TALISMAN_OF_ASCENSION3 = 192,
	EFFECT_SEAL_OF_ASCENSION3 = 193,
	EFFECT_MASTER_SEAL_OF_ASCENSION2 = 194,
	EFFECT_BLESSING_OF_LIGHT = 195,

	EFFECT_BOSS_DEFENSE = 196, //OK
	EFFECT_PVP_DEFENSE = 197, //OK
	EFFECT_PVP_DAMAGE = 198, //OK
	EFFECT_MASTER_SCROLL_OF_MANA = 199, //OK
	EFFECT_BOSS_DAMAGE = 200, //OK
	EFFECT_MASTER_SCROLL_OF_HEALING = 201, //OK
	EFFECT_MASTER_SCROLL_OF_BATTLE = 202, //OK
	EFFECT_MASTER_SCROLL_OF_STRENGTH = 203,
	EFFECT_MASTER_SCROLL_OF_QUICK = 204, //OK

	EFFECT_USE_MOUNT_UNIRIA = 205,
	EFFECT_USE_MOUNT_DINORANT = 206,
	EFFECT_USE_MOUNT_DLHORSE = 207,
	EFFECT_USE_MOUNT_FENRIR = 208,
	EFFECT_PARALYZE = 209,
	EFFECT_CALMA_MORENO = 210,
	EFFECT_INTERNET_CAFE = 211,
	EFFECT_BLESS_OF_LIGHT_50 = 212,
	EFFECT_BLESS_OF_LIGHT_100 = 213,
	EFFECT_EVASION = 214,

	EFFECT_CIRCLE_SHIELD = 216,
	EFFECT_OBSIDIAN = 217,
	EFFECT_WRATH = 218,
	EFFECT_BURST = 219,
	EFFECT_OBSIDIAN_STR = 220,
	EFFECT_CIRCLE_SHIELD_STR = 221,
	EFFECT_CIRCLE_SHIELD_MAS = 222,
	EFFECT_WRATH_STR = 223,
	EFFECT_WRATH_PRO = 224,
	EFFECT_WRATH_MAS = 225,
	EFFECT_BURST_STR = 226,
	EFFECT_EVOMON_SUCCESS = 227,
	EFFECT_EVOMON_FAILED = 228,
	EFFECT_NARS_BERSERKER = 229,
	EFFECT_NARS_CLONE = 230,
	EFFECT_NARS_SPIN = 231,
	EFFECT_DARK_SPIRITD = 232,
	EFFECT_BASTION = 238,
	EFFECT_HEMORRHAGE = 239,
	EFFECT_PARALYSIS = 240,
	EFFECT_BONDAGE = 241,
	EFFECT_BLINDNES = 242,
	EFFECT_IMMUNE_I = 243,
	EFFECT_IMMUNE_II = 244,
	EFFECT_WIDENED_I = 245,
	EFFECT_ARCHANGEL_WILL = 246,
	EFFECT_FEREA_PARTY_EXP = 247,

	EFFECT_BLESS_OF_LIGHT_GREATER = 253,
	EFFECT_BLESS_OF_LIGHT_MIDDLE = 254,
	EFFECT_BLESS_OF_LIGHT_LOW = 255,

	EFFECT_SWELL_LIFE_ENHANCEMENT = 264,
	EFFECT_MANA_SHIELD_ENHANCEMENT = 265,
	EFFECT_BERSERKER_ENHANCEMENT = 266,
	EFFECT_BERSERKER_ENHANCEMENT_PROFI = 267,
	EFFECT_STAMINA_ENHANCEMENT = 268,
	EFFECT_WRATH_ENHANCEMENT = 269,
	EFFECT_WRATH_ENHANCEMENT_PROFI = 270,
	EFFECT_DECREASE_SD_RATIO = 271,
	EFFECT_SD_RISE = 272,
	EFFECT_PLAGUE = 273,
	EFFECT_FREEZING = 274,
	EFFECT_BLEEDING2 = 275,
	EFFECT_SHOCK = 276,
	EFFECT_ADDICTED = 277,
	EFFECT_FREEZING1 = 278,
	EFFECT_EXCESSIVE_BLEEDING = 279,
	EFFECT_SHOCK1 = 280,
	EFFECT_INCREASED_SD_REDUCTION = 281,
	EFFECT_INCREASE_MAXIMUM_HEALTH = 282,
	EFFECT_FOURTH_STATS = 283,
	EFFECT_BASE_DEFENSE_INCREASE = 284,
	EFFECT_INCREASE_ATTACK_POWER_OF_4TH_WINGS = 285,
	EFFECT_DAMAGE_INCREASE = 286,
	EFFECT_WIZADRY_POWER_INCREASE = 287,
	EFFECT_FOURTH_STATS1 = 288,
	EFFECT_SKILL_DAMAGE_INCREASE = 289,
	EFFECT_FOURTH_BLADE_DAMAGE_INCREASE = 290,
	EFFECT_ATTACK_OR_WIZADRY_POWER_INCREASE = 291,
};

//**********************************************//
//************ GameServer -> Client ************//
//**********************************************//

struct PMSG_EFFECT_STATE_SEND
{
	PBMSG_HEAD header; // C1:07
	BYTE state;
	BYTE index[2];
	WORD effect;
};

struct PMSG_PERIODIC_EFFECT_SEND
{
	//
	//  BYTE      8
	// DWORD      12
	//  WORD      16
	//  BYTE      ITEMINFO 18
	//  WORD      30
	   
	PBMSG_HEAD header; // C1:2D

	WORD group;
	WORD value;
	BYTE state;
	int time;
	WORD effect;
	BYTE ItemInfo[MAX_ITEM_INFO];
	DWORD wEffectValue; // Season 13 addon
};


struct PMSG_PARTY_EFFECT_LIST_SEND
{
	PBMSG_HEAD header; // C1:2E
	char name[11];
	BYTE count;
};

struct PMSG_PARTY_EFFECT_LIST
{
#pragma pack(1)
	WORD effect;
	DWORD count;
#pragma pack()
};

//**********************************************//
//**********************************************//
//**********************************************//

struct EFFECT_INFO
{
	int Index;
	int Group;
	int ItemIndex;
	char Name[64];
	int Save;
	int Type;
	int Flag;
	int Count;
	int Value[4];
};

class CEffectManager
{
public:
	CEffectManager();
	virtual ~CEffectManager();
	void Init();
	void Load(char* path);
	void SetInfo(EFFECT_INFO info);
	EFFECT_INFO* GetInfo(int index);
	EFFECT_INFO* GetInfoByItem(int ItemIndex);
	void MainProc();
	bool AddEffect(LPOBJ lpObj, bool type, int index, int count, WORD value1, WORD value2, WORD value3, WORD value4);
	bool DelEffect(LPOBJ lpObj, int index);
	bool DelEffectByGroup(LPOBJ lpObj, int group);
	CEffect* GetEffect(LPOBJ lpObj, int index);
	CEffect* GetEffectByGroup(LPOBJ lpObj, int group);
	bool CheckEffect(LPOBJ lpObj, int index);
	bool CheckEffectByGroup(LPOBJ lpObj, int group);
	void InsertEffect(LPOBJ lpObj, CEffect* lpEffect);
	void RemoveEffect(LPOBJ lpObj, CEffect* lpEffect);
	bool ConvertEffectByte(CEffect* lpEffect, BYTE* lpMsg);
	void EffectByteConvert(BYTE* lpMsg, CEffect* lpEffect);
	int GenerateEffectList(LPOBJ lpObj, BYTE* lpMsg, int* size);
	int GenerateEffectList(LPOBJ lpObj, WORD* lpMsg, bool antilag);
	int GenerateEffectList(LPOBJ lpObj, BYTE* lpMsg);
	int GeneratePartyEffectList(LPOBJ lpObj, BYTE* lpMsg, int* size);
	bool CheckStunEffect(LPOBJ lpObj);
	bool CheckImmobilizeEffect(LPOBJ lpObj);
	void ClearAllEffect(LPOBJ lpObj);
	void ClearDebuffEffect(LPOBJ lpObj, int count);
	void PeriodicEffect(LPOBJ lpObj, CEffect* lpEffect);
	void GCEffectStateSend(LPOBJ lpObj, BYTE state, WORD effect);
	void GCPeriodicEffectSend(LPOBJ lpObj, WORD group, WORD value, BYTE state, DWORD time, WORD effect);
	void GCPartyEffectListSend(LPOBJ lpObj);
private:
	EFFECT_INFO m_EffectInfo[MAX_EFFECT];
};

extern CEffectManager gEffectManager;
