#include "stdafx.h"
#include "GremoryCase.h"
#include "Connection.h"
#include "GameMain.h"
#include "PentagramSystem.h"
#include "DSProtocol.h"
#include "Util.h"

CGremoryCase g_GremoryCase;

CGremoryCase::CGremoryCase(void)
{
}

CGremoryCase::~CGremoryCase(void)
{
}

void CGremoryCase::CheckStorageExpiredItems()
{
	time_t CurrTime = time(NULL);

	for (int i = OBJECT_START_USER; i < MAX_OBJECT; i++)
	{
		if (gObjIsConnected(i) == TRUE)
		{
			if (gObj[i].Type == OBJECT_USER)
			{
				if (gObj[i].m_bGremoryCaseDBInfo == TRUE)
				{
					for (int j = 0; j < MAX_GREMORYCASE_STORAGE_TYPES; j++)
					{
						for (int k = 0; k < MAX_GREMORYCASE_STORAGE_ITEMS; k++)
						{
							if (gObj[i].m_GremoryCaseData[j][k].btRewardInventory != 0)
							{
								if (gObj[i].m_GremoryCaseData[j][k].dwExpireTime < CurrTime)
								{
									time_t cc=gObj[i].m_GremoryCaseData[j][k].dwExpireTime;
									CItem Item=gObj[i].m_GremoryCaseData[j][k].ItemInfo;
									this->GDReqDeleteItemFromGremoryCase(i, gObj[i].m_GremoryCaseData[j][k].dwItemGUID, gObj[i].m_GremoryCaseData[j][k].dwAuthCode);
									this->GCSendDeleteItemFromGremoryCase(i, j, k);

									LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Deleted Expired Item (Storage Type: %d) (ItemGUID: %d) (AuthCode: %d)",gObj[i].Account, gObj[i].Name, j, gObj[i].m_GremoryCaseData[j][k].dwItemGUID, gObj[i].m_GremoryCaseData[j][k].dwAuthCode);
									gObj[i].m_GremoryCaseData[j][k].Clear();

								}
							}
						}
					}
				}
			}
		}
	}
}

void CGremoryCase::GDReqAddItemToGremoryCase(int iIndex, _stGremoryCaseItem stItem, int iDaysToExpire)//Ʒ
{
	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER ) 
	{
		return;
	}

	if ( lpObj->m_bGremoryCaseDBInfo == false )
	{
		return;
	}

	if (stItem.btStorageType != GC_STORAGE_SERVER && stItem.btStorageType != GC_STORAGE_CHARACTER)
	{
		return;
	}

	_stReqAddItemToGremoryCase pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x01, sizeof(pMsg));

	pMsg.iIndex = iIndex;
	memcpy(pMsg.szAccountID, gObj[iIndex].Account, MAX_ACCOUNT_LEN+1);
	memcpy(pMsg.szName, gObj[iIndex].Name, MAX_ACCOUNT_LEN+1);
	pMsg.iReceiveDate = time(NULL);
	pMsg.iExpireDate = time(NULL) + (iDaysToExpire * 24 * 60 * 60);
	pMsg.btStorageType=stItem.btStorageType;
	pMsg.btRewardSource= stItem.btRewardSource;
	pMsg.dwAuthCode=0;

	gItemManager.DBItemByteConvert(pMsg.ItemInfo,&stItem.ItemInfo);
	gDataServerConnection.DataSend((BYTE*)&pMsg,pMsg.h.size);

	//LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Request to Add item to Storage (Reward Source: %d) (ItemID: %d) (ExpireDays: %d)",lpObj->Account, lpObj->Name, stItem.btRewardSource, stItem.ItemInfo.m_Index, iDaysToExpire);
}

void CGremoryCase::DGAnsAddItemToGremoryCase(_stAnsAddItemToGremoryCase * lpMsg)
{
	/*this->GDReqStorageItemList(lpMsg->iIndex);
	return;*/
	
	int iIndex = lpMsg->iIndex;

	if ( !gObjIsConnectedGP(iIndex))
	{
		return;
	}
	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER )
	{
		return;
	}

	if ( lpMsg->btResult == 1 )
	{
		LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Failed to Add Item to Storage - DB Error", lpObj->Account, lpObj->Name);
		return;
	}

	int iItemArrayIndex = -1;

	for (int i = 0; i < MAX_GREMORYCASE_STORAGE_ITEMS; i++)
	{
		if(lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].btRewardInventory == 0)
		{
			CItem item;
			iItemArrayIndex = i;
			item.Clear();
			gItemManager.ConvertItemByte(&item,lpMsg->ItemInfo);
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].Clear();
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].ItemInfo.Clear();
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].btRewardInventory = lpMsg->btStorageType;
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].btRewardSource = lpMsg->btRewardSource;
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].dwItemGUID = lpMsg->ItemGUID;
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].dwAuthCode = lpMsg->dwAuthCode;
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].dwReceiveDate = lpMsg->iReceiveDate;
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].dwExpireTime = lpMsg->iExpireDate;
			lpObj->m_GremoryCaseData[lpMsg->btStorageType-1][i].ItemInfo = item;
			break;
		}
	}
	
	if (iItemArrayIndex == -1)
	{
		LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Failed to Add Item to Storage - No space in array", lpObj->Account, lpObj->Name);
		return;
	}

	//LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Success to Add Item to Storage (Storage: %d) (Source: %d) (ItemGUID: %d) (AuthCode: %d)",lpObj->Account, lpObj->Name, lpMsg->btStorageType, lpMsg->btRewardSource, lpMsg->ItemGUID, lpMsg->dwAuthCode);

	this->GCSendAddItemToGremoryCase(iIndex, lpMsg->btStorageType-1, iItemArrayIndex);
}

void CGremoryCase::GCSendAddItemToGremoryCase(int iIndex, BYTE btStorageType, BYTE btItemArrayIndex)
{
	if ( !gObjIsConnectedGP(iIndex))
	{
		return;
	}

	if (!gObjIsConnected(iIndex))
	{
		return;
	}

	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER) 
	{
		return;
	}

	PMSG_RECEIVE_GREMORYCASE_ITEM pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x01, sizeof(pMsg));

	pMsg.m_ReceivedItem.btRewardInventory = lpObj->m_GremoryCaseData[btStorageType][btItemArrayIndex].btRewardInventory;
	pMsg.m_ReceivedItem.btRewardSource = lpObj->m_GremoryCaseData[btStorageType][btItemArrayIndex].btRewardSource;
	pMsg.m_ReceivedItem.dwItemGUID = lpObj->m_GremoryCaseData[btStorageType][btItemArrayIndex].dwItemGUID;
	pMsg.m_ReceivedItem.dwAuthCode = lpObj->m_GremoryCaseData[btStorageType][btItemArrayIndex].dwAuthCode;
	pMsg.m_ReceivedItem.dwExpireTime = lpObj->m_GremoryCaseData[btStorageType][btItemArrayIndex].dwExpireTime;		
	gItemManager.ItemByteConvert(pMsg.m_ReceivedItem.btItemInfo, lpObj->m_GremoryCaseData[btStorageType][btItemArrayIndex].ItemInfo);

	DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);

	this->GCSendStorageItemList(iIndex);
}

void CGremoryCase::GCSendStorageItemList(int iIndex)
{
	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER ) 
	{
		return;
	}

	if ( lpObj->m_bGremoryCaseDBInfo == false )
	{
		return;
	}

	BYTE BUFFER[8192];
	PMSG_RECEIVE_GREMORYCASE_ITEMLIST * lpMsg = (PMSG_RECEIVE_GREMORYCASE_ITEMLIST *)(BUFFER);
	PMSG_GREMORYCASE_ITEM * lpItem;

	lpMsg->btCount = 0;

	for (int i = 0; i < MAX_GREMORYCASE_STORAGE_TYPES; i++)
	{
		for (int j = 0; j < MAX_GREMORYCASE_STORAGE_ITEMS; j++)
		{
			if (lpObj->m_GremoryCaseData[i][j].btRewardInventory != 0)
			{
				lpItem = (PMSG_GREMORYCASE_ITEM *)(BUFFER + sizeof(PMSG_RECEIVE_GREMORYCASE_ITEMLIST) + (lpMsg->btCount * sizeof(PMSG_GREMORYCASE_ITEM)));

				lpItem->btRewardInventory = lpObj->m_GremoryCaseData[i][j].btRewardInventory;
				lpItem->btRewardSource = lpObj->m_GremoryCaseData[i][j].btRewardSource;
				lpItem->dwItemGUID = lpObj->m_GremoryCaseData[i][j].dwItemGUID;
				lpItem->dwAuthCode = lpObj->m_GremoryCaseData[i][j].dwAuthCode;
				lpItem->dwExpireTime = lpObj->m_GremoryCaseData[i][j].dwExpireTime;		
				gItemManager.ItemByteConvert(lpItem->btItemInfo, lpObj->m_GremoryCaseData[i][j].ItemInfo);

				lpMsg->btCount++;
			}
		}
	}

	int PacketSize = sizeof(PMSG_RECEIVE_GREMORYCASE_ITEMLIST) + (lpMsg->btCount * sizeof(PMSG_GREMORYCASE_ITEM));
	PHeadSubSetW((LPBYTE)lpMsg, 0x4F, 0x00, PacketSize);

	DataSend(iIndex, BUFFER, PacketSize);
}

void CGremoryCase::CGReqOpenGremoryCase(int iIndex)
{
	if ( !gObjIsConnectedGP(iIndex))
	{
		return;
	}
	if (!gObjIsConnected(iIndex))
	{
		return;
	}

	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER ) 
	{
		return;
	}

	PMSG_GREMORYCASE_OPEN_ANS pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x05, sizeof(pMsg));

	if ( lpObj->m_bGremoryCaseDBInfo == false )
	{
		pMsg.btResult = 1;
		DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);

		LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Open failed - No info from DB.", lpObj->Account, lpObj->Name);
		return;
	}

	pMsg.btResult = 0;
	DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);

	//LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Open Gremory Case.", lpObj->Account, lpObj->Name);
}

void CGremoryCase::GDReqStorageItemList(int iIndex)//DSѯƷ
{
	gObj[iIndex].m_bGremoryCaseDBInfo = false;

	_stReqGremoryCaseItemList pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x00, sizeof(pMsg));

	pMsg.iIndex = iIndex;
	memcpy(pMsg.szAccountID, gObj[iIndex].Account, MAX_ACCOUNT_LEN+1);
	memcpy(pMsg.szName, gObj[iIndex].Name, MAX_ACCOUNT_LEN+1);
	gDataServerConnection.DataSend((BYTE*)&pMsg,pMsg.h.size);
	//LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Request to load Gremory Case item list.", gObj[iIndex].Account, gObj[iIndex].Name);
}

void CGremoryCase::DGAnsStorageItemList(LPBYTE lpRecv)//
{
	_stAnsGremoryCaseItemList * lpMsg = (_stAnsGremoryCaseItemList *)(lpRecv);
	_stDSGremoryCaseItem * lpItem;

	int iIndex = lpMsg->iIndex;

	if ( !gObjIsConnectedGP(iIndex))
	{
		return;
	}

	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER )
	{
		return;
	}

	int iCharacterStorageCount = 0;
	int iServerStorageCount = 0;

	for (int i = 0; i < lpMsg->btCount; i++ )
	{
		lpItem = (_stDSGremoryCaseItem *)(lpRecv + sizeof(_stAnsGremoryCaseItemList) + (i * sizeof(_stDSGremoryCaseItem)));

		for (int j = 0; j < MAX_GREMORYCASE_STORAGE_ITEMS; j++)
		{
			if ( lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].btRewardInventory == 0)
			{
				CItem item;
				item.Clear();
				gItemManager.ConvertItemByte(&item,lpItem->ItemInfo);
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].Clear();
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].ItemInfo.Clear();
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].btRewardInventory = lpItem->btStorageType;
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].btRewardSource = lpItem->btRewardSource;
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].dwItemGUID = lpItem->ItemGUID;
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].dwAuthCode = lpItem->dwAuthCode;
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].dwReceiveDate = lpItem->iReceiveDate;
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][j].dwExpireTime = lpItem->iExpireDate;
				lpObj->m_GremoryCaseData[lpItem->btStorageType-1][i].ItemInfo = item;
				//lpObj->m_GremoryCaseData[lpItem->btStorageType-1][i].ItemInfo.m_JewelOfHarmonyOption = 0;
				//lpObj->m_GremoryCaseData[lpItem->btStorageType-1][i].ItemInfo.Convert(item.m_Index,item.m_Option1,item.m_Option2,item.m_Option3,item.m_NewOption,item.m_SetOption,0,item.m_ItemOptionEx,item.m_SocketOption,item.m_SocketOptionBonus);
	
				if ( lpItem->btStorageType == GC_STORAGE_SERVER )
				{
					iServerStorageCount++;
				}
				else if ( lpItem->btStorageType == GC_STORAGE_CHARACTER )
				{
					iCharacterStorageCount++;
				}

				break;
			}
		}
	}

	lpObj->m_bGremoryCaseDBInfo = true;
	//LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Received item list (Character:%d) (Server:%d)",lpObj->Account, lpObj->Name, iCharacterStorageCount, iServerStorageCount);

	this->GCSendStorageItemList(iIndex);
	this->CheckIsInStorageItemAboutToExpire(iIndex);
	this->CheckIsStorageFull(iIndex);
	GCShutdownThat_dd_55_Shit(lpObj->Index);
}

void CGremoryCase::CheckIsInStorageItemAboutToExpire(int iIndex)
{
	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER ) 
	{
		return;
	}

	if ( lpObj->m_bGremoryCaseDBInfo == false )
	{
		return;
	}

	bool bItemFound = false;

	time_t TimeCheck = time(NULL) + (7 * 24 * 60 * 60); // add 7 days to date

	for (int i = 0; i < MAX_GREMORYCASE_STORAGE_TYPES; i++)
	{
		for (int j = 0; j < MAX_GREMORYCASE_STORAGE_ITEMS; j++)
		{
			if (lpObj->m_GremoryCaseData[i][j].btRewardInventory != 0)
			{
				if (lpObj->m_GremoryCaseData[i][j].dwExpireTime < TimeCheck)
				{
					bItemFound = true;
					break;
				}
			}
		}
	}

	if (bItemFound == false)
	{
		return;
	}

	PMSG_GREMORYCASE_SENT_NOTICE pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x04, sizeof(pMsg));
	pMsg.btNoticeIndex = 1;

	DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);
}

void CGremoryCase::CheckIsStorageFull(int iIndex)
{
	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER ) 
	{
		return;
	}

	if ( lpObj->m_bGremoryCaseDBInfo == false )
	{
		return;
	}

	BYTE btStorageState = 0;
	int iCharacterStorageCount = 0, iServerStorageCount = 0;

	for (int i = 0; i < MAX_GREMORYCASE_STORAGE_TYPES; i++)
	{
		for (int j = 0; j < MAX_GREMORYCASE_STORAGE_ITEMS; j++)
		{
			if (lpObj->m_GremoryCaseData[i][j].btRewardInventory != 0)
			{
				if (lpObj->m_GremoryCaseData[i][j].btRewardInventory == GC_STORAGE_SERVER)
				{
					iServerStorageCount++;
				}

				else if (lpObj->m_GremoryCaseData[i][j].btRewardInventory == GC_STORAGE_CHARACTER)
				{
					iCharacterStorageCount++;
				}
			}
		}
	}

	if (iServerStorageCount >= MAX_GREMORYCASE_STORAGE_ITEMS || iCharacterStorageCount >= MAX_GREMORYCASE_STORAGE_ITEMS)
	{
		btStorageState = 1;
	}

	else if ((iServerStorageCount >= MAX_GREMORYCASE_STORAGE_ITEMS-5 && iServerStorageCount < MAX_GREMORYCASE_STORAGE_ITEMS) || (iCharacterStorageCount >= MAX_GREMORYCASE_STORAGE_ITEMS-5 && iCharacterStorageCount < MAX_GREMORYCASE_STORAGE_ITEMS))
	{
		btStorageState = 2;
	}

	if ( btStorageState == 0 )
	{
		return;
	}

	PMSG_GREMORYCASE_SENT_NOTICE pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x04, sizeof(pMsg));
	pMsg.btNoticeIndex = btStorageState == 2 ? 5 : 6;

	DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);
}

void CGremoryCase::GDReqDeleteItemFromGremoryCase(int iIndex, DWORD dwItemGUID, DWORD dwAuthCode)
{
	_stReqDeleteItemFromGremoryCase pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x03, sizeof(pMsg));

	memcpy(pMsg.szAccountID, gObj[iIndex].Account, MAX_ACCOUNT_LEN+1);
	memcpy(pMsg.szName, gObj[iIndex].Name, MAX_ACCOUNT_LEN+1);


	pMsg.dwItemGUID = dwItemGUID;
	pMsg.dwAuthCode = dwAuthCode;

	gDataServerConnection.DataSend((BYTE *)&pMsg, pMsg.h.size);
}

void CGremoryCase::GCSendDeleteItemFromGremoryCase(int iIndex, BYTE btStorageType, int iItemArrayIndex)
{
	PMSG_REMOVE_ITEM_FROM_GREMORYCASE pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x03, sizeof(pMsg));

	pMsg.btStorageType = btStorageType+1;
	pMsg.dwItemGUID = gObj[iIndex].m_GremoryCaseData[btStorageType][iItemArrayIndex].dwItemGUID;
	pMsg.dwAuthCode =  gObj[iIndex].m_GremoryCaseData[btStorageType][iItemArrayIndex].dwAuthCode;

	DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);
}

void CGremoryCase::CGReqGetItemFromGremoryCase(PMSG_ADD_GREMORYCASE_ITEM_TO_INVENTORY_REQ * lpMsg, int iIndex)
{
	if ( !gObjIsConnectedGP(iIndex))
	{
		return;
	}
	if (!gObjIsConnected(iIndex))
	{
		return;
	}

	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER) 
	{
		return;
	}

	this->GDReqCheckItemUseGremoryCase(iIndex,lpMsg->wItemID, lpMsg->dwItemGUID, lpMsg->dwAuthCode);
}

void CGremoryCase::GDReqCheckItemUseGremoryCase(int iIndex,WORD wItemID, DWORD dwItemGUID, DWORD dwAuthCode)
{
	_stReqCheckUseItemGremoryCase pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x02, sizeof(pMsg));

	pMsg.iIndex = iIndex;
	memcpy(pMsg.szAccountID, gObj[iIndex].Account, MAX_ACCOUNT_LEN+1);
	memcpy(pMsg.szName, gObj[iIndex].Name, MAX_ACCOUNT_LEN+1);

	pMsg.dwItemGUID = dwItemGUID;
	pMsg.dwAuthCode = dwAuthCode;

	gDataServerConnection.DataSend((BYTE *)&pMsg, pMsg.h.size);
	LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Request to Use Item  (ItemGUID: %d) (AuthCode: %d)",gObj[iIndex].Account, gObj[iIndex].Name, dwItemGUID, dwAuthCode);
}

void CGremoryCase::DGAnsCheckItemUseGremoryCase(_stAnsCheckUseItemGremoryCase * lpMsg)
{
	int iIndex = lpMsg->iIndex;

	if ( !gObjIsConnectedGP(iIndex))
	{
		return;
	}
	LPOBJ lpObj = &gObj[iIndex];

	if ( lpObj->Type != OBJECT_USER )
	{
		return;
	}

	PMSG_ADD_GREMORYCASE_ITEM_TO_INVENTORY_ANS pMsg;
	PHeadSubSetB((LPBYTE)&pMsg, 0x4F, 0x02, sizeof(pMsg));

	if ( lpObj->m_bGremoryCaseDBInfo == false )
	{
		pMsg.btResult = 1;
		DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);

		LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Failed to Add Item to Inventory - Data not loaded from DB", lpObj->Account, lpObj->Name);
		return;
	}

	int iStorageType = -1;
	int iItemArrayIndex = -1;
	int ItemID;
	for (int i = 0; i < MAX_GREMORYCASE_STORAGE_TYPES; i++)
	{
		for (int j = 0; j < MAX_GREMORYCASE_STORAGE_ITEMS; j++)
		{
			if ( lpObj->m_GremoryCaseData[i][j].btRewardInventory != 0)
			{
				if ( lpObj->m_GremoryCaseData[i][j].dwItemGUID == lpMsg->dwItemGUID &&
					lpObj->m_GremoryCaseData[i][j].dwAuthCode == lpMsg->dwAuthCode)
				{
					ItemID =lpObj->m_GremoryCaseData[i][j].ItemInfo.m_Index;
					iStorageType = i;
					iItemArrayIndex = j;
					break;
				}
			}
		}
	}

	if ( iStorageType == -1 || iItemArrayIndex == -1 )
	{
		pMsg.btResult = 2;
		DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);

		LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Failed to Add Item to Inventory - Item not found", lpObj->Account, lpObj->Name);
		return;
	}

	if ( lpMsg->btResult == 0 )
	{
		pMsg.btResult = 3;
		DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);

		LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Failed to Add Item to Inventory - Item not Exists in DB", lpObj->Account, lpObj->Name);
		return;
	}
	
	ITEM_INFO ItemInfo;
	if(gItemManager.GetInfo(ItemID,&ItemInfo) == 0)
	{
		pMsg.btResult = 5;
		DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);
		return;
	}
	if(gItemManager.CheckItemInventorySpace(lpObj,ItemID) == 0)
	{
		pMsg.btResult = 4;
		DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);

		LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Failed to Add Item to Inventory - Not enough empty space", lpObj->Account, lpObj->Name);
		return;
	}

	pMsg.btResult = 0;
	pMsg.btStorageType = iStorageType+1;

	pMsg.dwItemGUID = lpMsg->dwItemGUID;
	pMsg.dwAuthCode = lpMsg->dwAuthCode;

	GDCreateItemSend(lpObj->Index,0xEB,0,0,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_Index,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_Level,
		lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_Durability,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_Option1,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_Option2,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_Option3,
		-1,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_NewOption,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_SetOption,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_JewelOfHarmonyOption,
		lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_ItemOptionEx,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_SocketOption,lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].ItemInfo.m_SocketOptionBonus,0);
	
	this->GDReqDeleteItemFromGremoryCase(iIndex, lpMsg->dwItemGUID, lpMsg->dwAuthCode);

	lpObj->m_GremoryCaseData[iStorageType][iItemArrayIndex].Clear();

	DataSend(iIndex, (LPBYTE)&pMsg, pMsg.h.size);

	//LogAdd(LOG_BLACK,"[Gremory Case] (%s)(%s) Success to Add Item to Inventory (ItemID: %d) (ItemGUID: %d) (AuthCode: %d)",lpObj->Account, lpObj->Name,ItemID, lpMsg->dwItemGUID, lpMsg->dwAuthCode);
}

void GremoryCase(PMSG_GREMORY_CASE*lpMsg,int aIndex)
{
	LPOBJ lpObj = &gObj[aIndex];
	PMSG_GREMORY_CASE pMsg;
	pMsg.h.set(0xCD,0x06,sizeof(pMsg));
	pMsg.type = 0x03;
	DataSend(aIndex,(BYTE*)&pMsg,pMsg.h.size);
}
