#pragma once

#include "DefaultClassInfo.h"
#include "Protocol.h"
#include "SkillManager.h"
#include "User.h"

#define MAX_SKILL_TREE_RANK 9
#define MAX_SKILL_TREE_TIER 4
#define MAX_SKILL_TREE_GROUP 3
#define MIN_SKILL_TREE_LEVEL 10
#define MAX_SKILL_TREE_LEVEL 20
#define MAX_CHARACTER_MASTER_LEVEL 600

enum eMasterSkillNumber
{
	MASTER_SKILL_ADD_ITEM_DURABILITY_RATE1 = 300,
	MASTER_SKILL_ADD_DEFENSE_SUCCESS_RATE_PVP1 = 301,
	MASTER_SKILL_ADD_MAX_SD1 = 302,
	MASTER_SKILL_ADD_MP_RECOVERY_RATE1 = 303,
	MASTER_SKILL_ADD_JEWELRY_DURABILITY_RATE1 = 305,
	MASTER_SKILL_ADD_SD_RECOVERY_RATE1 = 306,
	MASTER_SKILL_ADD_HP_RECOVERY_RATE1 = 307,
	MASTER_SKILL_ADD_DEFENSE1 = 309,
	MASTER_SKILL_ADD_BP_RECOVERY_RATE1 = 310,
	MASTER_SKILL_ADD_GUARDIAN_DURABILITY_RATE1 = 312,
	MASTER_SKILL_ADD_DEFENSE_SUCCESS_RATE1 = 313,
	MASTER_SKILL_ADD_ARMOR_SET_BONUS1 = 315,
	MASTER_SKILL_ADD_REFLECT_DAMAGE1 = 316,
	MASTER_SKILL_ADD_ENERGY1 = 317,
	MASTER_SKILL_ADD_VITALITY1 = 318,
	MASTER_SKILL_ADD_DEXTERITY1 = 319,
	MASTER_SKILL_ADD_STRENGTH1 = 320,
	MASTER_SKILL_ADD_DK_WING_DEFENSE = 322,
	MASTER_SKILL_ADD_DK_WING_DAMAGE = 324,
	MASTER_SKILL_ADD_ATTACK_SUCCESS_RATE1 = 325,
	MASTER_SKILL_ADD_CYCLONE_IMPROVED1 = 326,
	MASTER_SKILL_ADD_SLASH_IMPROVED = 327,
	MASTER_SKILL_ADD_FALLING_SLASH_IMPROVED = 328,
	MASTER_SKILL_ADD_LUNGE_IMPROVED = 329,
	MASTER_SKILL_ADD_TWISTING_SLASH_IMPROVED1 = 330,
	MASTER_SKILL_ADD_RAGEFUL_BLOW_IMPROVED = 331,	
	MASTER_SKILL_ADD_MAX_HP1 = 334,
	MASTER_SKILL_ADD_WEAPON_DAMAGE_BK = 335,
	MASTER_SKILL_ADD_DEATH_STAB_IMPROVED = 336,
	MASTER_SKILL_ADD_FROZEN_STAB_IMPROVED = 337,
	MASTER_SKILL_ADD_MAX_MP1 = 338,
	MASTER_SKILL_ADD_DEATH_STAB_ENHANCED = 339,
	MASTER_SKILL_ADD_MAX_BP1 = 341,
	MASTER_SKILL_ADD_BLOOD_STORM = 344,
	MASTER_SKILL_ADD_COMBO_DAMAGE = 345,
	MASTER_SKILL_ADD_BLOOD_STORM_IMPROVED = 346,
	MASTER_SKILL_ADD_ATTACK_SUCCESS_RATE_PVP1 = 347,
	MASTER_SKILL_ADD_TWO_HAND_SWORD_DAMAGE = 348,
	MASTER_SKILL_ADD_ONE_HAND_SWORD_DAMAGE = 349,
	MASTER_SKILL_ADD_MACE_DAMAGE = 350,
	MASTER_SKILL_ADD_SPEAR_DAMAGE = 351,
	MASTER_SKILL_ADD_TWO_HAND_SWORD_MASTERY = 352,
	MASTER_SKILL_ADD_ONE_HAND_SWORD_MASTERY = 353,
	MASTER_SKILL_ADD_MACE_MASTERY = 354,
	MASTER_SKILL_ADD_SPEAR_MASTERY = 355,
	MASTER_SKILL_ADD_GREATER_LIFE_IMPROVED = 356,
	MASTER_SKILL_ADD_MP_CONSUMPTION_RATE1 = 357,
	MASTER_SKILL_ADD_HUNT_SD1 = 358,
	MASTER_SKILL_ADD_HUNT_HP1 = 359,
	MASTER_SKILL_ADD_GREATER_LIFE_ENHANCED = 360,
	MASTER_SKILL_ADD_MIN_PHYSI_DAMAGE1 = 361,
	MASTER_SKILL_ADD_HUNT_MP1 = 362,
	MASTER_SKILL_ADD_GREATER_LIFE_MASTERED = 363,
	MASTER_SKILL_ADD_MAX_PHYSI_DAMAGE1 = 364,
	MASTER_SKILL_ADD_CRITICAL_DAMAGE_RATE1 = 366,
	MASTER_SKILL_ADD_RESTORE_MP_RATE1 = 367,
	MASTER_SKILL_ADD_RESTORE_HP_RATE1 = 368,
	MASTER_SKILL_ADD_EXCELLENT_DAMAGE_RATE1 = 369,
	MASTER_SKILL_ADD_DOUBLE_DAMAGE_RATE1 = 370,
	MASTER_SKILL_ADD_IGNORE_DEFENSE_RATE1 = 371,
	MASTER_SKILL_ADD_RESTORE_SD_RATE1 = 372,

	MASTER_SKILL_ADD_DW_WING_DEFENSE = 375,
	MASTER_SKILL_ADD_DW_WING_DAMAGE = 377,
	MASTER_SKILL_ADD_FLAME_IMPROVED1 = 378,
	MASTER_SKILL_ADD_LIGHTNING_IMPROVED1 = 379,
	MASTER_SKILL_ADD_MAGIC_CIRCLE_IMPROVED = 380,
	MASTER_SKILL_ADD_INFERNO_IMPROVED1 = 381,
	MASTER_SKILL_ADD_BLAST_IMPROVED1 = 382,
	MASTER_SKILL_ADD_MAGIC_CIRCLE_ENHANCED = 383,

	MASTER_SKILL_ADD_EVIL_SPIRIT_IMPROVED1 = 385,
	MASTER_SKILL_ADD_MAGIC_DAMAGE1 = 386,
	MASTER_SKILL_ADD_DECAY_IMPROVED = 387,
	MASTER_SKILL_ADD_HELL_FIRE_IMPROVED = 388,
	MASTER_SKILL_ADD_ICE_IMPROVED1 = 389,
	MASTER_SKILL_ADD_METEORITE_IMPROVED = 390,
	MASTER_SKILL_ADD_ICE_STORM_IMPROVED = 391,
	MASTER_SKILL_ADD_NOVA_IMPROVED = 392,

	MASTER_SKILL_ADD_ICE_STORM_ENHANCED = 393,
	MASTER_SKILL_ADD_METEORITE_ENHANCED = 394,
	MASTER_SKILL_ADD_NOVA_START_IMPROVED = 395,

	MASTER_SKILL_ADD_ONE_HAND_STAFF_DAMAGE = 397,
	MASTER_SKILL_ADD_TWO_HAND_STAFF_DAMAGE = 398,
	MASTER_SKILL_ADD_SHIELD_DEFENSE1 = 399,
	MASTER_SKILL_ADD_ONE_HAND_STAFF_MASTERY = 400,
	MASTER_SKILL_ADD_TWO_HAND_STAFF_MASTERY = 401,
	MASTER_SKILL_ADD_SHIELD_MASTERY1 = 402,	
	MASTER_SKILL_ADD_MANA_SHIELD_IMPROVED = 403,
	MASTER_SKILL_ADD_MANA_SHIELD_ENHANCED = 404,
	MASTER_SKILL_ADD_MIN_MAGIC_DAMAGE1 = 405,
	MASTER_SKILL_ADD_MANA_SHIELD_MASTERED = 406,
	MASTER_SKILL_ADD_MAX_MAGIC_DAMAGE1 = 407,

	MASTER_SKILL_ADD_FE_WING_DEFENSE = 410,
	MASTER_SKILL_ADD_FIVE_SHOT_IMPROVED = 411,
	MASTER_SKILL_ADD_FE_WING_DAMAGE = 412,
	MASTER_SKILL_ADD_HEAL_IMPROVED = 413,
	MASTER_SKILL_ADD_TRIPLE_SHOT_IMPROVED = 414,
	MASTER_SKILL_ADD_SUMMON_LIFE = 415,
	MASTER_SKILL_ADD_PENETRATION_IMPROVED = 416,
	MASTER_SKILL_ADD_GREATER_DEFENSE_IMPROVED = 417,
	MASTER_SKILL_ADD_TRIPLE_SHOT_ENHANCED = 418,
	MASTER_SKILL_ADD_SUMMON_DEFENSE = 419,
	MASTER_SKILL_ADD_GREATER_DAMAGE_IMPROVED = 420,
	MASTER_SKILL_ADD_WEAPON_DAMAGE_ELF = 421,
	MASTER_SKILL_ADD_GREATER_DAMAGE_ENHANCED = 422,
	MASTER_SKILL_ADD_GREATER_DEFENSE_ENHANCED = 423,
	MASTER_SKILL_ADD_ICE_ARROW_IMPROVED = 424,
	MASTER_SKILL_ADD_CURE = 425,
	MASTER_SKILL_ADD_PARTY_HEAL = 426,
	MASTER_SKILL_ADD_POISON_ARROW = 427,
	MASTER_SKILL_ADD_SUMMON_DAMAGE = 428,
	MASTER_SKILL_ADD_PARTY_HEAL_IMPROVED = 429,
	MASTER_SKILL_ADD_BLESS = 430,
	//MASTER_SKILL_ADD_FIVE_SHOT_ENHANCED = 431,
	MASTER_SKILL_ADD_SUMMON_SATYROS = 432,
	MASTER_SKILL_ADD_BLESS_IMPROVED = 433,
	MASTER_SKILL_ADD_POISON_ARROW_IMPROVED = 434,
	MASTER_SKILL_ADD_BOW_DAMAGE = 435,
	MASTER_SKILL_ADD_CROSS_BOW_DAMAGE = 436,
	MASTER_SKILL_ADD_SHIELD_DEFENSE2 = 437,
	MASTER_SKILL_ADD_BOW_MASTERY = 438,
	MASTER_SKILL_ADD_CROSS_BOW_MASTERY = 439,
	MASTER_SKILL_ADD_SHIELD_MASTERY2 = 440,
	MASTER_SKILL_ADD_INFINITY_ARROW_IMPROVED = 441,
	MASTER_SKILL_ADD_MIN_PHYSI_DAMAGE2 = 442,
	MASTER_SKILL_ADD_MAX_PHYSI_DAMAGE2 = 443,

	MASTER_SKILL_ADD_SU_WING_DEFENSE = 446,
	MASTER_SKILL_ADD_SU_WING_DAMAGE = 447,
	MASTER_SKILL_ADD_SAHAMUTT_IMPROVED = 448,
	MASTER_SKILL_ADD_NEIL_IMPROVED = 449,
	MASTER_SKILL_ADD_GHOST_PHANTOM_IMPROVED = 450,
	MASTER_SKILL_ADD_SAHAMUTT_ENHANCED = 451,
	MASTER_SKILL_ADD_NEIL_ENHANCED = 452,
	MASTER_SKILL_ADD_GHOST_PHANTOM_ENHANCED = 453,
	MASTER_SKILL_ADD_SLEEP_IMPROVED = 454,
	MASTER_SKILL_ADD_CHAIN_LIGHTNING_IMPROVED = 455,
	MASTER_SKILL_ADD_RED_STORM_IMPROVED = 456,
	MASTER_SKILL_ADD_MAGIC_DAMAGE2 = 457,
	MASTER_SKILL_ADD_DRAIN_LIFE_IMPROVED = 458,
	MASTER_SKILL_ADD_LESSER_DAMAGE_IMPROVED = 459,
	MASTER_SKILL_ADD_LESSER_DEFENSE_IMPROVED = 460,
	MASTER_SKILL_ADD_BLIND = 461,
	MASTER_SKILL_ADD_DRAIN_LIFE_ENHANCED = 462,
	MASTER_SKILL_ADD_BLIND_IMPROVED = 463,
	MASTER_SKILL_ADD_STICK_DAMAGE = 465,
	MASTER_SKILL_ADD_BOOK_DAMAGE = 466,
	MASTER_SKILL_ADD_STICK_MASTERY = 467,
	MASTER_SKILL_ADD_BOOK_MASTERY = 468,
	MASTER_SKILL_ADD_SWORD_POWER_IMPROVED = 469,
	MASTER_SKILL_ADD_SWORD_POWER_ENHANCED = 470,
	MASTER_SKILL_ADD_MIN_MAGIC_DAMAGE2 = 471,
	MASTER_SKILL_ADD_SWORD_POWER_MASTERED = 472,
	MASTER_SKILL_ADD_MAX_MAGIC_DAMAGE2 = 473,

	MASTER_SKILL_ADD_MG_WING_DEFENSE = 476,
	MASTER_SKILL_ADD_MG_WING_DAMAGE = 478,
	MASTER_SKILL_ADD_CYCLONE_IMPROVED2 = 479,
	MASTER_SKILL_ADD_LIGHTNING_IMPROVED2 = 480,
	MASTER_SKILL_ADD_TWISTING_SLASH_IMPROVED2 = 481,
	MASTER_SKILL_ADD_POWER_SLASH_IMPROVED = 482,
	MASTER_SKILL_ADD_FLAME_IMPROVED2 = 483,
	MASTER_SKILL_ADD_BLAST_IMPROVED2 = 484,
	MASTER_SKILL_ADD_WEAPON_DAMAGE_MG = 485,
	MASTER_SKILL_ADD_INFERNO_IMPROVED2 = 486,
	MASTER_SKILL_ADD_EVIL_SPIRIT_IMPROVED2 = 487,
	MASTER_SKILL_ADD_MAGIC_DAMAGE3 = 488,
	MASTER_SKILL_ADD_ICE_IMPROVED2 = 489,
	MASTER_SKILL_ADD_FIRE_SLASH_IMPROVED = 490,

	MASTER_SKILL_ADD_ICE_ENHANCED = 491,

	MASTER_SKILL_FLAME_STRIKE_STRENGTHENER = 492,
	MASTER_SKILL_ADD_FIRE_SLASH_ENHANCED = 493,

	MASTER_SKILL_ADD_SWORD_SLASH_ENHANCED = 494,
	MASTER_SKILL_ADD_EARTH_PRISON = 495,
	MASTER_SKILL_ADD_LIGHTNING_STORM_IMPROVED = 496,
	MASTER_SKILL_ADD_EARTH_PRISON_IMPROVED = 497,

	MASTER_SKILL_ADD_DL_WING_DEFENSE = 505,
	MASTER_SKILL_ADD_LEADERSHIP = 506,
	MASTER_SKILL_ADD_DL_WING_DAMAGE = 507,
	MASTER_SKILL_ADD_FIRE_BURST_IMPROVED = 508,
	MASTER_SKILL_ADD_FORCE_WAVE_IMPROVED = 509,
	MASTER_SKILL_ADD_DARK_HORSE_DEFENSE = 510,
	MASTER_SKILL_ADD_GREATER_CRITICAL_DAMAGE_IMPROVED = 511,
	MASTER_SKILL_ADD_EARTHQUAKE_IMPROVED = 512,
	MASTER_SKILL_ADD_WEAPON_DAMAGE4 = 513,
	MASTER_SKILL_ADD_FIRE_BURST_ENHANCED = 514,
	MASTER_SKILL_ADD_GREATER_CRITICAL_DAMAGE_ENHANCED = 515,
	MASTER_SKILL_ADD_EARTHQUAKE_ENHANCED = 516,
	MASTER_SKILL_ADD_GREATER_CRITICAL_DAMAGE_MASTERED = 517,
	MASTER_SKILL_ADD_FIRE_SCREAM_IMPROVED = 518,
	MASTER_SKILL_ADD_ELECTRIC_SPARK_IMPROVED = 519,
	MASTER_SKILL_ADD_FIRE_SCREAM_ENHANCED = 520,
	MASTER_SKILL_ADD_IRON_DEFENSE = 521,
	MASTER_SKILL_ADD_GREATER_CRITICAL_DAMAGE_EXTENDED = 522,
	MASTER_SKILL_ADD_BIRDS_IMPROVED = 523,
	MASTER_SKILL_ADD_IRON_DEFENSE_IMPROVED = 524,
	MASTER_SKILL_ADD_DARK_SPIRIT_DAMAGE = 526,
	MASTER_SKILL_ADD_SCEPTER_DAMAGE = 527,
	MASTER_SKILL_ADD_SHIELD_DEFENSE3 = 528,
	MASTER_SKILL_ADD_SCEPTER_PET_DAMAGE = 529,
	MASTER_SKILL_ADD_DARK_SPIRIT_CRITICAL_DAMAGE_RATE = 530,
	MASTER_SKILL_ADD_SCEPTER_MASTERY = 531,
	MASTER_SKILL_ADD_SHIELD_MASTERY3 = 532,
	MASTER_SKILL_ADD_DEFENSE_BY_LEADERSHIP = 533,
	MASTER_SKILL_ADD_DARK_SPIRIT_EXCELLENT_DAMAGE_RATE = 534,
	MASTER_SKILL_ADD_PET_DURABILITY_RATE = 535,
	MASTER_SKILL_ADD_DARK_SPIRIT_ATTACK_SPEED = 536,
	MASTER_SKILL_ADD_DARK_SPIRIT_DOUBLE_DAMAGE_RATE = 538,
	MASTER_SKILL_ADD_DARK_SPIRIT_IGNORE_DEFENSE_RATE = 539,

	MASTER_SKILL_ADD_RF_WING_DEFENSE = 549,
	MASTER_SKILL_ADD_RF_WING_DAMAGE = 550,
	MASTER_SKILL_KILLING_BLOW_STRENGTHENER = 551,
	MASTER_SKILL_BEAST_UPPERCUT_STRENGTHENER = 552,
	MASTER_SKILL_KILLING_BLOW_MASTERY = 554,
	MASTER_SKILL_BEAST_UPPERCUT_MASTERY = 555,

	MASTER_SKILL_ADD_WEAPON_DAMAGE_RF = 557,
	MASTER_SKILL_ADD_CHAIN_DRIVER_IMPROVED = 558,
	MASTER_SKILL_ADD_DARK_SIDE_IMPROVED = 559,
	MASTER_SKILL_ADD_DRAGON_LORE_IMPROVED = 560,


	MASTER_SKILL_ADD_DARK_SIDE_ENHANCED = 563,
	MASTER_SKILL_ADD_DRAGON_SLAYER_IMPROVED = 564,
	MASTER_SKILL_ADD_BLOOD_HOWLING = 565,
	//MASTER_SKILL_ADD_DRAGON_SLAYER_ENHANCED = 566,
	MASTER_SKILL_ADD_BLOOD_HOWLING_IMPROVED = 567,
	MASTER_SKILL_ADD_GLOVE_DAMAGE = 568,
	MASTER_SKILL_ADD_GREATER_DEFENSE_SUCCESS_RATE_IMPROVED = 569,

	MASTER_SKILL_ADD_GLOVE_MASTERY = 571,
	MASTER_SKILL_ADD_GREATER_DEFENSE_SUCCESS_RATE_ENHANCED = 572,
	MASTER_SKILL_STAMINA_INCREASE_STRENGTHENER = 573,

	MASTER_SKILL_ADD_DEFENSE_CONVERSION = 574,
	MASTER_SKILL_ADD_IGNORE_DEF_UP = 575,
	MASTER_SKILL_ADD_IGNORE_DEF_MASTERY = 577,

	MASTER_SKILL_ADD_ITEM_DURABILITY_RATE2 = 578,
	MASTER_SKILL_ADD_DEFENSE_SUCCESS_RATE_PVP2 = 579,
	MASTER_SKILL_ADD_MAX_SD2 = 580,
	MASTER_SKILL_ADD_MP_RECOVERY_RATE2 = 581,
	MASTER_SKILL_ADD_JEWELRY_DURABILITY_RATE2 = 583,
	MASTER_SKILL_ADD_SD_RECOVERY_RATE2 = 584,
	MASTER_SKILL_ADD_HP_RECOVERY_RATE2 = 585,
	//MASTER_SKILL_ADD_LIGHTNING_RESISTANCE2 = 586,
	MASTER_SKILL_ADD_DEFENSE2 = 587,
	MASTER_SKILL_ADD_BP_RECOVERY_RATE2 = 588,
	//MASTER_SKILL_ADD_ICE_RESISTANCE2 = 589,
	MASTER_SKILL_ADD_GUARDIAN_DURABILITY_RATE2 = 590,
	MASTER_SKILL_ADD_DEFENSE_SUCCESS_RATE3 = 591,
	MASTER_SKILL_ADD_ARMOR_SET_BONUS2 = 593,
	MASTER_SKILL_ADD_REFLECT_DAMAGE2 = 594,
	MASTER_SKILL_ADD_ENERGY2 = 595,
	MASTER_SKILL_ADD_VITALITY2 = 596,
	MASTER_SKILL_ADD_DEXTERITY2 = 597,
	MASTER_SKILL_ADD_STRENGTH2 = 598,
	MASTER_SKILL_ADD_ATTACK_SUCCESS_RATE2 = 599,
	MASTER_SKILL_ADD_MAX_HP2 = 600,
	MASTER_SKILL_ADD_MAX_MP2 = 601,
	MASTER_SKILL_ADD_MAX_BP2 = 602,
	MASTER_SKILL_ADD_ATTACK_SUCCESS_RATE_PVP2 = 603,
	MASTER_SKILL_ADD_MP_CONSUMPTION_RATE2 = 604,
	MASTER_SKILL_ADD_HUNT_SD2 = 605,
	MASTER_SKILL_ADD_HUNT_HP2 = 606,
	MASTER_SKILL_ADD_MIN_PHYSI_DAMAGE3 = 607,
	MASTER_SKILL_ADD_HUNT_MP2 = 608,
	MASTER_SKILL_ADD_MAX_PHYSI_DAMAGE3 = 609,
	MASTER_SKILL_ADD_CRITICAL_DAMAGE_RATE2 = 610,
	MASTER_SKILL_ADD_RESTORE_MP_RATE2 = 611,
	MASTER_SKILL_ADD_RESTORE_HP_RATE2 = 612,
	MASTER_SKILL_ADD_EXCELLENT_DAMAGE_RATE2 = 613,
	MASTER_SKILL_ADD_DOUBLE_DAMAGE_RATE2 = 614,
	MASTER_SKILL_ADD_IGNORE_DEFENSE_RATE2 = 615,
	MASTER_SKILL_ADD_RESTORE_SD_RATE2 = 616,

	//MASTER_SKILL_ADD_TRIPLE_DAMAGE_RATE = 617,

	MASTER_SKILL_ADD_DK_PROTECTION_SHIELD = 623,
	MASTER_SKILL_ADD_DK_WEAPON_BLOCK = 624,
	MASTER_SKILL_ADD_DK_SHIELD_BLOCK = 625,
	MASTER_SKILL_ADD_DK_STEEL_ARMOR = 626,
	MASTER_SKILL_ADD_DK_STRONGG_MIND = 627,
	MASTER_SKILL_ADD_DK_ABSORB_LIFE = 628,
	MASTER_SKILL_ADD_DK_ABSORB_SHIELD = 629,
	MASTER_SKILL_ADD_DK_BATTLE_MIND = 630,
	MASTER_SKILL_ADD_DK_RUSH = 631,
	MASTER_SKILL_ADD_DK_IRON_DEFENSE = 632,
	MASTER_SKILL_ADD_DK_IRON_DEFENSE_POW_IP = 633,

	MASTER_SKILL_ADD_DW_PROTECTION_SHIELD = 634,
	MASTER_SKILL_ADD_DW_WEAPON_BLOCK = 635,
	MASTER_SKILL_ADD_DW_SHIELD_BLOCK = 636,
	MASTER_SKILL_ADD_DW_STEEL_ARMOR = 637,
	MASTER_SKILL_ADD_DW_STRONGG_MIND = 638,
	MASTER_SKILL_ADD_DW_ABSORB_LIFE = 639,
	MASTER_SKILL_ADD_DW_ABSORB_SHIELD = 640,
	MASTER_SKILL_ADD_DW_GRAND_MAGIC_POW_UP = 641,

	MASTER_SKILL_ADD_DW_ILLUSION = 642,//OK
	MASTER_SKILL_ADD_FE_PROTECTION_SHIELD = 643,

	MASTER_SKILL_ADD_FE_WEAPON_BLOCK = 644,
	MASTER_SKILL_ADD_FE_SHIELD_BLOCK = 645,

	MASTER_SKILL_ADD_FE_STEEL_ARMOR = 646,

	MASTER_SKILL_ADD_FE_STRONGG_MIND = 647,
	MASTER_SKILL_ADD_FE_ABSORB_LIFE = 648,
	MASTER_SKILL_ADD_FE_ABSORB_SHIELD = 649,
	MASTER_SKILL_ADD_FE_MARKSMAN = 650,

	MASTER_SKILL_ADD_FE_SHADOW_STEP = 651, //ok
	MASTER_SKILL_ADD_FE_EVASION = 652, //ok

	MASTER_SKILL_ADD_SU_PROTECTION_SHIELD = 653,
	MASTER_SKILL_ADD_SU_WEAPON_BLOCK = 654,
	MASTER_SKILL_ADD_SU_SHIELD_BLOCK = 655,
	MASTER_SKILL_ADD_SU_STEEL_ARMOR = 656,
	MASTER_SKILL_ADD_SU_STRONGG_MIND = 657,
	MASTER_SKILL_ADD_SU_ABSORB_LIFE = 658,
	MASTER_SKILL_ADD_SU_ABSORB_SHIELD = 659,
	MASTER_SKILL_ADD_SU_PAIN_OF_CURSE = 660,
	MASTER_SKILL_ADD_SU_PARALYZE = 661,
	MASTER_SKILL_ADD_SU_PARALYZE_POW_UP = 662,

	MASTER_SKILL_ADD_MG_PROTECTION_SHIELD = 663,
	MASTER_SKILL_ADD_MG_WEAPON_BLOCK = 664,
	MASTER_SKILL_ADD_MG_SHIELD_BLOCK = 665,
	MASTER_SKILL_ADD_MG_STEEL_ARMOR = 666,

	MASTER_SKILL_ADD_MG_STRONGG_MIND = 667,

	MASTER_SKILL_ADD_MG_ABSORB_LIFE = 668,
	MASTER_SKILL_ADD_MG_ABSORB_SHIELD = 669,

	MASTER_SKILL_ADD_DL_PROTECTION_SHIELD = 670,
	MASTER_SKILL_ADD_DL_WEAPON_BLOCK = 671,
	MASTER_SKILL_ADD_DL_SHIELD_BLOCK = 672,
	MASTER_SKILL_ADD_DL_STEEL_ARMOR = 673,
	MASTER_SKILL_ADD_DL_STRONGG_MIND = 674,
	MASTER_SKILL_ADD_DL_ABSORB_LIFE = 675,
	MASTER_SKILL_ADD_DL_ABSORB_SHIELD = 676,

	MASTER_SKILL_ADD_RF_WEAPON_BLOCK = 678,
	MASTER_SKILL_ADD_RF_SHIELD_BLOCK = 679,

	MASTER_SKILL_ADD_RF_STEEL_ARMOR = 680,

	MASTER_SKILL_ADD_RF_STRONGG_MIND = 681,

	MASTER_SKILL_ADD_RF_ABSORB_LIFE = 682,
	MASTER_SKILL_ADD_RF_ABSORB_SHIELD = 683,

	MASTER_SKILL_ADD_FK_WING_DEFENSE = 685,
	MASTER_SKILL_ADD_FK_WING_DAMAGE = 686,
	MASTER_SKILL_ADD_FK_SPIN_STEP_POW_UP = 687,
	MASTER_SKILL_ADD_FK_HARSH_STRIKE_POW_UP = 688,
	MASTER_SKILL_ADD_FK_WEAPON_MASTERY = 689,
	MASTER_SKILL_ADD_GL_SPIN_SETP_MASTERY = 690,
	MASTER_SKILL_ADD_FK_HARSH_STRIKE_MASTERY = 691,
	MASTER_SKILL_ADD_FK_MAGIC_PIN_POW_UP = 692,
	MASTER_SKILL_ADD_FK_OBSIDIAN_POW_UP = 693,

	//MASTER_SKILL_ADD_FK_MAGIC_PIN_PROFICIENCY = 694,

	MASTER_SKILL_ADD_FK_MAGIC_PIN_MASTERY = 695,
	MASTER_SKILL_ADD_FK_BRECHE_POW_UP = 696,

	//MASTER_SKILL_ADD_FK_BRECHE_PROFICIENCY = 697,

	MASTER_SKILL_ADD_FK_BRECHE_MASTERY = 698,
	MASTER_SKILL_ADD_FK_SHINING_PEAK_POW_UP = 699,
	MASTER_SKILL_ADD_FK_BURST = 700,

	MASTER_SKILL_ADD_FK_BURST_POW_UP = 701,
	MASTER_SKILL_ADD_FK_LANCE_POW_UP = 702,
	MASTER_SKILL_ADD_GL_CIRCLE_SHIELD_POW_UP = 703,
	MASTER_SKILL_ADD_FK_SHIELD_POW_UP = 704,
	MASTER_SKILL_ADD_FK_LANCE_MASTERY = 705,
	MASTER_SKILL_ADD_GL_CIRCLE_SHIELD_MASTERY = 706,
	MASTER_SKILL_ADD_FK_SHIELD_MASTERY = 707,
	MASTER_SKILL_ADD_FK_WRATH_POW_UP = 708,
	MASTER_SKILL_ADD_FK_WRATH_PROFICIENCY = 709,
	MASTER_SKILL_ADD_FK_WRATH_MASTERY = 710,
	MASTER_SKILL_ADD_FK_INCREASES_RETALIATION_DMG = 711,
	MASTER_SKILL_ADD_FK_INCREASES_RAGE_DMG = 712,


	MASTER_SKILL_ADD_FK_PROTECTION_SHIELD = 713,

	MASTER_SKILL_ADD_FK_WEAPON_BLOCK = 714,

	MASTER_SKILL_ADD_FK_SHIELD_BLOCK = 715,
	MASTER_SKILL_ADD_FK_STEEL_ARMOR = 716,

	MASTER_SKILL_ADD_FK_STRONGG_MIND = 717,
	MASTER_SKILL_ADD_FK_ABSORB_LIFE = 718,
	MASTER_SKILL_ADD_FK_ABSORB_SHIELD = 719,

	MASTER_SKILL_ADD_MAX_HP3 = 743,

	MASTER_SKILL_ENHANCE_PHOENIX_SHOT = 744,
	MASTER_SKILL_PHOENIX_SHOT_MASTERY = 745,
};

//**********************************************//
//************ Client -> GameServer ************//
//**********************************************//

struct PMSG_MASTER_SKILL_RECV
{
	PSBMSG_HEAD header; // C1:F3:52
	WORD MasterSkill;
	WORD MasterEmpty;
};

//**********************************************//
//************ GameServer -> Client ************//
//**********************************************//

struct PMSG_MASTER_INFO_SEND
{
	PSBMSG_HEAD header; // C1:F3:50
	WORD MasterLevel;
	BYTE Experience[8];
	BYTE NextExperience[8];
	WORD MasterPoint;
	WORD MaxLife;
	WORD MaxMana;
	WORD MaxShield;
	WORD MaxBP;
	DWORD ViewMaxHP;
	DWORD ViewMaxMP;
	DWORD ViewMaxBP;
	DWORD ViewMaxSD;
};

struct PMSG_MASTER_LEVEL_UP_SEND
{
	PSBMSG_HEAD header; // C1:F3:51
	WORD MasterLevel;
	WORD MinMasterLevel;
	WORD MasterPoint;
	WORD MaxMasterLevel;
	WORD MaxLife;
	WORD MaxMana;
	WORD MaxShield;
	WORD MaxBP;

	WORD Level;
	DWORD ViewMaxHP;
	DWORD ViewMaxMP;
	DWORD ViewMaxBP;
	DWORD ViewMaxSD;
	QWORD ViewMasterExperience;
	QWORD ViewMasterNextExperience;
};

struct PMSG_MASTER_SKILL_SEND
{
	PSBMSG_HEAD header; // C1:F3:52
	BYTE type;
	WORD MasterPoint;
};

struct PMSG_MASTER_SKILL_LIST_SEND
{
	PSWMSG_HEAD header; // C1:F3:53
	DWORD count;
};

struct PMSG_MASTER_SKILL_LIST
{
	BYTE skill;
	BYTE level;
	float MainValue;
	float NextValue;
#if(GAMESERVER_UPDATE>=902)//2017/02/28
	BYTE unk;
#endif
};

//**********************************************//
//********** DataServer -> GameServer **********//
//**********************************************//

struct SDHP_MASTER_SKILL_TREE_RECV
{
	PSWMSG_HEAD header; // C2:0D:00
	WORD index;
	char account[11];
	char name[11];
	DWORD MasterLevel;
	DWORD MasterPoint;
	QWORD MasterExperience;
	BYTE MasterSkill[MAX_MASTER_SKILL_LIST][3];
};

//**********************************************//
//********** GameServer -> DataServer **********//
//**********************************************//

struct SDHP_MASTER_SKILL_TREE_SEND
{
	PSBMSG_HEAD header; // C1:0D:00
	WORD index;
	char account[11];
	char name[11];
};

struct SDHP_MASTER_SKILL_TREE_SAVE_SEND
{
	PSWMSG_HEAD header; // C2:0D:30
	WORD index;
	char account[11];
	char name[11];
	DWORD MasterLevel;
	DWORD MasterPoint;
	QWORD MasterExperience;
	BYTE MasterSkill[MAX_MASTER_SKILL_LIST][3];
};

//**********************************************//
//**********************************************//
//**********************************************//

struct MASTER_SKILL_TREE_INFO
{
	int Index;
	int Group;
	int Rank;
	int MinLevel;
	int MaxLevel;
	flt MainValue[MAX_SKILL_TREE_LEVEL];
	int RelatedSkill;
	int ReplaceSkill;
	int RequireSkill[2];
	int RequireClass[MAX_CLASS];
};
struct PMSG_ANS_MASTERLEVELSKILLTREE
{
	PSBMSG_HEAD	h;
	BYTE btResult;			// 4
	WORD wMasterLevelPoint;		// 6
	BYTE btMasterSkillUIIndex;	// 8
	int dwMasterSkillIndex;		// C
	int dwMasterSkillLevel;			// 10
	float fMasterSkillCurValue;			// 14
	float fMasterSkillNextValue;		// 18
};
class CMasterSkillTree
{
public:
	CMasterSkillTree();
	virtual ~CMasterSkillTree();
	void Load(char* path);
	bool GetInfo(int index,MASTER_SKILL_TREE_INFO* lpInfo);
	int GetMasterSkillRelated(int index);
	flt GetMasterSkillValue(int index,int level);
	int GetMasterSkillValue(LPOBJ lpObj,int index);
	int GetMasterSkillLevel(LPOBJ lpObj,int index);
	int GetMasterSkillWeapon(LPOBJ lpObj,int index);
	int GetMasterSkillDamageMin(LPOBJ lpObj,int index);
	int GetMasterSkillDamageMax(LPOBJ lpObj,int index);
	bool CheckMasterLevel(LPOBJ lpObj);
	bool CheckMasterReplaceSkill(LPOBJ lpObj,int index);
	bool CheckMasterRequireSkill(LPOBJ lpObj,int index);
	bool CheckMasterRequireGroup(LPOBJ lpObj,int group,int rank);
	void SetMasterLevelExperienceTable();
	void CalcMasterLevelNextExperience(LPOBJ lpObj);
	void CalcMasterSkillTreeOption(LPOBJ lpObj,bool flag);
	void InsertOption(LPOBJ lpObj,int index,int value,bool flag);
	bool ReplaceMasterSkill(LPOBJ lpObj,int index,int skill,int level);
	void CGMasterSkillRecv(PMSG_MASTER_SKILL_RECV* lpMsg,int aIndex);
	void GCMasterInfoSend(LPOBJ lpObj);
	void GCMasterLevelUpSend(LPOBJ lpObj);
	void GCMasterSkillSend(int aIndex,BYTE type,BYTE flag,int MasterPoint,int MasterSkill,int MasterEmpty);
	void GCMasterSkillListSend(int aIndex);
	void DGMasterSkillTreeRecv(SDHP_MASTER_SKILL_TREE_RECV* lpMsg);
	void GDMasterSkillTreeSend(int aIndex);
	void GDMasterSkillTreeSaveSend(int aIndex);
	void GetMasterSkillTreeDel(LPOBJ lpObj,int ItemIndex, int slot);
	int GetMasterSkillTreeTotalPoints(LPOBJ lpObj);
private:
	std::map<int,MASTER_SKILL_TREE_INFO> m_MasterSkillTreeInfo;
	QWORD m_MasterLevelExperienceTable[MAX_CHARACTER_MASTER_LEVEL+1];
};

extern CMasterSkillTree gMasterSkillTree;
