#pragma once

#include "DefaultClassInfo.h"
#include "Helper.h"
#include "Party.h"
#include "User.h"

class CServerInfo
{
public:
	CServerInfo();
	virtual ~CServerInfo();

	void ReadInit();
	void ReadCashShopInfo();
	void ReadChaosMixInfo();
	void ReadCharacterInfo();
	void ReadCommandInfo();
	void ReadCommonInfo();
	void ReadCustomInfo();
	void ReadEventInfo();
	void ReadEventItemBagInfo();
	void ReadHackInfo();
	void ReadItemInfo();
	void ReadMapInfo();
	void ReadMonsterInfo();
	void ReadMonsterSetBase();
	void ReadMoveInfo();
	void ReadQuestInfo();
	void ReadShopInfo();
	void ReadSkillInfo();
	void ReadUtilInfo();

	void ReloadMonsterInfo();
	void ReloadMonsterSetBase();
	void ReadStartupInfo(char* section,char* path);
	void ReadCashShopInfo(char* section,char* path);
	void ReadChaosMixInfo(char* section,char* path);
	void ReadCharacterInfo(char* section,char* path);
	void ReadCharacterElementalInfo(char* section, char* path);
	void ReadCommandConfig();
	void ReadCommonInfo(char* section,char* path);
	void ReadCustomInfo(char* section,char* path);
	void ReadEventInfo(char* section,char* path);
	void ReadHackInfo(char* section,char* path);
	void ReadSkillInfo(char* section,char* path);
public:
	char m_ServerName[32];
	long m_ServerCode;
	long m_ServerLock;
	long m_ServerPort;
	char m_ServerMutex[32];
	char m_ServerVersion[6];
	char m_ServerSerial[17];
	long m_ServerMaxUserNumber;
	char m_JoinServerAddress[16];
	long m_JoinServerPort;
	char m_DataServerAddress[16];
	long m_DataServerPort;
	char m_ConnectServerAddress[16];
	long m_ConnectServerPort;

	int m_WriteChatLog;
	int m_WriteCommandLog;
	int m_WriteTradeLog;
	int m_WriteConnectLog;
	int m_WriteHackLog;
	int m_WriteCashShopLog;
	int m_WriteChaosMixLog;
	int m_WriteItemDropLog;
	int m_WriteItemBagLog;
	int m_WriteItemUpgradeLog;
	int m_WriteStalkLog;
	int m_WriteHitQueueLog;
	int m_WriteMonsterSpawnerLog;

	int m_CheckSpeedHack;
	int m_CheckSpeedHackTolerance;
	int m_CheckLatencyHack;
	int m_CheckLatencyHackTolerance;
	int m_CheckAutoPotionHack;
	int m_CheckAutoPotionHackTolerance;
	int m_CheckAutoAntidoteHackTolerance;
	int m_CheckAutoComboHack;
	int m_CheckAutoComboHackTolerance;
	int m_MainChecksum;
	int m_MaxItemOption;
	int m_MaxIpConnection;
	int m_PersonalCodeCheck;
	int m_SetItemAcceptHarmonySwitch;
	int m_MonsterLifeRate;
	int m_MonsterHealthBarSwitch;

	int m_NonPK;
	int m_PKDownTime1;
	int m_PKDownTime2;
	int m_PKRuudDrop;
	int m_PKRuudTax;
	int m_PKItemDrop;

	int m_PartyTeleportDelay;

	int m_TradeSwitch;
	int m_PersonalShopSwitch;
	int m_OficinaSwitch;
	int m_PersonalShopMoneyCommisionRate;
	int m_PersonalShopJewelCommisionRate;
	int m_DuelSwitch;
	int m_DuelArenaAnnounceSwitch;
	int m_GuildCreateSwitch;
	int m_GuildDeleteSwitch;
	int m_GuildCreateMinLevel;
	int m_GuildInsertMaxUser1;
	int m_GuildInsertMaxUser2;
	int m_GuildAllianceMinUser;
	int m_GuildAllianceMaxCount;
	int m_GuildOwnerDestroyLimit;
	int m_GuildBattleMasterLimit;
	int m_GuildAssistentLimit;
	int m_ElfBufferMaxLevel[MAX_ACCOUNT_LEVEL];
	int m_ElfBufferMaxReset[MAX_ACCOUNT_LEVEL];
	int m_ElfBufferDamageConstA;
	int m_ElfBufferDamageConstB;
	int m_ElfBufferDefenseConstA;
	int m_ElfBufferDefenseConstB;
	int m_AddExperienceRate[MAX_ACCOUNT_LEVEL];
	int m_AddMasterExperienceRate[MAX_ACCOUNT_LEVEL];
	int m_MinMasterExperienceMonsterLevel[MAX_ACCOUNT_LEVEL];
	int m_AddEventExperienceRate[MAX_ACCOUNT_LEVEL];
	int m_AddQuestExperienceRate[MAX_ACCOUNT_LEVEL];
	int m_ItemDropTime;
	int m_ItemDropRate[MAX_ACCOUNT_LEVEL];
	int m_MoneyDropTime;
	int m_MoneyAmountDropRate[MAX_ACCOUNT_LEVEL];
	int m_WeaponDurabilityRate;
	int m_ArmorDurabilityRate;
	int m_WingDurabilityRate;
	int m_GuardianDurabilityRate;
	int m_PendantDurabilityRate;
	int m_RingDurabilityRate;
	int m_PetDurabilityRate;
	int m_MuunDurabilityRate;
	int m_TradeItemBlock;
	int m_TradeItemBlockExc;
	int m_TradeItemBlockSet;
	int m_TradeItemBlockHarmony;
	int m_TradeItemBlockSell;
	int m_MaxLevelUp;
	int m_MaxLevelUpEvent;
	int m_MaxLevelUpQuest;
	int m_MaxStatPoint[MAX_ACCOUNT_LEVEL];
	int m_LevelUpPoint[MAX_CLASS];
	int m_PlusStatPoint;
	int m_CharacterCreateSwitch;
	int m_MGCreateType;
	int m_DLCreateType;
	int m_SUCreateType;
	int m_RFCreateType;
	int m_GLCreateType;
	int m_MGCreateLevel[MAX_ACCOUNT_LEVEL];
	int m_DLCreateLevel[MAX_ACCOUNT_LEVEL];
	int m_SUCreateLevel[MAX_ACCOUNT_LEVEL];
	int m_RFCreateLevel[MAX_ACCOUNT_LEVEL];
	int m_GLCreateLevel[MAX_ACCOUNT_LEVEL];
	int m_ShieldGaugeRate;
	int m_ShieldGaugeConstA;
	int m_ShieldGaugeConstB;
	int m_ShieldGaugeAttackRate;
	int m_ShieldGaugeAttackComboMiss;
	int m_MasterSkillTree;
	int m_MasterSkillTreeMinClass;
	int m_MasterSkillTreePoint;
	int m_MasterSkillTreeMaxLevel;
	int m_PcPointSwitch;
	int m_PcPointMaxPoint;
	int m_PcPointPointDelay;
	int m_PcPointPointValue[MAX_ACCOUNT_LEVEL];
	int m_CashShopSwitch;
	int m_CashShopScriptVersion1;
	int m_CashShopScriptVersion2;
	int m_CashShopScriptVersion3;
	int m_CashShopBannerVersion1;
	int m_CashShopBannerVersion2;
	int m_CashShopBannerVersion3;
	int m_CashShopGoblinPointDelay;
	int m_CashShopGoblinPointValue[MAX_ACCOUNT_LEVEL];
	int m_GensSystemSwitch;
	int m_GensSystemGuildLock;
	int m_GensSystemPartyLock;
	int m_GensSystemInsertMinLevel;
	int m_GensSystemContributionFloodTime;
	int m_GensSystemVictimContributionDecrease;
	int m_GensSystemKillerContributionIncrease;
	int m_GensSystemVictimMinContributionDecrease;
	int m_GensSystemVictimMaxContributionDecrease;
	int m_GensSystemKillerMinContributionIncrease;
	int m_GensSystemKillerMaxContributionIncrease;
	int m_GensSystemStartRewardDay;
	int m_GensSystemFinalRewardDay;
	int m_HelperSwitch;
	int m_HelperActiveLevel;
	int m_HelperActiveDelay;
	int m_HelperActiveMoney[MAX_HELPER_STAGE];
	int m_EventInventorySwitch;
	int m_EventInventoryExpireYear;
	int m_EventInventoryExpireMonth;
	int m_EventInventoryExpireDay;
	int m_MuRummySwitch;
	int m_MuRummyRewardScore1;
	int m_MuRummyRewardScore2;
	int m_MuRummyRewardMoneyAmount;
	int m_BombHuntEventOn;
	int m_PartyReconnectTime;
	int m_PartyGeneralExperience[MAX_PARTY_USER];
	int m_PartySpecialExperience[MAX_PARTY_USER];
	int m_ApplePotionRate;
	int m_SmallLifePotionRate;
	int m_MidleLifePotionRate;
	int m_LargeLifePotionRate;
	int m_SmallManaPotionRate;
	int m_MidleManaPotionRate;
	int m_LargeManaPotionRate;
	int m_SmallShieldPotionRate;
	int m_MidleShieldPotionRate;
	int m_LargeShieldPotionRate;
	int m_SmallCompoundPotionRate1;
	int m_SmallCompoundPotionRate2;
	int m_MidleCompoundPotionRate1;
	int m_MidleCompoundPotionRate2;
	int m_LargeCompoundPotionRate1;
	int m_LargeCompoundPotionRate2;
	int m_EliteLifePotionRate;
	int m_EliteManaPotionRate;
	int m_EliteShieldPotionRate;
	int m_TransformationRing1;
	int m_TransformationRing2;
	int m_TransformationRing3;
	int m_TransformationRing4;
	int m_TransformationRing5;
	int m_TransformationRing6;
	int m_SoulSuccessRate[MAX_ACCOUNT_LEVEL];
	int m_LifeSuccessRate[MAX_ACCOUNT_LEVEL];
	int m_LifeSuccessRateLuck[MAX_ACCOUNT_LEVEL];
	int m_HarmonySuccessRate[MAX_ACCOUNT_LEVEL];
	int m_SmeltStoneSuccessRate1[MAX_ACCOUNT_LEVEL];
	int m_SmeltStoneSuccessRate2[MAX_ACCOUNT_LEVEL];
	int m_AddLuckSuccessRate1[MAX_ACCOUNT_LEVEL];
	int m_AddLuckSuccessRate2[MAX_ACCOUNT_LEVEL];
	int m_FruitAddPointMin;
	int m_FruitAddPointMax;
	int m_FruitAddPointSuccessRate[MAX_ACCOUNT_LEVEL];
	int m_FruitSubPointMin;
	int m_FruitSubPointMax;
	int m_FruitSubPointSuccessRate[MAX_ACCOUNT_LEVEL];

	int m_MysteriouStoneSetApplyRate;
	int m_MysteriouStoneBlueEyeSetApplyRate;
	int m_MysteriouStoneSilverHeartSetApplyRate;
	int m_MysteriouStoneWeaponApplyRate;
	int m_MysteriouStoneBlueEyeWeaponApplyRate;
	int m_MysteriouStoneSilverHeartWeaponApplyRate;
	int m_MysteriouStoneShieldApplyRate;
	int m_MysteriouStoneRingApplyRate;
	int m_MysteriouStonePendantApplyRate;

	int m_BloodCastleEvent;
	int m_BloodCastleMaxUser;
	int m_BloodCastleRewardParty;
	int m_BonusManagerSwitch;
	int m_CastleDeepEvent;
	int m_CastleDeepEventTime;

	int m_CastleSiegeEvent;
	int m_CastleSiegeCycleStartYear;
	int m_CastleSiegeCycleStartMonth;
	int m_CastleSiegeCycleStartDay;
	int m_CastleSiegeSpecificState;
	int m_CastleSiegeStateStartYear;
	int m_CastleSiegeStateStartMonth;
	int m_CastleSiegeStateStartDay;
	int m_CastleSiegeStateStartHour;
	int m_CastleSiegeStateStartMinute;
	int m_CastleSiegeOffensiveWeaponDamage;
	int m_CastleSiegeDefensiveWeaponDamage;
	int m_CastleSiegeDecayAccumulatedTimeValue;
	int m_CastleSiegeLowerAccumulatedTimeValue;
	int m_CastleSiegeLowerAccumulatedTimeFixed;
	int m_CastleSiegeCrownIdleTimeout;
	int m_CastleSiegeMaxMembersInTower;
	int m_CastleSiegeExtend;
	int m_CastleSiegeExtendTime;
	int m_CastleSiegeExtendCondition;
	int m_CastleSiegeTimeToRegister;
	int m_CastleSiegeWinningMode;


	int m_ChaosCastleEvent;
	int m_ChaosCastleMinUser;
	int m_ChaosCastleBlowUserRate;
	int m_CrywolfEvent;
	int m_CrywolfBenefitSwitch;
	int m_CrywolfBenefitChaosRate;
	int m_CrywolfBenefitMonsterLife;
	int m_CrywolfPenaltySwitch;
	int m_CrywolfPenaltyJewelDrop;
	int m_CrywolfPenaltyExperience;
	int m_DevilSquareEvent;
	int m_DevilSquareMaxUser;
	int m_DoubleGoerEvent;
	int m_DoubleGoerDifficultRate;

	int m_IllusionTempleEvent;
	int m_IllusionTempleMinUser;
	int m_IllusionTempleRestrictPC;
	int m_IllusionTempleMaxDailyEnter;
	int m_IllusionTempleMaxDailyWins;

	int m_ImperialGuardianEvent;
	int m_ImperialGuardianDifficultRate;
	int m_KanturuEvent;
	int m_MossMerchantEvent;
	int m_MossMerchantEventTime;
	int m_RaklionEvent;
	int m_SilvesterMaxPlayers;

	int m_GodOfDarknessMaxPlayers;
	int m_GodOfDarknessWarningTime;

	int m_NixDevilIceDelay;
	int m_NixRegenTime;
	int m_NixDieTime;
	bool m_NixRestrictPC;

	int OrdnaelEggDropRate;

	int m_ChaosDarkAngelLuckRate;
    int m_ChaosDarkAngelSet;
	int m_ChaosAngelEcxMaxRate;
	int m_ChaosAngelLuckRate;
	int m_AngelEcxAddSwitch;
	int m_AngelEcxMaxOption;
	int m_AngelSetOptionRate;
	int m_ChaosDrakAngelInheritBloodAngelEcx;
	int m_SocketItemUpRate;
	int m_SocketItemExtractSeedSphereRate;
	int m_FEAngelMixRate;
	int m_MGAngelMixRate;
	int m_MagicMazeEvent;
	int m_ChaosItemMixRate[MAX_ACCOUNT_LEVEL];
	int m_DevilSquareMixRate1[MAX_ACCOUNT_LEVEL];
	int m_DevilSquareMixRate2[MAX_ACCOUNT_LEVEL];
	int m_DevilSquareMixRate3[MAX_ACCOUNT_LEVEL];
	int m_DevilSquareMixRate4[MAX_ACCOUNT_LEVEL];
	int m_DevilSquareMixRate5[MAX_ACCOUNT_LEVEL];
	int m_DevilSquareMixRate6[MAX_ACCOUNT_LEVEL];
	int m_DevilSquareMixRate7[MAX_ACCOUNT_LEVEL];
	int m_PlusItemLevelMixRate1[MAX_ACCOUNT_LEVEL];
	int m_PlusItemLevelMixRate2[MAX_ACCOUNT_LEVEL];
	int m_PlusItemLevelMixRate3[MAX_ACCOUNT_LEVEL];
	int m_PlusItemLevelMixRate4[MAX_ACCOUNT_LEVEL];
	int m_PlusItemLevelMixRate5[MAX_ACCOUNT_LEVEL];
	int m_PlusItemLevelMixRate6[MAX_ACCOUNT_LEVEL];
	int m_DinorantMixRate[MAX_ACCOUNT_LEVEL];
	int m_FruitMixRate[MAX_ACCOUNT_LEVEL];
	int m_Wing2MixRate[MAX_ACCOUNT_LEVEL];
	int m_BloodCastleMixRate1[MAX_ACCOUNT_LEVEL];
	int m_BloodCastleMixRate2[MAX_ACCOUNT_LEVEL];
	int m_BloodCastleMixRate3[MAX_ACCOUNT_LEVEL];
	int m_BloodCastleMixRate4[MAX_ACCOUNT_LEVEL];
	int m_BloodCastleMixRate5[MAX_ACCOUNT_LEVEL];
	int m_BloodCastleMixRate6[MAX_ACCOUNT_LEVEL];
	int m_BloodCastleMixRate7[MAX_ACCOUNT_LEVEL];
	int m_BloodCastleMixRate8[MAX_ACCOUNT_LEVEL];
	int m_Wing1MixRate[MAX_ACCOUNT_LEVEL];
	int m_PetMixRate[MAX_ACCOUNT_LEVEL];
	int m_PieceOfHornMixRate[MAX_ACCOUNT_LEVEL];
	int m_BrokenHornMixRate[MAX_ACCOUNT_LEVEL];
	int m_HornOfFenrirMixRate[MAX_ACCOUNT_LEVEL];
	int m_HornOfFenrirUpgradeMixRate[MAX_ACCOUNT_LEVEL];
	int m_ShieldPotionMixRate1[MAX_ACCOUNT_LEVEL];
	int m_ShieldPotionMixRate2[MAX_ACCOUNT_LEVEL];
	int m_ShieldPotionMixRate3[MAX_ACCOUNT_LEVEL];
	int m_JewelOfHarmonyItemPurityMixRate[MAX_ACCOUNT_LEVEL];
	int m_JewelOfHarmonyItemSmeltMixRate1[MAX_ACCOUNT_LEVEL];
	int m_JewelOfHarmonyItemSmeltMixRate2[MAX_ACCOUNT_LEVEL];
	int m_JewelOfHarmonyItemRestoreMixRate[MAX_ACCOUNT_LEVEL];
	int m_Item380MixRate1[MAX_ACCOUNT_LEVEL];
	int m_Item380MixRate2[MAX_ACCOUNT_LEVEL];
	int m_IllusionTempleMixRate1[MAX_ACCOUNT_LEVEL];
	int m_IllusionTempleMixRate2[MAX_ACCOUNT_LEVEL];
	int m_IllusionTempleMixRate3[MAX_ACCOUNT_LEVEL];
	int m_IllusionTempleMixRate4[MAX_ACCOUNT_LEVEL];
	int m_IllusionTempleMixRate5[MAX_ACCOUNT_LEVEL];
	int m_IllusionTempleMixRate6[MAX_ACCOUNT_LEVEL];
	int m_FeatherOfCondorMixRate[MAX_ACCOUNT_LEVEL];
	int m_Wing3MixRate[MAX_ACCOUNT_LEVEL];
	int m_Wing4MixRate[MAX_ACCOUNT_LEVEL];
	int m_SocketItemCreateSeedMixRate[MAX_ACCOUNT_LEVEL];
	int m_SocketItemCreateSeedSphereMixRate[MAX_ACCOUNT_LEVEL];
	int m_SummonScrollMixRate1[MAX_ACCOUNT_LEVEL];
	int m_SummonScrollMixRate2[MAX_ACCOUNT_LEVEL];
	int m_SummonScrollMixRate3[MAX_ACCOUNT_LEVEL];
	int m_LuckyItemRefineMixRate1[MAX_ACCOUNT_LEVEL];
	int m_LuckyItemRefineMixRate2[MAX_ACCOUNT_LEVEL];
	int m_MonsterWingMixRate[MAX_ACCOUNT_LEVEL];
	int m_SocketWeaponMixRate[MAX_ACCOUNT_LEVEL];
	int m_PentagramMithrilMixRate[MAX_ACCOUNT_LEVEL];
	int m_PentagramElixirMixRate[MAX_ACCOUNT_LEVEL];
	int m_PentagramJewelMixRate[MAX_ACCOUNT_LEVEL];
	int m_PentagramDecompositeMixRate[MAX_ACCOUNT_LEVEL];
	int m_CriticalDamageRate;
	int m_ExcellentDamageRate;
	int m_DamageReflect;
	int m_DamageReduction;
	int m_ShieldDamageReduction;
	int m_DuelDamageRate;
	int m_GensDamageRate;
	int m_CustomArenaDamageRate;
	int m_ChaosCastleDamageRate;
	int m_IllusionTempleDamageRate;
	int m_CastleSiegeDamageRate;
	int m_MUFCDamageRate;
	int m_GeneralDamageRatePvP;
	int m_GeneralDamageRatePvM;
	int m_ReflectDamageRatePvP;
	int m_CastleSiegeReflectRatePvP;
	int m_ReflectDamageRatePvM;
	int m_DamageRatePvP[MAX_CLASS];
	int m_DamageRatePvM[MAX_CLASS];
	int m_DamageRateTo[MAX_CLASS][MAX_CLASS];
	int m_X_DamageRateTo[MAX_CLASS][MAX_CLASS];
	//int m_DamageStuckRate[MAX_CLASS];
	int m_DKDamageMultiplierConstA;
	int m_DLDamageMultiplierConstA;
	int m_RFDamageMultiplierConstA;
	int m_RFDamageMultiplierConstB;
	int m_RFDamageMultiplierConstC;
	int m_DKDamageMultiplierMaxRate;
	int m_DLDamageMultiplierMaxRate;
	int m_RFDamageMultiplierMaxRate;
	int m_DarkSpiritRangeAttackRate;
	int m_DarkSpiritCriticalDamageRate;
	int m_DarkSpiritExcellentDamageRate;
	int m_DarkSpiritAttackDamageMinConstA;
	int m_DarkSpiritAttackDamageMinConstB;
	int m_DarkSpiritAttackDamageMinConstC;
	int m_DarkSpiritAttackDamageMaxConstA;
	int m_DarkSpiritAttackDamageMaxConstB;
	int m_DarkSpiritAttackDamageMaxConstC;
	int m_DarkSpiritAttackSpeedConstA;
	int m_DarkSpiritAttackSpeedConstB;
	int m_DarkSpiritAttackSpeedConstC;
	int m_DarkSpiritAttackSpeedConstD;
	int m_DarkSpiritAttackSuccessRateConstA;
	int m_DarkSpiritAttackSuccessRateConstB;
	int m_DarkSpiritAttackSuccessRateConstC;
	int m_SatanIncDamageConstA;
	int m_DinorantIncDamageConstA;
	int m_BlackFenrirIncDamageConstA;
	int m_DemonIncDamageConstA;
	int m_SkeletonIncDamageConstA;
	int m_AngelDecDamageConstA;
	int m_DinorantDecDamageConstA;
	int m_DinorantDecDamageConstB;
	int m_DarkHorseDecDamageConstA;
	int m_DarkHorseDecDamageConstB;
	int m_BlueFenrirDecDamageConstA;
	int m_MariaDecDamageConstA;
	int m_ComboDamageConstA;
	int m_ComboDamageConstB;
	int m_EarthquakeDamageConstA;
	int m_EarthquakeDamageConstB;
	int m_EarthquakeDamageConstC;
	int m_ElectricSparkDamageConstA;
	int m_ElectricSparkDamageConstB;
	int m_DLSkillDamageConstA;
	int m_DLSkillDamageConstB;
	int m_NovaDamageConstA;
	int m_NovaDamageConstB;
	int m_NovaDamageConstC;
	int m_HPRecoveryRate[MAX_CLASS];
	int m_MPRecoveryRate[MAX_CLASS];
	int m_BPRecoveryRate[MAX_CLASS];
	int m_SDRecoveryRate[MAX_CLASS];
	int m_DWPlasmaStormDamageConstA;
	int m_DWPlasmaStormDamageConstB;
	int m_DWPlasmaStormDamageConstC;
	int m_DWPlasmaStormDamageConstD;
	int m_DKPlasmaStormDamageConstA;
	int m_DKPlasmaStormDamageConstB;
	int m_DKPlasmaStormDamageConstC;
	int m_DKPlasmaStormDamageConstD;
	int m_FEPlasmaStormDamageConstA;
	int m_FEPlasmaStormDamageConstB;
	int m_FEPlasmaStormDamageConstC;
	int m_FEPlasmaStormDamageConstD;
	int m_MGPlasmaStormDamageConstA;
	int m_MGPlasmaStormDamageConstB;
	int m_MGPlasmaStormDamageConstC;
	int m_MGPlasmaStormDamageConstD;
	int m_DLPlasmaStormDamageConstA;
	int m_DLPlasmaStormDamageConstB;
	int m_DLPlasmaStormDamageConstC;
	int m_DLPlasmaStormDamageConstD;
	int m_DLPlasmaStormDamageConstE;
	int m_SUPlasmaStormDamageConstA;
	int m_SUPlasmaStormDamageConstB;
	int m_SUPlasmaStormDamageConstC;
	int m_SUPlasmaStormDamageConstD;
	int m_RFPlasmaStormDamageConstA;
	int m_RFPlasmaStormDamageConstB;
	int m_RFPlasmaStormDamageConstC;
	int m_RFPlasmaStormDamageConstD;
	int m_DWPhysiDamageMinConstA;
	int m_DWPhysiDamageMaxConstA;
	int m_DWMagicDamageMinConstA;
	int m_DWMagicDamageMaxConstA;
	int m_DKPhysiDamageMinConstA;
	int m_DKPhysiDamageMaxConstA;
	int m_DKMagicDamageMinConstA;
	int m_DKMagicDamageMaxConstA;
	int m_FEPhysiDamageMinConstA;
	int m_FEPhysiDamageMaxConstA;
	int m_FEPhysiDamageMinBowConstA;
	int m_FEPhysiDamageMinBowConstB;
	int m_FEPhysiDamageMaxBowConstA;
	int m_FEPhysiDamageMaxBowConstB;
	int m_FEMagicDamageMinConstA;
	int m_FEMagicDamageMaxConstA;
	int m_MGPhysiDamageMinConstA;
	int m_MGPhysiDamageMinConstB;
	int m_MGPhysiDamageMaxConstA;
	int m_MGPhysiDamageMaxConstB;
	int m_MGMagicDamageMinConstA;
	int m_MGMagicDamageMaxConstA;
	int m_DLPhysiDamageMinConstA;
	int m_DLPhysiDamageMinConstB;
	int m_DLPhysiDamageMaxConstA;
	int m_DLPhysiDamageMaxConstB;
	int m_DLMagicDamageMinConstA;
	int m_DLMagicDamageMaxConstA;
	int m_SUPhysiDamageMinConstA;
	int m_SUPhysiDamageMaxConstA;
	int m_SUMagicDamageMinConstA;
	int m_SUMagicDamageMaxConstA;
	int m_RFPhysiDamageMinConstA;
	int m_RFPhysiDamageMinConstB;
	int m_RFPhysiDamageMaxConstA;
	int m_RFPhysiDamageMaxConstB;
	int m_RFMagicDamageMinConstA;
	int m_RFMagicDamageMaxConstA;
	int m_FKPlasmaStormDamageConstA;
	int m_FKPlasmaStormDamageConstB;
	int m_FKPlasmaStormDamageConstC;
	int m_FKPlasmaStormDamageConstD;

	int m_FKDamageMultiplierConstA;
	int m_FKDamageMultiplierConstB;
	int m_FKDamageMultiplierMaxRate;
	int m_FKPhysiDamageMinConstA;
	int m_FKPhysiDamageMaxConstA;
	int m_FKPhysiDamageMinConstB;
	int m_FKPhysiDamageMaxConstB;
	int m_FKMagicDamageMinConstA;
	int m_FKMagicDamageMaxConstA;

	int m_FKAttackSuccessRateConstA;
	int m_FKAttackSuccessRateConstB;
	int m_FKAttackSuccessRateConstC;
	int m_FKAttackSuccessRateConstD;

	int m_FKAttackSuccessRatePvPConstA;
	int m_FKAttackSuccessRatePvPConstB;
	int m_FKAttackSuccessRatePvPConstC;
	int m_FKAttackSuccessRatePvPConstD;

	int m_FKPhysiSpeedConstA;
	int m_FKMagicSpeedConstA;

	int m_FKDefenseSuccessRateConstA;

	int m_FKDefenseSuccessRatePvPConstA;
	int m_FKDefenseSuccessRatePvPConstB;
	int m_FKDefenseSuccessRatePvPConstC;

	int m_FKDefenseConstA;



	int m_DWAttackSuccessRateConstA;
	int m_DWAttackSuccessRateConstB;
	int m_DWAttackSuccessRateConstC;
	int m_DWAttackSuccessRateConstD;
	int m_DKAttackSuccessRateConstA;
	int m_DKAttackSuccessRateConstB;
	int m_DKAttackSuccessRateConstC;
	int m_DKAttackSuccessRateConstD;
	int m_FEAttackSuccessRateConstA;
	int m_FEAttackSuccessRateConstB;
	int m_FEAttackSuccessRateConstC;
	int m_FEAttackSuccessRateConstD;
	int m_MGAttackSuccessRateConstA;
	int m_MGAttackSuccessRateConstB;
	int m_MGAttackSuccessRateConstC;
	int m_MGAttackSuccessRateConstD;
	int m_DLAttackSuccessRateConstA;
	int m_DLAttackSuccessRateConstB;
	int m_DLAttackSuccessRateConstC;
	int m_DLAttackSuccessRateConstD;
	int m_DLAttackSuccessRateConstE;
	int m_SUAttackSuccessRateConstA;
	int m_SUAttackSuccessRateConstB;
	int m_SUAttackSuccessRateConstC;
	int m_SUAttackSuccessRateConstD;
	int m_RFAttackSuccessRateConstA;
	int m_RFAttackSuccessRateConstB;
	int m_RFAttackSuccessRateConstC;
	int m_RFAttackSuccessRateConstD;
	int m_DWAttackSuccessRatePvPConstA;
	int m_DWAttackSuccessRatePvPConstB;
	int m_DWAttackSuccessRatePvPConstC;
	int m_DWAttackSuccessRatePvPConstD;
	int m_DKAttackSuccessRatePvPConstA;
	int m_DKAttackSuccessRatePvPConstB;
	int m_DKAttackSuccessRatePvPConstC;
	int m_DKAttackSuccessRatePvPConstD;
	int m_FEAttackSuccessRatePvPConstA;
	int m_FEAttackSuccessRatePvPConstB;
	int m_FEAttackSuccessRatePvPConstC;
	int m_FEAttackSuccessRatePvPConstD;
	int m_MGAttackSuccessRatePvPConstA;
	int m_MGAttackSuccessRatePvPConstB;
	int m_MGAttackSuccessRatePvPConstC;
	int m_MGAttackSuccessRatePvPConstD;
	int m_DLAttackSuccessRatePvPConstA;
	int m_DLAttackSuccessRatePvPConstB;
	int m_DLAttackSuccessRatePvPConstC;
	int m_DLAttackSuccessRatePvPConstD;
	int m_SUAttackSuccessRatePvPConstA;
	int m_SUAttackSuccessRatePvPConstB;
	int m_SUAttackSuccessRatePvPConstC;
	int m_SUAttackSuccessRatePvPConstD;
	int m_RFAttackSuccessRatePvPConstA;
	int m_RFAttackSuccessRatePvPConstB;
	int m_RFAttackSuccessRatePvPConstC;
	int m_RFAttackSuccessRatePvPConstD;
	int m_DWPhysiSpeedConstA;
	int m_DWMagicSpeedConstA;
	int m_DKPhysiSpeedConstA;
	int m_DKMagicSpeedConstA;
	int m_FEPhysiSpeedConstA;
	int m_FEMagicSpeedConstA;
	int m_MGPhysiSpeedConstA;
	int m_MGMagicSpeedConstA;
	int m_DLPhysiSpeedConstA;
	int m_DLMagicSpeedConstA;
	int m_SUPhysiSpeedConstA;
	int m_SUMagicSpeedConstA;
	int m_RFPhysiSpeedConstA;
	int m_RFMagicSpeedConstA;
	int m_DWDefenseSuccessRateConstA;
	int m_DKDefenseSuccessRateConstA;
	int m_FEDefenseSuccessRateConstA;
	int m_MGDefenseSuccessRateConstA;
	int m_DLDefenseSuccessRateConstA;
	int m_SUDefenseSuccessRateConstA;
	int m_RFDefenseSuccessRateConstA;
	int m_DWDefenseSuccessRatePvPConstA;
	int m_DWDefenseSuccessRatePvPConstB;
	int m_DWDefenseSuccessRatePvPConstC;
	int m_DKDefenseSuccessRatePvPConstA;
	int m_DKDefenseSuccessRatePvPConstB;
	int m_DKDefenseSuccessRatePvPConstC;
	int m_FEDefenseSuccessRatePvPConstA;
	int m_FEDefenseSuccessRatePvPConstB;
	int m_FEDefenseSuccessRatePvPConstC;
	int m_MGDefenseSuccessRatePvPConstA;
	int m_MGDefenseSuccessRatePvPConstB;
	int m_MGDefenseSuccessRatePvPConstC;
	int m_DLDefenseSuccessRatePvPConstA;
	int m_DLDefenseSuccessRatePvPConstB;
	int m_DLDefenseSuccessRatePvPConstC;
	int m_SUDefenseSuccessRatePvPConstA;
	int m_SUDefenseSuccessRatePvPConstB;
	int m_SUDefenseSuccessRatePvPConstC;
	int m_RFDefenseSuccessRatePvPConstA;
	int m_RFDefenseSuccessRatePvPConstB;
	int m_RFDefenseSuccessRatePvPConstC;

	int m_ClassDefenseConst[MAX_CLASS];

	int	MASTERY_OPTION_DAMAGE_AGAINST_[MAX_CLASS];
	int	MASTERY_OPTION_DAMAGE_AGAINST_2[MAX_CLASS];
	int	MASTERY_OPTION_DAMAGE_AGAINST_3[MAX_CLASS];
	int MASTERY_OPTION_DAMAGE_AGAINST_MAX;
	int	MASTERY_OPTION_INCREASE_BOSS_DAMAGE;
	int	MASTERY_OPTION_INCREASE_BOSS_DAMAGE2;
	int	MASTERY_OPTION_INCREASE_BOSS_DAMAGE3;
	int	MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE;
	int	MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE2;
	int	MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE3;

	int	MASTERY_BONUS_TRIPLE_DAMAGE_RATE;
	int	MASTERY_BONUS_FINAL_DAMAGE;
	int	MASTERY_BONUS_ULTRAHIT_50;
	int	MASTERY_BONUS_DOUBLE_DAMAGE_BOSS;

	int	MASTERY_BONUS_TRIPLE_DAMAGE_RATE2;
	int	MASTERY_BONUS_FINAL_DAMAGE2;
	int	MASTERY_BONUS_ULTRAHIT_502;
	int	MASTERY_BONUS_DOUBLE_DAMAGE_BOSS2;
	//Shield
	int MASTERY_OPTION_PVP_DAMAGE_REDUCTION;
	int MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION;
	int MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION;
	int MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION;
	int MASTERY_OPTION_TRUE_DAMAGE_PROTECTION;
	int MASTERY_OPTION_ULTRAHIT_PROTECTION;
	//Shield Blue Eye
	int MASTERY_OPTION_PVP_DAMAGE_REDUCTION_2;
	int MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION_2;
	int MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION_2;
	int MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION_2;
	int MASTERY_OPTION_TRUE_DAMAGE_PROTECTION_2;
	int MASTERY_OPTION_ULTRAHIT_PROTECTION_2;
	//Shield Silver Heart
	int MASTERY_OPTION_PVP_DAMAGE_REDUCTION_3;
	int MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION_3;
	int MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION_3;
	int MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION_3;
	int MASTERY_OPTION_TRUE_DAMAGE_PROTECTION_3;
	int MASTERY_OPTION_ULTRAHIT_PROTECTION_3;
	//Shield Bonus
	int MASTERY_BONUS_HP_DAMAGE_PROTECTION;
	int MASTERY_BONUS_REFLECT_INCREASE;
	int MASTERY_BONUS_BOSS_POWER_PROTECTION;
	//Shield Blue Eye Bonus
	int MASTERY_BONUS_HP_DAMAGE_PROTECTION_2;
	int MASTERY_BONUS_REFLECT_INCREASE_2;
	int MASTERY_BONUS_BOSS_POWER_PROTECTION_2;
	//Shield Silver Heart Bonus
	int MASTERY_BONUS_HP_DAMAGE_PROTECTION_3;
	int MASTERY_BONUS_REFLECT_INCREASE_3;
	int MASTERY_BONUS_BOSS_POWER_PROTECTION_3;
	//Armas
	int MASTERY_OPTION_BOSS_DECREASE_DELAY;
	int MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON;
	int MASTERY_OPTION_BOSS_DAMAGE_INCREASE;
	int MASTERY_OPTION_PVP_DAMAGE_INCREASE;
	int MASTERY_OPTION_DOUBLE_DAMAGE_RATE;
	int MASTERY_OPTION_TRIPLE_DAMAGE_RATE;
	int MASTERY_OPTION_TRUE_DAMAGE_RATE;
	int MASTERY_OPTION_30P_HP_ULTRAHIT;
	//Armas Blue Eye
	int MASTERY_OPTION_BOSS_DECREASE_DELAY_2;
	int MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON_2;
	int MASTERY_OPTION_BOSS_DAMAGE_INCREASE_2;
	int MASTERY_OPTION_PVP_DAMAGE_INCREASE_2;
	int MASTERY_OPTION_DOUBLE_DAMAGE_RATE_2;
	int MASTERY_OPTION_TRIPLE_DAMAGE_RATE_2;
	int MASTERY_OPTION_TRUE_DAMAGE_RATE_2;
	int MASTERY_OPTION_30P_HP_ULTRAHIT_2;
	//Armas Silver Heart
	int MASTERY_OPTION_BOSS_DECREASE_DELAY_3;
	int MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON_3;
	int MASTERY_OPTION_BOSS_DAMAGE_INCREASE_3;
	int MASTERY_OPTION_PVP_DAMAGE_INCREASE_3;
	int MASTERY_OPTION_DOUBLE_DAMAGE_RATE_3;
	int MASTERY_OPTION_TRIPLE_DAMAGE_RATE_3;
	int MASTERY_OPTION_TRUE_DAMAGE_RATE_3;
	int MASTERY_OPTION_30P_HP_ULTRAHIT_3;

	int MASTERY_BONUS_ULTRAHIT_50_WEAPON;
	int MASTERY_BONUS_REFLECT_DECREASE;
	int MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON;
	int MASTERY_BONUS_BLEEDING;
	int MASTERY_BONUS_STERN_RATE;
	int MASTERY_BONUS_CURE_HARM;
	int MASTERY_BONUS_CURE_HARM_FACTOR;
	
	int MASTERY_BONUS_ULTRAHIT_50_WEAPON_2;
	int MASTERY_BONUS_REFLECT_DECREASE_2;
	int MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON_2;
	int MASTERY_BONUS_BLEEDING_2;
	int MASTERY_BONUS_STERN_RATE_2;
	int MASTERY_BONUS_CURE_HARM_2;
	int MASTERY_BONUS_FREEZING_DAMAGE;

	int MASTERY_BONUS_ULTRAHIT_50_WEAPON_3;
	int MASTERY_BONUS_REFLECT_DECREASE_3;
	int MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON_3;
	int MASTERY_BONUS_BLEEDING_3;
	int MASTERY_BONUS_STERN_RATE_3;
	int MASTERY_BONUS_CURE_HARM_3;
	int MASTERY_BONUS_FREEZING_DAMAGE_2;
	int MASTERY_BONUS_FIREING_DAMAGE;

	//Pendants
	int MASTERY_BONUS_PENDANT_CURE_HARM;
	int MASTERY_BONUS_PENDANT_STERN;
	int MASTERY_BONUS_PENDANT_BLEEDING;
	int MASTERY_BONUS_PENDANT_SHIELD_SKILL_IGNORE;
	int MASTERY_BONUS_PENDANT_ULTRAHIT_50;
	int MASTERY_BONUS_PENDANT_FREEZING;
	
	int MASTERY_OPTION_PENDANT_PVP_DMG;
	int MASTERY_OPTION_PENDANT_TRIPLE_DMG;
	int MASTERY_OPTION_PENDANT_TRUE_DMG;
	int MASTERY_OPTION_PENDANT_DOUBLE_DMG;
	int MASTERY_OPTION_PENDANT_BOSS_DMG;
	int MASTERY_OPTION_PENDANT_BOSS_DECREASE_DELAY;
	int MASTERY_OPTION_PENDANT_ELEMENTAL_DAMAGE_INCREASE;
	int MASTERY_OPTION_PENDANT_BACKSPRING_INCREASE;

	int MASTERY_OPTION_RING_BACKSPRING_PROTECTION;
	int MASTERY_OPTION_RING_DROP_BOSS_INC;
	int MASTERY_OPTION_RING_MAX_HP_INC;
	int MASTERY_OPTION_RING_BLOCK_CHANCE_INC;
	int MASTERY_OPTION_RING_BOSS_SKILL_PROTECTION;
	int MASTERY_OPTION_RING_ELEMENTAL_DMG_REDUCE;
	int MASTERY_OPTION_RING_PVP_DAMAGE_REDUCE;
	int MASTERY_OPTION_RING_BOSS_DAMAGE_REDUCE;
	int MASTERY_OPTION_RING_TRIPLE_DMG_PROTECTION;
	int MASTERY_OPTION_RING_TRUE_DMG_PROTECTION;
	int MASTERY_OPTION_RING_ULTRAHIT_PROTECTION;

	int MASTERY_BONUS_RING_STERN_RESIST;
	int MASTERY_BONUS_RING_BLEEDING_RESIST;
	int MASTERY_BONUS_RING_CURE_HARM_RESIST;
	int MASTERY_BONUS_RING_CURE_IMPROVE;
	int MASTERY_BONUS_RING_FULL_REFLECT_INC;
	int MASTERY_BONUS_RING_MASTERY_REVERT;
	int MASTERY_BONUS_RING_FREEZING_DAMAGE_RESIST;
	int MASTERY_BONUS_RING_FIREING_DAMAGE_RESIST;

	int m_DuelElementalDamageRate;
	int m_GensElementalDamageRate;
	int m_CustomArenaElementalDamageRate;
	int m_ChaosCastleElementalDamageRate;
	int m_IllusionTempleElementalDamageRate;
	int m_CastleSiegeElementalDamageRate;
	int m_GeneralElementalDamageRatePvP;
	int m_GeneralElementalDamageRatePvM;
	int m_ElementalDamageRatePvP[MAX_CLASS];
	int m_ElementalDamageRatePvM[MAX_CLASS];
	int m_ElementalDamageRateTo[MAX_CLASS][MAX_CLASS];

	int m_FKElementalDefenseConstA;
	int m_FKElementalDamageMinConstA;
	int m_FKElementalDamageMaxConstA;
	int m_FKElementalAttackSuccessRateConstA;
	int m_FKElementalAttackSuccessRateConstB;
	int m_FKElementalAttackSuccessRateConstC;
	int m_FKElementalAttackSuccessRateConstD;
	int m_FKElementalDefenseSuccessRateConstA;
	int m_ObsidianConst;
	int m_ObsidianTimeConst;
	int m_ObsidianMax;
	int m_WrathCutDefConst;
	int m_WrathConst;
	int m_WrathTimeConst;

	int m_ArchangelWillCount;
	int m_ArchangelWillValue;
	int DarkPhoenixShotDexDivisor;
	int	DarkPhoenixShotDexSum;

	int m_DWElementalDefenseConstA;
	int m_DKElementalDefenseConstA;
	int m_FEElementalDefenseConstA;
	int m_MGElementalDefenseConstA;
	int m_DLElementalDefenseConstA;
	int m_SUElementalDefenseConstA;
	int m_RFElementalDefenseConstA;
	int m_DWElementalDamageMinConstA;
	int m_DWElementalDamageMaxConstA;
	int m_DKElementalDamageMinConstA;
	int m_DKElementalDamageMaxConstA;
	int m_FEElementalDamageMinConstA;
	int m_FEElementalDamageMinConstB;
	int m_FEElementalDamageMaxConstA;
	int m_FEElementalDamageMaxConstB;
	int m_MGElementalDamageMinConstA;
	int m_MGElementalDamageMinConstB;
	int m_MGElementalDamageMaxConstA;
	int m_MGElementalDamageMaxConstB;
	int m_DLElementalDamageMinConstA;
	int m_DLElementalDamageMinConstB;
	int m_DLElementalDamageMaxConstA;
	int m_DLElementalDamageMaxConstB;
	int m_SUElementalDamageMinConstA;
	int m_SUElementalDamageMaxConstA;
	int m_RFElementalDamageMinConstA;
	int m_RFElementalDamageMinConstB;
	int m_RFElementalDamageMaxConstA;
	int m_RFElementalDamageMaxConstB;
	int m_DWElementalAttackSuccessRateConstA;
	int m_DWElementalAttackSuccessRateConstB;
	int m_DWElementalAttackSuccessRateConstC;
	int m_DWElementalAttackSuccessRateConstD;
	int m_DKElementalAttackSuccessRateConstA;
	int m_DKElementalAttackSuccessRateConstB;
	int m_DKElementalAttackSuccessRateConstC;
	int m_DKElementalAttackSuccessRateConstD;
	int m_FEElementalAttackSuccessRateConstA;
	int m_FEElementalAttackSuccessRateConstB;
	int m_FEElementalAttackSuccessRateConstC;
	int m_FEElementalAttackSuccessRateConstD;
	int m_MGElementalAttackSuccessRateConstA;
	int m_MGElementalAttackSuccessRateConstB;
	int m_MGElementalAttackSuccessRateConstC;
	int m_MGElementalAttackSuccessRateConstD;
	int m_DLElementalAttackSuccessRateConstA;
	int m_DLElementalAttackSuccessRateConstB;
	int m_DLElementalAttackSuccessRateConstC;
	int m_DLElementalAttackSuccessRateConstD;
	int m_SUElementalAttackSuccessRateConstA;
	int m_SUElementalAttackSuccessRateConstB;
	int m_SUElementalAttackSuccessRateConstC;
	int m_SUElementalAttackSuccessRateConstD;
	int m_RFElementalAttackSuccessRateConstA;
	int m_RFElementalAttackSuccessRateConstB;
	int m_RFElementalAttackSuccessRateConstC;
	int m_RFElementalAttackSuccessRateConstD;
	int m_DWElementalDefenseSuccessRateConstA;
	int m_DKElementalDefenseSuccessRateConstA;
	int m_FEElementalDefenseSuccessRateConstA;
	int m_MGElementalDefenseSuccessRateConstA;
	int m_DLElementalDefenseSuccessRateConstA;
	int m_SUElementalDefenseSuccessRateConstA;
	int m_RFElementalDefenseSuccessRateConstA;

	int m_CommandPostEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandPostLevel[MAX_ACCOUNT_LEVEL];
	int m_CommandPostReset[MAX_ACCOUNT_LEVEL];
	int m_CommandPostMoney[MAX_ACCOUNT_LEVEL];
	int m_CommandPostDelay[MAX_ACCOUNT_LEVEL];
	int m_CommandPostGlobal[MAX_ACCOUNT_LEVEL];
	int m_CommandPostType[MAX_ACCOUNT_LEVEL];

	int m_CommandAddPointEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandAddPointAutoEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandAddPointMoney[MAX_ACCOUNT_LEVEL];

	int m_CommandPKClearEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandPKClearMoney[MAX_ACCOUNT_LEVEL];
	int m_CommandPKClearGoblinPoint[MAX_ACCOUNT_LEVEL];
	int m_CommandPKClearWCoinP[MAX_ACCOUNT_LEVEL];
	int m_CommandPKClearWCoinC[MAX_ACCOUNT_LEVEL];

	int m_CommandChangeEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandChangeMoney[MAX_ACCOUNT_LEVEL];
	int m_CommandChangeGP[MAX_ACCOUNT_LEVEL];
	int m_CommandChangeWP[MAX_ACCOUNT_LEVEL];
	int m_CommandChangeWC[MAX_ACCOUNT_LEVEL];
	int m_CommandChangeLimit[MAX_ACCOUNT_LEVEL];

	int m_CommandWareEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandWareNumber[MAX_ACCOUNT_LEVEL];

	int m_CommandResetType;
	int m_CommandResetEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandResetAutoEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandResetCheckItem[MAX_ACCOUNT_LEVEL];
	int m_CommandResetMove[MAX_ACCOUNT_LEVEL];
	int m_CommandResetQuest[MAX_ACCOUNT_LEVEL];
	int m_CommandResetSkill[MAX_ACCOUNT_LEVEL];
	int m_CommandResetLevel[MAX_ACCOUNT_LEVEL];
	int m_CommandResetMoney[MAX_ACCOUNT_LEVEL];
	int m_CommandResetCount[MAX_ACCOUNT_LEVEL];
	int m_CommandResetLimit[MAX_ACCOUNT_LEVEL];
	int m_CommandResetLimitDay[MAX_ACCOUNT_LEVEL];
	int m_CommandResetLimitWek[MAX_ACCOUNT_LEVEL];
	int m_CommandResetLimitMon[MAX_ACCOUNT_LEVEL];
	int m_CommandResetStartLevel[MAX_ACCOUNT_LEVEL];
	int m_CommandResetStartMasterLevel[MAX_ACCOUNT_LEVEL];
	int m_CommandResetPoint[MAX_ACCOUNT_LEVEL];
	int m_CommandResetPointRate[MAX_CLASS];

	int m_CommandMasterResetType;
	int m_CommandMasterResetEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetCheckItem[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetMove[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetQuest[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetSkill[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetLevel[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetReset[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetMoney[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetCount[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetLimit[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetLimitDay[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetLimitWek[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetLimitMon[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetStartLevel[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetStartReset[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetPoint[MAX_ACCOUNT_LEVEL];
	int m_CommandMasterResetPointRate[MAX_CLASS];
	int m_CommandMasterResetRuudBonus[MAX_ACCOUNT_LEVEL];

	int m_CommandRebuildEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandRebuildMoney[MAX_ACCOUNT_LEVEL];
	int m_CommandRebuildGP[MAX_ACCOUNT_LEVEL];
	int m_CommandRebuildWP[MAX_ACCOUNT_LEVEL];
	int m_CommandRebuildWC[MAX_ACCOUNT_LEVEL];

	int m_CommandClearInventoryEnable[MAX_ACCOUNT_LEVEL];

	char m_CommandCoinSyntaxZen[8];
	int m_CommandCoinLevelZen;
	char m_CommandCoinSyntaxGP[8];
	int m_CommandCoinLevelGP;
	char m_CommandCoinSyntaxWP[8];
	int m_CommandCoinLevelWP;
	char m_CommandCoinSyntaxWC[8];
	int m_CommandCoinLevelWC;
	char m_CommandCoinSyntaxRuud[8];
	int m_CommandCoinLevelRuud;
	int m_CommandRemoveWingOptionRuud;

	int m_CommandFillPotionEnable[MAX_ACCOUNT_LEVEL];
	int m_CommandFillPotionMoney[MAX_ACCOUNT_LEVEL];
	int m_CommandFillPotionGP[MAX_ACCOUNT_LEVEL];
	int m_CommandFillPotionWP[MAX_ACCOUNT_LEVEL];
	int m_CommandFillPotionWC[MAX_ACCOUNT_LEVEL];
	int m_CommandFillPotionMaxAmount[MAX_ACCOUNT_LEVEL];

	




	int m_ManaShieldConstA;
	int m_ManaShieldConstB;
	int m_ManaShieldConstC;
	int m_ManaShieldRate[MAX_CLASS];
	int m_ManaShieldTimeConstA;
	int m_ManaShieldTimeConstB;
	int m_ManaShieldMaxRate;
	int m_DefenseConstA;
	int m_DefenseTimeConstA;
	int m_HealConstA;
	int m_HealConstB;
	int m_GreaterDefenseConstA;
	int m_GreaterDefenseConstB;
	int m_GreaterDefenseRate[MAX_CLASS];
	int m_GreaterDefenseTimeConstA;
	int m_GreaterDefenseMax;
	int m_GreaterDamageConstA;
	int m_GreaterDamageConstB;
	int m_GreaterDamageRate[MAX_CLASS];
	int m_GreaterDamageTimeConstA;
	int m_GreaterDamageMax;
	int m_SummonMonster1;
	int m_SummonMonster2;
	int m_SummonMonster3;
	int m_SummonMonster4;
	int m_SummonMonster5;
	int m_SummonMonster6;
	int m_SummonMonster7;
	int m_SummonMonster8;
	int m_GreaterLifeConstA;
	int m_GreaterLifeConstB;
	int m_GreaterLifeConstC;
	int m_GreaterLifeRate[MAX_CLASS];
	int m_GreaterLifeTimeConstA;
	int m_GreaterLifeTimeConstB;
	int m_GreaterLifeMaxRate;
	int m_FireSlashConstA;
	int m_FireSlashConstB;
	int m_FireSlashTimeConstA;
	int m_FireSlashMaxRate;
	int m_GreaterCriticalDamageConstA;
	int m_GreaterCriticalDamageConstB;
	int m_GreaterCriticalDamageTimeConstA;
	int m_GreaterCriticalDamageTimeConstB;
	int m_GreaterCriticalDamageMax;
	int m_SternTimeConstA;
	int m_GreaterManaConstA;
	int m_GreaterManaTimeConstA;
	int m_InvisibilityTimeConstA;
	int m_BrandTimeConstA;
	int m_InfinityArrowTimeConstA;
	int m_MagicDamageImmunityTimeConstA;
	int m_PhysiDamageImmunityTimeConstA;
	int m_DrainLifeConstA;
	int m_DrainLifeConstB;
	int m_ReflectDamageConstA;
	int m_ReflectDamageConstB;
	int m_ReflectDamageRate[MAX_CLASS];
	int m_ReflectDamageTimeConstA;
	int m_ReflectDamageTimeConstB;
	int m_ReflectDamageMaxRate;
	int m_SwordPowerConstA;
	int m_SwordPowerConstB;
	int m_SwordPowerTimeConstA;
	int m_SwordPowerTimeConstB;
	int m_SwordPowerMaxRate;
	int m_SleepConstA;
	int m_SleepConstB;
	int m_SleepTimeConstA;
	int m_SleepTimeConstB;
	int m_SleepMaxTime;
	int m_LesserDefenseConstA;
	int m_LesserDefenseConstB;
	int m_LesserDefenseConstC;
	int m_LesserDefenseConstD;
	int m_LesserDefenseTimeConstA;
	int m_LesserDefenseTimeConstB;
	int m_LesserDefenseMaxRate;
	int m_LesserDamageConstA;
	int m_LesserDamageConstB;
	int m_LesserDamageConstC;
	int m_LesserDamageConstD;
	int m_LesserDamageTimeConstA;
	int m_LesserDamageTimeConstB;
	int m_LesserDamageMaxRate;
	int m_SahamuttConstA;
	int m_NeilConstA;
	int m_MagicCircleConstA;
	int m_MagicCircleTimeConstA;
	int m_ShieldRecoverConstA;
	int m_ShieldRecoverConstB;
	int m_DragonSlayerConstA;
	int m_DragonSlayerConstB;
	int m_DragonSlayerConstC;
	int m_DragonSlayerConstD;
	int m_DragonSlayerMaxRate;
	int m_GreaterIgnoreDefenseRateConstA;
	int m_GreaterIgnoreDefenseRateConstB;
	int m_GreaterIgnoreDefenseRateTimeConstA;
	int m_GreaterIgnoreDefenseRateTimeConstB;
	int m_GreaterIgnoreDefenseMax;

	int m_FitnessConstA;
	int m_FitnessConstB;
	int m_FitnessTimeConstA;
	int m_FitnessTimeConstB;
	int m_FitnessMax;

	int m_GreaterDefenseSuccessRateConstA;
	int m_GreaterDefenseSuccessRateConstB;
	int m_GreaterDefenseSuccessRateTimeConstA;
	int m_GreaterDefenseSuccessRateTimeConstB;
	int m_GreaterDefenseSuccessMax;

	int m_PartyHealConstA;
	int m_PartyHealConstB;
	int m_BlessConstA;
	int m_BlessTimeConstA;
	int m_BlindConstA;
	int m_BlindConstB;
	int m_BlindConstC;
	int m_BlindTimeConstA;
	int m_EarthPrisonConstA;
	int m_IronDefenseConstA;
	int m_IronDefenseConstB;
	int m_IronDefenseTimeConstA;
	int m_BloodHowlingConstA;
	int m_BloodHowlingConstB;
	int m_BloodHowlingTimeConstA;
	int m_CircleShieldValue;
	int m_CircleShieldCount;
	int m_BackSpringDelay;


	long m_AnnounceChaosMix;
	char m_AnnounceChaosMixText[50];

	int m_DefenseAbs;
	int m_LifeAbs;
	int m_BastionConstA;
	int m_BastionConstB;
	int m_BleedingConst;
	int m_ParalyzingConst;
	int m_PunishConst;
	int m_BlindingConst;

	int m_ForMasterTreeMaxLevel;
	int m_ForMasterSkillTree;
	int m_ForMasterSkillTreePoint;
	int m_MinForMasterExperienceMonsterLevel[MAX_ACCOUNT_LEVEL];
	int m_AddForMasterExperienceRate[MAX_ACCOUNT_LEVEL];

	short SpeedGenerateConfig;
	char CharacterToTest[11];
	short AntiSpeedEnable;
	short GenerateConfigTimer;
	short AgilityAutoIncrement;

	//Hit queue system
	short FilaHit;
	short FilaHitGenerateConfig;
	short FilaHitAgiInc;
	short FilaHitCleanTime;

	short FilaHitLogProcesso;
	char FilaHitLogStalk[11];

	int BackSpringCheck;
	int BackSpringTolerance;
	int BackSpringBlockTime;

	short m_PotionMode;
	short m_PotionModeDelay;

	short MUFC_Map;
	short MUFC_1_X;
	short MUFC_1_Y;
	short MUFC_2_X;
	short MUFC_2_Y;
	short MUFC_TimerToStart;
	short MUFC_TimerRound;

	int m_DamageRateByDistance[13];
};

extern CServerInfo gServerInfo;
