#include "stdafx.h"
#include "ObjectManager.h"
#include "Attack.h"
#include "380ItemOption.h"
#include "BattleSoccerManager.h"
#include "BloodCastle.h"
#include "BonusManager.h"
#include "CastleDeep.h"
#include "CastleSiege.h"
#include "CastleSiegeSync.h"
#include "ChaosBox.h"
#include "ChaosCastle.h"
#include "CommandManager.h"
#include "Crywolf.h"
#include "CrywolfSync.h"
#include "CustomArena.h"
#include "CustomAttack.h"
#include "CustomJewel.h"
#include "CustomMonster.h"
#include "CustomWing.h"
#include "DarkSpirit.h"
#include "DevilSquare.h"
#include "DoubleGoer.h"
#include "DSProtocol.h"
#include "Duel.h"
#include "EffectManager.h"
#include "ESProtocol.h"
#include "ExperienceTable.h"
#include "GameMaster.h"
#include "Gate.h"
#include "Guild.h"
#include "GuildMatching.h"
#include "Helper.h"
#include "IllusionTemple.h"
#include "ImperialGuardian.h"
#include "InventoryEquipment.h"
#include "ItemOption.h"
#include "JewelOfHarmonyOption.h"
#include "JSProtocol.h"
#include "Kalima.h"
#include "Kanturu.h"
#include "KanturuBattleUserMng.h"
#include "LifeStone.h"
#include "Map.h"
#include "MapManager.h"
#include "MapServerManager.h"
#include "MasterSkillTree.h"
#include "Mercenary.h"
#include "Message.h"
#include "Monster.h"
#include "MonsterSkillManager.h"
#include "Move.h"
#include "MoveSummon.h"
#include "MUFC.h"
#include "MuunSystem.h"
#include "Notice.h"
#include "Party.h"
#include "PartyMatching.h"
#include "PentagramSystem.h"
#include "Quest.h"
#include "QuestObjective.h"
#include "QuestWorld.h"
#include "QuestWorldObjective.h"
#include "Raklion.h"
#include "RaklionBattleUserMng.h"
#include "RaklionUtil.h"
#include "Reconnect.h"
#include "SerialCheck.h"
#include "ServerInfo.h"
#include "SetItemOption.h"
#include "SkillManager.h"
#include "SocketItemOption.h"
#include "SocketItemType.h"
#include "Trade.h"
#include "Util.h"
#include "SXIDecryp.h"
//#include "Silvester.h"
#include "SummonScroll.h"
#include "NewQuestWorld.h"
#include "StatSpecialize.h"
#include "MasterSkillTree_4th.h"
#include "ForThTree.h"
#include "HuntingGrounds.h"
#include "CNixiesLakeBossZone.h"
//#include "LabyrinthMission.h"
//#include "LabyrinthInfo.h"
//#include "Labyrinth.h"
//#include "InstanceSystemMgr.h"
#include "CBlockChatUserSystem.h"
#include "Log.h"
#include "Configs.h"
#include "Logger.h"
#include "ChatSystem.h"
#include "FilaHit.h"
#include "DSProtocol.h"
#include "MonsterSpawner.h"
#include "RandomManager.h"
#include "NpcTalk.h"
#include "Wings4thOption.h"
#include "MasteryItemExtOptionSet.h"
#include "RheaGold.h"
#include "GodOfDarkness.h"
#include "GameMain.h"


CObjectManager gObjectManager;

CObjectManager::CObjectManager() // OK
{

}

CObjectManager::~CObjectManager() // OK
{

}

void CObjectManager::ObjectMsgProc(LPOBJ lpObj) // OK
{
	for (int n = 0; n < MAX_MONSTER_SEND_MSG; n++)
	{
		if (gSMMsg[lpObj->Index][n].MsgCode != -1 && GetTickCount() > ((DWORD)gSMMsg[lpObj->Index][n].MsgTime))
		{
			if (lpObj->Type == OBJECT_MONSTER || lpObj->Type == OBJECT_NPC)
			{
				gObjMonsterStateProc(lpObj, gSMMsg[lpObj->Index][n].MsgCode, gSMMsg[lpObj->Index][n].SendUser, gSMMsg[lpObj->Index][n].SubCode);
				gSMMsg[lpObj->Index][n].Clear();
			}
			else
			{
				this->ObjectStateProc(lpObj, gSMMsg[lpObj->Index][n].MsgCode, gSMMsg[lpObj->Index][n].SendUser, gSMMsg[lpObj->Index][n].SubCode);
				gSMMsg[lpObj->Index][n].Clear();
			}
		}
	}
}

void CObjectManager::ObjectSetStateCreate(int aIndex) // OK
{
	LPOBJ lpObj = &gObj[aIndex];

	if (gObjIsConnected(aIndex) == 0)
	{
		return;
	}

	/*if (lpObj->Class == 476 && lpObj->Live == 1 && (GetTickCount() - lpObj->ConnectTickCount) > 300000)
	{
		lpObj->ConnectTickCount = GetTickCount();

		switch (GetLargeRand() % 2)
		{
		case 0:
			gNotice.GCNoticeSendToAll(0, 0, 0, 0, 0, 0, "Hou hou hou, o Capetaum Chegou!");
			break;
		default:
			gNotice.GCNoticeSendToAll(0, 0, 0, 0, 0, 0, "Vem pegar o buff, vem bebe! Hou hou hou!");
		}
	}*/

	if (lpObj->DieRegen == 1 && (GetTickCount() - lpObj->RegenTime) > (lpObj->MaxRegenTime + 1000))
	{
		lpObj->DieRegen = 2;
		lpObj->State = OBJECT_DIECMD;
		this->CharacterCalcAttribute(aIndex);

		CUSTOM_MONSTER_INFO CustomMonsterInfo;
		if (gCustomMonster.GetCustomMonsterInfo(lpObj->Class, lpObj->Map, &CustomMonsterInfo) == 1)
		{
			if (CustomMonsterInfo.TimerRandom > 0)
			{
				lpObj->MaxRegenTime = ((GetLargeRand() % CustomMonsterInfo.TimerRandom * 1000) + lpObj->OriginalRegenTime);
			}
		}
	}

	if (lpObj->Type == OBJECT_USER && lpObj->Teleport == 2)
	{
		lpObj->Teleport = 3;

		lpObj->TX = lpObj->X;
		lpObj->TY = lpObj->Y;

		gMove.GCTeleportSend(aIndex, 0, lpObj->Map, (BYTE)lpObj->X, (BYTE)lpObj->Y, lpObj->Dir);

		gObjViewportListProtocolCreate(lpObj);

		this->CharacterUpdateMapEffect(lpObj);

		lpObj->Teleport = 0;
		lpObj->PathCur = 0;
		lpObj->PathCount = 0;
		lpObj->PathStartEnd = 0;
	}

	if (lpObj->Type == OBJECT_MONSTER && lpObj->Teleport == 2)
	{
		lpObj->Teleport = 3;

		lpObj->TX = lpObj->X;
		lpObj->TY = lpObj->Y;

		gObjViewportListProtocolCreate(lpObj);

		lpObj->Teleport = 0;
		lpObj->PathCur = 0;
		lpObj->PathCount = 0;
		lpObj->PathStartEnd = 0;
	}

	if (lpObj->Type == OBJECT_NPC && lpObj->Teleport == 2)
	{
		lpObj->Teleport = 3;

		if (OBJECT_RANGE(lpObj->SummonIndex) == 0)
		{
			lpObj->X = lpObj->X + ((GetLargeRand() % 6) - 3);
			lpObj->Y = lpObj->Y + ((GetLargeRand() % 6) - 3);
			lpObj->TX = lpObj->X;
			lpObj->TY = lpObj->Y;
		}
		else
		{
			lpObj->TX = lpObj->X;
			lpObj->TY = lpObj->Y;
		}

		gObjViewportListProtocolCreate(lpObj);

		lpObj->Teleport = 0;
		lpObj->PathCur = 0;
		lpObj->PathCount = 0;
		lpObj->PathStartEnd = 0;
	}

	lpObj->Teleport = ((lpObj->Teleport == 1) ? ((lpObj->DieRegen == 0) ? (((GetTickCount64() - lpObj->TeleportTime) > 100) ? 2 : lpObj->Teleport) : 0) : lpObj->Teleport);

	if (lpObj->Type == OBJECT_USER && lpObj->RegenOk == 2)
	{
		lpObj->RegenOk = 3;
		lpObj->State = OBJECT_CREATE;
		lpObj->X = lpObj->RegenMapX;
		lpObj->Y = lpObj->RegenMapY;
		lpObj->TX = lpObj->RegenMapX;
		lpObj->TY = lpObj->RegenMapY;
		lpObj->Map = lpObj->RegenMapNumber;

		this->CharacterUpdateMapEffect(lpObj);

		/*if (lpObj->Map == MAP_KANTURU2)
		{
			GCMessagePopupSend(lpObj, "ATENCAO!\nVoce esta em uma area perigosa! Se voce for morto por outro jogador neste local, perdera %d Ruud. Se nao tiver o Ruud no inventario, podera perder um de seus itens.\nMUITO CUIDADO POR AQUI!", gServerInfo.m_PKRuudDrop);
		}*/
	}
}

void CObjectManager::ObjectSetStateProc() // OK
{
	for (int n = 0; n < MAX_OBJECT; n++)
	{
		if (gObjIsConnected(n) == 0)
		{
			continue;
		}

		LPOBJ lpObj = &gObj[n];

		lpObj->Teleport = ((lpObj->Teleport == 3) ? 0 : lpObj->Teleport);

		if (lpObj->State == OBJECT_CREATE)
		{
			lpObj->State = OBJECT_PLAYING;
			lpObj->RegenOk = ((lpObj->RegenOk == 3) ? 0 : lpObj->RegenOk);
		}

		if (lpObj->Type == OBJECT_MONSTER)
		{
			if (lpObj->DieRegen != 2)
			{
				continue;
			}

			lpObj->AttackerKilled = 0;

			if (lpObj->CurrentAI != 0 && lpObj->RegenType != 0)
			{
				continue;
			}

			if (BC_MAP_RANGE(lpObj->Map) != 0 && lpObj->Class >= 131 && lpObj->Class <= 134)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

			if (CC_MAP_RANGE(lpObj->Map) != 0)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

			if (DG_MAP_RANGE(lpObj->Map) != 0)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

			if (IG_MAP_RANGE(lpObj->Map) != 0)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

#if(GAMESERVER_TYPE==1)
			if (lpObj->Map == MAP_CRYWOLF && gCrywolf.GetCrywolfState() == CRYWOLF_STATE_READY)
			{
				continue;
			}
#endif

			if (lpObj->Map == MAP_KANTURU3)
			{
				continue;
			}

			if (lpObj->Map == MAP_RAKLION2)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

			if (lpObj->Attribute == 60 || lpObj->Attribute == 61)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

			if (lpObj->Attribute == 62 && lpObj->Class == 295)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

			if (lpObj->Attribute == 62 && lpObj->Class >= 300 && lpObj->Class <= 303)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

			if (lpObj->Attribute == 62 && (GetTickCount() - lpObj->LastCheckTick) > 600000)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

#if(GAMESERVER_TYPE==1)

			if (lpObj->Class == 278)
			{
				gLifeStone.DeleteLifeStone(lpObj->Index);
				gObjDel(lpObj->Index);
				continue;
			}

			if (lpObj->Class == 286 || lpObj->Class == 287)
			{
				gMercenary.DeleteMercenary(lpObj->Index);
				gObjDel(lpObj->Index);
				continue;
			}

#endif

			/*if (lpObj->Class >= 647 && lpObj->Class <= 650)
			{
				gObjDel(lpObj->Index);
				continue;
			}*/

			/*if (lpObj->Class >= 652 && lpObj->Class <= 657)
			{
				gObjDel(lpObj->Index);
				continue;
			}*/

			/*if (lpObj->Class >= 674 && lpObj->Class <= 677)
			{
				gObjDel(lpObj->Index);
				continue;
			}*/

			/*if (lpObj->Class >= 733 && lpObj->Class <= 735)
			{
				continue;
			}*/

			if (lpObj->Class == 747 || lpObj->Class == 746)
			{
				continue;
			}

			if (lpObj->DeleteAfterDie)
			{
				LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[lpObj->Index].Class);
				gObjDel(lpObj->Index);
				continue;
			}

			gCustomMonster.SetCustomMonsterElement(lpObj);

			lpObj->Live = 1;
			lpObj->ViewState = 0;
			lpObj->Teleport = 0;
			lpObj->Life = lpObj->MaxLife + lpObj->AddLife;
			lpObj->Mana = lpObj->MaxMana + lpObj->AddMana;

			gEffectManager.ClearAllEffect(lpObj);

			if (gObjMonsterRegen(lpObj) == 0)
			{
				continue;
			}

			lpObj->DieRegen = 0;
			lpObj->State = OBJECT_CREATE;			

			gObjViewportListProtocolCreate(lpObj);
		}

		if (lpObj->Type == OBJECT_USER)
		{
			if (lpObj->DieRegen != 2)
			{
				continue;
			}

			lpObj->Live = 1;
			lpObj->ViewState = 0;
			lpObj->Teleport = 0;
			lpObj->Life = lpObj->MaxLife + lpObj->AddLife;
			lpObj->Mana = lpObj->MaxMana + lpObj->AddMana;
			lpObj->BP = lpObj->MaxBP + lpObj->AddBP;
			lpObj->Shield = lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield;
			lpObj->MiniMapState = 0;
			lpObj->MiniMapValue = -1;
			lpObj->HPAutoRecuperationTime = GetTickCount();
			lpObj->MPAutoRecuperationTime = GetTickCount();
			lpObj->BPAutoRecuperationTime = GetTickCount();
			lpObj->SDAutoRecuperationTime = GetTickCount();
			lpObj->ResurrectionTalismanActive = 1;
			lpObj->ResurrectionTalismanMap = lpObj->Map;
			lpObj->ResurrectionTalismanX = lpObj->X;
			lpObj->ResurrectionTalismanY = lpObj->Y;

			memset(lpObj->SelfDefenseTime, 0, sizeof(lpObj->SelfDefenseTime));

			gObjTimeCheckSelfDefense(lpObj);

			gEffectManager.ClearAllEffect(lpObj);

			gHelper.DisableHelper(lpObj);

			gObjClearViewport(lpObj);

			gDarkSpirit[lpObj->Index].SetMode(DARK_SPIRIT_MODE_NORMAL, -1);

			switch (lpObj->KillerType)
			{
			case 0:
			case 1:
				if (this->CharacterGetRespawnLocation(lpObj) == 0)
				{
					if (!IsPvPTestOn && !lpObj->isGhost && !lpObj->AutoPVPTesting)
					{
						gMap[lpObj->Map].GetMapPos(lpObj->Map, &lpObj->X, &lpObj->Y);
					}
				}
				break;
			case 2:
				if (lpObj->Guild == 0 || lpObj->Guild->WarType != 1)
				{
					gMap[lpObj->Map].GetMapRandomPos(&lpObj->X, &lpObj->Y, 18);
				}
				else
				{
					gBattleGetTeamPosition(lpObj->Guild->BattleGroundIndex, lpObj->Guild->BattleTeamCode, (short&)lpObj->X, (short&)lpObj->Y);
				}
				break;
			case 3:
				gDuel.RespawnDuelUser(lpObj);
				break;
			}

			if (this->CharacterMapServerMove(lpObj->Index, lpObj->Map, lpObj->X, lpObj->Y) != 0)
			{
				continue;
			}

			lpObj->TX = lpObj->X;
			lpObj->TY = lpObj->Y;
			lpObj->PathCur = 0;
			lpObj->PathCount = 0;
			lpObj->PathStartEnd = 0;
			lpObj->DieRegen = 0;
			lpObj->State = OBJECT_CREATE;

			GCCharacterRegenSend(lpObj);

			/*if (g_Labyrinth.IsLabyrinthMapNumber(lpObj->Map) == 1)
			{
				//lpLabInfo = lpObj->m_cLabyrinthInfo;
				int nConfigNum = lpObj->m_cLabyrinthInfo->GetConfigNum();
				int nZoneNumber = -1;
				g_Labyrinth.FindEntranceZone(nConfigNum, &nZoneNumber);
				g_Labyrinth.MoveLabyrinthZone(lpObj->Index, nConfigNum, nZoneNumber);
				lpObj->m_cLabyrinthInfo->SendCurrentZoneMissionInfo(lpObj->Index, nZoneNumber);
				lpObj->m_cLabyrinthInfo->SendZonePath(lpObj->Index);
			}*/

			gObjViewportListProtocolCreate(lpObj);

			this->CharacterUpdateMapEffect(lpObj);
		}
	}

	for (int n = 0; n < MAX_MAP; n++)
	{
		gMap[n].StateSetDestroy();
	}

	//g_InstanceSystemMgr->StateSetInstanceMap();
}

void CObjectManager::ObjectStateProc(LPOBJ lpObj, int MessageCode, int aIndex, int SubCode) // OK
{
	if (gObjIsConnected(aIndex) == 0)
	{
		return;
	}

	switch (MessageCode)
	{
	case 2:
		if (lpObj->Live != 0)
		{
			/*if (gServerInfo.BackSpringCheck == 1)
			{
				if (gServerInfo.BackSpringBlockTime > 0 && GetTickCount() < (lpObj->BackSpringTick + gServerInfo.BackSpringBlockTime))
				{
					LogAdd(LOG_RED,"[%s]->[%s] BackSpring blocked by time", lpObj->Name, gObj[aIndex].Name);
					lpObj->BackSpringCounter = 0;
					return;
				}

				if (lpObj->BackSpringTarget == aIndex)
				{
					lpObj->BackSpringCounter++;
				}
				else
				{
					lpObj->BackSpringCounter = 0;
					lpObj->BackSpringTarget = aIndex;
				}

				if (lpObj->BackSpringCounter > gServerInfo.BackSpringTolerance)
				{
					lpObj->BackSpringTick = GetTickCount();
					LogAdd(LOG_RED, "[%s]->[%s] Back Spring blocked by [%d] repetitions", lpObj->Name, gObj[aIndex].Name, lpObj->BackSpringCounter);
					return;
				}
			}*/

			if (GetLargeRand() % 100 >= (gObj[aIndex].BackSpringProtection - lpObj->BackSpringIncrease))
			{
				gObjBackSpring(lpObj, &gObj[aIndex]);
			}
		}
		break;
	case 3:
		if (lpObj->Live != 0)
		{
			this->CharacterMonsterDieHunt(lpObj, &gObj[aIndex]);
		}
		break;
	case 4:
		/*if (lpObj->Guild != 0 && lpObj->Guild->TargetGuildNode != 0)
		{
			gObjGuildWarEnd(lpObj->Guild, lpObj->Guild->TargetGuildNode);
		}*/
		break;
	case 5:
		if (lpObj->Guild != 0 && lpObj->Guild->WarState != 0 && lpObj->Guild->WarType == 1)
		{
			BattleSoccerGoalStart(0);
		}
		break;
	case 10:
		if (lpObj->Live != 0 && SubCode > 0)
		{
			gAttack.Attack(lpObj, &gObj[aIndex], 0, 0, 0, SubCode, 0, 0);
		}
		break;
	case 16:
		if ((lpObj->Life + SubCode) > (lpObj->MaxLife + lpObj->AddLife))
		{
			lpObj->Life = lpObj->MaxLife + lpObj->AddLife;
		}
		else
		{
			lpObj->Life += SubCode;
		}

		GCLifeSend(lpObj->Index, 0xFF, (int)lpObj->Life, lpObj->Shield);
		break;
	}
}

void CObjectManager::ObjectStateAttackProc(LPOBJ lpObj, int MessageCode, int aIndex, int SubCode1, int SubCode2) // OK
{
	if (gObjIsConnected(aIndex) == 0)
	{
		return;
	}

	switch (MessageCode)
	{
	case 50:
		if (lpObj->Live != 0 && (SubCode1 == 0 || gSkillManager.GetSkill(lpObj, SubCode1) != 0))
		{
			gAttack.Attack(lpObj, &gObj[aIndex], gSkillManager.GetSkill(lpObj, SubCode1), 0, 0, 0, 0, (bool)(SubCode2 & 1));
		}
		break;
	case 51:
		if (lpObj->Live != 0)
		{
			gDarkSpirit[lpObj->Index].Attack(lpObj, &gObj[aIndex], 0, (bool)(SubCode1 & 1), 0, SubCode2);
		}
		break;
	case 52:
		if (lpObj->Live != 0 && (SubCode1 == 0 || gSkillManager.GetSkill(lpObj, SubCode1) != 0))
		{
			gAttack.Attack(lpObj, &gObj[aIndex], gSkillManager.GetSkill(lpObj, SubCode1), 0, 0, 0, SubCode2, 0);
		}
		break;
	case 53:
		if (lpObj->Live != 0 && (SubCode1 == 0 || gSkillManager.GetSkill(lpObj, SubCode1) != 0))
		{
			gAttack.Attack(lpObj, &gObj[aIndex], gSkillManager.GetSkill(lpObj, SubCode1), 1, 0, 0, 0, (bool)(SubCode2 & 1));
		}
		break;
	case 54:
		if (lpObj->Live != 0 && (SubCode1 == 0 || gSkillManager.GetSkill(lpObj, SubCode1) != 0))
		{
			gAttack.Attack(lpObj, &gObj[aIndex], gSkillManager.GetSkill(lpObj, SubCode1), 1, 0, 0, SubCode2, 0);
		}
		break;
	case 55:
		if (lpObj->Live != 0 && (SubCode1 == 0 || gSkillManager.GetSkill(lpObj, SubCode1) != 0))
		{
			gSkillManager.SkillGhostPhantomAreaAttack(lpObj->Index, aIndex, gSkillManager.GetSkill(lpObj, SubCode1), (BYTE)SET_NUMBERHW(SubCode2), (BYTE)SET_NUMBERLW(SubCode2));
		}
		break;
	case 100:
	{
		int effect = 1;
		if (SubCode2 % 2 == 0) { effect |= 0x10; }
		else { effect |= 0x20; }
		if (!gObj[aIndex].isGhost) { gObj[aIndex].Life -= SubCode1; }
		gObjectManager.CharacterLifeCheck(lpObj, &gObj[aIndex], SubCode1, 0, 0, effect, 0, 0);
	}
		break;
	case 101:
	{
		int effect2 = 7;
		if (SubCode2 % 2 == 0) { effect2 |= 0x10; }
		else { effect2 |= 0x20; }
		if (!gObj[aIndex].isGhost) { gObj[aIndex].Life -= SubCode1; }
		gObjectManager.CharacterLifeCheck(lpObj, &gObj[aIndex], SubCode1, 0, 0, effect2, 0, 0);
	}
		break;
	}
}

void CObjectManager::ObjectMoveProc() // OK
{
	for (int n = 0; n < MAX_OBJECT; n++)
	{
		if (gObjIsConnected(n) == 0)
		{
			continue;
		}

		LPOBJ lpObj = &gObj[n];

		if (lpObj->State != OBJECT_PLAYING)
		{
			continue;
		}

		if (lpObj->CurrentAI != 0 && (lpObj->Type == OBJECT_MONSTER || lpObj->Type == OBJECT_NPC))
		{
			continue;
		}

		if (lpObj->PathCount == 0 || gEffectManager.CheckStunEffect(lpObj) != 0 || gEffectManager.CheckImmobilizeEffect(lpObj) != 0)
		{
			continue;
		}

		if (lpObj->Type == OBJECT_MONSTER && (KALIMA_ATTRIBUTE_RANGE(lpObj->Attribute) != 0 || lpObj->Class == 131 || lpObj->Class == 132 || lpObj->Class == 133 || lpObj->Class == 134 || lpObj->Class == 204 || lpObj->Class == 205 || lpObj->Class == 206 || lpObj->Class == 207 || lpObj->Class == 208 || lpObj->Class == 209 || lpObj->Class == 216 || lpObj->Class == 217 || lpObj->Class == 218 || lpObj->Class == 219 || lpObj->Class == 277 || lpObj->Class == 278 || lpObj->Class == 283 || lpObj->Class == 288 || lpObj->Class == 524 || lpObj->Class == 525 || lpObj->Class == 527 || lpObj->Class == 528))
		{
			continue;
		}

		DWORD MoveTime = 0;

		if ((lpObj->PathDir[lpObj->PathCur] % 2) == 0)
		{
			MoveTime = (DWORD)((lpObj->MoveSpeed + ((lpObj->DelayLevel == 0) ? 0 : 300)) * (double)1.3);
		}
		else
		{
			MoveTime = (DWORD)((lpObj->MoveSpeed + ((lpObj->DelayLevel == 0) ? 0 : 300)) * (double)1.0);
		}

		if ((GetTickCount() - lpObj->PathTime) > MoveTime && lpObj->PathCur < (MAX_ROAD_PATH_TABLE - 1))
		{
			if (gMap[lpObj->Map].CheckAttr(lpObj->PathX[lpObj->PathCur], lpObj->PathY[lpObj->PathCur], 4) != 0 || gMap[lpObj->Map].CheckAttr(lpObj->PathX[lpObj->PathCur], lpObj->PathY[lpObj->PathCur], 8) != 0)
			{
				lpObj->PathCur = 0;
				lpObj->PathCount = 0;
				lpObj->PathTime = GetTickCount();
				lpObj->PathStartEnd = ((lpObj->Type == OBJECT_USER) ? lpObj->PathStartEnd : 0);

				memset(lpObj->PathX, 0, sizeof(lpObj->PathX));

				memset(lpObj->PathY, 0, sizeof(lpObj->PathY));

				memset(lpObj->PathOri, 0, sizeof(lpObj->PathOri));

				gObjSetPosition(lpObj->Index, lpObj->X, lpObj->Y);
			}
			else
			{
				lpObj->X = lpObj->PathX[lpObj->PathCur];
				lpObj->Y = lpObj->PathY[lpObj->PathCur];
				lpObj->Dir = lpObj->PathDir[lpObj->PathCur];
				lpObj->PathTime = GetTickCount();

				if ((++lpObj->PathCur) >= lpObj->PathCount)
				{
					lpObj->PathCur = 0;
					lpObj->PathCount = 0;
					lpObj->PathStartEnd = ((lpObj->Type == OBJECT_USER) ? lpObj->PathStartEnd : 0);
				}
			}
		}
	}
}

void CObjectManager::ObjectMonsterAndMsgProc() // OK
{
	for (int n = 0; n < MAX_OBJECT; n++)
	{
		if (gObjIsConnected(n) != 0)
		{
			if (gObj[n].Type == OBJECT_MONSTER || gObj[n].Type == OBJECT_NPC)
			{
				if (gObj[n].CurrentAI == 0)
				{
					gObjMonsterProcess(&gObj[n]);
				}
			}
			else
			{
				gDarkSpirit[n].MainProc();
				gObjSkillNovaCheckTime(&gObj[n]);
				gObjectManager.ObjectMsgProc(&gObj[n]);
				gCustomAttack.OnAttackMonsterAndMsgProc(&gObj[n]);
			}
		}
	}

	for (int n = 0; n < MAX_OBJECT; n++)
	{
		if (gObjIsConnected(n) != 0)
		{
			for (int i = 0; i < MAX_MONSTER_SEND_ATTACK_MSG; i++)
			{
				if (gSMAttackProcMsg[n][i].MsgCode != -1 && GetTickCount() > ((DWORD)gSMAttackProcMsg[n][i].MsgTime))
				{
					gObjectManager.ObjectStateAttackProc(&gObj[n], gSMAttackProcMsg[n][i].MsgCode, gSMAttackProcMsg[n][i].SendUser, gSMAttackProcMsg[n][i].SubCode, gSMAttackProcMsg[n][i].SubCode2);
					gSMAttackProcMsg[n][i].Clear();
				}
			}
		}
	}
}

bool CObjectManager::CharacterGameClose(int aIndex) // OK
{
	if (OBJECT_RANGE(aIndex) == 0)
	{
		return 0;
	}

	LPOBJ lpObj = &gObj[aIndex];

	if (lpObj->Connected != OBJECT_ONLINE)
	{
		return 0;
	}

	if (lpObj->Type != OBJECT_USER || lpObj->MapServerMoveQuit != 0)
	{
		return 0;
	}

	if (OBJECT_RANGE(lpObj->SummonIndex) != 0)
	{
		gObjSummonKill(lpObj->Index);
	}

	if (lpObj->Interface.use != 0 && (lpObj->Interface.type == INTERFACE_CHAOS_BOX || lpObj->Interface.type == INTERFACE_TRAINER))
	{
		if (lpObj->IsChaosMixCompleted != 0 || lpObj->IsCastleNPCUpgradeCompleted != 0)
		{
			gChaosBox.ChaosBoxItemSave(lpObj);
		}
		else
		{
			gObjInventoryRollback(aIndex);
		}
	}

	if (OBJECT_RANGE(lpObj->TargetNumber) != 0)
	{
		gTrade.ResetTrade(lpObj->TargetNumber);
		gTrade.GCTradeResultSend(lpObj->TargetNumber, 0);
		gTrade.ResetTrade(aIndex);
	}

	if (OBJECT_RANGE(lpObj->DuelUserReserved) != 0)
	{
		gDuel.ResetDuel(&gObj[lpObj->DuelUserReserved]);
		gDuel.GCDuelStartSend(aIndex, 0, lpObj->DuelUserReserved);
		gDuel.ResetDuel(lpObj);
	}

	if (OBJECT_RANGE(lpObj->DuelUserRequested) != 0)
	{
		gDuel.ResetDuel(&gObj[lpObj->DuelUserRequested]);
		gDuel.GCDuelStartSend(lpObj->DuelUserRequested, 0, aIndex);
		gDuel.ResetDuel(lpObj);
	}

	if (OBJECT_RANGE(lpObj->DuelUser) != 0)
	{
		gDuel.ResetDuel(&gObj[lpObj->DuelUser]);
		gDuel.GCDuelEndSend(lpObj->DuelUser, 0);
		gDuel.ResetDuel(lpObj);
		gDuel.GCDuelEndSend(aIndex, 0);
	}

	if (OBJECT_RANGE(lpObj->MiningIndex) != 0)
	{
		gObj[lpObj->MiningIndex].MiningStage = 0;
		gObj[lpObj->MiningIndex].MiningIndex = -1;
	}

	gReconnect.SetReconnectInfo(lpObj);

	if (OBJECT_RANGE(lpObj->PartyNumber) != 0)
	{
		if (IT_MAP_RANGE(lpObj->Map) == 0 && DG_MAP_RANGE(lpObj->Map) == 0 && IG_MAP_RANGE(lpObj->Map) == 0)
		{
			if (gParty.GetMemberCount(lpObj->PartyNumber) <= 1)
			{
				gParty.Destroy(lpObj->PartyNumber);
			}
			else
			{
				gParty.DelMember(lpObj->PartyNumber, lpObj->Index);
			}
		}
	}

	if (lpObj->Guild != 0 && lpObj->Guild->WarState == 1)
	{
		gObjGuildWarMasterClose(lpObj);
	}

	if (BC_MAP_RANGE(lpObj->Map) != 0)
	{
		if (gBloodCastle.GetState(GET_BC_LEVEL(lpObj->Map)) == BC_STATE_START)
		{
			gBloodCastle.SearchUserDropEventItem(aIndex);
		}
		else
		{
			gBloodCastle.SearchUserDeleteEventItem(aIndex);
		}
	}

	if (IT_MAP_RANGE(lpObj->Map) != 0)
	{
		if (gIllusionTemple.GetState() == IT_STATE_START)
		{
			gIllusionTemple.CheckUserStoneState(lpObj);
			gIllusionTemple.SearchUserDropEventItem(aIndex);
		}
		else
		{
			gIllusionTemple.SearchUserDeleteEventItem(aIndex);
		}
	}

	gObjFixInventoryPointer(aIndex);

	gObjFixEventInventoryPointer(aIndex);

	GDCharacterInfoSaveSend(aIndex);

	/*if (g_Labyrinth.IsLabyrinthMapNumber(lpObj->Map) == 1 && gObj[aIndex].Type == OBJECT_USER)
	{
		g_Labyrinth.LeaveLabyrinth(lpObj->Index, lpObj->m_cLabyrinthInfo->GetConfigNum());
	}*/

	gPartyMatching.GDPartyMatchingJoinCancelSend(aIndex, 0, 1);

	gPartyMatching.GDPartyMatchingJoinCancelSend(aIndex, 1, 1);

	GDDisconnectCharacterSend(aIndex);

	if (lpObj->Guild == 0)
	{
		GDCharClose(1, 0, lpObj->Name);
	}
	else
	{
		GDCharClose(0, lpObj->Guild->Name, lpObj->Name);
	}

	gDarkSpirit[aIndex].SetMode(DARK_SPIRIT_MODE_NORMAL, -1);

	gObjClearViewport(lpObj);

	LogAdd(LOG_BLACK, "[ObjectManager][%d] DelCharacterInfo (%s)", lpObj->Index, lpObj->Name);

	memset(lpObj->Name, 0, sizeof(lpObj->Name));

	lpObj->Connected = OBJECT_LOGGED;

	return 1;
}

void CObjectManager::CharacterGameCloseSet(int aIndex, int type) // OK
{
	LPOBJ lpObj = &gObj[aIndex];

	if (lpObj->CloseCount > 0)
	{
		return;
	}

	if (lpObj->Connected == OBJECT_ONLINE)
	{
		if (lpObj->Interface.use != 0 && lpObj->Interface.type == INTERFACE_TRADE)
		{
			gNotice.GCNoticeSend(aIndex, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(261));
			return;
		}

		if (lpObj->Interface.use != 0 && lpObj->Interface.type == INTERFACE_WAREHOUSE)
		{
			gNotice.GCNoticeSend(aIndex, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(262));
			return;
		}

		if (lpObj->Interface.use != 0 && lpObj->Interface.type == INTERFACE_CHAOS_BOX)
		{
			gNotice.GCNoticeSend(aIndex, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(263));
			return;
		}

		if (lpObj->Interface.use != 0 && lpObj->Interface.type == INTERFACE_TRAINER)
		{
			gNotice.GCNoticeSend(aIndex, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(264));
			return;
		}

		if ((GetTickCount() - lpObj->MySelfDefenseTime) < 30000)
		{
			gNotice.GCNoticeSend(aIndex, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(265));
			return;
		}

		if (gEffectManager.CheckStunEffect(lpObj) != 0 || gEffectManager.CheckImmobilizeEffect(lpObj) != 0)
		{
			gNotice.GCNoticeSend(aIndex, 1, 0, 0, 0, 0, 0, "Corre nao, pai ... aguenta ai.");
			return;
		}

		/*if (g_Labyrinth.IsLabyrinthMapNumber(lpObj->Map) == 1 && gObj[aIndex].Type == OBJECT_USER)
		{
			g_Labyrinth.LeaveLabyrinth(lpObj->Index, lpObj->m_cLabyrinthInfo->GetConfigNum());
		}*/
	}

	lpObj->CloseCount = 4;

	lpObj->CloseType = type;

	lpObj->EnableDelCharacter = 1;
}

bool CObjectManager::CharacterMapServerMove(int aIndex, int map, int x, int y) // OK
{
	if ((gObj[aIndex].NextServerCode = gMapServerManager.CheckMapServerMove(aIndex, map, gObj[aIndex].LastServerCode)) != -1)
	{
		if (gObj[aIndex].NextServerCode != gServerInfo.m_ServerCode)
		{
			GJMapServerMoveSend(aIndex, gObj[aIndex].NextServerCode, map, x, y);
			return 1;
		}
	}

	return 0;
}

void CObjectManager::CharacterUpdateMapEffect(LPOBJ lpObj) // OK
{
#if(GAMESERVER_TYPE==1)

	if (lpObj->Map == MAP_CASTLE_SIEGE)
	{
		GCAnsCsNotifyStart(lpObj->Index, ((gCastleSiege.GetCastleState() == CASTLESIEGE_STATE_STARTSIEGE) ? 1 : 0));

		if (gCastleSiege.GetCastleState() == CASTLESIEGE_STATE_STARTSIEGE)
		{
			gCastleSiege.NotifySelfCsJoinSide(lpObj->Index);
			gCastleSiege.NotifyCsSelfLeftTime(lpObj->Index);
		}
	}

#endif

	if (lpObj->Map == MAP_RAKLION1 || lpObj->Map == MAP_RAKLION2)
	{
		gRaklionUtil.NotifyRaklionState(lpObj->Index, gRaklion.GetRaklionState(), gRaklion.GetRaklionDetailState());
	}

	gMonsterSpawner.CheckAndSendMapEffect(lpObj);
}

bool CObjectManager::CharacterGetRespawnLocation(LPOBJ lpObj) // OK
{
	if (IsPvPTestOn || lpObj->isGhost || lpObj->AutoPVPTesting)
	{
		return 0;
	}

	bool result = 0;

	int gate, map, x, y, dir, level;

	if (lpObj->Map == MAP_LORENCIA)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DUNGEON)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DEVIAS)
	{
		result = gGate.GetGate(22, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_NORIA)
	{
		result = gGate.GetGate(27, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_LOST_TOWER)
	{
		result = gGate.GetGate(42, &gate, &map, &x, &y, &dir, &level);
	}
	else if (CA_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gCustomArena.GetUserRespawnLocation(lpObj, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_ARENA)
	{
		result = gGate.GetGate(115, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_ATLANS)
	{
		result = gGate.GetGate(49, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_TARKAN)
	{
		result = gGate.GetGate(57, &gate, &map, &x, &y, &dir, &level);
	}
	else if (DS_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(503, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_ICARUS)
	{
		result = gGate.GetGate(72, &gate, &map, &x, &y, &dir, &level);
	}
	else if (BC_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(503, &gate, &map, &x, &y, &dir, &level);
	}
	else if (CC_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(503, &gate, &map, &x, &y, &dir, &level);
	}
	else if (KALIMA_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(503, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_CASTLE_SIEGE)
	{
#if(GAMESERVER_TYPE==0)
		result = gGate.GetGate(100, &gate, &map, &x, &y, &dir, &level);
#else

		if (gLifeStone.SetReSpawnUserXY(lpObj->Index) == 0)
		{
			if (lpObj->CsJoinSide == 1)
			{
				result = gGate.GetGate(101, &gate, &map, &x, &y, &dir, &level);
			}
			else
			{
				result = gGate.GetGate(100, &gate, &map, &x, &y, &dir, &level);
			}
		}

#endif
	}
	else if (lpObj->Map == MAP_LAND_OF_TRIALS)
	{
		result = gGate.GetGate(106, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_AIDA)
	{
		result = gGate.GetGate(119, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_CRYWOLF)
	{
		result = gGate.GetGate(118, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_RESERVED2)
	{
		result = gGate.GetGate(401, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_KANTURU1)
	{
		result = gGate.GetGate(138, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_KANTURU2)
	{
		result = gGate.GetGate(139, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_KANTURU3)
	{
		result = gGate.GetGate(137, &gate, &map, &x, &y, &dir, &level);

		gKanturuBattleUserMng.DelUserData(lpObj->Index);
	}
	else if (lpObj->Map == MAP_SILENT)
	{
		result = gGate.GetGate(402, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_BARRACKS)
	{
		result = gGate.GetGate(256, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_REFUGE)
	{
		result = gGate.GetGate(256, &gate, &map, &x, &y, &dir, &level);
	}
	else if (IT_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gIllusionTemple.GetUserRespawnLocation(lpObj, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_ELBELAND)
	{
		result = gGate.GetGate(267, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_SWAMP_OF_CALMNESS)
	{
		result = gGate.GetGate(273, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_RAKLION1)
	{
		result = gGate.GetGate(286, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_RAKLION2)
	{
		result = gGate.GetGate(286, &gate, &map, &x, &y, &dir, &level);
		gRaklionBattleUserMng.DelUserData(lpObj->Index);
	}
	else if (lpObj->Map == MAP_SANTA_TOWN)
	{
		result = gGate.GetGate(22, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_VULCANUS)
	{
		result = gGate.GetGate(294, &gate, &map, &x, &y, &dir, &level);
	}
	else if (DA_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(294, &gate, &map, &x, &y, &dir, &level);
	}
	else if (DG_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(267, &gate, &map, &x, &y, &dir, &level);
	}
	else if (IG_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(22, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_EVENT_SQUARE)
	{
		result = gGate.GetGate(503, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_KARUTAN1)
	{
		result = gGate.GetGate(335, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_KARUTAN2)
	{
		result = gGate.GetGate(335, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_ACHERON1)
	{
		result = gGate.GetGate(417, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_ACHERON2)
	{
		result = gGate.GetGate(426, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DEVENTER1)
	{
		result = gGate.GetGate(417, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DEVENTER2)
	{
		result = gGate.GetGate(426, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_CHAOS_CASTLE_FINAL)
	{
		result = gGate.GetGate(503, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_URUK_MOUNTAIN)
	{
		result = gGate.GetGate(417, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DURBAN_TYLER)
	{
		result = gGate.GetGate(417, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_FEREA)
	{
		result = gGate.GetGate(509, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_KNICKS)
	{
		result = gGate.GetGate(522, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_Labyrinth)
	{
		result = gGate.GetGate(503, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DEEP_DUNGEON1)
	{
		result = gGate.GetGate(561, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DEEP_DUNGEON2)
	{
		result = gGate.GetGate(562, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DEEP_DUNGEON3)
	{
		result = gGate.GetGate(563, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DEEP_DUNGEON4)
	{
		result = gGate.GetGate(564, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_DEEP_DUNGEON5)
	{
		result = gGate.GetGate(565, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_4_TH_QUEST)
	{
		result = gGate.GetGate(537, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_SWAMP_OF_DARKNESS)
	{
		result = gGate.GetGate(567, &gate, &map, &x, &y, &dir, &level);
	}

	if (result != 0)
	{
		lpObj->Map = map;
		lpObj->X = x;
		lpObj->Y = y;
		lpObj->Dir = dir;
	}

	return result;
}

void CObjectManager::CharacterCalcExperienceSplit(LPOBJ lpObj, LPOBJ lpMonster, int damage, int flag) // OK
{
	if (lpMonster->Type != OBJECT_MONSTER)
	{
		return;
	}

	gObjMonsterDelHitDamageUser(lpMonster);

	lpMonster->Money = 0;

	for (int n = 0; n < MAX_HIT_DAMAGE; n++)
	{
		if (OBJECT_RANGE(lpMonster->HitDamage[n].index) == 0)
		{
			continue;
		}

		if (lpMonster->HitDamage[n].damage == 0)
		{
			continue;
		}

		if (lpMonster->HitDamage[n].index == lpObj->Index)
		{
			this->CharacterCalcExperienceAlone(&gObj[lpMonster->HitDamage[n].index], lpMonster, lpMonster->HitDamage[n].damage, flag, 0, damage);
		}
		else
		{
			this->CharacterCalcExperienceAlone(&gObj[lpMonster->HitDamage[n].index], lpMonster, lpMonster->HitDamage[n].damage, flag, 1, damage);
		}
	}
}

void CObjectManager::CharacterCalcExperienceAlone(LPOBJ lpObj, LPOBJ lpMonster, int damage, int flag, bool type, int AttackDamage) // OK
{
	if (lpMonster->Type != OBJECT_MONSTER)
	{
		return;
	}

	int level = ((lpMonster->Level + 25) * lpMonster->Level) / 3;

	if (gMasterSkillTree.CheckMasterLevel(lpObj) == 0)
	{
		level = (((lpMonster->Level + 10) < lpObj->Level) ? ((level * (lpMonster->Level + 10)) / lpObj->Level) : level);
	}
	else
	{
		if (gMasterSkillTree_4th.CheckForMaster(lpObj) == 0)
		{
			level = (((lpMonster->Level + 10) < (lpObj->Level + lpObj->MasterLevel)) ? ((level * (lpMonster->Level + 10)) / (lpObj->Level + lpObj->MasterLevel)) : level);
		}
		else
		{
			level = (((lpMonster->Level + 10) < (lpObj->Level + lpObj->MasterLevel)) ? ((level * (lpMonster->Level + 10)) / (lpObj->Level + lpObj->MasterLevel)) : level);
		}
	}

	if (lpMonster->Level >= 65)
	{
		level += (lpMonster->Level - 64) * (lpMonster->Level / 4);
	}

	level = ((level < 0) ? 0 : level);

	damage = ((damage > lpMonster->MaxLife) ? (int)lpMonster->MaxLife : damage);

	__int64 experience = level + (level / 4);

	if (gMasterSkillTree.CheckMasterLevel(lpObj) == 0)
	{
		experience = ((damage * experience) / (int)lpMonster->MaxLife) * gServerInfo.m_AddExperienceRate[lpObj->AccountLevel];

		experience = (experience * (lpObj->ExperienceRate + lpObj->EffectOption.AddExperienceRate)) / 100;

		experience = (experience * (gMapManager.GetMapExperienceRate(lpObj->Map) + ((lpObj->Map == MAP_VULCANUS) ? lpObj->EffectOption.AddVolcanoExperienceRate : 0))) / 100;

		experience = (experience * gBonusManager.GetBonusValue(lpObj, BONUS_INDEX_EXPERIENCE_RATE, 100, -1, -1, lpMonster->Class, lpMonster->Level)) / 100;

		experience = (experience * gExperienceTable.GetExperienceRate(lpObj)) / 100;
	}
	else
	{
		if (gMasterSkillTree_4th.CheckForMaster(lpObj) == 0)
		{
			experience = ((damage * experience) / (int)lpMonster->MaxLife) * gServerInfo.m_AddMasterExperienceRate[lpObj->AccountLevel];

			experience = (experience * (lpObj->MasterExperienceRate + lpObj->EffectOption.AddMasterExperienceRate)) / 100;

			experience = (experience * (gMapManager.GetMapMasterExperienceRate(lpObj->Map) + ((lpObj->Map == MAP_VULCANUS) ? lpObj->EffectOption.AddVolcanoExperienceRate : 0))) / 100;

			experience = (experience * gBonusManager.GetBonusValue(lpObj, BONUS_INDEX_MASTER_EXPERIENCE_RATE, 100, -1, -1, lpMonster->Class, lpMonster->Level)) / 100;

			experience = (experience * gExperienceTable.GetMasterExperienceRate(lpObj)) / 100;
		}
		else
		{
			experience = ((damage * experience) / (int)lpMonster->MaxLife) * gServerInfo.m_AddForMasterExperienceRate[lpObj->AccountLevel];

			experience = (experience * (lpObj->MasterExperienceRate + lpObj->EffectOption.AddForMasterExperienceRate)) / 100;

			experience = (experience * (gMapManager.GetMapMasterExperienceRate(lpObj->Map) + ((lpObj->Map == MAP_VULCANUS) ? lpObj->EffectOption.AddVolcanoExperienceRate : 0))) / 100;

			experience = (experience * gBonusManager.GetBonusValue(lpObj, BONUS_INDEX_MASTER_EXPERIENCE_RATE, 100, -1, -1, lpMonster->Class, lpMonster->Level)) / 100;

			experience = (experience * gExperienceTable.GetMasterExperienceRate(lpObj)) / 100;
		}
	}

	/*if (gCrywolfSync.CheckApplyPenalty() != 0)
	{
		if (gCrywolfSync.GetOccupationState() == 1)
		{
			experience = (experience * gCrywolfSync.GetGettingExpPenaltyRate()) / 100;
		}
	}*/

	gCGHuntingGrounds.AddGainExp(lpObj->Index, lpMonster->Class, experience);

	/*if (g_Labyrinth.IsLabyrinthMapNumber(lpObj->Map) == 1 && lpObj->Type == OBJECT_USER)
	{
		lpObj->m_cLabyrinthInfo->CheckPlayMission(lpObj->Index, experience, LAB_MISSION_EXP, -1);
		lpObj->m_cLabyrinthInfo->AddEntireExp(experience);
	}*/

	lpMonster->Money += (DWORD)experience;

	this->CharacterPetLevelUp(lpObj, (DWORD)experience);

	if (gMasterSkillTree.CheckMasterLevel(lpObj) != 0 && lpMonster->Level < gServerInfo.m_MinMasterExperienceMonsterLevel[lpObj->AccountLevel])
	{
		GCMonsterDieSend(lpObj->Index, lpMonster->Index, 0, ((type == 0) ? AttackDamage : 0), flag);
		return;
	}

	if (gEffectManager.CheckEffect(lpObj, EFFECT_SEAL_OF_SUSTENANCE1) != 0 || gEffectManager.CheckEffect(lpObj, EFFECT_SEAL_OF_SUSTENANCE2) != 0)
	{
		GCMonsterDieSend(lpObj->Index, lpMonster->Index, 0, ((type == 0) ? AttackDamage : 0), flag);
		return;
	}

	if (this->CharacterLevelUp(lpObj, experience, gServerInfo.m_MaxLevelUp, EXPERIENCE_COMMON) == 0)
	{
		GCMonsterDieSend(lpObj->Index, lpMonster->Index, (DWORD)experience, ((type == 0) ? AttackDamage : 0), flag);
	}
	else
	{
		GCMonsterDieSend(lpObj->Index, lpMonster->Index, 0, ((type == 0) ? AttackDamage : 0), flag);
	}
}

void CObjectManager::CharacterCalcExperienceParty(LPOBJ lpObj, LPOBJ lpMonster, int damage, int flag) // OK
{
	if (OBJECT_RANGE(lpObj->PartyNumber) == 0)
	{
		return;
	}

	if (lpMonster->Type != OBJECT_MONSTER)
	{
		return;
	}

	PARTY_INFO* lpParty = &gParty.m_PartyInfo[lpObj->PartyNumber];

	int PartyTopLevel = 0;

	for (int n = 0; n < MAX_PARTY_USER; n++)
	{
		if (OBJECT_RANGE(lpParty->Index[n]) != 0)
		{
			if (lpMonster->Map == gObj[lpParty->Index[n]].Map && gObjCalcDistance(lpMonster, &gObj[lpParty->Index[n]]) < MAX_PARTY_DISTANCE)
			{
				if (gMasterSkillTree.CheckMasterLevel(&gObj[lpParty->Index[n]]) == 0)
				{
					PartyTopLevel = ((gObj[lpParty->Index[n]].Level > PartyTopLevel) ? gObj[lpParty->Index[n]].Level : PartyTopLevel);
				}
				else
				{
					if (gMasterSkillTree_4th.CheckForMaster(&gObj[lpParty->Index[n]]) == 0)
					{
						PartyTopLevel = (((gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel) > PartyTopLevel) ? (gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel) : PartyTopLevel);
					}
					else
					{
						PartyTopLevel = (((gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel) > PartyTopLevel) ? (gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel) : PartyTopLevel);
					}
				}
			}
		}
	}

	int TotalLevel = 0;
	int PartyLevel = 0;
	int PartyTable = 0;
	int PartyClass = 0;
	int PartyCount = 0;

	for (int n = 0; n < MAX_PARTY_USER; n++)
	{
		if (OBJECT_RANGE(lpParty->Index[n]) != 0)
		{
			if (gObj[lpParty->Index[n]].Map == lpMonster->Map && gObjCalcDistance(lpMonster, &gObj[lpParty->Index[n]]) < MAX_PARTY_DISTANCE)
			{
				if (gMasterSkillTree.CheckMasterLevel(&gObj[lpParty->Index[n]]) == 0)
				{
					TotalLevel += (((gObj[lpParty->Index[n]].Level + 200) < PartyTopLevel) ? (gObj[lpParty->Index[n]].Level + 200) : gObj[lpParty->Index[n]].Level);
					PartyTable += (((PartyTable & (1 << gObj[lpParty->Index[n]].Class)) == 0) ? (1 << gObj[lpParty->Index[n]].Class) : ((++PartyClass) * 0));
					PartyCount++;
				}
				else
				{
					if (gMasterSkillTree_4th.CheckForMaster(&gObj[lpParty->Index[n]]) == 0)
					{
						TotalLevel += ((((gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel) + 200) < PartyTopLevel) ? ((gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel) + 200) : (gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel));
					}
					else
					{
						TotalLevel += ((((gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel) + 200) < PartyTopLevel) ? ((gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel) + 200) : (gObj[lpParty->Index[n]].Level + gObj[lpParty->Index[n]].MasterLevel));
					}

					PartyTable += (((PartyTable & (1 << gObj[lpParty->Index[n]].Class)) == 0) ? (1 << gObj[lpParty->Index[n]].Class) : ((++PartyClass) * 0));
					PartyCount++;
				}
			}
		}
	}

	if (PartyCount == 0) { return; }

	int ExperienceRate = (((PartyClass >= 3) ? gServerInfo.m_PartySpecialExperience[(PartyCount - 1)] : gServerInfo.m_PartyGeneralExperience[(PartyCount - 1)]) * PartyCount);

	PartyLevel = TotalLevel / PartyCount;

	int level = ((lpMonster->Level + 25) * lpMonster->Level) / 3;

	if ((lpMonster->Level + 10) < PartyLevel)
	{
		level = (level * (lpMonster->Level + 10)) / PartyLevel;
	}

	if (lpMonster->Level >= 65)
	{
		if (PartyCount == 1)
		{
			level += (lpMonster->Level - 64) * (lpMonster->Level / 4);
		}
		else
		{
			if (gMasterSkillTree.CheckMasterLevel(lpObj) == 0)
			{
				level += (200 - (lpObj->Level / 5));
			}
			else
			{
				if (gMasterSkillTree_4th.CheckForMaster(lpObj) == 0)
				{
					level += (200 - ((lpObj->Level + lpObj->MasterLevel) / 5));
				}
				else
				{
					level += (200 - ((lpObj->Level + lpObj->MasterLevel) / 5));
				}
			}
		}
	}

	level = ((level < 0) ? 0 : level);

	DWORD TotalExperience = level + (level / 4);

	lpMonster->Money = 0;

	for (int n = 0; n < MAX_PARTY_USER; n++)
	{
		if (OBJECT_RANGE(lpParty->Index[n]) == 0)
		{
			continue;
		}

		LPOBJ lpTarget = &gObj[lpParty->Index[n]];

		if (lpTarget->Map != lpMonster->Map || gObjCalcDistance(lpMonster, lpTarget) >= MAX_PARTY_DISTANCE)
		{
			continue;
		}

		__int64 experience = 0;

		if (gMasterSkillTree.CheckMasterLevel(lpTarget) == 0)
		{
			experience = ((((TotalExperience * ExperienceRate) * lpTarget->Level) / TotalLevel) / 100) * gServerInfo.m_AddExperienceRate[lpTarget->AccountLevel];

			experience = (experience * (lpTarget->ExperienceRate + lpTarget->EffectOption.AddExperienceRate + (lpTarget->EffectOption.AddPartyBonusExperienceRate * (PartyCount - 1)))) / 100;

			experience = (experience * (gMapManager.GetMapExperienceRate(lpTarget->Map) + ((lpTarget->Map == MAP_VULCANUS) ? lpTarget->EffectOption.AddVolcanoExperienceRate : 0))) / 100;

			experience = (experience * gBonusManager.GetBonusValue(lpTarget, BONUS_INDEX_EXPERIENCE_RATE, 100, -1, -1, lpMonster->Class, lpMonster->Level)) / 100;

			experience = (experience * gExperienceTable.GetExperienceRate(lpTarget)) / 100;
		}
		else
		{
			if (gMasterSkillTree_4th.CheckForMaster(lpTarget) == 0)
			{
				experience = ((((TotalExperience * ExperienceRate) * (lpTarget->Level + lpTarget->MasterLevel)) / TotalLevel) / 100) * gServerInfo.m_AddMasterExperienceRate[lpTarget->AccountLevel];

				experience = (experience * (lpTarget->MasterExperienceRate + lpTarget->EffectOption.AddMasterExperienceRate + (lpTarget->EffectOption.AddPartyBonusExperienceRate * (PartyCount - 1)))) / 100;

				experience = (experience * (gMapManager.GetMapMasterExperienceRate(lpTarget->Map) + ((lpTarget->Map == MAP_VULCANUS) ? lpTarget->EffectOption.AddVolcanoExperienceRate : 0))) / 100;

				experience = (experience * gBonusManager.GetBonusValue(lpTarget, BONUS_INDEX_MASTER_EXPERIENCE_RATE, 100, -1, -1, lpMonster->Class, lpMonster->Level)) / 100;

				experience = (experience * gExperienceTable.GetMasterExperienceRate(lpTarget)) / 100;
			}
			else
			{
				experience = ((((TotalExperience * ExperienceRate) * (lpTarget->Level + lpTarget->MasterLevel)) / TotalLevel) / 100) * gServerInfo.m_AddForMasterExperienceRate[lpTarget->AccountLevel];

				experience = (experience * (gMapManager.GetMapMasterExperienceRate(lpTarget->Map) + ((lpTarget->Map == MAP_VULCANUS) ? lpTarget->EffectOption.AddVolcanoExperienceRate : 0))) / 100;

				experience = (experience * gBonusManager.GetBonusValue(lpTarget, BONUS_INDEX_MASTER_EXPERIENCE_RATE, 100, -1, -1, lpMonster->Class, lpMonster->Level)) / 100;

				experience = (experience * gExperienceTable.GetMasterExperienceRate(lpTarget)) / 100;
			}
		}

		/*if (gCrywolfSync.CheckApplyPenalty() != 0)
		{
			if (gCrywolfSync.GetOccupationState() == 1)
			{
				experience = (experience * gCrywolfSync.GetGettingExpPenaltyRate()) / 100;
			}
		}*/

		gCGHuntingGrounds.AddGainExp(lpTarget->Index, lpMonster->Class, experience);

		lpMonster->Money += (DWORD)(experience / PartyCount);

		this->CharacterPetLevelUp(lpTarget, (DWORD)experience);

		if (gMasterSkillTree.CheckMasterLevel(lpTarget) != 0 && lpMonster->Level < gServerInfo.m_MinMasterExperienceMonsterLevel[lpTarget->AccountLevel])
		{
			GCMonsterDieSend(lpTarget->Index, lpMonster->Index, 0, damage, flag);
			continue;
		}

		if (gEffectManager.CheckEffect(lpTarget, EFFECT_SEAL_OF_SUSTENANCE1) != 0 || gEffectManager.CheckEffect(lpTarget, EFFECT_SEAL_OF_SUSTENANCE2) != 0)
		{
			GCMonsterDieSend(lpTarget->Index, lpMonster->Index, 0, damage, flag);
			continue;
		}

		if (this->CharacterLevelUp(lpTarget, experience, gServerInfo.m_MaxLevelUp, EXPERIENCE_PARTY) == 0)
		{
			GCMonsterDieSend(lpTarget->Index, lpMonster->Index, (DWORD)experience, damage, flag);
		}
		else
		{
			GCMonsterDieSend(lpTarget->Index, lpMonster->Index, 0, damage, flag);
		}
	}
}

bool CObjectManager::CharacterLevelUp(LPOBJ lpObj, __int64 AddExperience, int MaxLevelUp, int ExperienceType) // OK
{
	if (gMasterSkillTree.CheckMasterLevel(lpObj) == 0)
	{
		if (lpObj->Level >= MAX_CHARACTER_LEVEL)
		{
			//gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(266));
			return 1;
		}

		if ((lpObj->Experience + AddExperience) < lpObj->NextExperience)
		{
			lpObj->Experience += AddExperience;
			return 0;
		}

		while (true)
		{
			lpObj->Level++;

			lpObj->LevelUpPoint += gServerInfo.m_LevelUpPoint[lpObj->Class];

			lpObj->LevelUpPoint += ((lpObj->Level > 220) ? ((gQuest.CheckQuestListState(lpObj, 2, QUEST_FINISH) == 0) ? 0 : gServerInfo.m_PlusStatPoint) : 0);

			//Auto stats add
			int availablePoints = lpObj->LevelUpPoint;

			for (int i = 0; i < 5; i++)
			{
				if (lpObj->Class != CLASS_DL && i == 4)
				{
					break;
				}

				int addPoints = GetRoundValue(availablePoints * lpObj->AutoDtFix[i] / 100);

				if (addPoints > 0)
				{
					gObjectManager.CharacterLevelUpPointAdd(lpObj, i, addPoints, false);
				}
			}

			AddExperience -= (((--MaxLevelUp) == 0) ? AddExperience : (lpObj->NextExperience - lpObj->Experience));

			lpObj->Experience = lpObj->NextExperience;

			gObjCalcExperience(lpObj);

			if (lpObj->Level >= MAX_CHARACTER_LEVEL)
			{
				AddExperience = 0;
				break;
			}

			if ((lpObj->Experience + AddExperience) < lpObj->NextExperience)
			{
				lpObj->Experience += AddExperience;
				break;
			}
		}

		this->CharacterCalcAttribute(lpObj->Index);

		lpObj->Life = lpObj->MaxLife + lpObj->AddLife;
		lpObj->Mana = lpObj->MaxMana + lpObj->AddMana;
		lpObj->BP = lpObj->MaxBP + lpObj->AddBP;
		lpObj->Shield = lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield;

		GCLevelUpSend(lpObj);
	}
	else
	{
		if (lpObj->MasterLevel >= gServerInfo.m_MasterSkillTreeMaxLevel && gMasterSkillTree_4th.CheckForMaster(lpObj) == 0)
		{
			//gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(267));
			return 1;
		}
		else
		{
			if (gMasterSkillTree_4th.CheckForMaster(lpObj))
			{
				if ((lpObj->MasterLevel - gServerInfo.m_MasterSkillTreeMaxLevel) >= gServerInfo.m_ForMasterTreeMaxLevel)
				{
					//gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(267));
					return 1;
				}
			}

			while (true)
			{
				if ((lpObj->MasterExperience + AddExperience) < lpObj->MasterNextExperience)
				{
					lpObj->MasterExperience += AddExperience;
					return 0;
				}

				if (gMasterSkillTree_4th.CheckForMaster(lpObj) && lpObj->MasterLevel >= gServerInfo.m_MasterSkillTreeMaxLevel)
				{
					lpObj->SkillEnhanceTreePoints += gServerInfo.m_ForMasterSkillTreePoint;
					gMasterSkillTree_4th.GCSkillTreeEnchancePointSend(lpObj);
				}
				else
				{
					if (lpObj->ChangeUp >= gServerInfo.m_MasterSkillTreeMinClass)
					{
						if (gMasterSkillTree.GetMasterSkillTreeTotalPoints(lpObj) < ((lpObj->MasterLevel + 1) * gServerInfo.m_MasterSkillTreePoint))
						{
							lpObj->MasterPoint += gServerInfo.m_MasterSkillTreePoint;
						}
					}
				}

				lpObj->MasterLevel++;

				AddExperience -= (((--MaxLevelUp) == 0) ? AddExperience : (DWORD)(lpObj->MasterNextExperience - lpObj->MasterExperience));

				lpObj->MasterExperience = lpObj->MasterNextExperience;

				gObjCalcExperience(lpObj);

				if (gMasterSkillTree_4th.CheckForMaster(lpObj) && (gServerInfo.m_MasterSkillTreeMaxLevel - lpObj->MasterLevel) >= gServerInfo.m_ForMasterTreeMaxLevel)
				{
					AddExperience = 0;
					break;
				}

				if (gMasterSkillTree_4th.CheckForMaster(lpObj) == 0 && lpObj->MasterLevel >= gServerInfo.m_MasterSkillTreeMaxLevel)
				{
					AddExperience = 0;
					break;
				}

				if ((lpObj->MasterExperience + AddExperience) < lpObj->MasterNextExperience)
				{
					lpObj->MasterExperience += AddExperience;
					break;
				}
			}

			this->CharacterCalcAttribute(lpObj->Index);

			lpObj->Life = lpObj->MaxLife + lpObj->AddLife;
			lpObj->Mana = lpObj->MaxMana + lpObj->AddMana;
			lpObj->BP = lpObj->MaxBP + lpObj->AddBP;
			lpObj->Shield = lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield;

			gMasterSkillTree.GCMasterLevelUpSend(lpObj);
			gMasterSkillTree.GCMasterInfoSend(lpObj);
		}
	}

	if ((GetTickCount() - lpObj->CharSaveTime) > 15000)
	{
		GDCharacterInfoSaveSend(lpObj->Index);
	}

	return 1;
}

bool CObjectManager::CharacterLevelUpPointAdd(LPOBJ lpObj, int type, int amount, bool send) // OK
{
	if (lpObj->Type != OBJECT_USER)
	{
		return 0;
	}

	if (lpObj->LevelUpPoint < amount)
	{
		return 0;
	}

	if (lpObj->Map == MAP_ARENA && (lpObj->MUFCFighter == 1 || lpObj->MUFCFighter == 2))
	{
		GCMessagePopupSend(lpObj, "Voce nao pode mexer nos pontos durante o MUFC.");
		return 0;
	}

	int* stat;

	switch (type)
	{
	case 0:
		stat = &lpObj->Strength;
		break;
	case 1:
		stat = &lpObj->Dexterity;
		break;
	case 2:
		stat = &lpObj->Vitality;
		break;
	case 3:
		stat = &lpObj->Energy;
		break;
	case 4:
		stat = &lpObj->Leadership;
		break;
	default:
		return 0;
	}

	if (((*stat) + amount) > gServerInfo.m_MaxStatPoint[lpObj->AccountLevel])
	{
		gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(268), gServerInfo.m_MaxStatPoint[lpObj->AccountLevel]);
		return 0;
	}

	(*stat) += amount;

	lpObj->LevelUpPoint -= amount;

	if (send)
	{
		this->CharacterCalcAttribute(lpObj->Index);
	}

	return 1;
}

void CObjectManager::CharacterPetLevelUp(LPOBJ lpObj, DWORD AddExperience) // OK
{
	if (lpObj->Inventory[lpObj->m_btInvenPetPos].m_Index == GET_ITEM(13, 4)) // Dark Horse
	{
		if (lpObj->Inventory[lpObj->m_btInvenPetPos].AddPetItemExp((AddExperience / 10)) == 0)
		{
			GCPetItemInfoSend(lpObj->Index, 1, 0, 8, lpObj->Inventory[lpObj->m_btInvenPetPos].m_PetItemLevel, lpObj->Inventory[lpObj->m_btInvenPetPos].m_PetItemExp, (BYTE)lpObj->Inventory[lpObj->m_btInvenPetPos].m_Durability);
		}
		else
		{
			if (gItemManager.IsValidItem(lpObj, &lpObj->Inventory[lpObj->m_btInvenPetPos]) == 0)
			{
				if (lpObj->Inventory[lpObj->m_btInvenPetPos].DecPetItemExp((AddExperience / 10)) != 0)
				{
					GCPetItemInfoSend(lpObj->Index, 1, 0, 8, lpObj->Inventory[lpObj->m_btInvenPetPos].m_PetItemLevel, lpObj->Inventory[lpObj->m_btInvenPetPos].m_PetItemExp, (BYTE)lpObj->Inventory[lpObj->m_btInvenPetPos].m_Durability);
				}
			}
			else
			{
				GCPetItemInfoSend(lpObj->Index, 1, 0xFE, 8, lpObj->Inventory[lpObj->m_btInvenPetPos].m_PetItemLevel, lpObj->Inventory[lpObj->m_btInvenPetPos].m_PetItemExp, (BYTE)lpObj->Inventory[lpObj->m_btInvenPetPos].m_Durability);
			}
		}
	}

	if (lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_Index == GET_ITEM(13, 5)) // Dark Reaven
	{
		if (lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].AddPetItemExp((AddExperience / 10)) == 0)
		{
			GCPetItemInfoSend(lpObj->Index, 0, 0, 1, lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_PetItemLevel, lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_PetItemExp, (BYTE)lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_Durability);
		}
		else
		{
			if (gItemManager.IsValidItem(lpObj, &lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos]) == 0)
			{
				if (lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].DecPetItemExp((AddExperience / 10)) != 0)
				{
					GCPetItemInfoSend(lpObj->Index, 0, 0, 1, lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_PetItemLevel, lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_PetItemExp, (BYTE)lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_Durability);
				}
			}
			else
			{
				GCPetItemInfoSend(lpObj->Index, 0, 0xFE, 1, lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_PetItemLevel, lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_PetItemExp, (BYTE)lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_Durability);
			}
		}
	}
}

void CObjectManager::CharacterMakePreviewCharSet(int aIndex) // OK
{
	LPOBJ lpObj = &gObj[aIndex];

	this->CharacterMakePreviewCharSetAntilag(aIndex);
	this->CharacterMakePreviewCharSetAntilag2(aIndex);

	memset(lpObj->CharSet, 0, sizeof(lpObj->CharSet));

	lpObj->CharSet[0] = CS_SET_CLASS_SX(lpObj->Class);

	if (lpObj->ChangeUp == 1)//4
	{
		lpObj->CharSet[0] |= CS_SET_CHANGEUP_SXII;
	}

	if (lpObj->ChangeUp == 2)//2
	{
		lpObj->CharSet[0] |= CS_SET_CHANGEUP_SXII;
		lpObj->CharSet[0] |= CS_SET_CHANGEUP2_SXII;

	}
	if (lpObj->ChangeUp == 3)//3
	{
		lpObj->CharSet[0] |= CS_SET_CHANGEUP_SXII;
		lpObj->CharSet[0] |= CS_SET_CHANGEUP2_SXII;
		lpObj->CharSet[0] |= CS_SET_CHANGEUP4_SXII;
	}

	if (lpObj->ActionNumber == ACTION_SIT1)
	{
		lpObj->CharSet[0] |= 2;
	}

	if (lpObj->ActionNumber == ACTION_POSE1)
	{
		lpObj->CharSet[0] |= 3;
	}

	WORD TempInventory[INVENTORY_WEAR_SIZE];

	for (int n = 0; n < INVENTORY_WEAR_SIZE; n++)
	{
		if (n == 0 || n == 1)
		{
			if (lpObj->Inventory[n].IsItem() == 0)
			{
				TempInventory[n] = 0xFFFF;
			}
			else
			{
				TempInventory[n] = lpObj->Inventory[n].m_Index;
			}
		}
		else
		{
			if (lpObj->Inventory[n].IsItem() == 0)
			{
				TempInventory[n] = 0x1FF;
			}
			else
			{
				TempInventory[n] = lpObj->Inventory[n].m_Index % MAX_ITEM_TYPE;
			}
		}
	}

	lpObj->CharSet[1] = TempInventory[0] % 256;
	lpObj->CharSet[12] |= (TempInventory[0] / 16) & 0xF0;

	lpObj->CharSet[2] = TempInventory[1] % 256;
	lpObj->CharSet[13] |= (TempInventory[1] / 16) & 0xF0;

	lpObj->CharSet[3] |= (TempInventory[2] & 0x0F) << 4;
	lpObj->CharSet[9] |= (TempInventory[2] & 0x10) << 3;
	lpObj->CharSet[13] |= (TempInventory[2] & 0x1E0) >> 5;

	lpObj->CharSet[3] |= (TempInventory[3] & 0x0F);
	lpObj->CharSet[9] |= (TempInventory[3] & 0x10) << 2;
	lpObj->CharSet[14] |= (TempInventory[3] & 0x1E0) >> 1;

	lpObj->CharSet[4] |= (TempInventory[4] & 0x0F) << 4;
	lpObj->CharSet[9] |= (TempInventory[4] & 0x10) << 1;
	lpObj->CharSet[14] |= (TempInventory[4] & 0x1E0) >> 5;

	lpObj->CharSet[4] |= (TempInventory[5] & 0x0F);
	lpObj->CharSet[9] |= (TempInventory[5] & 0x10);
	lpObj->CharSet[15] |= (TempInventory[5] & 0x1E0) >> 1;

	lpObj->CharSet[5] |= (TempInventory[6] & 0x0F) << 4;
	lpObj->CharSet[9] |= (TempInventory[6] & 0x10) >> 1;
	lpObj->CharSet[15] |= (TempInventory[6] & 0x1E0) >> 5;

	int level = 0;

	BYTE table[7] = { 1,0,6,5,4,3,2 };

	for (int n = 0; n < 7; n++)
	{
		if (TempInventory[n] != 0x1FF && TempInventory[n] != 0xFFFF)
		{
			level |= ((lpObj->Inventory[n].m_Level - 1) / 2) << (n * 3);

			lpObj->CharSet[10] |= ((lpObj->Inventory[n].m_NewOption & 0x3F) ? 2 : 0) << table[n];
			lpObj->CharSet[11] |= ((lpObj->Inventory[n].m_SetOption & 0x03) ? 2 : 0) << table[n];
		}
	}

	this->CharacterCalcAttribute(aIndex);

	SXGetCharacterInfo(lpObj->Index);

	if (lpObj->IsFullSetItem != 0)
	{
		lpObj->CharSet[11] |= 1;
	}

	lpObj->CharSet[6] = level >> 16;
	lpObj->CharSet[7] = level >> 8;
	lpObj->CharSet[8] = level;

	//Stupid fix for bound wings visual as normal ones
	if (TempInventory[7] == 422) TempInventory[7] = 4;
	else if (TempInventory[7] == 423) TempInventory[7] = 5;
	else if (TempInventory[7] == 424) TempInventory[7] = 3;
	else if (TempInventory[7] == 425) TempInventory[7] = 6;
	else if (TempInventory[7] == 426) TempInventory[7] = 30;
	else if (TempInventory[7] == 427) TempInventory[7] = 42;
	else if (TempInventory[7] == 428) TempInventory[7] = 49;
	else if (TempInventory[7] == 429) TempInventory[7] = 269;
	else if (TempInventory[7] == 430) TempInventory[7] = 37;
	else if (TempInventory[7] == 431) TempInventory[7] = 36;
	else if (TempInventory[7] == 432) TempInventory[7] = 38;
	else if (TempInventory[7] == 433) TempInventory[7] = 39;
	else if (TempInventory[7] == 434) TempInventory[7] = 40;
	else if (TempInventory[7] == 435) TempInventory[7] = 43;
	else if (TempInventory[7] == 436) TempInventory[7] = 50;
	else if (TempInventory[7] == 437) TempInventory[7] = 270;

	//Wings
	if (TempInventory[7] >= 0 && TempInventory[7] <= 6)
	{
		lpObj->CharSet[16] |= ((TempInventory[7] + 1) << 2);
	}
	else if (TempInventory[7] == 30)
	{
		lpObj->CharSet[9] |= 0x03;
		lpObj->CharSet[16] |= 0x18;
	}
	else if (TempInventory[7] >= 36 && TempInventory[7] <= 43)
	{
		lpObj->CharSet[9] |= 1;
		lpObj->CharSet[16] |= ((TempInventory[7] - 36) << 2);
	}
	else if ((TempInventory[7] >= 49 && TempInventory[7] <= 50) || (TempInventory[7] >= 130 && TempInventory[7] <= 135))
	{
		lpObj->CharSet[9] |= 0x02;

		if (TempInventory[7] == 49 || TempInventory[7] == 50)
		{
			lpObj->CharSet[16] |= ((TempInventory[7] - 49) << 2);
		}

		else if (TempInventory[7] >= 130 && TempInventory[7] <= 135)
		{
			lpObj->CharSet[16] |= ((0x02 + (TempInventory[7] - 130)) << 2);
		}
	}
	else if (TempInventory[7] >= 262 && TempInventory[7] <= 269)
	{
		lpObj->CharSet[9] |= 0x03;

		if (TempInventory[7] >= 262 && TempInventory[7] <= 265)
		{
			lpObj->CharSet[16] |= ((TempInventory[7] - 262) << 2);
		}

		if (TempInventory[7] == 266 || TempInventory[7] == 268)
		{
			lpObj->CharSet[16] |= 0x10;
		}

		if (TempInventory[7] == 267)
		{
			lpObj->CharSet[16] |= 0x14;
		}

		if (TempInventory[7] == 269)
		{
			lpObj->CharSet[16] |= 0x1C;
		}
	}
	else if (TempInventory[7] == 270)
	{
		lpObj->CharSet[9] |= 0x04;
		lpObj->CharSet[16] |= 0x08;
	}
	else if (TempInventory[7] == 278)
	{
		lpObj->CharSet[9] |= 0x04;
		lpObj->CharSet[16] |= 0x04;
	}
	else if (TempInventory[7] >= 414 && TempInventory[7] <= 421)
	{
		lpObj->CharSet[9] |= 0x05;
		lpObj->CharSet[16] |= ((TempInventory[7] - 414) << 2);
		lpObj->CharSet[18] |= 15;
	}	

	//Dark raven
	if (TempInventory[8] == 0 || TempInventory[8] == 1 || lpObj->Inventory[lpObj->m_btInvenPetPos].m_Index == GET_ITEM(13, 2))
	{
		lpObj->CharSet[5] |= TempInventory[8];
	}

	//Pets / Guardians
	if (TempInventory[8] == 0x1FF || lpObj->Inventory[lpObj->m_btInvenPetPos].m_Index == -1)
	{
		//lpObj->CharSet[5] |= 3;
		//LogAdd(LOG_DEBUG, "Nada %d %d %d", TempInventory[8], lpObj->m_btInvenPetPos, lpObj->Inventory[lpObj->m_btInvenPetPos].m_Index);
	}
	else if (lpObj->Inventory[lpObj->m_btInvenPetPos].m_Index == GET_ITEM(13, 3)) //Dinorant
	{
		//LogAdd(LOG_DEBUG, "Fazendo Dinorant de %s", lpObj->Name);
		//lpObj->CharSet[5] |= 3;
		lpObj->CharSet[10] |= 1;
	}
	else if (lpObj->Inventory[lpObj->m_btInvenPetPos].m_Index == GET_ITEM(13, 4)) //Dark Horse
	{
		//LogAdd(LOG_DEBUG, "Fazendo cavalo de %s", lpObj->Name);
		//lpObj->CharSet[5] |= 3;
		lpObj->CharSet[12] |= 1;
	}
	else if (lpObj->Inventory[lpObj->m_btInvenPetPos].m_Index == GET_ITEM(13, 37)) //Fenrir
	{
		//LogAdd(LOG_DEBUG, "Fazendo fenrir de %s", lpObj->Name);
		//lpObj->CharSet[5] |= 3;
		lpObj->CharSet[10] &= 0xFE;
		lpObj->CharSet[12] &= 0xFE;
		lpObj->CharSet[12] |= 4;

		if ((lpObj->Inventory[lpObj->m_btInvenPetPos].m_NewOption & 1) != 0)
		{
			lpObj->CharSet[16] |= 1;
		}
		else if ((lpObj->Inventory[lpObj->m_btInvenPetPos].m_NewOption & 2) != 0)
		{
			lpObj->CharSet[16] |= 2;
		}
		else if ((lpObj->Inventory[lpObj->m_btInvenPetPos].m_NewOption & 4) != 0)
		{
			lpObj->CharSet[17] |= 1;
		}
	}

	lpObj->CharSet[5] |= 3;

	BYTE btItemIndex = 0x00;

	//Demon
	if (TempInventory[8] == 64)
	{
		btItemIndex = 0x20;
	}
	else if (TempInventory[8] == 65) //Maria
	{
		btItemIndex = 0x40;
	}
	else if (TempInventory[8] == 67) //Rudolph
	{
		btItemIndex = 0x80;
	}
	else if (TempInventory[8] == 80) //panda
	{
		btItemIndex = 0xE0;
	}
	else if (TempInventory[8] == 123) //skeleton
	{
		btItemIndex = 0x60;
	}
	else if (TempInventory[8] == 469) //sei la
	{
		btItemIndex = 0xE0;
	}
	else if (TempInventory[8] == 470) //sei la
	{
		btItemIndex = 0x60;
	}

	lpObj->CharSet[16] |= btItemIndex;
}

void CObjectManager::CharacterMakePreviewCharSetAntilag(int aIndex) // OK
{
	LPOBJ lpObj = &gObj[aIndex];

	int AntiLagSet[8] = { 2,0,10,5,25,39,59,91 };
	int AntiLagWeapon[8] = { GET_ITEM(5,0), GET_ITEM(0,1), GET_ITEM(4,0), GET_ITEM(0,1), GET_ITEM(2,1), GET_ITEM(5,14), 32, GET_ITEM(0,2) };
	int AntiLagWing[8] = { GET_ITEM(12,133),GET_ITEM(12,134),GET_ITEM(12,132),GET_ITEM(12,134),GET_ITEM(12,130),GET_ITEM(12,131),GET_ITEM(12,135),GET_ITEM(12,278) };

	memset(lpObj->CharSetAntilag, 0, sizeof(lpObj->CharSetAntilag));

	lpObj->CharSetAntilag[0] = CS_SET_CLASS_SX(lpObj->Class);

	if (lpObj->ChangeUp == 1)//4
	{
		lpObj->CharSetAntilag[0] |= CS_SET_CHANGEUP_SXII;
	}

	if (lpObj->ChangeUp == 2)//2
	{
		lpObj->CharSetAntilag[0] |= CS_SET_CHANGEUP_SXII;
		lpObj->CharSetAntilag[0] |= CS_SET_CHANGEUP2_SXII;

	}
	if (lpObj->ChangeUp == 3)//3
	{
		lpObj->CharSetAntilag[0] |= CS_SET_CHANGEUP_SXII;
		lpObj->CharSetAntilag[0] |= CS_SET_CHANGEUP2_SXII;
		lpObj->CharSetAntilag[0] |= CS_SET_CHANGEUP4_SXII;
	}

	if (lpObj->ActionNumber == ACTION_SIT1)
	{
		lpObj->CharSetAntilag[0] |= 2;
	}

	if (lpObj->ActionNumber == ACTION_POSE1)
	{
		lpObj->CharSetAntilag[0] |= 3;
	}

	WORD TempInventory[INVENTORY_WEAR_SIZE];

	for (int n = 0; n < INVENTORY_WEAR_SIZE; n++)
	{
		if (n == 0 || n == 1)
		{
			if (lpObj->Inventory[n].IsItem() == 0)
			{
				TempInventory[n] = 0xFFFF;
			}
			else
			{
				if (n == 0)
				{
					TempInventory[n] = AntiLagWeapon[lpObj->Class];
				}
				else if (n == 1)
				{
					if (lpObj->Inventory[n].m_Index >= GET_ITEM(6, 0) && lpObj->Inventory[n].m_Index < GET_ITEM(7, 0))
					{
						TempInventory[n] = GET_ITEM(6, 0);
					}
					else
					{
						if (lpObj->Class != CLASS_SU)
						{
							TempInventory[n] = AntiLagWeapon[lpObj->Class];
						}
						else
						{
							TempInventory[n] = lpObj->Inventory[n].m_Index;
						}
					}
				}
				else
				{
					TempInventory[n] = lpObj->Inventory[n].m_Index;
				}
			}
		}
		else
		{
			if (lpObj->Inventory[n].IsItem() == 0)
			{
				TempInventory[n] = 0x1FF;
			}
			else
			{
				if ((n >= 2 && n <= 6))
				{
					TempInventory[n] = AntiLagSet[lpObj->Class];
				}
				else if (n == 7)
				{
					TempInventory[n] = AntiLagWing[lpObj->Class] % MAX_ITEM_TYPE;
				}
				else
				{
					TempInventory[n] = lpObj->Inventory[n].m_Index % MAX_ITEM_TYPE;
				}
			}
		}
	}

	lpObj->CharSetAntilag[1] = TempInventory[0] % 256;
	lpObj->CharSetAntilag[12] |= (TempInventory[0] / 16) & 0xF0;

	lpObj->CharSetAntilag[2] = TempInventory[1] % 256;
	lpObj->CharSetAntilag[13] |= (TempInventory[1] / 16) & 0xF0;

	lpObj->CharSetAntilag[3] |= (TempInventory[2] & 0x0F) << 4;
	lpObj->CharSetAntilag[9] |= (TempInventory[2] & 0x10) << 3;
	lpObj->CharSetAntilag[13] |= (TempInventory[2] & 0x1E0) >> 5;

	lpObj->CharSetAntilag[3] |= (TempInventory[3] & 0x0F);
	lpObj->CharSetAntilag[9] |= (TempInventory[3] & 0x10) << 2;
	lpObj->CharSetAntilag[14] |= (TempInventory[3] & 0x1E0) >> 1;

	lpObj->CharSetAntilag[4] |= (TempInventory[4] & 0x0F) << 4;
	lpObj->CharSetAntilag[9] |= (TempInventory[4] & 0x10) << 1;
	lpObj->CharSetAntilag[14] |= (TempInventory[4] & 0x1E0) >> 5;

	lpObj->CharSetAntilag[4] |= (TempInventory[5] & 0x0F);
	lpObj->CharSetAntilag[9] |= (TempInventory[5] & 0x10);
	lpObj->CharSetAntilag[15] |= (TempInventory[5] & 0x1E0) >> 1;

	lpObj->CharSetAntilag[5] |= (TempInventory[6] & 0x0F) << 4;
	lpObj->CharSetAntilag[9] |= (TempInventory[6] & 0x10) >> 1;
	lpObj->CharSetAntilag[15] |= (TempInventory[6] & 0x1E0) >> 5;

	int level = 0;

	BYTE table[7] = { 1,0,6,5,4,3,2 };

	lpObj->CharSetAntilag[6] = level >> 16;
	lpObj->CharSetAntilag[7] = level >> 8;
	lpObj->CharSetAntilag[8] = level;

	//Wings
	if ((TempInventory[7] >= 49 && TempInventory[7] <= 50) || (TempInventory[7] >= 130 && TempInventory[7] <= 135))
	{
		lpObj->CharSetAntilag[9] |= 0x02;

		if (TempInventory[7] == 49 || TempInventory[7] == 50)
		{
			lpObj->CharSetAntilag[16] |= ((TempInventory[7] - 49) << 2);
		}

		else if (TempInventory[7] >= 130 && TempInventory[7] <= 135)
		{
			lpObj->CharSetAntilag[16] |= ((0x02 + (TempInventory[7] - 130)) << 2);
		}
	}
	else if (TempInventory[7] >= 262 && TempInventory[7] <= 269)
	{
		lpObj->CharSetAntilag[9] |= 0x03;

		if (TempInventory[7] >= 262 && TempInventory[7] <= 265)
		{
			lpObj->CharSetAntilag[16] |= ((TempInventory[7] - 262) << 2);
		}

		if (TempInventory[7] == 266 || TempInventory[7] == 268)
		{
			lpObj->CharSetAntilag[16] |= 0x10;
		}

		if (TempInventory[7] == 267)
		{
			lpObj->CharSetAntilag[16] |= 0x14;
		}

		if (TempInventory[7] == 269)
		{
			lpObj->CharSetAntilag[16] |= 0x1C;
		}
	}
	else if (TempInventory[7] == 270)
	{
		lpObj->CharSetAntilag[9] |= 0x04;
	}
	else if (TempInventory[7] == 278)
	{
		lpObj->CharSetAntilag[9] |= 0x04;
		lpObj->CharSetAntilag[16] |= 0x04;
	}

	lpObj->CharSetAntilag[5] |= 3;
	lpObj->CharSetAntilag[16] |= 0x00;
}

void CObjectManager::CharacterMakePreviewCharSetAntilag2(int aIndex) // OK
{
	LPOBJ lpObj = &gObj[aIndex];

	int AntiLagWeapon[8] = { GET_ITEM(5,0), GET_ITEM(0,1), GET_ITEM(4,0), GET_ITEM(0,1), GET_ITEM(2,1), GET_ITEM(5,14), 32, GET_ITEM(0,2) };

	memset(lpObj->CharSetAntilag2, 0, sizeof(lpObj->CharSetAntilag2));

	lpObj->CharSetAntilag2[0] = CS_SET_CLASS_SX(lpObj->Class);

	if (lpObj->ChangeUp == 1)//4
	{
		lpObj->CharSetAntilag2[0] |= CS_SET_CHANGEUP_SXII;
	}

	if (lpObj->ChangeUp == 2)//2
	{
		lpObj->CharSetAntilag2[0] |= CS_SET_CHANGEUP_SXII;
		lpObj->CharSetAntilag2[0] |= CS_SET_CHANGEUP2_SXII;

	}
	if (lpObj->ChangeUp == 3)//3
	{
		lpObj->CharSetAntilag2[0] |= CS_SET_CHANGEUP_SXII;
		lpObj->CharSetAntilag2[0] |= CS_SET_CHANGEUP2_SXII;
		lpObj->CharSetAntilag2[0] |= CS_SET_CHANGEUP4_SXII;
	}

	WORD TempInventory[INVENTORY_WEAR_SIZE];

	for (int n = 0; n < INVENTORY_WEAR_SIZE; n++)
	{
		if (n < 2)
			TempInventory[n] = 0xFFFF;
		else
			TempInventory[n] = 0x1FF;
	}

	lpObj->CharSetAntilag2[1] = TempInventory[0] % 256;
	lpObj->CharSetAntilag2[12] |= (TempInventory[0] / 16) & 0xF0;

	lpObj->CharSetAntilag2[2] = TempInventory[1] % 256;
	lpObj->CharSetAntilag2[13] |= (TempInventory[1] / 16) & 0xF0;

	lpObj->CharSetAntilag2[3] |= (TempInventory[2] & 0x0F) << 4;
	lpObj->CharSetAntilag2[9] |= (TempInventory[2] & 0x10) << 3;
	lpObj->CharSetAntilag2[13] |= (TempInventory[2] & 0x1E0) >> 5;

	lpObj->CharSetAntilag2[3] |= (TempInventory[3] & 0x0F);
	lpObj->CharSetAntilag2[9] |= (TempInventory[3] & 0x10) << 2;
	lpObj->CharSetAntilag2[14] |= (TempInventory[3] & 0x1E0) >> 1;

	lpObj->CharSetAntilag2[4] |= (TempInventory[4] & 0x0F) << 4;
	lpObj->CharSetAntilag2[9] |= (TempInventory[4] & 0x10) << 1;
	lpObj->CharSetAntilag2[14] |= (TempInventory[4] & 0x1E0) >> 5;

	lpObj->CharSetAntilag2[4] |= (TempInventory[5] & 0x0F);
	lpObj->CharSetAntilag2[9] |= (TempInventory[5] & 0x10);
	lpObj->CharSetAntilag2[15] |= (TempInventory[5] & 0x1E0) >> 1;

	lpObj->CharSetAntilag2[5] |= (TempInventory[6] & 0x0F) << 4;
	lpObj->CharSetAntilag2[9] |= (TempInventory[6] & 0x10) >> 1;
	lpObj->CharSetAntilag2[15] |= (TempInventory[6] & 0x1E0) >> 5;

	lpObj->CharSetAntilag2[5] |= 3;
	lpObj->CharSetAntilag2[16] |= 0x00;
}

bool CObjectManager::CharacterUseScroll(LPOBJ lpObj, CItem* lpItem) // OK
{
	int skill, slot;

	if ((lpObj->Strength + lpObj->AddStrength) < lpItem->m_RequireStrength)
	{
		return 0;
	}

	if ((lpObj->Dexterity + lpObj->AddDexterity) < lpItem->m_RequireDexterity)
	{
		return 0;
	}

	if (lpItem->m_Index >= GET_ITEM(12, 8) && lpItem->m_Index <= GET_ITEM(12, 24) || (lpItem->m_Index >= GET_ITEM(12, 44) && lpItem->m_Index <= GET_ITEM(12, 48)))
	{
		if (lpObj->Level < lpItem->m_RequireLevel)
		{
			return 0;
		}
	}

	if ((lpItem->m_Index >= GET_ITEM(12, 44) && lpItem->m_Index <= GET_ITEM(12, 46)) || lpItem->m_Index == GET_ITEM(15, 18) || lpItem->m_Index == GET_ITEM(15, 27) || lpItem->m_Index == GET_ITEM(15, 28))
	{
		if (gQuest.CheckQuestListState(lpObj, 2, QUEST_FINISH) == 0)
		{
			return 0;
		}
	}

	if (gItemManager.CheckItemRequireClass(lpObj, lpItem->m_Index) == 0)
	{
		gItemManager.GCItemDeleteSend(lpObj->Index, -1, 1);
		return 0;
	}

	if ((skill = gSkillManager.GetSkillNumber(lpItem->m_Index, lpItem->m_Level)) == -1)
	{
		gItemManager.GCItemDeleteSend(lpObj->Index, -1, 1);
		return 0;
	}

	if ((slot = gSkillManager.AddSkill(lpObj, skill, lpItem->m_Level)) == -1)
	{
		gItemManager.GCItemDeleteSend(lpObj->Index, -1, 1);
		return 0;
	}

	gSkillManager.GCSkillAddSend(lpObj->Index, slot, skill, (BYTE)lpItem->m_Level, 0);
	return 1;
}

bool CObjectManager::CharacterUsePotion(LPOBJ lpObj, CItem* lpItem) // OK
{
	if (gServerInfo.m_CheckAutoPotionHack != 0 && (GetTickCount64() - lpObj->PotionTime) > 0 && (GetTickCount64() - lpObj->PotionTime) < ((DWORD)gServerInfo.m_CheckAutoPotionHackTolerance))
	{
		return 0;
	}

	lpObj->PotionTime = GetTickCount64();

	int HPValue = 0;
	int SDValue = 0;
	int MPValue = 0;
	int BPValue = 0;

	switch (lpItem->m_Index)
	{
	case GET_ITEM(14, 0):
		HPValue = (int)(((lpObj->MaxLife + lpObj->AddLife) * gServerInfo.m_ApplePotionRate) / 100);
		if (lpObj->AutoPotionBot) return false;
		break;
	case GET_ITEM(14, 1):
		HPValue = (int)(((lpObj->MaxLife + lpObj->AddLife) * gServerInfo.m_SmallLifePotionRate) / 100);
		if (lpObj->AutoPotionBot) return false;
		break;
	case GET_ITEM(14, 2):
		HPValue = (int)(((lpObj->MaxLife + lpObj->AddLife) * gServerInfo.m_MidleLifePotionRate) / 100);
		if (lpObj->AutoPotionBot) return false;
		break;
	case GET_ITEM(14, 3):
		HPValue = (int)(((lpObj->MaxLife + lpObj->AddLife) * gServerInfo.m_LargeLifePotionRate) / 100);
		if (lpObj->AutoPotionBot) return false;
		break;
	case GET_ITEM(14, 4):
		MPValue = (int)(((lpObj->MaxMana + lpObj->AddMana) * gServerInfo.m_SmallManaPotionRate) / 100);
		break;
	case GET_ITEM(14, 5):
		MPValue = (int)(((lpObj->MaxMana + lpObj->AddMana) * gServerInfo.m_MidleManaPotionRate) / 100);
		break;
	case GET_ITEM(14, 6):
		MPValue = (int)(((lpObj->MaxMana + lpObj->AddMana) * gServerInfo.m_LargeManaPotionRate) / 100);
		break;
	case GET_ITEM(14, 35):
		SDValue = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * gServerInfo.m_SmallShieldPotionRate) / 100);
		break;
	case GET_ITEM(14, 36):
		SDValue = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * gServerInfo.m_MidleShieldPotionRate) / 100);
		break;
	case GET_ITEM(14, 37):
		SDValue = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * gServerInfo.m_LargeShieldPotionRate) / 100);
		break;
	case GET_ITEM(14, 38):
		HPValue = (int)(((lpObj->MaxLife + lpObj->AddLife) * gServerInfo.m_SmallCompoundPotionRate1) / 100);
		SDValue = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * gServerInfo.m_SmallCompoundPotionRate2) / 100);
		if (lpObj->AutoPotionBot) return false;
		break;
	case GET_ITEM(14, 39):
		HPValue = (int)(((lpObj->MaxLife + lpObj->AddLife) * gServerInfo.m_MidleCompoundPotionRate1) / 100);
		SDValue = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * gServerInfo.m_MidleCompoundPotionRate2) / 100);
		if (lpObj->AutoPotionBot) return false;
		break;
	case GET_ITEM(14, 40):
		HPValue = (int)(((lpObj->MaxLife + lpObj->AddLife) * gServerInfo.m_LargeCompoundPotionRate1) / 100);
		SDValue = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * gServerInfo.m_LargeCompoundPotionRate2) / 100);
		if (lpObj->AutoPotionBot) return false;
		break;
	case GET_ITEM(14, 70):
		HPValue = (int)(((lpObj->MaxLife + lpObj->AddLife) * gServerInfo.m_EliteLifePotionRate) / 100);
		break;
	case GET_ITEM(14, 71):
		MPValue = (int)(((lpObj->MaxMana + lpObj->AddMana) * gServerInfo.m_EliteManaPotionRate) / 100);
		break;
	case GET_ITEM(14, 133):
		SDValue = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * gServerInfo.m_EliteShieldPotionRate) / 100);
		break;
	}

	if (gEffectManager.CheckEffect(lpObj, EFFECT_PARALYSIS))
	{
		HPValue = (HPValue * gServerInfo.m_ParalyzingConst) / 100;
		SDValue = (SDValue * gServerInfo.m_ParalyzingConst) / 100;
		MPValue = (MPValue * gServerInfo.m_ParalyzingConst) / 100;
		BPValue = (BPValue * gServerInfo.m_ParalyzingConst) / 100;
	}

	if (lpObj->CureImproveRate > 0)
	{
		HPValue += (HPValue * lpObj->CureImproveRate / 100);
	}

	if (gEffectManager.CheckEffect(lpObj, EFFECT_BLINDNES))
	{
		HPValue -= (HPValue * gServerInfo.MASTERY_BONUS_CURE_HARM_FACTOR / 100);
	}

	if ((lpObj->Life + HPValue) > (lpObj->MaxLife + lpObj->AddLife))
	{
		lpObj->Life = lpObj->MaxLife + lpObj->AddLife;
	}
	else
	{
		lpObj->Life += HPValue;
	}

	if ((lpObj->Shield + SDValue) > (lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield))
	{
		lpObj->Shield = lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield;
	}
	else
	{
		lpObj->Shield += SDValue;
	}

	GCLifeSend(lpObj->Index, 0xFF, (int)lpObj->Life, lpObj->Shield);

	if ((lpObj->Mana + MPValue) > (lpObj->MaxMana + lpObj->AddMana))
	{
		lpObj->Mana = lpObj->MaxMana + lpObj->AddMana;
	}
	else
	{
		lpObj->Mana += MPValue;
	}

	if ((lpObj->BP + BPValue) > (lpObj->MaxBP + lpObj->AddBP))
	{
		lpObj->BP = lpObj->MaxBP + lpObj->AddBP;
	}
	else
	{
		lpObj->BP += BPValue;
	}

	GCManaSend(lpObj->Index, 0xFF, (int)lpObj->Mana, lpObj->BP);
	return 1;
}

bool CObjectManager::CharacterUsePortal(LPOBJ lpObj, CItem* lpItem) // OK
{
	if (lpObj->Interface.use != 0)
	{
		return 0;
	}

	if (gEffectManager.CheckStunEffect(lpObj) != 0 || gEffectManager.CheckImmobilizeEffect(lpObj) != 0)
	{
		return 0;
	}

	if (lpObj->Map == MAP_LORENCIA)
	{
		gObjMoveGate(lpObj->Index, 17);
	}
	else if (lpObj->Map == MAP_DUNGEON)
	{
		gObjMoveGate(lpObj->Index, 17);
	}
	else if (lpObj->Map == MAP_DEVIAS)
	{
		gObjMoveGate(lpObj->Index, 22);
	}
	else if (lpObj->Map == MAP_NORIA)
	{
		gObjMoveGate(lpObj->Index, 27);
	}
	else if (lpObj->Map == MAP_LOST_TOWER)
	{
		gObjMoveGate(lpObj->Index, 42);
	}
	else if (lpObj->Map == MAP_ARENA)
	{
		gObjMoveGate(lpObj->Index, 115);
	}
	else if (lpObj->Map == MAP_ATLANS)
	{
		gObjMoveGate(lpObj->Index, 49);
	}
	else if (lpObj->Map == MAP_TARKAN)
	{
		gObjMoveGate(lpObj->Index, 57);
	}
	else if (DS_MAP_RANGE(lpObj->Map) != 0)
	{
		gObjMoveGate(lpObj->Index, 27);
	}
	else if (lpObj->Map == MAP_ICARUS)
	{
		gObjMoveGate(lpObj->Index, 42);
	}
	else if (BC_MAP_RANGE(lpObj->Map) != 0)
	{
		gObjMoveGate(lpObj->Index, 22);
	}
	else if (CC_MAP_RANGE(lpObj->Map) != 0)
	{
		gObjMoveGate(lpObj->Index, 17);
	}
	else if (KALIMA_MAP_RANGE(lpObj->Map) != 0)
	{
		gObjMoveGate(lpObj->Index, 17);
	}
	else if (lpObj->Map == MAP_CASTLE_SIEGE)
	{
#if(GAMESERVER_TYPE==0)

		gObjMoveGate(lpObj->Index, 100);

#else

		if (gCastleSiege.GetCastleState() == CASTLESIEGE_STATE_STARTSIEGE)
		{
			if (lpObj->CsJoinSide == 1)
			{
				gObjMoveGate(lpObj->Index, 101);
			}
			else
			{
				gObjMoveGate(lpObj->Index, 100);
			}
		}
		else
		{
			if (gCastleSiege.CheckCastleOwnerMember(lpObj->Index) != 0 || gCastleSiege.CheckCastleOwnerUnionMember(lpObj->Index) != 0)
			{
				gObjMoveGate(lpObj->Index, 101);
			}
			else
			{
				gObjMoveGate(lpObj->Index, 100);
			}
		}

#endif
	}
	else if (lpObj->Map == MAP_LAND_OF_TRIALS)
	{
		gObjMoveGate(lpObj->Index, 106);
	}
	else if (lpObj->Map == MAP_AIDA)
	{
		gObjMoveGate(lpObj->Index, 119);
	}
	else if (lpObj->Map == MAP_CRYWOLF)
	{
		gObjMoveGate(lpObj->Index, 118);
	}
	else if (lpObj->Map == MAP_KANTURU1)
	{
		gObjMoveGate(lpObj->Index, 138);
	}
	else if (lpObj->Map == MAP_KANTURU2)
	{
		gObjMoveGate(lpObj->Index, 139);
	}
	else if (lpObj->Map == MAP_KANTURU3)
	{
		gObjMoveGate(lpObj->Index, 137);
	}
	else if (lpObj->Map == MAP_BARRACKS)
	{
		gObjMoveGate(lpObj->Index, 256);
	}
	else if (lpObj->Map == MAP_REFUGE)
	{
		gObjMoveGate(lpObj->Index, 256);
	}
	else if (IT_MAP_RANGE(lpObj->Map) != 0)
	{
		gObjMoveGate(lpObj->Index, 267);
	}
	else if (lpObj->Map == MAP_ELBELAND)
	{
		gObjMoveGate(lpObj->Index, 267);
	}
	else if (lpObj->Map == MAP_SWAMP_OF_CALMNESS)
	{
		gObjMoveGate(lpObj->Index, 273);
	}
	else if (lpObj->Map == MAP_RAKLION1)
	{
		gObjMoveGate(lpObj->Index, 286);
	}
	else if (lpObj->Map == MAP_RAKLION2)
	{
		gObjMoveGate(lpObj->Index, 286);
	}
	else if (lpObj->Map == MAP_SANTA_TOWN)
	{
		gObjMoveGate(lpObj->Index, 22);
	}
	else if (lpObj->Map == MAP_VULCANUS)
	{
		gObjMoveGate(lpObj->Index, 294);
	}
	else if (DA_MAP_RANGE(lpObj->Map) != 0)
	{
		gObjMoveGate(lpObj->Index, 294);
	}
	else if (DG_MAP_RANGE(lpObj->Map) != 0)
	{
		gObjMoveGate(lpObj->Index, 267);
	}
	else if (IG_MAP_RANGE(lpObj->Map) != 0)
	{
		gObjMoveGate(lpObj->Index, 22);
	}
	else if (lpObj->Map == MAP_EVENT_SQUARE)
	{
		gObjMoveGate(lpObj->Index, 333);
	}

	else
	{
		gObjMoveGate(lpObj->Index, 17);
	}

	return 1;
}

bool CObjectManager::CharacterUseJewelOfBles(LPOBJ lpObj, int SourceSlot, int TargetSlot) // OK
{
	if (INVENTORY_FULL_RANGE(SourceSlot) == 0)
	{
		return 0;
	}

	if (INVENTORY_FULL_RANGE(TargetSlot) == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[SourceSlot].IsItem() == 0)
	{
		return 0;
	}

	/*if (lpObj->Inventory[SourceSlot].m_Durability > 1)
	{
		return 0;
	}*/

	if (lpObj->Inventory[TargetSlot].IsItem() == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[TargetSlot].m_IsPeriodicItem != 0)
	{
		return 0;
	}

	CItem* lpItem = &lpObj->Inventory[TargetSlot];
	CItem oldItem = lpObj->Inventory[TargetSlot];

	if (lpItem->m_Index == GET_ITEM(0, 41)) // Pick Axe
	{
		GCMessagePopupSend(lpObj, "A pica reta nao pode ser reparada. :(");
		return 0;
	}

	/*if (lpObj->Inventory[SourceSlot].m_Index == GET_ITEM(12, 30) && lpItem->m_Index != GET_ITEM(0, 41))
	{
		return 0;
	}

	if (lpItem->m_Index == GET_ITEM(0, 41)) // Pick Axe
	{
		lpItem->m_Durability += ((lpObj->Inventory[SourceSlot].m_Index == GET_ITEM(12, 30)) ? ((lpObj->Inventory[SourceSlot].m_Level + 1) * 40) : 4);
		lpItem->m_Durability = ((lpItem->m_Durability > 255) ? 255 : lpItem->m_Durability);
		gLog.Output(ITEM_UPGRADE_LOG, "[JewelOfBless][%s][%s] Pandora Pick restored [Durability: %d]", lpObj->Account, lpObj->Name, lpItem->m_Durability);
		return 1;
	}*/

	if (lpItem->m_Index == GET_ITEM(13, 37)) // Fenrir
	{
		gLog.Output(ITEM_UPGRADE_LOG, "[JewelOfBless][%s][%s] Fenrir restored", lpObj->Account, lpObj->Name);
		lpItem->m_Durability = 255;
		return 1;
	}

	if (lpItem->m_Index > GET_ITEM(12, 6) &&
		(lpItem->m_Index < GET_ITEM(12, 36) || lpItem->m_Index > GET_ITEM(12, 43)) &&
		lpItem->m_Index != GET_ITEM(12, 49) && lpItem->m_Index != GET_ITEM(12, 50) &&
		(lpItem->m_Index < GET_ITEM(12, 262) || lpItem->m_Index > GET_ITEM(12, 270)) &&
		(lpItem->m_Index < GET_ITEM(12, 414) || lpItem->m_Index > GET_ITEM(12, 437)) &&
		lpItem->m_Index != GET_ITEM(13, 30) && lpItem->IsPentagramItem() == 0 &&
		gCustomWing.CheckCustomWingByItem(lpItem->m_Index) == 0)
	{
		return 0;
	}

	if (lpItem->m_Level >= 6)
	{
		return 0;
	}

	lpItem->m_Level++;

	float dur = (float)gItemManager.GetItemDurability(lpItem->m_Index, lpItem->m_Level, lpItem->IsExcItem(), lpItem->IsSetItem());

	lpItem->m_Durability = (dur * lpItem->m_Durability) / lpItem->m_BaseDurability;

	lpItem->Convert(lpItem->m_Index, lpItem->m_Option1, lpItem->m_Option2, lpItem->m_Option3, lpItem->m_NewOption, lpItem->m_SetOption, lpItem->m_JewelOfHarmonyOption, lpItem->m_ItemOptionEx, lpItem->m_SocketOption, lpItem->m_SocketOptionBonus);

	this->CharacterMakePreviewCharSet(lpObj->Index);

	gLog.Output(ITEM_UPGRADE_LOG, "[JewelOfBless][%s][%s] [Item: %s] [To TimerRandom: %d]", lpObj->Account, lpObj->Name, gItemManager.GetName(lpItem->m_Index), lpItem->m_Level);

	CItem newItem = lpObj->Inventory[TargetSlot];

	GDItemTrackingSaveSend(oldItem, newItem, lpObj->Account, lpObj->Account, 1, 0);

	return 1;
}

bool CObjectManager::CharacterUseJewelOfSoul(LPOBJ lpObj, int SourceSlot, int TargetSlot) // OK
{
	if (INVENTORY_FULL_RANGE(SourceSlot) == 0)
	{
		return 0;
	}

	if (INVENTORY_FULL_RANGE(TargetSlot) == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[SourceSlot].IsItem() == 0)
	{
		return 0;
	}

	/*if (lpObj->Inventory[SourceSlot].m_Durability > 1)
	{
		return 0;
	}*/

	if (lpObj->Inventory[TargetSlot].IsItem() == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[TargetSlot].m_IsPeriodicItem != 0)
	{
		return 0;
	}

	CItem* lpItem = &lpObj->Inventory[TargetSlot];

	CItem oldItem = lpObj->Inventory[TargetSlot];

	if (lpItem->m_Index > GET_ITEM(12, 6) &&
		(lpItem->m_Index < GET_ITEM(12, 36) || lpItem->m_Index > GET_ITEM(12, 43)) &&
		lpItem->m_Index != GET_ITEM(12, 49) && lpItem->m_Index != GET_ITEM(12, 50) &&
		(lpItem->m_Index < GET_ITEM(12, 262) || lpItem->m_Index > GET_ITEM(12, 270)) &&
		(lpItem->m_Index < GET_ITEM(12, 414) || lpItem->m_Index > GET_ITEM(12, 437)) &&
		lpItem->m_Index != GET_ITEM(13, 30) && lpItem->IsPentagramItem() == 0 &&
		gCustomWing.CheckCustomWingByItem(lpItem->m_Index) == 0)
	{
		return 0;
	}

	if (lpItem->m_Level >= 9)
	{
		return 0;
	}

	int rate = gServerInfo.m_SoulSuccessRate[lpObj->AccountLevel];

	if (lpItem->m_Option2 != 0)
	{
		rate += gServerInfo.m_AddLuckSuccessRate1[lpObj->AccountLevel];
	}

	int success = 0;
	int oldLevel = lpItem->m_Level;

	if ((GetLargeRand() % 100) < rate)
	{
		lpItem->m_Level++;
		success = 1;
	}
	else
	{
		if (lpItem->m_Level >= 7)
		{
			lpItem->m_Level = 0;
		}
		else if (lpItem->m_Level >= 1)
		{
			lpItem->m_Level--;
		}
	}

	float dur = (float)gItemManager.GetItemDurability(lpItem->m_Index, lpItem->m_Level, lpItem->IsExcItem(), lpItem->IsSetItem());

	lpItem->m_Durability = (dur * lpItem->m_Durability) / lpItem->m_BaseDurability;

	lpItem->Convert(lpItem->m_Index, lpItem->m_Option1, lpItem->m_Option2, lpItem->m_Option3, lpItem->m_NewOption, lpItem->m_SetOption, lpItem->m_JewelOfHarmonyOption, lpItem->m_ItemOptionEx, lpItem->m_SocketOption, lpItem->m_SocketOptionBonus);

	this->CharacterMakePreviewCharSet(lpObj->Index);

	gLog.Output(ITEM_UPGRADE_LOG, "[JewelOfSoul][%s][%s] [Item: %s] [Rate: %d%%] [Old TimerRandom: %d] [New TimerRandom: %d]", lpObj->Account, lpObj->Name, gItemManager.GetName(lpItem->m_Index), rate, oldLevel, lpItem->m_Level);

	CItem newItem = lpObj->Inventory[TargetSlot];

	GDItemTrackingSaveSend(oldItem, newItem, lpObj->Account, lpObj->Account, 1, 1);

	return 1;
}

bool CObjectManager::CharacterUseJewelOfLife(LPOBJ lpObj, int SourceSlot, int TargetSlot) // OK
{
	if (INVENTORY_FULL_RANGE(SourceSlot) == 0)
	{
		return 0;
	}

	if (INVENTORY_FULL_RANGE(TargetSlot) == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[SourceSlot].IsItem() == 0)
	{
		return 0;
	}

	/*if (lpObj->Inventory[SourceSlot].m_Durability > 1)
	{
		return 0;
	}*/

	if (lpObj->Inventory[TargetSlot].IsItem() == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[TargetSlot].m_IsPeriodicItem != 0)
	{
		return 0;
	}

	CItem* lpItem = &lpObj->Inventory[TargetSlot];

	CItem oldItem = lpObj->Inventory[TargetSlot];

	if (lpItem->m_Index > GET_ITEM(12, 6) &&
		(lpItem->m_Index < GET_ITEM(12, 36) || lpItem->m_Index > GET_ITEM(12, 43)) &&
		lpItem->m_Index != GET_ITEM(12, 49) && lpItem->m_Index != GET_ITEM(12, 50) &&
		(lpItem->m_Index < GET_ITEM(12, 262) || lpItem->m_Index > GET_ITEM(12, 270)) &&
		(lpItem->m_Index < GET_ITEM(12, 414) || lpItem->m_Index > GET_ITEM(12, 437)) &&
		lpItem->m_Index != GET_ITEM(13, 30) &&
		gCustomWing.CheckCustomWingByItem(lpItem->m_Index) == 0)
	{
		return 0;
	}

	if (lpItem->m_Option3 >= gServerInfo.m_MaxItemOption)
	{
		return 0;
	}

	int oldOption = lpItem->m_Option3;

	int rate = gServerInfo.m_LifeSuccessRate[lpObj->AccountLevel];

	if (lpItem->m_Option2 != 0)
	{
		rate = gServerInfo.m_LifeSuccessRateLuck[lpObj->AccountLevel];
	}

	if ((GetLargeRand() % 100) < rate)
	{
		if (lpItem->m_Option3 == 0 &&
			(lpItem->m_Index == GET_ITEM(12, 269) || (lpItem->m_Index >= GET_ITEM(12, 3) && lpItem->m_Index <= GET_ITEM(12, 6)) || lpItem->m_Index == GET_ITEM(12, 42) || lpItem->m_Index == GET_ITEM(12, 49) ||
			(lpItem->m_Index >= GET_ITEM(12, 422) && lpItem->m_Index <= GET_ITEM(12, 429))) //2nd Wing Bound
			)
		{
			lpItem->m_NewOption &= 0xDF;
			lpItem->m_NewOption |= (32 * (GetLargeRand() % 2));
		}

		if (lpItem->m_Option3 == 0 && (lpItem->m_Index == GET_ITEM(12, 270) || (lpItem->m_Index >= GET_ITEM(12, 36) && lpItem->m_Index <= GET_ITEM(12, 40)) || lpItem->m_Index == GET_ITEM(12, 43) || lpItem->m_Index == GET_ITEM(12, 50) ||
			(lpItem->m_Index >= GET_ITEM(12, 430) && lpItem->m_Index <= GET_ITEM(12, 437))) // 3rd wing Bound
			)
		{
			lpItem->m_NewOption &= 0xCF;
			lpItem->m_NewOption |= (16 * (GetLargeRand() % 3));
		}

		if (lpItem->m_Option3 == 0 && gCustomWing.CheckCustomWingByItem(lpItem->m_Index) != 0)
		{
			lpItem->m_NewOption &= 0xCF;
			lpItem->m_NewOption |= (16 * (GetLargeRand() % 3));
		}

		lpItem->m_Option3++;
	}
	else
	{
		lpItem->m_Option3 = 0;
	}

	float dur = (float)gItemManager.GetItemDurability(lpItem->m_Index, lpItem->m_Level, lpItem->IsExcItem(), lpItem->IsSetItem());

	lpItem->m_Durability = (dur * lpItem->m_Durability) / lpItem->m_BaseDurability;

	lpItem->Convert(lpItem->m_Index, lpItem->m_Option1, lpItem->m_Option2, lpItem->m_Option3, lpItem->m_NewOption, lpItem->m_SetOption, lpItem->m_JewelOfHarmonyOption, lpItem->m_ItemOptionEx, lpItem->m_SocketOption, lpItem->m_SocketOptionBonus);

	this->CharacterMakePreviewCharSet(lpObj->Index);

	gLog.Output(ITEM_UPGRADE_LOG, "[JewelOfLife][%s][%s] [Item: %s] [Rate: %d%%] [Old Option: %d] [New Option: %d]", lpObj->Account, lpObj->Name, gItemManager.GetName(lpItem->m_Index), gServerInfo.m_LifeSuccessRate[lpObj->AccountLevel], oldOption, lpItem->m_Option3);

	CItem newItem = lpObj->Inventory[TargetSlot];

	GDItemTrackingSaveSend(oldItem, newItem, lpObj->Account, lpObj->Account, 1, 2);

	return 1;
}

bool CObjectManager::CharacterUseCustomJewel(LPOBJ lpObj, int SourceSlot, int TargetSlot) // OK
{
	if (INVENTORY_FULL_RANGE(SourceSlot) == 0)
	{
		return 0;
	}

	if (INVENTORY_FULL_RANGE(TargetSlot) == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[SourceSlot].IsItem() == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[TargetSlot].IsItem() == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[TargetSlot].m_IsPeriodicItem != 0)
	{
		return 0;
	}

	if (gItemManager.InventoryAddItemStack(lpObj, SourceSlot, TargetSlot) != 0)
	{
		return 0;
	}

	CItem* lpItem = &lpObj->Inventory[TargetSlot];
	CItem itemOld = lpObj->Inventory[TargetSlot];

	CUSTOM_JEWEL_SUCCESS_INFO* lpInfo = gCustomJewel.GetSuccessInfo(lpObj->Inventory[SourceSlot].m_Index);
	CUSTOM_JEWEL_FAILURE_INFO* lpInfoF = gCustomJewel.GetFailureInfo(lpObj->Inventory[SourceSlot].m_Index);

	if (lpInfo->AllFull < 1 && gCustomJewel.CheckCustomJewelApplyItem(lpObj->Inventory[SourceSlot].m_Index, lpItem) == 0)
	{
		gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, "Esta joia nao se aplica a este item.");
		return 0;
	}

	if ((GetLargeRand() % 100) < gCustomJewel.GetCustomJewelSuccessRate(lpObj->Inventory[SourceSlot].m_Index, lpObj->AccountLevel))
	{
		if (lpInfo->AllFull > 0)
		{
			if (lpItem->m_Index >= GET_ITEM(14, 0))
			{
				gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, "Esta joia nao se aplica a este item.");
				return 0;
			}

			if ((lpItem->m_Index >= GET_ITEM(0, 0) && lpItem->m_Index < GET_ITEM(7, 0))) //weapons / shield
			{
				lpItem->m_Level = 15;

				lpItem->m_Option1 = 1;
				lpItem->m_Option2 = 1;
				lpItem->m_Option3 = 7;

				if (gSocketItemType.CheckSocketItemType(lpItem->m_Index) != 0)
				{
					gCustomJewel.GetCustomJewelSocketOption(lpItem, 5);
				}
				else
				{
					gCustomJewel.GetCustomJewelNewOption(lpItem, 6);
				}
			}
			else if ((lpItem->m_Index >= GET_ITEM(6, 0) && lpItem->m_Index < GET_ITEM(12, 0))) //armor
			{
				lpItem->m_Level = 15;
				lpItem->m_Option2 = 1;
				lpItem->m_Option3 = 7;

				if (gSocketItemType.CheckSocketItemType(lpItem->m_Index) != 0)
				{
					gCustomJewel.GetCustomJewelSocketOption(lpItem, 5);
				}
				else
				{
					gCustomJewel.GetCustomJewelNewOption(lpItem, 6);
				}
			}
			//Common Wings
			else if (((lpItem->m_Index >= GET_ITEM(12, 0) && lpItem->m_Index <= GET_ITEM(12, 6)) || (lpItem->m_Index >= GET_ITEM(12, 36) && lpItem->m_Index <= GET_ITEM(12, 43)) || lpItem->m_Index == GET_ITEM(12, 49) || lpItem->m_Index == GET_ITEM(12, 50) || (lpItem->m_Index >= GET_ITEM(12, 262) && lpItem->m_Index <= GET_ITEM(12, 270)) || lpItem->m_Index == GET_ITEM(13, 30)))
			{
				lpItem->m_Level = 15;
				lpItem->m_Option2 = 1;
				lpItem->m_Option3 = 7;
				gCustomJewel.GetCustomJewelNewOption(lpItem, 6);
			}
			//4th Wings
			else if ((lpItem->m_Index >= GET_ITEM(12, 414) && lpItem->m_Index <= GET_ITEM(12, 421)))
			{
				lpItem->m_Level = 15;
				lpItem->m_Option2 = 1;
				lpItem->m_Option3 = 7;

				lpItem->m_SocketOptionBonus = 15; //def to max lvl

				if (lpItem->m_SocketOption[4] == 0xFF)
				{
					int ElementalOption = 0x00;
					CRandomManager RandomManager;
					RandomManager.AddElement(0 * 16, 12);
					RandomManager.AddElement(1 * 16, 12);
					RandomManager.AddElement(2 * 16, 12);
					RandomManager.AddElement(4 * 16, 12);
					RandomManager.AddElement(5 * 16, 12);
					RandomManager.AddElement(6 * 16, 12);
					RandomManager.AddElement(7 * 16, 5);
					RandomManager.AddElement(8 * 16, 5);
					RandomManager.AddElement(9 * 16, 5);
					RandomManager.AddElement(10 * 16, 5);
					RandomManager.AddElement(11 * 16, 5);
					RandomManager.GetRandomElement(&ElementalOption);

					lpItem->m_SocketOption[4] = ElementalOption;
					lpItem->m_SocketOption[4] = ElementalOption + 15;
				}
				else
				{
					lpItem->m_SocketOption[4] = ((lpItem->m_SocketOption[4] / 16) * 16) + 15;
				}

				CRandomManager RandomOptions;

				for (int y = 0; y <= 14; y++)
				{
					bool jatem = false;

					for (int w = 0; w < 4; w++)
					{
						if ((lpItem->m_SocketOption[w] / 16) == y)
						{
							jatem = true;
						}
					}

					if (jatem == false)
					{
						RandomOptions.AddElement(y * 16, 100);
					}
				}

				for (int l = 0; l < 4; l++)
				{
					if (lpItem->m_SocketOption[l] == 0xFF)
					{
						RandomOptions.GetRandomElementUnique(&lpItem->m_SocketOption[l]);
						lpItem->m_SocketOption[l] += 1;
					}
				}
			}
			//Acessories
			else if (lpItem->m_Index == GET_ITEM(13, 8) ||
				lpItem->m_Index == GET_ITEM(13, 9) ||
				lpItem->m_Index == GET_ITEM(13, 12) ||
				lpItem->m_Index == GET_ITEM(13, 13) ||
				(lpItem->m_Index >= GET_ITEM(13, 21) && lpItem->m_Index <= GET_ITEM(13, 28)) ||
				(lpItem->m_Index >= GET_ITEM(13, 107) && lpItem->m_Index <= GET_ITEM(13, 115)) ||
				(lpItem->m_Index >= GET_ITEM(13, 171) && lpItem->m_Index <= GET_ITEM(13, 176)))
			{
				lpItem->m_Level = 15;
				lpItem->m_Option2 = 1;
				lpItem->m_Option3 = 7;
				gCustomJewel.GetCustomJewelNewOption(lpItem, 6);
			}
			//Errtel
			else if (lpItem->IsPentagramJewel())
			{
				lpItem->m_Level = 10;
				lpItem->m_SocketOptionBonus = (lpItem->m_SocketOptionBonus % 16) + (4 * 16);

				for (int l = 0; l < 5; l++)
				{
					if (lpItem->m_SocketOption[l] == 0xFF)
					{
						gPentagramSystem.GetPentagramRandomJewelOption(lpItem->m_Index, l + 1, &lpItem->m_SocketOption[l]);
						lpItem->m_SocketOption[l] = (lpItem->m_SocketOption[l] % 16) + (10 * 16);
					}
					else
					{
						lpItem->m_SocketOption[l] = (lpItem->m_SocketOption[l] % 16) + (10 * 16);
					}
				}
			}
			//Pentagrams
			else if (lpItem->m_Index != GET_ITEM(12, 215) && lpItem->IsPentagramItem())
			{
				lpItem->m_Level = 15;
				gCustomJewel.GetCustomJewelSocketOption(lpItem, 5);
			}
		}

		if (lpInfo->Level > 0)
		{
			lpItem->m_Level = (((lpItem->m_Level + lpInfo->Level) > 15) ? 15 : (lpItem->m_Level + lpInfo->Level));
		}

		if (lpInfo->Skill > 0)
		{
			lpItem->m_Option1 = 1;
		}

		if (lpInfo->Luck > 0)
		{
			lpItem->m_Option2 = 1;
		}

		if (lpInfo->AddOption > 0)
		{
			lpItem->m_Option3 = (((lpItem->m_Option3 + lpInfo->AddOption) > gServerInfo.m_MaxItemOption) ? gServerInfo.m_MaxItemOption : (lpItem->m_Option3 + lpInfo->AddOption));
		}

		if (lpInfo->Excellent > 0)
		{
			gCustomJewel.GetCustomJewelNewOption(lpItem, lpInfo->Excellent);
		}

		if (lpInfo->Ancient > 0)
		{
			gCustomJewel.GetCustomJewelSetOption(lpItem, lpInfo->Ancient);
		}

		if (lpInfo->SocketOption > 0)
		{
			gCustomJewel.GetCustomJewelSocketOption(lpItem, lpInfo->SocketOption);
		}

		if (lpInfo->ErrtelRank > 0)
		{
			if (gPentagramSystem.GetPentagramRandomJewelOption(lpItem->m_Index, ((lpItem->m_SocketOptionBonus + 16) / 16), &lpItem->m_SocketOption[(((lpItem->m_SocketOptionBonus + 16) / 16) - 1)]) > 0)
			{
				lpItem->m_SocketOptionBonus += 16;
			}
		}

		if (lpInfo->ErrtelLevel > 0)
		{
			int higherLevel = 0;
			int lowerLevel = 11;
			int slot = 0;

			for (int l = 0; l < 5; l++)
			{
				if (lpItem->m_SocketOption[l] != 0xFF)
				{
					int rankLevel = (lpItem->m_SocketOption[l] / 16);

					if (rankLevel > higherLevel) { higherLevel = rankLevel; }
					if (rankLevel < lowerLevel) { lowerLevel = rankLevel; slot = l; }
				}
			}

			lpItem->m_SocketOption[slot] += 16;

			lpItem->m_Level = higherLevel;

			if (lowerLevel + 1 > higherLevel) { lpItem->m_Level++; }
		}

		if (lpInfo->Wing4thElement > 0)
		{
			int ElementalOption = 0x00;
			CRandomManager RandomManager;
			RandomManager.AddElement(0 * 16, 12);
			RandomManager.AddElement(1 * 16, 12);
			RandomManager.AddElement(2 * 16, 12);
			RandomManager.AddElement(3 * 16, 1);
			RandomManager.AddElement(4 * 16, 12);
			RandomManager.AddElement(5 * 16, 12);
			RandomManager.AddElement(6 * 16, 12);
			RandomManager.AddElement(7 * 16, 5);
			RandomManager.AddElement(8 * 16, 5);
			RandomManager.AddElement(9 * 16, 5);
			RandomManager.AddElement(10 * 16, 5);
			RandomManager.AddElement(11 * 16, 5);
			RandomManager.AddElement(12 * 16, 1);
			RandomManager.AddElement(13 * 16, 1);
			RandomManager.GetRandomElement(&ElementalOption);

			if (lpItem->m_SocketOptionBonus == 0xFF || lpItem->m_SocketOption[4] == 0xFF)
			{
				if (lpItem->m_SocketOptionBonus == 0xFF)
				{
					lpItem->m_SocketOptionBonus = 0;
					lpItem->m_SocketOption[4] = ElementalOption;
				}
				else
				{
					if (lpItem->m_SocketOption[4] == 0xFF)
					{
						lpItem->m_SocketOption[4] = ElementalOption;
					}
				}
			}
			else
			{
				if (lpItem->m_SocketOptionBonus >= 15 && lpItem->m_SocketOption[4] % 16 >= 15)
				{
					lpItem->m_SocketOptionBonus = 15;
					lpItem->m_SocketOption[4] = ElementalOption;
				}
				else
				{
					if (lpItem->m_SocketOptionBonus < 15)
					{
						lpItem->m_SocketOptionBonus++;
					}

					if (lpItem->m_SocketOption[4] % 16 < 15)
					{
						lpItem->m_SocketOption[4]++;
					}
				}
			}
		}

		if (lpInfo->Wing4thOption > 0)
		{
			bool OptionAdded = false;

			for (int l = 0; l < 4; l++)
			{
				if (lpItem->m_SocketOption[l] == 0xFF)
				{
					CRandomManager RandomOptions;

					for (int y = 0; y <= 14; y++)
					{
						bool jatem = false;

						for (int w = 0; w < 4; w++)
						{
							if ((int)(lpItem->m_SocketOption[w] / 16) == y)
							{
								jatem = true;
							}
						}

						if (jatem == false)
						{
							RandomOptions.AddElement(y * 16, 100);
						}
					}

					RandomOptions.GetRandomElement(&lpItem->m_SocketOption[l]);

					OptionAdded = true;

					break;
				}
			}

			if (!OptionAdded)
			{
				int lowerLevel = 16;
				int slot = 0;

				for (int l = 0; l < 4; l++)
				{
					int rankLevel = (lpItem->m_SocketOption[l] % 16);
					if (rankLevel < lowerLevel) { lowerLevel = rankLevel; slot = l; }
				}

				lpItem->m_SocketOption[slot]++;
			}
		}

		float dur = (float)gItemManager.GetItemDurability(lpItem->m_Index, lpItem->m_Level, lpItem->IsExcItem(), lpItem->IsSetItem());

		lpItem->m_Durability = (dur * lpItem->m_Durability) / lpItem->m_BaseDurability;

		lpItem->Convert(lpItem->m_Index, lpItem->m_Option1, lpItem->m_Option2, lpItem->m_Option3, lpItem->m_NewOption, lpItem->m_SetOption, lpItem->m_JewelOfHarmonyOption, lpItem->m_ItemOptionEx, lpItem->m_SocketOption, lpItem->m_SocketOptionBonus);

		this->CharacterMakePreviewCharSet(lpObj->Index);

		CItem item = lpObj->Inventory[TargetSlot];

		GDItemTrackingSaveSend(itemOld, item, lpObj->Account, lpObj->Account, 1, 4);
	}
	else
	{
		lpItem->m_Level = (((lpItem->m_Level - lpInfoF->Level) < 0) ? 0 : (lpItem->m_Level - lpInfoF->Level));

		lpItem->m_Option1 = (((lpItem->m_Option1 - lpInfoF->Option1) < 0) ? 0 : (lpItem->m_Option1 - lpInfoF->Option1));
		lpItem->m_Option2 = (((lpItem->m_Option2 - lpInfoF->Option2) < 0) ? 0 : (lpItem->m_Option2 - lpInfoF->Option2));
		lpItem->m_Option3 = (((lpItem->m_Option3 - lpInfoF->Option3) < 0) ? 0 : (lpItem->m_Option3 - lpInfoF->Option3));

		float dur = (float)gItemManager.GetItemDurability(lpItem->m_Index, lpItem->m_Level, lpItem->IsExcItem(), lpItem->IsSetItem());

		lpItem->m_Durability = (dur * lpItem->m_Durability) / lpItem->m_BaseDurability;

		lpItem->Convert(lpItem->m_Index, lpItem->m_Option1, lpItem->m_Option2, lpItem->m_Option3, lpItem->m_NewOption, lpItem->m_SetOption, lpItem->m_JewelOfHarmonyOption, lpItem->m_ItemOptionEx, lpItem->m_SocketOption, lpItem->m_SocketOptionBonus);

		this->CharacterMakePreviewCharSet(lpObj->Index);
	}

	return 1;
}

bool CObjectManager::CharacterUseTalismanOfResurrection(LPOBJ lpObj, int SourceSlot) // OK
{
	if (lpObj->ResurrectionTalismanActive == 0)
	{
		gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(226));
		return 0;
	}

	if (gMoveSummon.CheckMoveSummon(lpObj, lpObj->ResurrectionTalismanMap, lpObj->ResurrectionTalismanX, lpObj->ResurrectionTalismanY) == 0)
	{
		gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(226));
		return 0;
	}

	gObjTeleport(lpObj->Index, lpObj->ResurrectionTalismanMap, lpObj->ResurrectionTalismanX, lpObj->ResurrectionTalismanY);

	lpObj->ResurrectionTalismanActive = 0;

	lpObj->ResurrectionTalismanMap = 0;

	lpObj->ResurrectionTalismanX = 0;

	lpObj->ResurrectionTalismanY = 0;

	GCServerCommandSend(lpObj->Index, 60, 0, 0);
	return 1;
}

bool CObjectManager::CharacterUseTalismanOfMobility(LPOBJ lpObj, int SourceSlot) // OK
{
	if (lpObj->MobilityTalismanActive == 0)
	{
		lpObj->MobilityTalismanActive = 1;
		lpObj->MobilityTalismanMap = lpObj->Map;
		lpObj->MobilityTalismanX = lpObj->X;
		lpObj->MobilityTalismanY = lpObj->Y;
		lpObj->Inventory[SourceSlot].m_Durability = 1;
		gItemManager.GCItemDurSend(lpObj->Index, SourceSlot, (BYTE)lpObj->Inventory[SourceSlot].m_Durability, 1);
		return 0;
	}

	if (gMoveSummon.CheckMoveSummon(lpObj, lpObj->MobilityTalismanMap, lpObj->MobilityTalismanX, lpObj->MobilityTalismanY) == 0)
	{
		gNotice.GCNoticeSend(lpObj->Index, 1, 0, 0, 0, 0, 0, gMessage.GetMessage(226));
		return 0;
	}

	gObjTeleport(lpObj->Index, lpObj->MobilityTalismanMap, lpObj->MobilityTalismanX, lpObj->MobilityTalismanY);

	lpObj->MobilityTalismanActive = 0;

	lpObj->MobilityTalismanMap = 0;

	lpObj->MobilityTalismanX = 0;

	lpObj->MobilityTalismanY = 0;

	GCServerCommandSend(lpObj->Index, 61, 0, 0);
	return 1;
}

bool CObjectManager::CharacterUseCreationCard(LPOBJ lpObj, CItem* lpItem) // OK
{
	switch (lpItem->m_Index)
	{
	case GET_ITEM(14, 91):
		if ((lpObj->ClassCode & 1) == 0 && (lpObj->ClassFlag & 1) != 0)
		{
			lpObj->ClassCode |= 1;
			GDCreationCardSaveSend(lpObj->Index, (lpObj->ClassCode & 9));
			return 1;
		}
		break;
	case GET_ITEM(14, 97):
		if ((lpObj->ClassCode & 4) == 0 && (lpObj->ClassFlag & 4) != 0)
		{
			lpObj->ClassCode |= 4;
			GDCreationCardSaveSend(lpObj->Index, (lpObj->ClassCode & 9));
			return 1;
		}
		break;
	case GET_ITEM(14, 98):
		if ((lpObj->ClassCode & 2) == 0 && (lpObj->ClassFlag & 2) != 0)
		{
			lpObj->ClassCode |= 2;
			GDCreationCardSaveSend(lpObj->Index, (lpObj->ClassCode & 9));
			return 1;
		}
		break;
	case GET_ITEM(14, 169):
		if ((lpObj->ClassCode & 8) == 0 && (lpObj->ClassFlag & 8) != 0)
		{
			lpObj->ClassCode |= 8;
			GDCreationCardSaveSend(lpObj->Index, (lpObj->ClassCode & 9));
			return 1;
		}
		break;
#if(GAMESERVER_UPDATE>=1000)//2017/02/28
	case GET_ITEM(14, 281):
		if ((lpObj->ClassCode & 16) == 0 && (lpObj->ClassFlag & 16) != 0)
		{
			lpObj->ClassCode |= 16;
			GDCreationCardSaveSend(lpObj->Index, (lpObj->ClassCode & 9));
			return 1;
		}
		break;
#endif
	}

	return 0;
}

bool CObjectManager::CharacterUseInventoryExpansion(LPOBJ lpObj, CItem* lpItem) // OK
{
	if (lpObj->ExtInventory >= 2)
	{
		return 0;
	}

	lpObj->ExtInventory++;
	GDCharacterInfoSaveSend(lpObj->Index);
	return 1;
}

bool CObjectManager::CharacterUseWarehouseExpansion(LPOBJ lpObj, CItem* lpItem) // OK
{
	if (lpObj->ExtWarehouse >= 1)
	{
		return 0;
	}

	lpObj->ExtWarehouse++;

	GCMessagePopupSend(lpObj, "Seu ba extra foi criado com sucesso. Voc precisa fazer o login novamente. Pressione ESC, em seguida Selecionar Servidor.");

	GDCharacterInfoSaveSend(lpObj->Index);

	return 1;
}

bool CObjectManager::CharacterUseTradeableSeal(LPOBJ lpObj, int SourceSlot, int TargetSlot) // OK
{
	if (INVENTORY_FULL_RANGE(SourceSlot) == 0)
	{
		return 0;
	}

	if (INVENTORY_FULL_RANGE(TargetSlot) == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[SourceSlot].IsItem() == 0)
	{
		return 0;
	}

	if (lpObj->Inventory[TargetSlot].IsItem() == 0)
	{
		return 0;
	}

	CItem* lpItem = &lpObj->Inventory[TargetSlot];

	if (lpItem->IsPentagramItem() == 0 || lpItem->m_Durability >= 255)
	{
		return 0;
	}

	lpItem->m_Durability++;

	return 1;
}

void CObjectManager::CharacterMonsterDieHunt(LPOBJ lpObj, LPOBJ lpTarget) // OK
{
	int HPValue = (lpObj->HuntHP > 0) ? (int)((lpObj->MaxLife + lpObj->AddLife) / lpObj->HuntHP) : 0;
	int MPValue = (lpObj->HuntMP > 0) ? (int)((lpObj->MaxMana + lpObj->AddMana) / lpObj->HuntMP) : 0;
	int BPValue = (lpObj->HuntBP > 0) ? (int)((lpObj->MaxBP + lpObj->AddBP) / lpObj->HuntBP) : 0;
	int SDValue = (lpObj->HuntSD > 0) ? (int)((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) / lpObj->HuntSD) : 0;

	if (HPValue > 0 || SDValue > 0)
	{
		if ((lpObj->Life + HPValue) > (lpObj->MaxLife + lpObj->AddLife))
		{
			lpObj->Life = lpObj->MaxLife + lpObj->AddLife;
		}
		else
		{
			lpObj->Life += HPValue;
		}

		if ((lpObj->Shield + SDValue) > (lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield))
		{
			lpObj->Shield = lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield;
		}
		else
		{
			lpObj->Shield += SDValue;
		}

		GCLifeSend(lpObj->Index, 0xFF, (int)lpObj->Life, lpObj->Shield);
	}

	if (MPValue > 0 || BPValue > 0)
	{
		if ((lpObj->Mana + MPValue) > (lpObj->MaxMana + lpObj->AddMana))
		{
			lpObj->Mana = lpObj->MaxMana + lpObj->AddMana;
		}
		else
		{
			lpObj->Mana += MPValue;
		}

		if ((lpObj->BP + BPValue) > (lpObj->MaxBP + lpObj->AddBP))
		{
			lpObj->BP = lpObj->MaxBP + lpObj->AddBP;
		}
		else
		{
			lpObj->BP += BPValue;
		}

		GCManaSend(lpObj->Index, 0xFF, (int)lpObj->Mana, lpObj->BP);
	}
}

void CObjectManager::CharacterAutoRecuperation(LPOBJ lpObj) // OK
{
	int HPChange = 0;
	int SDChange = 0;
	int MPChange = 0;
	int BPChange = 0;

	if (((lpObj->HPRecoveryCount++) % 5) == 0)
	{
		if (lpObj->Life != (lpObj->MaxLife + lpObj->AddLife))
		{
			int rate = gServerInfo.m_HPRecoveryRate[lpObj->Class];

			rate += (((GetTickCount() - lpObj->HPAutoRecuperationTime) > 5000) ? 5 : 0);

			rate += lpObj->m_MPSkillOpt.HPRecoveryRate;

			rate += lpObj->EffectOption.AddHPRecoveryRate;

			int value = (int)(((lpObj->MaxLife + lpObj->AddLife) * rate) / 100);

			value += lpObj->HPRecovery;

			value += lpObj->EffectOption.AddHPRecovery;

			if ((lpObj->Life + value) > (lpObj->MaxLife + lpObj->AddLife))
			{
				lpObj->Life = lpObj->MaxLife + lpObj->AddLife;
			}
			else
			{
				lpObj->Life += value;
			}

			HPChange = 1;
		}
	}

	if (((lpObj->SDRecoveryCount++) % 5) == 0)
	{
		if (lpObj->Shield != (lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield))
		{
			if (lpObj->SDRecoveryType != 0 || gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) != 0)
			{
				int rate = gServerInfo.m_SDRecoveryRate[lpObj->Class];

				rate += (((GetTickCount() - lpObj->SDAutoRecuperationTime) > 5000) ? 5 : 0);

				rate += lpObj->m_MPSkillOpt.SDRecoveryRate;

				rate += lpObj->EffectOption.AddSDRecoveryRate;

				int value = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * rate) / 100);

				value += lpObj->SDRecovery;

				value += lpObj->EffectOption.AddSDRecovery;

				if ((lpObj->Shield + value) > (lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield))
				{
					lpObj->Shield = lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield;
				}
				else
				{
					lpObj->Shield += value;
				}

				SDChange = 1;
			}
		}
	}

	if (((lpObj->MPRecoveryCount++) % 3) == 0)
	{
		if (lpObj->Mana != (lpObj->MaxMana + lpObj->AddMana))
		{
			int rate = gServerInfo.m_MPRecoveryRate[lpObj->Class];

			rate += (((GetTickCount() - lpObj->MPAutoRecuperationTime) > 5000) ? 3 : 0);

			rate += lpObj->m_MPSkillOpt.MPRecoveryRate;

			rate += lpObj->EffectOption.AddMPRecoveryRate;

			int value = (int)(((lpObj->MaxMana + lpObj->AddMana) * rate) / 100);

			value += lpObj->MPRecovery;

			value += lpObj->EffectOption.AddMPRecovery;

			if ((lpObj->Mana + value) > (lpObj->MaxMana + lpObj->AddMana))
			{
				lpObj->Mana = lpObj->MaxMana + lpObj->AddMana;
			}
			else
			{
				lpObj->Mana += value;
			}

			MPChange = 1;
		}
	}

	if (((lpObj->BPRecoveryCount++) % 3) == 0)
	{
		if (lpObj->BP != (lpObj->MaxBP + lpObj->AddBP))
		{
			int rate = gServerInfo.m_BPRecoveryRate[lpObj->Class];

			rate += (((GetTickCount() - lpObj->BPAutoRecuperationTime) > 5000) ? 3 : 0);

			rate += lpObj->m_MPSkillOpt.BPRecoveryRate;

			rate += lpObj->EffectOption.AddBPRecoveryRate;

			int value = (int)(((lpObj->MaxBP + lpObj->AddBP) * rate) / 100);

			value += lpObj->BPRecovery;

			value += lpObj->EffectOption.AddBPRecovery;

			if ((lpObj->BP + value) > (lpObj->MaxBP + lpObj->AddBP))
			{
				lpObj->BP = lpObj->MaxBP + lpObj->AddBP;
			}
			else
			{
				lpObj->BP += value;
			}

			BPChange = 1;
		}
	}

	if (HPChange != 0 || SDChange != 0)
	{
		GCLifeSend(lpObj->Index, 0xFF, (int)lpObj->Life, lpObj->Shield);
	}

	if (MPChange != 0 || BPChange != 0)
	{
		GCManaSend(lpObj->Index, 0xFF, (int)lpObj->Mana, lpObj->BP);
	}
}

void CObjectManager::CharacterItemDurationDown(LPOBJ lpObj) // OK
{
	if (((lpObj->TimeCount++) % 10) != 0)
	{
		return;
	}

	for (int n = 2; n < 10; n++)
	{
		if (lpObj->Inventory[n].IsItem() != 0)
		{
			bool result = 0;

			switch (n)
			{
			case 2:
				result = lpObj->Inventory[n].LuckyDurabilityDown(lpObj->Index, 10);
				break;
			case 3:
				result = lpObj->Inventory[n].LuckyDurabilityDown(lpObj->Index, 10);
				break;
			case 4:
				result = lpObj->Inventory[n].LuckyDurabilityDown(lpObj->Index, 10);
				break;
			case 5:
				result = lpObj->Inventory[n].LuckyDurabilityDown(lpObj->Index, 10);
				break;
			case 6:
				result = lpObj->Inventory[n].LuckyDurabilityDown(lpObj->Index, 10);
				break;
			case 7:
				result = lpObj->Inventory[n].WingDurabilityDown(lpObj->Index, ((gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0) ? 1 : 0));
				break;
			case 9:
				result = lpObj->Inventory[n].PendantDurabilityDown(lpObj->Index, ((gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0) ? 1 : 0));
				break;
			}

			if (result != 0)
			{
				gItemManager.GCItemDurSend(lpObj->Index, n, (BYTE)lpObj->Inventory[n].m_Durability, 0);
			}
		}
	}

	for (int n = 10; n < 12; n++)
	{
		if (lpObj->Inventory[n].IsItem() != 0)
		{
			bool result = 0;

			switch (lpObj->Inventory[n].m_Index)
			{
			case GET_ITEM(13, 10):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, 113);
				break;
			case GET_ITEM(13, 20):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, ((gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0) ? 70 : 0));
				break;
			case GET_ITEM(13, 38):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, ((gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0) ? 63 : 0));
				break;
			case GET_ITEM(13, 39):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, 113);
				break;
			case GET_ITEM(13, 40):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, 113);
				break;
			case GET_ITEM(13, 41):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, 113);
				break;
			case GET_ITEM(13, 42):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, 0);
				break;
			case GET_ITEM(13, 68):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, 113);
				break;
			case GET_ITEM(13, 76):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, 113);
				break;
			case GET_ITEM(13, 122):
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, 113);
				break;
			default:
				result = lpObj->Inventory[n].RingDurabilityDown(lpObj->Index, ((gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0) ? 1 : 0));
				break;
			}

			if (result != 0)
			{
				gItemManager.GCItemDurSend(lpObj->Index, n, (BYTE)lpObj->Inventory[n].m_Durability, 0);

				if (gSkillManager.SkillChangeUse(lpObj->Index) != 0)
				{
					gObjViewportListProtocolCreate(lpObj);
					this->CharacterUpdateMapEffect(lpObj);
				}
			}
		}
	}
}

void CObjectManager::CharacterCalcBP(LPOBJ lpObj) // OK
{
	switch (lpObj->Class)
	{
	case CLASS_DW:
		lpObj->MaxBP = (int)(((lpObj->Strength + lpObj->AddStrength) * 0.20) + ((lpObj->Dexterity + lpObj->AddDexterity) * 0.40) + ((lpObj->Vitality + lpObj->AddVitality) * 0.30) + ((lpObj->Energy + lpObj->AddEnergy) * 0.20));
		break;
	case CLASS_DK:
		lpObj->MaxBP = (int)(((lpObj->Strength + lpObj->AddStrength) * 0.15) + ((lpObj->Dexterity + lpObj->AddDexterity) * 0.20) + ((lpObj->Vitality + lpObj->AddVitality) * 0.30) + ((lpObj->Energy + lpObj->AddEnergy) * 1.00));
		break;
	case CLASS_FE:
		lpObj->MaxBP = (int)(((lpObj->Strength + lpObj->AddStrength) * 0.30) + ((lpObj->Dexterity + lpObj->AddDexterity) * 0.20) + ((lpObj->Vitality + lpObj->AddVitality) * 0.30) + ((lpObj->Energy + lpObj->AddEnergy) * 0.20));
		break;
	case CLASS_MG:
		lpObj->MaxBP = (int)(((lpObj->Strength + lpObj->AddStrength) * 0.20) + ((lpObj->Dexterity + lpObj->AddDexterity) * 0.25) + ((lpObj->Vitality + lpObj->AddVitality) * 0.30) + ((lpObj->Energy + lpObj->AddEnergy) * 0.15));
		break;
	case CLASS_DL:
		lpObj->MaxBP = (int)(((lpObj->Strength + lpObj->AddStrength) * 0.30) + ((lpObj->Dexterity + lpObj->AddDexterity) * 0.20) + ((lpObj->Vitality + lpObj->AddVitality) * 0.10) + ((lpObj->Energy + lpObj->AddEnergy) * 0.15) + ((lpObj->Leadership + lpObj->AddLeadership) * 0.30));
		break;
	case CLASS_SU:
		lpObj->MaxBP = (int)(((lpObj->Strength + lpObj->AddStrength) * 0.20) + ((lpObj->Dexterity + lpObj->AddDexterity) * 0.25) + ((lpObj->Vitality + lpObj->AddVitality) * 0.30) + ((lpObj->Energy + lpObj->AddEnergy) * 0.15));
		break;
	case CLASS_RF:
		lpObj->MaxBP = (int)(((lpObj->Strength + lpObj->AddStrength) * 0.15) + ((lpObj->Dexterity + lpObj->AddDexterity) * 0.20) + ((lpObj->Vitality + lpObj->AddVitality) * 0.30) + ((lpObj->Energy + lpObj->AddEnergy) * 1.00));
		break;
	case CLASS_GL:
		lpObj->MaxBP = (int)(((lpObj->Strength + lpObj->AddStrength) * 0.15) + ((lpObj->Dexterity + lpObj->AddDexterity) * 0.20) + ((lpObj->Vitality + lpObj->AddVitality) * 0.30) + ((lpObj->Energy + lpObj->AddEnergy) * 1.00));
		break;
	}
}

void CObjectManager::CharacterCalcSD(LPOBJ lpObj) // OK
{
	int value = (lpObj->Strength + lpObj->AddStrength) + (lpObj->Dexterity + lpObj->AddDexterity) + (lpObj->Vitality + lpObj->AddVitality) + (lpObj->Energy + lpObj->AddEnergy);

	if (lpObj->Class == CLASS_DL)
	{
		value += (lpObj->Leadership + lpObj->AddLeadership);
	}

	lpObj->MaxShield = (((value * gServerInfo.m_ShieldGaugeConstA) / 10) + (((lpObj->Level + lpObj->MasterLevel) * (lpObj->Level + lpObj->MasterLevel)) / gServerInfo.m_ShieldGaugeConstB)) + (lpObj->Defense / 2);
}

void CObjectManager::CharacterCalcPvPAccessoryOption(LPOBJ lpObj) // OK
{
	int doubleResist = 0;
	int tripleResist = 0;
	int trueResist = 0;
	int doubleVal = 0;
	int tripleVal = 0;
	int trueVal = 0;

	for (int n = 9; n < INVENTORY_WEAR_SIZE; n++)
	{
		CItem* lpItem = &lpObj->Inventory[n];

		if (lpItem->IsItem() == 0 || lpItem->m_IsValidItem == 0 || lpItem->m_Durability == 0)
		{
			continue;
		}

		switch (lpItem->m_Index)
		{
		case GET_ITEM(13, 171):
			lpObj->m_MPSkillOpt.IgnoreDefenseRate += 10;
			break;
		case GET_ITEM(13, 172):
			lpObj->m_MPSkillOpt.ExcellentDamageRate += 10;
			break;
		case GET_ITEM(13, 173):
			doubleVal = 15;
			if(doubleVal > doubleResist)
				doubleResist = doubleVal;
			break;
		case GET_ITEM(13, 175):
			tripleVal = 2;
			if (tripleVal > tripleResist)
				tripleResist = tripleVal;
			break;
		case GET_ITEM(13, 176):
			trueVal = 1;
			if (trueVal > trueResist)
				trueResist = trueVal;
			break;
		}
	}

	if (doubleResist > 0)
	{
		lpObj->ResistDoubleDamageRate += doubleResist;
	}

	if (tripleResist > 0)
	{
		lpObj->ResistTripleDamageRate += tripleResist;
	}

	if (trueResist > 0)
	{
		lpObj->TrueDamageProtection += trueResist;
	}
}

void CObjectManager::CharacterCalcAttribute(int aIndex) // OK
{
	LPOBJ lpObj = &gObj[aIndex];

	if (lpObj->Type != OBJECT_USER)
	{
		return;
	}

	CItem* Right = &lpObj->Inventory[0];
	CItem* Left = &lpObj->Inventory[1];
	CItem* Gloves = &lpObj->Inventory[5];
	CItem* Wings = &lpObj->Inventory[7];
	CItem* Helper = &lpObj->Inventory[8];
	CItem* Amulet = &lpObj->Inventory[9];
	CItem* Ring1 = &lpObj->Inventory[10];
	CItem* Ring2 = &lpObj->Inventory[11];
	CItem* Pentagram = &lpObj->Inventory[236];

	float TotalHP = 100;
	float TotalSD = 100;
	float TotalMP = 100;
	float TotalBP = 100;

	if ((lpObj->MaxLife + lpObj->AddLife) != 0)
	{
		TotalHP = (float)(lpObj->Life * 100) / (float)(lpObj->MaxLife + lpObj->AddLife);
	}

	if ((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) != 0)
	{
		TotalSD = (float)(lpObj->Shield * 100) / (float)(lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield);
	}

	if ((lpObj->MaxMana + lpObj->AddMana) != 0)
	{
		TotalMP = (float)(lpObj->Mana * 100) / (lpObj->MaxMana + lpObj->AddMana);
	}

	if ((lpObj->MaxBP + lpObj->AddBP) != 0)
	{
		TotalBP = (float)(lpObj->BP * 100) / (float)(lpObj->MaxBP + lpObj->AddBP);
	}

	lpObj->HaveWeaponInHand = 1;

	if (Right->IsItem() == 0 && Left->IsItem() == 0)
	{
		lpObj->HaveWeaponInHand = 0;
	}
	else if (Right->IsItem() == 0)
	{
		if (Left->m_Index == GET_ITEM(4, 7) || Left->m_Index == GET_ITEM(4, 15)) // Bolt
		{
			lpObj->HaveWeaponInHand = 0;
		}
		else if (Left->m_Index >= GET_ITEM(6, 0) && Left->m_Index < GET_ITEM(7, 0)) // Shields
		{
			lpObj->HaveWeaponInHand = 0;
		}
	}

	for (int n = 0; n < INVENTORY_WEAR_SIZE; n++)
	{
		if (lpObj->Inventory[n].IsItem() != 0)
		{
			lpObj->Inventory[n].m_IsValidItem = 1;
		}
	}

	for (int n = INVENTORY_WEAR_SIZE; n < INVENTORY_SIZE; n++)
	{
		if (lpObj->Inventory[n].IsItem() != 0)
		{
			lpObj->Inventory[n].m_IsValidItem = 1;
		}
	}

	if (lpObj->m_btInvenPetDkSpiritPos >= INVENTORY_WEAR_SIZE)
	{
		lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_IsValidItem = 1;
	}

	if (lpObj->m_btInvenPetPos >= INVENTORY_WEAR_SIZE)
	{
		lpObj->Inventory[lpObj->m_btInvenPetPos].m_IsValidItem = 1;
	}

	lpObj->AddLife = 0;
	//LogAdd(LOG_RED, "lpObj->AddLife %d | %s %d", lpObj->AddLife, __FUNCTION__, __LINE__);

	lpObj->AddMana = 0;
	lpObj->AddBP = 0;
	lpObj->m_MPSkillOpt.AddShield = 0;
	lpObj->SkillLongSpearChange = 0;

	memset(lpObj->AddResistance, 0, sizeof(lpObj->AddResistance));

	gObjClearSpecialOption(lpObj);

	bool change = 1;

	while (change != 0)
	{
		change = 0;

		lpObj->AddStrength = lpObj->EffectOption.AddStrength;
		lpObj->AddDexterity = lpObj->EffectOption.AddDexterity;
		lpObj->AddVitality = lpObj->EffectOption.AddVitality;
		lpObj->AddEnergy = lpObj->EffectOption.AddEnergy;
		lpObj->AddLeadership = lpObj->EffectOption.AddLeadership;

		gSetItemOption.CalcSetItemStat(lpObj);
		gItemOption.CalcItemCommonOption(lpObj, 1);
		gSetItemOption.CalcSetItemOption(lpObj, 1);
		//gJewelOfHarmonyOption.CalcJewelOfHarmonyOption(lpObj, 1);
		//g380ItemOption.Calc380ItemOption(lpObj, 1);
		gSocketItemOption.CalcSocketItemOption(lpObj, 1);
		gWings4thOption.Calc4thWingOption(lpObj, 1);
		gMasterSkillTree.CalcMasterSkillTreeOption(lpObj, 1);
		gPentagramSystem.CalcPentagramOption(lpObj, 1);
		gPentagramSystem.CalcPentagramJewelOption(lpObj, 1);
		//gMuunSystem.CalcMuunOption(lpObj, 1);

		gMasterSkillTree_4th.CalcMasterSkillTreeOption(lpObj, 1);

		for (int n = 0; n < INVENTORY_SIZE; n++)
		{
			if (lpObj->Inventory[n].m_IsValidItem != 0)
			{
				if (gItemManager.IsValidItem(lpObj, &lpObj->Inventory[n]) == 0)
				{
					change = 1;
					lpObj->Inventory[n].m_IsValidItem = 0;
				}
			}
		}

		if (lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_IsValidItem != 0)
		{
			if (gItemManager.IsValidItem(lpObj, &lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos]) == 0)
			{
				change = 1;
				lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos].m_IsValidItem = 0;
			}
		}

		if (lpObj->Inventory[lpObj->m_btInvenPetPos].m_IsValidItem != 0)
		{
			if (gItemManager.IsValidItem(lpObj, &lpObj->Inventory[lpObj->m_btInvenPetPos]) == 0)
			{
				change = 1;
				lpObj->Inventory[lpObj->m_btInvenPetPos].m_IsValidItem = 0;
			}
		}
	}

	if ((Wings->m_Index >= GET_ITEM(12, 0) && Wings->m_Index <= GET_ITEM(12, 2)) || Wings->m_Index == GET_ITEM(12, 41)) // 1st wing
	{
		lpObj->DamageDecRate = (float)(12 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(12 + (Wings->m_Level * 2));
	}
	else if ((Wings->m_Index >= GET_ITEM(12, 3) && Wings->m_Index <= GET_ITEM(12, 6)) || Wings->m_Index == GET_ITEM(12, 42) ||
		(Wings->m_Index >= GET_ITEM(12, 422) && Wings->m_Index <= GET_ITEM(12, 428))) //2nd Wing Bound
	{
		lpObj->DamageDecRate = (float)(25 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(32 + Wings->m_Level);
	}
	else if (Wings->m_Index == GET_ITEM(12, 269) || Wings->m_Index == GET_ITEM(12, 429))
	{
		lpObj->DamageDecRate = (float)(10 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(20 + (Wings->m_Level * 2));
	}
	else if (Wings->m_Index == GET_ITEM(12, 270) || (Wings->m_Index >= GET_ITEM(12, 36) && Wings->m_Index <= GET_ITEM(12, 39)) || Wings->m_Index == GET_ITEM(12, 43) || Wings->m_Index == GET_ITEM(12, 50) ||
		(Wings->m_Index >= GET_ITEM(12, 430) && Wings->m_Index <= GET_ITEM(12, 437))) // 3rd wing Bound
	{
		lpObj->DamageDecRate = (float)(39 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(39 + (Wings->m_Level * 2));
	}
	else if (Wings->m_Index == GET_ITEM(12, 40)) // Mantle of Monarch
	{
		lpObj->DamageDecRate = (float)(24 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(39 + (Wings->m_Level * 2));
	}
	else if (Wings->m_Index == GET_ITEM(12, 49)) // Cloak of Fighter
	{
		lpObj->DamageDecRate = (float)(10 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(20 + (Wings->m_Level * 2));
	}
	else if (Wings->m_Index == GET_ITEM(12, 130) || Wings->m_Index == GET_ITEM(12, 135)) // Mini Wings
	{
		lpObj->DamageDecRate = (float)(20 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(20 + (Wings->m_Level * 2));
	}
	else if (Wings->m_Index >= GET_ITEM(12, 131) && Wings->m_Index <= GET_ITEM(12, 134)) // Mini Wings
	{
		lpObj->DamageDecRate = (float)(14 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(14 + (Wings->m_Level * 2));
	}
	else if (Wings->m_Index == GET_ITEM(12, 262)) // Cloak of Death
	{
		lpObj->DamageDecRate = (float)(13 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(21 + Wings->m_Level);
	}
	else if (Wings->m_Index == GET_ITEM(12, 263)) // Wings of Chaos
	{
		lpObj->DamageDecRate = (float)(30 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(33 + Wings->m_Level);
	}
	else if (Wings->m_Index == GET_ITEM(12, 264)) // Wings of Magic
	{
		lpObj->DamageDecRate = (float)(29 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(35 + Wings->m_Level);
	}
	else if (Wings->m_Index == GET_ITEM(12, 265)) // Wings of Life
	{
		lpObj->DamageDecRate = (float)(29 + (Wings->m_Level * 2));
		lpObj->DamageIncRate = (float)(35 + Wings->m_Level);
	}
	else if (Wings->m_Index == GET_ITEM(12, 266)) // Wings of Conqueror
	{
		lpObj->DamageDecRate = (float)73;
		lpObj->DamageIncRate = (float)73;
	}
	else if (Wings->m_Index == GET_ITEM(12, 267)) // Wings of Angel and Devil
	{
		lpObj->DamageDecRate = (float)(60 + Wings->m_Level);
		lpObj->DamageIncRate = (float)(60 + Wings->m_Level);
	}
	else if (Wings->m_Index == GET_ITEM(13, 30)) // Cloak of Lord
	{
		lpObj->DamageDecRate = (float)(10 + Wings->m_Level);
		lpObj->DamageIncRate = (float)(20 + (Wings->m_Level * 2));
	}
	else if (Wings->m_Index >= GET_ITEM(12, 414) && Wings->m_Index <= GET_ITEM(12, 421)) //4th Wings and Capes
	{
		if (Wings->m_Index == GET_ITEM(12, 418)) // DL 4th cape
		{
			lpObj->DamageDecRate = (float)(100 - (63 - (Wings->m_Level * 2)));
		}
		else //any other level 4
		{
			lpObj->DamageDecRate = (float)(100 - (57 - (Wings->m_Level * 2)));
		}

		lpObj->DamageIncRate = (float)(55 + Wings->m_Level);
	}

	int Strength = lpObj->Strength + lpObj->AddStrength;
	int Dexterity = lpObj->Dexterity + lpObj->AddDexterity;
	int Vitality = lpObj->Vitality + lpObj->AddVitality;
	int Energy = lpObj->Energy + lpObj->AddEnergy;
	//LogAdd(LOG_DEBUG, "F: %s L: %d AddEnergy: %d", __FUNCTION__, __LINE__, lpObj->AddEnergy);
	int Leadership = lpObj->Leadership + lpObj->AddLeadership;

	if (lpObj->Class == CLASS_DW)
	{
		lpObj->PhysiDamageMinRight = Strength / gServerInfo.m_DWPhysiDamageMinConstA;
		lpObj->PhysiDamageMaxRight = Strength / gServerInfo.m_DWPhysiDamageMaxConstA;
		lpObj->PhysiDamageMinLeft = Strength / gServerInfo.m_DWPhysiDamageMinConstA;
		lpObj->PhysiDamageMaxLeft = Strength / gServerInfo.m_DWPhysiDamageMaxConstA;
		lpObj->MagicDamageMin = Energy / gServerInfo.m_DWMagicDamageMinConstA;
		lpObj->MagicDamageMax = Energy / gServerInfo.m_DWMagicDamageMaxConstA;
		lpObj->CurseDamageMin = Energy / gServerInfo.m_DWMagicDamageMinConstA;
		lpObj->CurseDamageMax = Energy / gServerInfo.m_DWMagicDamageMaxConstA;
	}
	else if (lpObj->Class == CLASS_DK)
	{
		lpObj->PhysiDamageMinRight = Strength / gServerInfo.m_DKPhysiDamageMinConstA;
		lpObj->PhysiDamageMaxRight = Strength / gServerInfo.m_DKPhysiDamageMaxConstA;
		lpObj->PhysiDamageMinLeft = Strength / gServerInfo.m_DKPhysiDamageMinConstA;
		lpObj->PhysiDamageMaxLeft = Strength / gServerInfo.m_DKPhysiDamageMaxConstA;
		lpObj->MagicDamageMin = Energy / gServerInfo.m_DKMagicDamageMinConstA;
		lpObj->MagicDamageMax = Energy / gServerInfo.m_DKMagicDamageMaxConstA;
		lpObj->CurseDamageMin = Energy / gServerInfo.m_DKMagicDamageMinConstA;
		lpObj->CurseDamageMax = Energy / gServerInfo.m_DKMagicDamageMaxConstA;
		lpObj->DKDamageMultiplierRate = 200 + (Energy / gServerInfo.m_DKDamageMultiplierConstA);
		lpObj->DKDamageMultiplierRate = ((lpObj->DKDamageMultiplierRate > gServerInfo.m_DKDamageMultiplierMaxRate) ? gServerInfo.m_DKDamageMultiplierMaxRate : lpObj->DKDamageMultiplierRate);
		//LogAdd(LOG_DEBUG, "DKDamageMultiplierRate: %d | Energy: %d", lpObj->DKDamageMultiplierRate, Energy);
	}
	else if (lpObj->Class == CLASS_FE)
	{
		if (Left->m_Index >= GET_ITEM(4, 0) && Left->m_Index < GET_ITEM(5, 0) && (Left->m_Index != GET_ITEM(4, 7) || Left->m_Index != GET_ITEM(4, 15)))
		{
			if ((Right->IsItem() != 0 && Right->m_IsValidItem == 0) || (Left->IsItem() != 0 && Left->m_IsValidItem == 0))
			{
				lpObj->PhysiDamageMinRight = (Strength + Dexterity) / gServerInfo.m_FEPhysiDamageMinConstA;
				lpObj->PhysiDamageMaxRight = (Strength + Dexterity) / gServerInfo.m_FEPhysiDamageMaxConstA;
				lpObj->PhysiDamageMinLeft = (Strength + Dexterity) / gServerInfo.m_FEPhysiDamageMinConstA;
				lpObj->PhysiDamageMaxLeft = (Strength + Dexterity) / gServerInfo.m_FEPhysiDamageMaxConstA;
			}
			else
			{
				lpObj->PhysiDamageMinRight = (Strength / gServerInfo.m_FEPhysiDamageMinBowConstA) + (Dexterity / gServerInfo.m_FEPhysiDamageMinBowConstB);
				lpObj->PhysiDamageMaxRight = (Strength / gServerInfo.m_FEPhysiDamageMaxBowConstA) + (Dexterity / gServerInfo.m_FEPhysiDamageMaxBowConstB);
				lpObj->PhysiDamageMinLeft = (Strength / gServerInfo.m_FEPhysiDamageMinBowConstA) + (Dexterity / gServerInfo.m_FEPhysiDamageMinBowConstB);
				lpObj->PhysiDamageMaxLeft = (Strength / gServerInfo.m_FEPhysiDamageMaxBowConstA) + (Dexterity / gServerInfo.m_FEPhysiDamageMaxBowConstB);
			}
		}
		else
		{
			lpObj->PhysiDamageMinRight = (Strength + Dexterity) / gServerInfo.m_FEPhysiDamageMinConstA;
			lpObj->PhysiDamageMaxRight = (Strength + Dexterity) / gServerInfo.m_FEPhysiDamageMaxConstA;
			lpObj->PhysiDamageMinLeft = (Strength + Dexterity) / gServerInfo.m_FEPhysiDamageMinConstA;
			lpObj->PhysiDamageMaxLeft = (Strength + Dexterity) / gServerInfo.m_FEPhysiDamageMaxConstA;
		}

		lpObj->MagicDamageMin = Energy / gServerInfo.m_FEMagicDamageMinConstA;
		lpObj->MagicDamageMax = Energy / gServerInfo.m_FEMagicDamageMaxConstA;
		lpObj->CurseDamageMin = Energy / gServerInfo.m_FEMagicDamageMinConstA;
		lpObj->CurseDamageMax = Energy / gServerInfo.m_FEMagicDamageMaxConstA;
	}
	else if (lpObj->Class == CLASS_MG)
	{
		lpObj->PhysiDamageMinRight = (Strength / gServerInfo.m_MGPhysiDamageMinConstA);// + (Energy / gServerInfo.m_MGPhysiDamageMinConstB);
		lpObj->PhysiDamageMaxRight = (Strength / gServerInfo.m_MGPhysiDamageMaxConstA);// + (Energy / gServerInfo.m_MGPhysiDamageMaxConstB);
		lpObj->PhysiDamageMinLeft = (Strength / gServerInfo.m_MGPhysiDamageMinConstA);// + (Energy / gServerInfo.m_MGPhysiDamageMinConstB);
		lpObj->PhysiDamageMaxLeft = (Strength / gServerInfo.m_MGPhysiDamageMaxConstA);// + (Energy / gServerInfo.m_MGPhysiDamageMaxConstB);
		lpObj->MagicDamageMin = Energy / gServerInfo.m_MGMagicDamageMinConstA;
		lpObj->MagicDamageMax = Energy / gServerInfo.m_MGMagicDamageMaxConstA;
		lpObj->CurseDamageMin = Energy / gServerInfo.m_MGMagicDamageMinConstA;
		lpObj->CurseDamageMax = Energy / gServerInfo.m_MGMagicDamageMaxConstA;
		lpObj->DKDamageMultiplierRate = 200 + (Energy / gServerInfo.m_DKDamageMultiplierConstA);
		lpObj->DKDamageMultiplierRate = ((lpObj->DKDamageMultiplierRate > gServerInfo.m_DKDamageMultiplierMaxRate) ? gServerInfo.m_DKDamageMultiplierMaxRate : lpObj->DKDamageMultiplierRate);
	}
	else if (lpObj->Class == CLASS_DL)
	{
		lpObj->PhysiDamageMinRight = (Strength / gServerInfo.m_DLPhysiDamageMinConstA);// +(Energy / gServerInfo.m_DLPhysiDamageMinConstB);
		lpObj->PhysiDamageMaxRight = (Strength / gServerInfo.m_DLPhysiDamageMaxConstA);// + (Energy / gServerInfo.m_DLPhysiDamageMaxConstB);
		lpObj->PhysiDamageMinLeft = (Strength / gServerInfo.m_DLPhysiDamageMinConstA);// + (Energy / gServerInfo.m_DLPhysiDamageMinConstB);
		lpObj->PhysiDamageMaxLeft = (Strength / gServerInfo.m_DLPhysiDamageMaxConstA);// + (Energy / gServerInfo.m_DLPhysiDamageMaxConstB);
		lpObj->MagicDamageMin = Energy / gServerInfo.m_DLMagicDamageMinConstA;
		lpObj->MagicDamageMax = Energy / gServerInfo.m_DLMagicDamageMaxConstA;
		lpObj->CurseDamageMin = Energy / gServerInfo.m_DLMagicDamageMinConstA;
		lpObj->CurseDamageMax = Energy / gServerInfo.m_DLMagicDamageMaxConstA;
		lpObj->DLDamageMultiplierRate = 200 + (Energy / gServerInfo.m_DLDamageMultiplierConstA);
		lpObj->DLDamageMultiplierRate = ((lpObj->DLDamageMultiplierRate > gServerInfo.m_DLDamageMultiplierMaxRate) ? gServerInfo.m_DLDamageMultiplierMaxRate : lpObj->DLDamageMultiplierRate);
	}
	else if (lpObj->Class == CLASS_SU)
	{
		lpObj->PhysiDamageMinRight = (Strength + Dexterity) / gServerInfo.m_SUPhysiDamageMinConstA;
		lpObj->PhysiDamageMaxRight = (Strength + Dexterity) / gServerInfo.m_SUPhysiDamageMaxConstA;
		lpObj->PhysiDamageMinLeft = (Strength + Dexterity) / gServerInfo.m_SUPhysiDamageMinConstA;
		lpObj->PhysiDamageMaxLeft = (Strength + Dexterity) / gServerInfo.m_SUPhysiDamageMaxConstA;
		lpObj->MagicDamageMin = Energy / gServerInfo.m_SUMagicDamageMinConstA;
		lpObj->MagicDamageMax = Energy / gServerInfo.m_SUMagicDamageMaxConstA;
		lpObj->CurseDamageMin = Energy / gServerInfo.m_SUMagicDamageMinConstA;
		lpObj->CurseDamageMax = Energy / gServerInfo.m_SUMagicDamageMaxConstA;
	}
	else if (lpObj->Class == CLASS_RF)
	{
		lpObj->PhysiDamageMinRight = (Strength / gServerInfo.m_RFPhysiDamageMinConstA);// +(Vitality / gServerInfo.m_RFPhysiDamageMinConstB);
		lpObj->PhysiDamageMaxRight = (Strength / gServerInfo.m_RFPhysiDamageMaxConstA);// +(Vitality / gServerInfo.m_RFPhysiDamageMaxConstB);
		lpObj->PhysiDamageMinLeft = (Strength / gServerInfo.m_RFPhysiDamageMinConstA);// +(Vitality / gServerInfo.m_RFPhysiDamageMinConstB);
		lpObj->PhysiDamageMaxLeft = (Strength / gServerInfo.m_RFPhysiDamageMaxConstA);// +(Vitality / gServerInfo.m_RFPhysiDamageMaxConstB);
		lpObj->MagicDamageMin = Energy / gServerInfo.m_RFMagicDamageMinConstA;
		lpObj->MagicDamageMax = Energy / gServerInfo.m_RFMagicDamageMaxConstA;
		lpObj->CurseDamageMin = Energy / gServerInfo.m_RFMagicDamageMinConstA;
		lpObj->CurseDamageMax = Energy / gServerInfo.m_RFMagicDamageMaxConstA;
		lpObj->RFDamageMultiplierRate[0] = 50 + (Vitality / gServerInfo.m_RFDamageMultiplierConstB);
		lpObj->RFDamageMultiplierRate[0] = ((lpObj->RFDamageMultiplierRate[0] > gServerInfo.m_RFDamageMultiplierMaxRate) ? gServerInfo.m_RFDamageMultiplierMaxRate : lpObj->RFDamageMultiplierRate[0]);
		lpObj->RFDamageMultiplierRate[1] = 50 + (Energy / gServerInfo.m_RFDamageMultiplierConstC);
		lpObj->RFDamageMultiplierRate[1] = ((lpObj->RFDamageMultiplierRate[1] > gServerInfo.m_RFDamageMultiplierMaxRate) ? gServerInfo.m_RFDamageMultiplierMaxRate : lpObj->RFDamageMultiplierRate[1]);
		lpObj->RFDamageMultiplierRate[2] = 100 + (Dexterity / gServerInfo.m_RFDamageMultiplierConstA) + (Energy / gServerInfo.m_RFDamageMultiplierConstC);
		lpObj->RFDamageMultiplierRate[2] = ((lpObj->RFDamageMultiplierRate[2] > gServerInfo.m_RFDamageMultiplierMaxRate) ? gServerInfo.m_RFDamageMultiplierMaxRate : lpObj->RFDamageMultiplierRate[2]);
	}
	else if (lpObj->Class == CLASS_GL)
	{
		lpObj->PhysiDamageMinRight = (Strength / gServerInfo.m_FKPhysiDamageMinConstA);// +(Dexterity / gServerInfo.m_FKPhysiDamageMinConstB);
		lpObj->PhysiDamageMaxRight = (Strength / gServerInfo.m_FKPhysiDamageMaxConstA);// +(Dexterity / gServerInfo.m_FKPhysiDamageMaxConstB);
		lpObj->PhysiDamageMinLeft = (Strength / gServerInfo.m_FKPhysiDamageMinConstA);// +(Dexterity / gServerInfo.m_FKPhysiDamageMinConstB);
		lpObj->PhysiDamageMaxLeft = (Strength / gServerInfo.m_FKPhysiDamageMaxConstA);// +(Dexterity / gServerInfo.m_FKPhysiDamageMaxConstB);
		lpObj->MagicDamageMin = Energy / gServerInfo.m_FKMagicDamageMinConstA;
		lpObj->MagicDamageMax = Energy / gServerInfo.m_FKMagicDamageMaxConstA;
		lpObj->CurseDamageMin = Energy / gServerInfo.m_FKMagicDamageMinConstA;
		lpObj->CurseDamageMax = Energy / gServerInfo.m_FKMagicDamageMaxConstA;
		lpObj->GLDamageMultiplierRate[0] = 97 + (Strength / gServerInfo.m_FKDamageMultiplierConstA);
		lpObj->GLDamageMultiplierRate[0] = ((lpObj->GLDamageMultiplierRate[0] > gServerInfo.m_FKDamageMultiplierMaxRate) ? gServerInfo.m_FKDamageMultiplierMaxRate : lpObj->GLDamageMultiplierRate[0]);
		lpObj->GLDamageMultiplierRate[1] = 97 + (Dexterity / gServerInfo.m_FKDamageMultiplierConstB);
		lpObj->GLDamageMultiplierRate[1] = ((lpObj->GLDamageMultiplierRate[1] > gServerInfo.m_FKDamageMultiplierMaxRate) ? gServerInfo.m_FKDamageMultiplierMaxRate : lpObj->GLDamageMultiplierRate[1]);
	}

	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_MAGIC_DAMAGE);
	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_CURSE_DAMAGE);

	if (Right->IsItem() != 0)
	{
		if (Right->m_Index >= GET_ITEM(5, 0) && Right->m_Index < GET_ITEM(6, 0))
		{
			lpObj->PhysiDamageMinRight += Right->GetDamageMin() / 2;
			lpObj->PhysiDamageMaxRight += Right->GetDamageMax() / 2;
			lpObj->SkillLongSpearChange = ((Right->m_SkillChange == 0) ? lpObj->SkillLongSpearChange : 1);
		}
		else
		{
			lpObj->PhysiDamageMinRight += Right->GetDamageMin() / 1;
			lpObj->PhysiDamageMaxRight += Right->GetDamageMax() / 1;
			lpObj->SkillLongSpearChange = ((Right->m_SkillChange == 0) ? lpObj->SkillLongSpearChange : 1);
		}
	}

	if (Left->IsItem() != 0)
	{
		if (Left->m_Index >= GET_ITEM(5, 0) && Left->m_Index < GET_ITEM(6, 0))
		{
			lpObj->PhysiDamageMinLeft += Left->GetDamageMin() / 2;
			lpObj->PhysiDamageMaxLeft += Left->GetDamageMax() / 2;
			lpObj->SkillLongSpearChange = ((Left->m_SkillChange == 0) ? lpObj->SkillLongSpearChange : 1);
		}
		else
		{
			lpObj->PhysiDamageMinLeft += Left->GetDamageMin() / 1;
			lpObj->PhysiDamageMaxLeft += Left->GetDamageMax() / 1;
			lpObj->SkillLongSpearChange = ((Left->m_SkillChange == 0) ? lpObj->SkillLongSpearChange : 1);
		}
	}

	if (lpObj->Class == CLASS_DW)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DWAttackSuccessRateConstA) + ((Dexterity * gServerInfo.m_DWAttackSuccessRateConstB) / gServerInfo.m_DWAttackSuccessRateConstC) + (Strength / gServerInfo.m_DWAttackSuccessRateConstD);
	}
	else if (lpObj->Class == CLASS_DK)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DKAttackSuccessRateConstA) + ((Dexterity * gServerInfo.m_DKAttackSuccessRateConstB) / gServerInfo.m_DKAttackSuccessRateConstC) + (Strength / gServerInfo.m_DKAttackSuccessRateConstD);
	}
	else if (lpObj->Class == CLASS_FE)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_FEAttackSuccessRateConstA) + ((Dexterity * gServerInfo.m_FEAttackSuccessRateConstB) / gServerInfo.m_FEAttackSuccessRateConstC) + (Strength / gServerInfo.m_FEAttackSuccessRateConstD);
	}
	else if (lpObj->Class == CLASS_MG)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_MGAttackSuccessRateConstA) + ((Dexterity * gServerInfo.m_MGAttackSuccessRateConstB) / gServerInfo.m_MGAttackSuccessRateConstC) + (Strength / gServerInfo.m_MGAttackSuccessRateConstD);
	}
	else if (lpObj->Class == CLASS_DL)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DLAttackSuccessRateConstA) + ((Dexterity * gServerInfo.m_DLAttackSuccessRateConstB) / gServerInfo.m_DLAttackSuccessRateConstC) + (Strength / gServerInfo.m_DLAttackSuccessRateConstD) + (Leadership / gServerInfo.m_DLAttackSuccessRateConstE);
	}
	else if (lpObj->Class == CLASS_SU)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_SUAttackSuccessRateConstA) + ((Dexterity * gServerInfo.m_SUAttackSuccessRateConstB) / gServerInfo.m_SUAttackSuccessRateConstC) + (Strength / gServerInfo.m_SUAttackSuccessRateConstD);
	}
	else if (lpObj->Class == CLASS_RF)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_RFAttackSuccessRateConstA) + ((Dexterity * gServerInfo.m_RFAttackSuccessRateConstB) / gServerInfo.m_RFAttackSuccessRateConstC) + (Strength / gServerInfo.m_RFAttackSuccessRateConstD);
	}
	else if (lpObj->Class == CLASS_GL)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_FKAttackSuccessRateConstA) + ((Dexterity * gServerInfo.m_FKAttackSuccessRateConstB) / gServerInfo.m_FKAttackSuccessRateConstC) + (Strength / gServerInfo.m_FKAttackSuccessRateConstD);
	}

	if (lpObj->Class == CLASS_DW)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DWAttackSuccessRatePvPConstA) / gServerInfo.m_DWAttackSuccessRatePvPConstB) + ((Dexterity * gServerInfo.m_DWAttackSuccessRatePvPConstC) / gServerInfo.m_DWAttackSuccessRatePvPConstD);
	}
	else if (lpObj->Class == CLASS_GL)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_FKAttackSuccessRatePvPConstA) / gServerInfo.m_FKAttackSuccessRatePvPConstB) + ((Dexterity * gServerInfo.m_FKAttackSuccessRatePvPConstC) / gServerInfo.m_FKAttackSuccessRatePvPConstD);
	}
	else if (lpObj->Class == CLASS_DK)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DKAttackSuccessRatePvPConstA) / gServerInfo.m_DKAttackSuccessRatePvPConstB) + ((Dexterity * gServerInfo.m_DKAttackSuccessRatePvPConstC) / gServerInfo.m_DKAttackSuccessRatePvPConstD);
	}
	else if (lpObj->Class == CLASS_FE)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_FEAttackSuccessRatePvPConstA) / gServerInfo.m_FEAttackSuccessRatePvPConstB) + ((Dexterity * gServerInfo.m_FEAttackSuccessRatePvPConstC) / gServerInfo.m_FEAttackSuccessRatePvPConstD);
	}
	else if (lpObj->Class == CLASS_MG)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_MGAttackSuccessRatePvPConstA) / gServerInfo.m_MGAttackSuccessRatePvPConstB) + ((Dexterity * gServerInfo.m_MGAttackSuccessRatePvPConstC) / gServerInfo.m_MGAttackSuccessRatePvPConstD);
	}
	else if (lpObj->Class == CLASS_DL)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DLAttackSuccessRatePvPConstA) / gServerInfo.m_DLAttackSuccessRatePvPConstB) + ((Dexterity * gServerInfo.m_DLAttackSuccessRatePvPConstC) / gServerInfo.m_DLAttackSuccessRatePvPConstD);
	}
	else if (lpObj->Class == CLASS_SU)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_SUAttackSuccessRatePvPConstA) / gServerInfo.m_SUAttackSuccessRatePvPConstB) + ((Dexterity * gServerInfo.m_SUAttackSuccessRatePvPConstC) / gServerInfo.m_SUAttackSuccessRatePvPConstD);
	}
	else if (lpObj->Class == CLASS_RF)
	{
		lpObj->m_MPSkillOpt.AttackSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_RFAttackSuccessRatePvPConstA) / gServerInfo.m_RFAttackSuccessRatePvPConstB) + ((Dexterity * gServerInfo.m_RFAttackSuccessRatePvPConstC) / gServerInfo.m_RFAttackSuccessRatePvPConstD);
	}

	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_ATTACK_RATE);
	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_ATTACK_RATE_PVP);

	if (lpObj->Class == CLASS_DW)
	{
		lpObj->PhysiSpeed = Dexterity / gServerInfo.m_DWPhysiSpeedConstA;
		lpObj->MagicSpeed = Dexterity / gServerInfo.m_DWMagicSpeedConstA;
	}
	else if (lpObj->Class == CLASS_GL)
	{
		lpObj->PhysiSpeed = Dexterity / gServerInfo.m_FKPhysiSpeedConstA;
		lpObj->MagicSpeed = Dexterity / gServerInfo.m_FKMagicSpeedConstA;
	}
	else if (lpObj->Class == CLASS_DK)
	{
		lpObj->PhysiSpeed = Dexterity / gServerInfo.m_DKPhysiSpeedConstA;
		lpObj->MagicSpeed = Dexterity / gServerInfo.m_DKMagicSpeedConstA;
	}
	else if (lpObj->Class == CLASS_FE)
	{
		lpObj->PhysiSpeed = Dexterity / gServerInfo.m_FEPhysiSpeedConstA;
		lpObj->MagicSpeed = Dexterity / gServerInfo.m_FEMagicSpeedConstA;
	}
	else if (lpObj->Class == CLASS_MG)
	{
		lpObj->PhysiSpeed = Dexterity / gServerInfo.m_MGPhysiSpeedConstA;
		lpObj->MagicSpeed = Dexterity / gServerInfo.m_MGMagicSpeedConstA;
	}
	else if (lpObj->Class == CLASS_DL)
	{
		lpObj->PhysiSpeed = Dexterity / gServerInfo.m_DLPhysiSpeedConstA;
		lpObj->MagicSpeed = Dexterity / gServerInfo.m_DLMagicSpeedConstA;
	}
	else if (lpObj->Class == CLASS_SU)
	{
		lpObj->PhysiSpeed = Dexterity / gServerInfo.m_SUPhysiSpeedConstA;
		lpObj->MagicSpeed = Dexterity / gServerInfo.m_SUMagicSpeedConstA;
	}
	else if (lpObj->Class == CLASS_RF)
	{
		lpObj->PhysiSpeed = Dexterity / gServerInfo.m_RFPhysiSpeedConstA;
		lpObj->MagicSpeed = Dexterity / gServerInfo.m_RFMagicSpeedConstA;
	}

	lpObj->PhysiSpeed += lpObj->DrinkSpeed;
	lpObj->MagicSpeed += lpObj->DrinkSpeed;

	lpObj->PhysiSpeed += lpObj->EffectOption.AddPhysiSpeed;
	lpObj->MagicSpeed += lpObj->EffectOption.AddMagicSpeed;

	lpObj->PhysiSpeed += (lpObj->PhysiSpeed * lpObj->EffectOption.MulPhysiSpeed) / 100;
	lpObj->MagicSpeed += (lpObj->MagicSpeed * lpObj->EffectOption.MulMagicSpeed) / 100;

	lpObj->PhysiSpeed += (lpObj->PhysiSpeed * lpObj->EffectOption.DivPhysiSpeed) / 100;
	lpObj->MagicSpeed += (lpObj->MagicSpeed * lpObj->EffectOption.DivMagicSpeed) / 100;

	bool RightItem = 0;

	if (Right->m_Index >= GET_ITEM(0, 0) && Right->m_Index < GET_ITEM(6, 0) && Right->m_Index != GET_ITEM(4, 7) && Right->m_Index != GET_ITEM(4, 15))
	{
		if (Right->m_IsValidItem != 0)
		{
			RightItem = 1;
		}
	}

	bool LeftItem = 0;

	if (Left->m_Index >= GET_ITEM(0, 0) && Left->m_Index < GET_ITEM(6, 0) && Left->m_Index != GET_ITEM(4, 7) && Left->m_Index != GET_ITEM(4, 15))
	{
		if (Left->m_IsValidItem != 0)
		{
			LeftItem = 1;
		}
	}

	if (RightItem != 0 && LeftItem != 0)
	{
		lpObj->PhysiSpeed += (Right->m_AttackSpeed + Left->m_AttackSpeed) / 2;
		lpObj->MagicSpeed += (Right->m_AttackSpeed + Left->m_AttackSpeed) / 2;
	}
	else if (RightItem != 0)
	{
		lpObj->PhysiSpeed += Right->m_AttackSpeed;
		lpObj->MagicSpeed += Right->m_AttackSpeed;
	}
	else if (LeftItem != 0)
	{
		lpObj->PhysiSpeed += Left->m_AttackSpeed;
		lpObj->MagicSpeed += Left->m_AttackSpeed;
	}

	if (Gloves->IsItem() != 0 && Gloves->m_IsValidItem != 0)
	{
		lpObj->PhysiSpeed += Gloves->m_AttackSpeed;
		lpObj->MagicSpeed += Gloves->m_AttackSpeed;
	}

	if (Helper->IsItem() != 0 && Helper->m_IsValidItem != 0)
	{
		lpObj->PhysiSpeed += Helper->m_AttackSpeed;
		lpObj->MagicSpeed += Helper->m_AttackSpeed;
	}

	if (Amulet->IsItem() != 0 && Amulet->m_IsValidItem != 0)
	{
		lpObj->PhysiSpeed += Amulet->m_AttackSpeed;
		lpObj->MagicSpeed += Amulet->m_AttackSpeed;
	}

	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_ATTACK_SPEED);

	if (lpObj->Class == CLASS_DW)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRate = Dexterity / gServerInfo.m_DWDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_GL)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRate = Dexterity / gServerInfo.m_FKDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_DK)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRate = Dexterity / gServerInfo.m_DKDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_FE)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRate = Dexterity / gServerInfo.m_FEDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_MG)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRate = Dexterity / gServerInfo.m_MGDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_DL)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRate = Dexterity / gServerInfo.m_DLDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_SU)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRate = Dexterity / gServerInfo.m_SUDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_RF)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRate = Dexterity / gServerInfo.m_RFDefenseSuccessRateConstA;
	}

	lpObj->m_MPSkillOpt.DefenseSuccessRate += lpObj->Inventory[1].GetDefenseSuccessRate();
	lpObj->m_MPSkillOpt.DefenseSuccessRate += lpObj->Inventory[2].GetDefenseSuccessRate();
	lpObj->m_MPSkillOpt.DefenseSuccessRate += lpObj->Inventory[3].GetDefenseSuccessRate();
	lpObj->m_MPSkillOpt.DefenseSuccessRate += lpObj->Inventory[4].GetDefenseSuccessRate();
	lpObj->m_MPSkillOpt.DefenseSuccessRate += lpObj->Inventory[5].GetDefenseSuccessRate();
	lpObj->m_MPSkillOpt.DefenseSuccessRate += lpObj->Inventory[6].GetDefenseSuccessRate();
	lpObj->m_MPSkillOpt.DefenseSuccessRate += lpObj->Inventory[7].GetDefenseSuccessRate();

	if (lpObj->Class == CLASS_DW)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DWDefenseSuccessRatePvPConstA) / gServerInfo.m_DWDefenseSuccessRatePvPConstB) + (Dexterity / gServerInfo.m_DWDefenseSuccessRatePvPConstC);
	}
	else if (lpObj->Class == CLASS_GL)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_FKDefenseSuccessRatePvPConstA) / gServerInfo.m_FKDefenseSuccessRatePvPConstB) + (Dexterity / gServerInfo.m_FKDefenseSuccessRatePvPConstC);
	}
	else if (lpObj->Class == CLASS_DK)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DKDefenseSuccessRatePvPConstA) / gServerInfo.m_DKDefenseSuccessRatePvPConstB) + (Dexterity / gServerInfo.m_DKDefenseSuccessRatePvPConstC);
	}
	else if (lpObj->Class == CLASS_FE)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_FEDefenseSuccessRatePvPConstA) / gServerInfo.m_FEDefenseSuccessRatePvPConstB) + (Dexterity / gServerInfo.m_FEDefenseSuccessRatePvPConstC);
	}
	else if (lpObj->Class == CLASS_MG)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_MGDefenseSuccessRatePvPConstA) / gServerInfo.m_MGDefenseSuccessRatePvPConstB) + (Dexterity / gServerInfo.m_MGDefenseSuccessRatePvPConstC);
	}
	else if (lpObj->Class == CLASS_DL)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DLDefenseSuccessRatePvPConstA) / gServerInfo.m_DLDefenseSuccessRatePvPConstB) + (Dexterity / gServerInfo.m_DLDefenseSuccessRatePvPConstC);
	}
	else if (lpObj->Class == CLASS_SU)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_SUDefenseSuccessRatePvPConstA) / gServerInfo.m_SUDefenseSuccessRatePvPConstB) + (Dexterity / gServerInfo.m_SUDefenseSuccessRatePvPConstC);
	}
	else if (lpObj->Class == CLASS_RF)
	{
		lpObj->m_MPSkillOpt.DefenseSuccessRatePvP = (((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_RFDefenseSuccessRatePvPConstA) / gServerInfo.m_RFDefenseSuccessRatePvPConstB) + (Dexterity / gServerInfo.m_RFDefenseSuccessRatePvPConstC);
	}

	int LastItemIndex = -1;

	for (int n = 2; n < 7; n++)
	{
		if (n == 2 && lpObj->Class == CLASS_MG)
		{
			continue;
		}

		if (n == 5 && lpObj->Class == CLASS_RF)
		{
			continue;
		}

		if (lpObj->Inventory[n].IsItem() == 0 || lpObj->Inventory[n].m_IsValidItem == 0 || (LastItemIndex != -1 && (lpObj->Inventory[n].m_Index % MAX_ITEM_TYPE) != LastItemIndex))
		{
			lpObj->ArmorSetBonus = 0;
			break;
		}
		else
		{
			lpObj->ArmorSetBonus = 1;
			LastItemIndex = lpObj->Inventory[n].m_Index % MAX_ITEM_TYPE;
		}
	}

	int Level11Count = 0;
	int Level10Count = 0;
	int Level12Count = 0;
	int Level13Count = 0;
	int Level14Count = 0;
	int Level15Count = 0;

	if (lpObj->ArmorSetBonus != 0)
	{
		for (int n = 2; n < 7; n++)
		{
			if (n == 2 && lpObj->Class == CLASS_MG)
			{
				Level15Count++;
				continue;
			}

			if (n == 5 && lpObj->Class == CLASS_RF)
			{
				Level15Count++;
				continue;
			}

			if (lpObj->Inventory[n].m_Level == 10)
			{
				Level10Count++;
			}
			else if (lpObj->Inventory[n].m_Level == 11)
			{
				Level11Count++;
			}
			else if (lpObj->Inventory[n].m_Level == 12)
			{
				Level12Count++;
			}
			else if (lpObj->Inventory[n].m_Level == 13)
			{
				Level13Count++;
			}
			else if (lpObj->Inventory[n].m_Level == 14)
			{
				Level14Count++;
			}
			else if (lpObj->Inventory[n].m_Level == 15)
			{
				Level15Count++;
			}
		}

		lpObj->m_MPSkillOpt.DefenseSuccessRate += (lpObj->m_MPSkillOpt.DefenseSuccessRate * 10) / 100;
	}

	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_DEFENSE_RATE);
	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_DEFENSE_RATE_PVP);

	int maxDexterity[MAX_CLASS] = {28000,25000,37000,23000,25000,22000,24000,32000};

	//Mapa da temporada, limite de agi -> defesa
	if ((lpObj->Map == MAP_TEMPORADA) && Dexterity > maxDexterity[lpObj->Class]) 
	{
		lpObj->Defense = maxDexterity[lpObj->Class] / gServerInfo.m_ClassDefenseConst[lpObj->Class];
	}
	else
	{
		lpObj->Defense = Dexterity / gServerInfo.m_ClassDefenseConst[lpObj->Class];
	}

	//lpObj->Defense = Dexterity / gServerInfo.m_ClassDefenseConst[lpObj->Class];

	lpObj->Defense += lpObj->Inventory[1].GetDefense();
	lpObj->Defense += lpObj->Inventory[2].GetDefense();
	lpObj->Defense += lpObj->Inventory[3].GetDefense();
	lpObj->Defense += lpObj->Inventory[4].GetDefense();
	lpObj->Defense += lpObj->Inventory[5].GetDefense();
	lpObj->Defense += lpObj->Inventory[6].GetDefense();
	lpObj->Defense += lpObj->Inventory[7].GetDefense();

	/*if (Helper->IsItem() != 0 && Helper->m_IsValidItem != 0 && Helper->m_Durability != 0)
	{
		if (Helper->m_Index == GET_ITEM(13, 4))
		{
			lpObj->Defense += (Dexterity / 20) + (Helper->m_PetItemLevel * 2) + 5;
		}
	}*/

	/*
	if (lpObj->Inventory[lpObj->m_btInvenPetPos].m_Index == GET_ITEM(13, 4) && lpObj->Inventory[lpObj->m_btInvenPetPos].m_JewelOfHarmonyOption == 1)
	{
		lpObj->Defense += (Dexterity / 20) + (Helper->m_PetItemLevel * 2) + 5;
	}*/

	if (lpObj->ArmorSetBonus != 0 && (Level15Count + Level14Count + Level13Count + Level12Count + Level11Count + Level10Count) >= 5)
	{
		if (Level15Count == 5)
		{
			lpObj->Defense += (lpObj->Defense * 30) / 100;
		}
		else if (Level14Count == 5 || (Level14Count + Level15Count) == 5)
		{
			lpObj->Defense += (lpObj->Defense * 25) / 100;
		}
		else if (Level13Count == 5 || (Level13Count + Level14Count + Level15Count) == 5)
		{
			lpObj->Defense += (lpObj->Defense * 20) / 100;
		}
		else if (Level12Count == 5 || (Level12Count + Level13Count + Level14Count + Level15Count) == 5)
		{
			lpObj->Defense += (lpObj->Defense * 15) / 100;
		}
		else if (Level11Count == 5 || (Level11Count + Level12Count + Level13Count + Level14Count + Level15Count) == 5)
		{
			lpObj->Defense += (lpObj->Defense * 10) / 100;
		}
		else if (Level10Count == 5 || (Level10Count + Level11Count + Level12Count + Level13Count + Level14Count + Level15Count) == 5)
		{
			lpObj->Defense += (lpObj->Defense * 5) / 100;
		}
	}

	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_DEFENSE);

	gDarkSpirit[lpObj->Index].Set(lpObj->Index, &lpObj->Inventory[lpObj->m_btInvenPetDkSpiritPos]);

	lpObj->m_MPSkillOpt.Resistance[SKILL_ELEMENT_ICE] = GET_MAX_RESISTANCE(Amulet->m_Resistance[0], Ring1->m_Resistance[0], Ring2->m_Resistance[0]);
	lpObj->m_MPSkillOpt.Resistance[SKILL_ELEMENT_POISON] = GET_MAX_RESISTANCE(Amulet->m_Resistance[1], Ring1->m_Resistance[1], Ring2->m_Resistance[1]);
	lpObj->m_MPSkillOpt.Resistance[SKILL_ELEMENT_LIGHTNING] = GET_MAX_RESISTANCE(Amulet->m_Resistance[2], Ring1->m_Resistance[2], Ring2->m_Resistance[2]);
	lpObj->m_MPSkillOpt.Resistance[SKILL_ELEMENT_FIRE] = GET_MAX_RESISTANCE(Amulet->m_Resistance[3], Ring1->m_Resistance[3], Ring2->m_Resistance[3]);
	lpObj->m_MPSkillOpt.Resistance[SKILL_ELEMENT_EARTH] = GET_MAX_RESISTANCE(Amulet->m_Resistance[4], Ring1->m_Resistance[4], Ring2->m_Resistance[4]);
	lpObj->m_MPSkillOpt.Resistance[SKILL_ELEMENT_WIND] = GET_MAX_RESISTANCE(Amulet->m_Resistance[5], Ring1->m_Resistance[5], Ring2->m_Resistance[5]);
	lpObj->m_MPSkillOpt.Resistance[SKILL_ELEMENT_WATER] = GET_MAX_RESISTANCE(Amulet->m_Resistance[6], Ring1->m_Resistance[6], Ring2->m_Resistance[6]);

	if (lpObj->Class == CLASS_DW)
	{
		lpObj->ElementalAttribute = 0;
		lpObj->ElementalDefense = Dexterity / gServerInfo.m_DWElementalDefenseConstA;
		lpObj->ElementalDamageMin = Energy / gServerInfo.m_DWElementalDamageMinConstA;
		lpObj->ElementalDamageMax = Energy / gServerInfo.m_DWElementalDamageMaxConstA;
		lpObj->ElementalAttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DWElementalAttackSuccessRateConstA) + (Strength / gServerInfo.m_DWElementalAttackSuccessRateConstB) + ((Dexterity * gServerInfo.m_DWElementalAttackSuccessRateConstC) / gServerInfo.m_DWElementalAttackSuccessRateConstD);
		lpObj->ElementalDefenseSuccessRate = Dexterity / gServerInfo.m_DWElementalDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_DK)
	{
		lpObj->ElementalAttribute = 0;
		lpObj->ElementalDefense = Dexterity / gServerInfo.m_DKElementalDefenseConstA;
		lpObj->ElementalDamageMin = Strength / gServerInfo.m_DKElementalDamageMinConstA;
		lpObj->ElementalDamageMax = Strength / gServerInfo.m_DKElementalDamageMaxConstA;
		lpObj->ElementalAttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DKElementalAttackSuccessRateConstA) + (Strength / gServerInfo.m_DKElementalAttackSuccessRateConstB) + ((Dexterity * gServerInfo.m_DKElementalAttackSuccessRateConstC) / gServerInfo.m_DKElementalAttackSuccessRateConstD);
		lpObj->ElementalDefenseSuccessRate = Dexterity / gServerInfo.m_DKElementalDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_FE)
	{
		lpObj->ElementalAttribute = 0;
		lpObj->ElementalDefense = Dexterity / gServerInfo.m_FEElementalDefenseConstA;
		lpObj->ElementalDamageMin = (Dexterity / gServerInfo.m_FEElementalDamageMinConstA);
		lpObj->ElementalDamageMax = (Dexterity / gServerInfo.m_FEElementalDamageMaxConstA);
		lpObj->ElementalAttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_FEElementalAttackSuccessRateConstA) + (Strength / gServerInfo.m_FEElementalAttackSuccessRateConstB) + ((Dexterity * gServerInfo.m_FEElementalAttackSuccessRateConstC) / gServerInfo.m_FEElementalAttackSuccessRateConstD);
		lpObj->ElementalDefenseSuccessRate = Dexterity / gServerInfo.m_FEElementalDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_MG)
	{
		lpObj->ElementalAttribute = 0;
		lpObj->ElementalDefense = Dexterity / gServerInfo.m_MGElementalDefenseConstA;
		lpObj->ElementalDamageMin = (Strength / gServerInfo.m_MGElementalDamageMinConstA);
		lpObj->ElementalDamageMax = (Strength / gServerInfo.m_MGElementalDamageMaxConstA);
		lpObj->ElementalAttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_MGElementalAttackSuccessRateConstA) + (Strength / gServerInfo.m_MGElementalAttackSuccessRateConstB) + ((Dexterity * gServerInfo.m_MGElementalAttackSuccessRateConstC) / gServerInfo.m_MGElementalAttackSuccessRateConstD);
		lpObj->ElementalDefenseSuccessRate = Dexterity / gServerInfo.m_MGElementalDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_DL)
	{
		lpObj->ElementalAttribute = 0;
		lpObj->ElementalDefense = Dexterity / gServerInfo.m_DLElementalDefenseConstA;
		lpObj->ElementalDamageMin = (Strength / gServerInfo.m_DLElementalDamageMinConstA);
		lpObj->ElementalDamageMax = (Strength / gServerInfo.m_DLElementalDamageMaxConstA);
		lpObj->ElementalAttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_DLElementalAttackSuccessRateConstA) + (Strength / gServerInfo.m_DLElementalAttackSuccessRateConstB) + ((Dexterity * gServerInfo.m_DLElementalAttackSuccessRateConstC) / gServerInfo.m_DLElementalAttackSuccessRateConstD);
		lpObj->ElementalDefenseSuccessRate = Dexterity / gServerInfo.m_DLElementalDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_SU)
	{
		lpObj->ElementalAttribute = 0;
		lpObj->ElementalDefense = Dexterity / gServerInfo.m_SUElementalDefenseConstA;
		lpObj->ElementalDamageMin = Energy / gServerInfo.m_SUElementalDamageMinConstA;
		lpObj->ElementalDamageMax = Energy / gServerInfo.m_SUElementalDamageMaxConstA;
		lpObj->ElementalAttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_SUElementalAttackSuccessRateConstA) + (Strength / gServerInfo.m_SUElementalAttackSuccessRateConstB) + ((Dexterity * gServerInfo.m_SUElementalAttackSuccessRateConstC) / gServerInfo.m_SUElementalAttackSuccessRateConstD);
		lpObj->ElementalDefenseSuccessRate = Dexterity / gServerInfo.m_SUElementalDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_RF)
	{
		lpObj->ElementalAttribute = 0;
		lpObj->ElementalDefense = Dexterity / gServerInfo.m_RFElementalDefenseConstA;
		lpObj->ElementalDamageMin = (Strength / gServerInfo.m_RFElementalDamageMinConstA);
		lpObj->ElementalDamageMax = (Strength / gServerInfo.m_RFElementalDamageMaxConstA);
		lpObj->ElementalAttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_RFElementalAttackSuccessRateConstA) + (Strength / gServerInfo.m_RFElementalAttackSuccessRateConstB) + ((Dexterity * gServerInfo.m_RFElementalAttackSuccessRateConstC) / gServerInfo.m_RFElementalAttackSuccessRateConstD);
		lpObj->ElementalDefenseSuccessRate = Dexterity / gServerInfo.m_RFElementalDefenseSuccessRateConstA;
	}
	else if (lpObj->Class == CLASS_GL)
	{
		lpObj->ElementalAttribute = 0;
		lpObj->ElementalDefense = Dexterity / gServerInfo.m_FKElementalDefenseConstA;
		lpObj->ElementalDamageMin = (Strength / gServerInfo.m_FKElementalDamageMinConstA);
		lpObj->ElementalDamageMax = (Strength / gServerInfo.m_FKElementalDamageMaxConstA);
		lpObj->ElementalAttackSuccessRate = ((lpObj->Level + lpObj->MasterLevel) * gServerInfo.m_FKElementalAttackSuccessRateConstA) + (Strength / gServerInfo.m_DKElementalAttackSuccessRateConstB) + ((Dexterity * gServerInfo.m_FKElementalAttackSuccessRateConstC) / gServerInfo.m_FKElementalAttackSuccessRateConstD);
		lpObj->ElementalDefenseSuccessRate = Dexterity / gServerInfo.m_FKElementalDefenseSuccessRateConstA;
	}

	if (Pentagram->IsItem() != 0 && Pentagram->IsPentagramItem() != 0 && Pentagram->m_IsValidItem != 0)
	{
		lpObj->ElementalAttribute = Pentagram->m_SocketOptionBonus % 16;
		lpObj->ElementalDefense += Pentagram->m_Defense;
		lpObj->ElementalDamageMin += Pentagram->m_DamageMin;
		lpObj->ElementalDamageMax += Pentagram->m_DamageMax;
	}

	gObjCalcExperience(lpObj);
	gItemOption.CalcItemCommonOption(lpObj, 0);
	gSetItemOption.CalcSetItemOption(lpObj, 0);
	//gJewelOfHarmonyOption.CalcJewelOfHarmonyOption(lpObj, 0);
	//g380ItemOption.Calc380ItemOption(lpObj, 0);
	gSocketItemOption.CalcSocketItemOption(lpObj, 0);
	gWings4thOption.Calc4thWingOption(lpObj, 0);
	gMasterSkillTree.CalcMasterSkillTreeOption(lpObj, 0);
	gPentagramSystem.CalcPentagramOption(lpObj, 0);
	gPentagramSystem.CalcPentagramJewelOption(lpObj, 0);

	for (int i = 0; i < MAX_CLASS; i++)
	{
		if (lpObj->AddGeneralDamageRateByClass[i] > gServerInfo.MASTERY_OPTION_DAMAGE_AGAINST_MAX)
		{
			lpObj->AddGeneralDamageRateByClass[i] = gServerInfo.MASTERY_OPTION_DAMAGE_AGAINST_MAX;
		}
	}

	this->CharacterCalcPvPAccessoryOption(lpObj);

	//gMuunSystem.CalcMuunOption(lpObj, 0);

	gMasterSkillTree_4th.CalcMasterSkillTreeOption(lpObj, 0);

	/*if (Right->m_Index >= GET_ITEM(4, 0) && Right->m_Index < GET_ITEM(5, 0) && Right->m_Slot == 0)
	{
		if (Left->m_Index == GET_ITEM(4, 7) && Left->m_Level > 0)
		{
			lpObj->PhysiDamageMinRight += ((lpObj->PhysiDamageMinRight * ((Left->m_Level * 2) + 1)) / 100) + 1;
			lpObj->PhysiDamageMaxRight += ((lpObj->PhysiDamageMinRight * ((Left->m_Level * 2) + 1)) / 100) + 1;
		}

		if (Left->m_Index == GET_ITEM(4, 15) && Left->m_Level > 0)
		{
			lpObj->PhysiDamageMinRight += ((lpObj->PhysiDamageMinRight * ((Left->m_Level * 2) + 1)) / 100) + 1;
			lpObj->PhysiDamageMaxRight += ((lpObj->PhysiDamageMinRight * ((Left->m_Level * 2) + 1)) / 100) + 1;
		}
	}*/

	if (lpObj->Class == CLASS_SU || lpObj->Class == CLASS_FE || lpObj->Class == CLASS_DK || lpObj->Class == CLASS_MG || lpObj->Class == CLASS_RF)
	{
		if (Right->IsItem() != 0 && Left->IsItem() != 0)
		{
			if (Right->m_Index >= GET_ITEM(0, 0) && Right->m_Index < GET_ITEM(6, 0) && Left->m_Index >= GET_ITEM(0, 0) && Left->m_Index < GET_ITEM(6, 0))
			{
				if (lpObj->Class == CLASS_RF)
				{
					lpObj->PhysiDamageMinRight = (lpObj->PhysiDamageMinRight * 60) / 100;
					lpObj->PhysiDamageMaxRight = (lpObj->PhysiDamageMaxRight * 60) / 100;
					lpObj->PhysiDamageMinLeft = (lpObj->PhysiDamageMinLeft * 60) / 100;
					lpObj->PhysiDamageMaxLeft = (lpObj->PhysiDamageMaxLeft * 60) / 100;
				}
				else
				{
					lpObj->PhysiDamageMinRight = (lpObj->PhysiDamageMinRight * 50) / 100;
					lpObj->PhysiDamageMaxRight = (lpObj->PhysiDamageMaxRight * 50) / 100;
					lpObj->PhysiDamageMinLeft = (lpObj->PhysiDamageMinLeft * 50) / 100;
					lpObj->PhysiDamageMaxLeft = (lpObj->PhysiDamageMaxLeft * 50) / 100;
				}
			}
		}
	}

	g_StatSpec.CalcStatOption(lpObj, STAT_OPTION_INC_ATTACK_POWER);

	lpObj->MaxLife = gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].MaxLife;
	lpObj->MaxMana = gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].MaxMana;

	lpObj->MaxLife += gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].LevelLife * (lpObj->Level - 1);
	lpObj->MaxMana += gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].LevelMana * (lpObj->Level - 1);

	if (gMasterSkillTree.CheckMasterLevel(lpObj) != 0)
	{
		lpObj->MaxLife += gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].LevelLife * lpObj->MasterLevel;
		lpObj->MaxMana += gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].LevelMana * lpObj->MasterLevel;
	}

	//Vitality limit for PVP
	if (lpObj->Map == MAP_ARENA)
	{
		int VitLimit = (lpObj->Class == CLASS_FE || lpObj->Class == CLASS_RF) ? 50000 : 45000;

		if (lpObj->Vitality > VitLimit)
		{
			lpObj->MaxLife += ((VitLimit - gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].Vitality) + lpObj->AddVitality) * lpObj->VitalityToLife;
		}
		else
		{
			lpObj->MaxLife += ((lpObj->Vitality - gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].Vitality) + lpObj->AddVitality) * lpObj->VitalityToLife;
		}
	}
	else if (lpObj->Map == MAP_TEMPORADA) //Mapa da temporada, limite de vit -> HP
	{
		int VitLimit = 35000;

		if (lpObj->Vitality > VitLimit)
		{
			lpObj->MaxLife += ((VitLimit - gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].Vitality) + lpObj->AddVitality) * lpObj->VitalityToLife;
		}
		else
		{
			lpObj->MaxLife += ((lpObj->Vitality - gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].Vitality) + lpObj->AddVitality) * lpObj->VitalityToLife;
		}
	}
	else
	{
		lpObj->MaxLife += ((lpObj->Vitality - gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].Vitality) + lpObj->AddVitality) * lpObj->VitalityToLife;
	}

	lpObj->MaxMana += ((lpObj->Energy - gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].Energy) + lpObj->AddEnergy) * lpObj->EnergyToMana;

	this->CharacterCalcBP(lpObj);
	this->CharacterCalcSD(lpObj);

	lpObj->AddLife += lpObj->EffectOption.AddMaxHP;
	lpObj->AddLife += (int)(lpObj->MaxLife * lpObj->EffectOption.MulMaxHP) / 100;
	lpObj->AddLife -= (int)(lpObj->MaxLife * lpObj->EffectOption.DivMaxHP) / 100;
	lpObj->AddLife += (int)(lpObj->MaxLife * lpObj->SocketAddLife) / 100;

	lpObj->AddMana += lpObj->EffectOption.AddMaxMP;
	lpObj->AddMana += (int)(lpObj->MaxMana * lpObj->EffectOption.MulMaxMP) / 100;
	lpObj->AddMana -= (int)(lpObj->MaxMana * lpObj->EffectOption.DivMaxMP) / 100;

	lpObj->AddBP += lpObj->EffectOption.AddMaxBP;
	lpObj->AddBP += (int)(lpObj->MaxBP * lpObj->EffectOption.MulMaxBP) / 100;
	lpObj->AddBP -= (int)(lpObj->MaxBP * lpObj->EffectOption.DivMaxBP) / 100;

	lpObj->m_MPSkillOpt.AddShield += lpObj->EffectOption.AddMaxSD;
	lpObj->m_MPSkillOpt.AddShield += (int)(lpObj->MaxShield * lpObj->EffectOption.MulMaxSD) / 100;
	lpObj->m_MPSkillOpt.AddShield -= (int)(lpObj->MaxShield * lpObj->EffectOption.DivMaxSD) / 100;

	lpObj->Life = ((lpObj->MaxLife + lpObj->AddLife) * TotalHP) / 100;
	lpObj->Life = ((lpObj->Life > (lpObj->MaxLife + lpObj->AddLife)) ? (lpObj->MaxLife + lpObj->AddLife) : lpObj->Life);

	lpObj->Shield = (int)(((lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) * TotalSD) / 100);
	lpObj->Shield = (int)(((lpObj->Shield > (lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield)) ? (lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield) : lpObj->Shield));

	lpObj->Mana = ((lpObj->MaxMana + lpObj->AddMana) * TotalMP) / 100;
	lpObj->Mana = ((lpObj->Mana > (lpObj->MaxMana + lpObj->AddMana)) ? (lpObj->MaxMana + lpObj->AddMana) : lpObj->Mana);

	lpObj->BP = (int)(((lpObj->MaxBP + lpObj->AddBP) * TotalBP) / 100);
	lpObj->BP = (int)(((lpObj->BP > (lpObj->MaxBP + lpObj->AddBP)) ? (lpObj->MaxBP + lpObj->AddBP) : lpObj->BP));

	GCLifeSend(aIndex, 0xFE, (int)(lpObj->MaxLife + lpObj->AddLife), (lpObj->MaxShield + lpObj->m_MPSkillOpt.AddShield));
	GCLifeSend(aIndex, 0xFF, (int)lpObj->Life, lpObj->Shield);

	GCManaSend(aIndex, 0xFE, (int)(lpObj->MaxMana + lpObj->AddMana), (lpObj->MaxBP + lpObj->AddBP));
	GCManaSend(aIndex, 0xFF, (int)lpObj->Mana, lpObj->BP);

	//GCNewCharacterCalcSend(lpObj);

	GCCharacterAttackSpeedSend(lpObj);

	GCCharacterInfo(lpObj);
	SXGetCharacterInfo(lpObj->Index);
	SXGetMosaic(lpObj->Index);
	//SXGetSpecial(lpObj->Index);
	g_StatSpec.SendOptionList(lpObj);

	g_FilaHit.Velocidade(lpObj);
}

bool CObjectManager::CharacterInfoSet(BYTE* aRecv, int aIndex) // OK
{
	SDHP_CHARACTER_INFO_RECV* lpMsg = (SDHP_CHARACTER_INFO_RECV*)aRecv;

	if (OBJECT_RANGE(aIndex) == 0)
	{
		return 0;
	}

	LPOBJ lpObj = &gObj[aIndex];

	if (lpObj->Connected == OBJECT_OFFLINE || lpObj->Connected == OBJECT_CONNECTED)
	{
		return 0;
	}

	if (lpMsg->Class != DB_CLASS_PK && lpMsg->Class != DB_CLASS_FK && lpMsg->Class != DB_CLASS_DW && lpMsg->Class != DB_CLASS_SM && lpMsg->Class != DB_CLASS_GM && lpMsg->Class != DB_CLASS_DK && lpMsg->Class != DB_CLASS_BK && lpMsg->Class != DB_CLASS_BM && lpMsg->Class != DB_CLASS_FE && lpMsg->Class != DB_CLASS_ME && lpMsg->Class != DB_CLASS_HE && lpMsg->Class != DB_CLASS_MG && lpMsg->Class != DB_CLASS_DM && lpMsg->Class != DB_CLASS_DL && lpMsg->Class != DB_CLASS_LE && lpMsg->Class != DB_CLASS_SU && lpMsg->Class != DB_CLASS_BS && lpMsg->Class != DB_CLASS_DS && lpMsg->Class != DB_CLASS_RF && lpMsg->Class != DB_CLASS_FM && lpMsg->Class != DB_CLASS_FS && lpMsg->Class != DB_CLASS_D && lpMsg->Class != DB_CLASS_SF && lpMsg->Class != DB_CLASS_MK && lpMsg->Class != DB_CLASS_HP && lpMsg->Class != DB_CLASS_WZ && lpMsg->Class != DB_CLASS_FG && lpMsg->Class != DB_CLASS_SY)
	{
		return 0;
	}

	gObjCharZeroSet(lpObj->Index);

	gChaosBox.ChaosBoxInit(lpObj);

	lpObj->PosNum = -1;
	lpObj->Level = lpMsg->Level;
	lpObj->MasterLevel = lpMsg->MasterLevel;
	lpObj->LevelUpPoint = lpMsg->LevelUpPoint;
	lpObj->DBClass = lpMsg->Class;

	lpObj->Class = lpMsg->Class >> 4;

	lpObj->ChangeUp = CS_GET_CHANGEUP_SXII(lpMsg->Class);

	if (lpObj->ChangeUp == 4)//2
	{
		lpObj->ChangeUp = 1;
	}

	if (lpObj->ChangeUp == 6)//3
	{
		lpObj->ChangeUp = 2;
	}

	if (lpObj->ChangeUp == 7)//4
	{
		lpObj->ChangeUp = 3;
	}

	lpObj->ExtInventory = lpMsg->ExtInventory;
	lpObj->ExtWarehouse = lpMsg->ExtWarehouse;

	lpObj->Reset = lpMsg->Reset;
	lpObj->MasterReset = lpMsg->MasterReset;

	lpObj->UseGuildMatching = lpMsg->UseGuildMatching;
	lpObj->UseGuildMatchingJoin = lpMsg->UseGuildMatchingJoin;

	lpObj->Ruud = lpMsg->Ruud;

	lpObj->ChatLimitTime = lpMsg->ChatLimitTime;

	for (int i = 0; i < 5; i++)
	{
		lpObj->AutoDt[i] = lpMsg->AutoDt[i];
	}

	float TotalPoints = lpObj->AutoDt[0] + lpObj->AutoDt[1] + lpObj->AutoDt[2] + lpObj->AutoDt[3] + lpObj->AutoDt[4];

	for (int i = 0; i < 5; i++)
	{
		lpObj->AutoDtFix[i] = GetRoundValue(lpObj->AutoDt[i] / TotalPoints * 100.0);
	}

	lpObj->AutoResetEnable = lpMsg->AutoRr;
	lpObj->AutoRe = lpMsg->AutoRe;

	if (lpObj->AutoRe == true)
	{
		lpObj->Option |= 1;
		lpObj->Option |= 2;
		lpObj->Option |= 4;
	}

	ZeroMemory(lpObj->Name, sizeof(lpObj->Name));
	memcpy(lpObj->Name, lpMsg->name, sizeof(lpObj->Name));

	lpObj->Map = lpMsg->Map;
	lpObj->X = lpMsg->X;
	lpObj->Y = lpMsg->Y;
	lpObj->StartX = lpMsg->X;
	lpObj->StartY = lpMsg->Y;

	/********/

	lpObj->IllusionTemple_DailyEnter = (lpMsg->IllusionTemple_Enter > 50) ? 0 : lpMsg->IllusionTemple_Enter;
	lpObj->IllusionTemple_DailyWins = (lpMsg->IllusionTemple_Wins > 50) ? 0 : lpMsg->IllusionTemple_Wins;
	lpObj->ImperialGuardian_Enter = (lpMsg->ImperialGuardian_Enter > 50) ? 0 : lpMsg->ImperialGuardian_Enter;
	lpObj->BloodCastle_Enter = (lpMsg->BloodCastle_Enter > 50) ? 0 : lpMsg->BloodCastle_Enter;
	lpObj->DevilSquare_Enter = (lpMsg->DevilSquare_Enter > 50) ? 0 : lpMsg->DevilSquare_Enter;
	lpObj->ChaosCastle_Enter = (lpMsg->ChaosCastle_Enter > 50) ? 0 : lpMsg->ChaosCastle_Enter;

	bool result = 0;

	int gate, map, x, y, dir, level;

	if (MAP_RANGE(lpObj->Map) == 0)
	{
		lpObj->Map = MAP_LORENCIA;
		gMap[lpObj->Map].GetMapPos(lpObj->Map, &lpObj->X, &lpObj->Y);
	}

	if (lpObj->Level < 6 && lpObj->Class == CLASS_DW && gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Level < 6 && lpObj->Class == CLASS_DK && gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Level < 6 && lpObj->Class == CLASS_FE && gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0)
	{
		result = gGate.GetGate(27, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Level < 6 && lpObj->Class == CLASS_MG && gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Level < 6 && lpObj->Class == CLASS_DL && gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Level < 6 && lpObj->Class == CLASS_SU && gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0)
	{
		result = gGate.GetGate(267, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Level < 6 && lpObj->Class == CLASS_RF && gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Level < 6 && lpObj->Class == CLASS_GL && gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 1) == 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (CA_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (DS_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(27, &gate, &map, &x, &y, &dir, &level);
	}
	else if (BC_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(22, &gate, &map, &x, &y, &dir, &level);
	}
	else if (CC_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_CASTLE_SIEGE && gCastleSiegeSync.GetCastleState() == CASTLESIEGE_STATE_STARTSIEGE)
	{
		result = gGate.GetGate(100, &gate, &map, &x, &y, &dir, &level);
	}
	/*else if (lpObj->Map == MAP_LAND_OF_TRIALS)
	{
		result = gGate.GetGate(106, &gate, &map, &x, &y, &dir, &level);
	}*/
	else if (IT_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(503, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_KANTURU3)
	{
		result = gGate.GetGate(139, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_RAKLION2)
	{
		result = gGate.GetGate(286, &gate, &map, &x, &y, &dir, &level);
	}
	else if (DA_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_SANTA_TOWN)
	{
		result = gGate.GetGate(22, &gate, &map, &x, &y, &dir, &level);
	}
	else if (DG_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(267, &gate, &map, &x, &y, &dir, &level);
	}
	else if (IG_MAP_RANGE(lpObj->Map) != 0)
	{
		result = gGate.GetGate(22, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_4_TH_QUEST)
	{
		result = gGate.GetGate(537, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_KNICKS && g_NixiesLakeBossZone.IsBossZone(lpObj->X, lpObj->Y) == 1)
	{
		result = gGate.GetGate(522, &gate, &map, &x, &y, &dir, &level);
	}
	else if (g_GodOfDarkness.IsBossZone(lpObj->Map, lpObj->X, lpObj->Y) == 1)
	{
		result = gGate.GetGate(567, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map == MAP_URUK_MOUNTAIN)
	{
		result = gGate.GetGate(417, &gate, &map, &x, &y, &dir, &level);
	}
	else if (lpObj->Map > 200)
	{
		result = gGate.GetGate(17, &gate, &map, &x, &y, &dir, &level);
	}

	if (result != 0)
	{
		lpObj->Map = map;
		lpObj->X = x;
		lpObj->Y = y;
		lpObj->Dir = dir;
	}

	if (lpObj->MapServerMoveRequest != 0)
	{
		if (gMapServerManager.CheckMapServerMove(aIndex, lpObj->DestMap, lpObj->LastServerCode) == gServerInfo.m_ServerCode)
		{
			lpObj->Map = (BYTE)lpObj->DestMap;
			lpObj->X = lpObj->DestX;
			lpObj->Y = lpObj->DestY;
			lpObj->StartX = lpObj->DestX;
			lpObj->StartY = lpObj->DestY;
		}
		else
		{
			//LogAdd(LOG_DEBUG, "NO DEU PRA MOVER CS");
			LogAdd(LOG_RED, "gObjDel %s %s %d [Class: %d]", __FILE__, __FUNCTION__, __LINE__, gObj[aIndex].Class);
			gObjDel(aIndex);
			return 0;
		}
	}

	if (gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 4) != 0 || gMap[lpObj->Map].CheckAttr(lpObj->X, lpObj->Y, 8) != 0)
	{
		gMap[lpObj->Map].GetMapPos(lpObj->Map, &lpObj->X, &lpObj->Y);
	}

	gMap[lpObj->Map].SetStandAttr(lpObj->X, lpObj->Y);

	lpObj->TX = lpObj->X;
	lpObj->TY = lpObj->Y;
	lpObj->OldX = lpObj->X;
	lpObj->OldY = lpObj->Y;
	lpObj->Experience = lpMsg->Experience;
	lpObj->Strength = lpMsg->Strength;
	lpObj->Dexterity = lpMsg->Dexterity;
	lpObj->Vitality = lpMsg->Vitality;
	lpObj->Energy = lpMsg->Energy;
	lpObj->Leadership = lpMsg->Leadership;
	lpObj->Life = (float)lpMsg->Life;
	lpObj->MaxLife = (float)lpMsg->MaxLife;
	lpObj->Mana = (float)lpMsg->Mana;
	lpObj->MaxMana = (float)lpMsg->MaxMana;
	lpObj->BP = lpMsg->BP;
	lpObj->MaxBP = lpMsg->MaxBP;
	lpObj->Shield = lpMsg->Shield;
	lpObj->MaxShield = lpMsg->MaxShield;
	lpObj->Money = lpMsg->Money;
	lpObj->FruitAddPoint = lpMsg->FruitAddPoint;
	lpObj->FruitSubPoint = lpMsg->FruitSubPoint;
	lpObj->VitalityToLife = gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].VitalityToLife;
	lpObj->EnergyToMana = gDefaultClassInfo.m_DefaultClassInfo[lpObj->Class].EnergyToMana;
	lpObj->PKCount = (char)lpMsg->PKCount;
	lpObj->PKLevel = (char)lpMsg->PKLevel;
	lpObj->PKTime = lpMsg->PKTime;
	lpObj->MaxRegenTime = 4000;
	lpObj->OriginalRegenTime = 4000;
	lpObj->MoveSpeed = 400;

	if (lpObj->PKLevel == 3)
	{
		lpObj->PKCount = 0;
		lpObj->PKTime = 0;
	}

	for (int i = 0; i < 50; i++)
	{
		const auto questNumber = i * 4;
		lpObj->Quest[questNumber].questState = lpMsg->Quest[i] & 3;
		lpObj->Quest[questNumber + 1].questState = lpMsg->Quest[i] >> 2 & 3;
		lpObj->Quest[questNumber + 2].questState = lpMsg->Quest[i] >> 4 & 3;
		lpObj->Quest[questNumber + 3].questState = lpMsg->Quest[i] >> 6 & 3;
	}

	gObjSetInventory1Pointer(lpObj);

	lpObj->GuildNumber = 0;
	lpObj->Guild = 0;

	for (int n = 0; n < MAX_SKILL_LIST; n++)
	{
		CSkill skill;

		lpObj->Skill[n].Clear();

		if (gSkillManager.ConvertSkillByte(&skill, lpMsg->Skill[n]) == 0)
		{
			continue;
		}

		gSkillManager.AddSkill(lpObj, skill.m_index, skill.m_level);
	}

	if (lpObj->Class == CLASS_DW)
	{
		gSkillManager.AddSkill(lpObj, SKILL_ENERGY_BALL, 0);
		gSkillManager.AddSkill(lpObj, SKILL_MANA_GLAIVE, 0);
	}
	else if (lpObj->Class == CLASS_DK)
	{
		gSkillManager.AddSkill(lpObj, SKILL_CRESCENT_MOON_SLASH, 0);
	}
	else if (lpObj->Class == CLASS_FE)
	{
		gSkillManager.AddSkill(lpObj, SKILL_STAR_FALL, 0);

		if (gQuest.CheckQuestListState(lpObj, 2, QUEST_FINISH) != 0)
		{
			gSkillManager.AddSkill(lpObj, SKILL_INFINITY_ARROW, 0);
		}
	}
	else if (lpObj->Class == CLASS_MG)
	{
		gSkillManager.AddSkill(lpObj, SKILL_SPIRAL_SLASH, 0);
		gSkillManager.AddSkill(lpObj, SKILL_MANA_RAYS, 0);
		gSkillManager.AddSkill(lpObj, SKILL_RUSH, 0);
	}
	else if (lpObj->Class == CLASS_DL)
	{
		gSkillManager.AddSkill(lpObj, SKILL_FORCE, 0);
		gSkillManager.AddSkill(lpObj, SKILL_FIRE_BLAST, 0);
	}
	else if (lpObj->Class == CLASS_SU)
	{
		gSkillManager.AddSkill(lpObj, SKILL_MANA_GLAIVE, 0);
	}
	else if (lpObj->Class == CLASS_RF)
	{
		gSkillManager.AddSkill(lpObj, SKILL_CHARGE, 0);
	}

	gSkillManager.AddSkill(lpObj, SKILL_STERN, 0);
	gSkillManager.AddSkill(lpObj, SKILL_REMOVE_STERN, 0);
	gSkillManager.AddSkill(lpObj, SKILL_GREATER_MANA, 0);
	gSkillManager.AddSkill(lpObj, SKILL_INVISIBILITY, 0);
	gSkillManager.AddSkill(lpObj, SKILL_REMOVE_INVISIBILITY, 0);
	gSkillManager.AddSkill(lpObj, SKILL_REMOVE_ALL_EFFECT, 0);
	gSkillManager.AddSkill(lpObj, SKILL_ARCHANGEL_S_WILL, 0);

	gSkillManager.AddSkill(lpObj, SKILL_EXPLOSION, 0);

	for (int n = 0; n < INVENTORY_SIZE; n++)
	{
		CItem item;

		lpObj->Inventory[n].Clear();

		if (gItemManager.ConvertItemByte(&item, lpMsg->Inventory[n]) == 0)
		{
			continue;
		}

		gItemManager.InventoryAddItem(aIndex, item, n);

		if ((lpObj->Inventory[n].m_Index == GET_ITEM(13, 4) || lpObj->Inventory[n].m_Index == GET_ITEM(13, 3) || lpObj->Inventory[n].m_Index == GET_ITEM(13, 2) || lpObj->Inventory[n].m_Index == GET_ITEM(13, 37)) && lpObj->Inventory[n].m_JewelOfHarmonyOption == 1)
		{
			lpObj->m_btInvenPetPos = n;

			EFFECT_INFO* lpInfo = gEffectManager.GetInfoByItem(lpObj->Inventory[n].m_Index);

			if (lpInfo != 0)
			{
				gEffectManager.AddEffect(lpObj, 1, lpInfo->Index, 0, 0, 0, 0, 0);

				CItem* lpItem = &lpObj->Inventory[lpObj->m_btInvenPetPos];

				if (lpItem->m_Option1)
				{
					gSkillManager.AddSkillWeapon(lpObj, lpItem->m_SpecialIndex[0], lpItem->m_Level);
				}
			}
		}
		else if (lpObj->Inventory[n].m_Index == GET_ITEM(13, 5) && lpObj->Inventory[n].m_JewelOfHarmonyOption == 1)
		{
			lpObj->m_btInvenPetDkSpiritPos = n;
		}
	}

	this->CharacterMakePreviewCharSet(aIndex);

	for (int n = 0; n < MAX_EFFECT_LIST; n++)
	{
		CEffect effect;

		lpObj->Effect[n].Clear();

		if (gEffectManager.ConvertEffectByte(&effect, lpMsg->Effect[n]) == 0)
		{
			continue;
		}

		gEffectManager.GCPeriodicEffectSend(lpObj, effect.m_group, 0, 2, 0, effect.m_index);

		gEffectManager.AddEffect(lpObj, 1, effect.m_index, effect.m_count, effect.m_value[0], effect.m_value[1], effect.m_value[2], effect.m_value[3]);
	}

	for (int n = 0; n < MAX_SKILL_LIST; n++)
	{
		if (lpObj->Skill[n].IsSkill() != 0)
		{
			if (gSkillManager.CheckSkillRequireWeapon(lpObj, lpObj->Skill[n].m_skill) == 0)
			{
				gSkillManager.DelSkill(lpObj, lpObj->Skill[n].m_index);
			}
		}
	}

	lpObj->Live = 1;
	lpObj->Type = OBJECT_USER;
	lpObj->State = OBJECT_CREATE;
	lpObj->Connected = OBJECT_ONLINE;
	lpObj->TargetNumber = -1;

	if (lpObj->Life == 0)
	{
		lpObj->Live = 1;
		lpObj->State = OBJECT_DYING;
		lpObj->DieRegen = 1;
		lpObj->RegenTime = GetTickCount();
	}

	lpObj->Authority = 1;

	if ((lpMsg->CtlCode & 8) != 0)
	{
		lpObj->Authority = 2;
	}

	if ((lpMsg->CtlCode & 32) != 0)
	{
		lpObj->Authority = 32;
#if(IAJulia == 0)
		gGameMaster.SetGameMasterLevel(lpObj, 0);
#endif
		gEffectManager.AddEffect(lpObj, 0, EFFECT_GAME_MASTER, 0, 0, 0, 0, 0);
	}

	lpObj->Penalty = 0;

	if ((lpMsg->CtlCode & 2) != 0)
	{
		lpObj->Penalty = 4;
	}

	//g_CBlockChatUserSystem.AddBlockChattingUserInfo(lpObj);

	gObjAuthorityCodeSet(lpObj);

	gInventoryEquipment.InsertInventoryEquipment(lpObj);

	GCWeatherSend(lpObj->Index, (gMap[lpObj->Map].GetWeather() / 16));

	GCMainCheckSend(aIndex);

	gDarkSpirit[aIndex].SetMode(DARK_SPIRIT_MODE_NORMAL, -1);

	lpObj->HPAutoRecuperationTime = GetTickCount();
	lpObj->MPAutoRecuperationTime = GetTickCount();
	lpObj->BPAutoRecuperationTime = GetTickCount();
	lpObj->SDAutoRecuperationTime = GetTickCount();

	return 1;
}

void CObjectManager::CharacterLifeCheck(LPOBJ lpObj, LPOBJ lpTarget, int damage, int DamageType, int flag, int type, int skill, int ShieldDamage) // OK
{
	if (lpObj->Connected != OBJECT_ONLINE)
	{
		return;
	}

	if (KALIMA_ATTRIBUTE_RANGE(lpObj->Attribute) != 0 || KALIMA_ATTRIBUTE_RANGE(lpTarget->Attribute) != 0)
	{
		return;
	}

	if (lpTarget->Type == OBJECT_USER)
	{
		if (lpTarget->RegenOk > 0 || lpTarget->Live == 0 || lpTarget->DieRegen != 0 || lpTarget->State >= OBJECT_DYING)
		{
			//LogAdd(LOG_RED, "Ja morreu e ta tomando dano");
			return;
		}
	}

	int SummonIndex = lpObj->Index;

	if (lpObj->Type == OBJECT_MONSTER && OBJECT_RANGE(lpObj->SummonIndex) != 0)
	{
		SummonIndex = lpObj->SummonIndex;
	}

	if (gObj[SummonIndex].Type == OBJECT_USER && lpTarget->Type == OBJECT_MONSTER && damage > 0)
	{
		gObjMonsterSetHitDamage(lpTarget, SummonIndex, damage);

		gCGHuntingGrounds.AddNormalDamage(lpObj->Index, lpTarget->Index, damage);

		/*if (g_Labyrinth.IsLabyrinthMapNumber(lpObj->Map) == 1)
		{
			lpObj->m_cLabyrinthInfo->CheckPlayMission(lpObj->Index, damage, LAB_MISSION_DAMAGE, -1);
		}*/
	}

	if (gObj[SummonIndex].Type == OBJECT_USER && lpTarget->Type == OBJECT_USER && damage > 0)
	{
		this->PlayerSetHitDamage(lpTarget, SummonIndex, damage);
	}

	if (lpTarget->Type == OBJECT_MONSTER && OBJECT_RANGE(lpTarget->SummonIndex) != 0 && damage > 0)
	{
		GCSummonLifeSend(lpTarget->SummonIndex, (int)lpTarget->Life, (int)lpTarget->MaxLife);
	}

	/*if (damage && lpTarget->Type == OBJECT_USER && g_Labyrinth.IsLabyrinthMapNumber(lpTarget->Map) == 1	)
	{
		lpTarget->m_cLabyrinthInfo->CheckPlayMission(lpTarget->Index, damage, LAB_MISSION_ASSAULTED_DAMAGE, -1);
	}*/

	if (lpTarget->Life <= 0 && lpTarget->Live != 0)
	{
		if (gObj[SummonIndex].Type == OBJECT_MONSTER)
		{
			lpTarget->KillerType = 1;
			gObjAddMsgSend(&gObj[SummonIndex], 3, lpTarget->Index, 0);
		}

		if (gObj[SummonIndex].Type == OBJECT_USER)
		{
			gDarkSpirit[SummonIndex].ResetTarget(lpTarget->Index);
		}

		if (gObj[SummonIndex].Type == OBJECT_USER && lpTarget->Type == OBJECT_USER)
		{
			//gObjSetKillCount(SummonIndex, 1);
			GDPkInfoSaveSend(SummonIndex);
		}

		if (lpTarget->Type == OBJECT_MONSTER)
		{
			if (lpTarget->Class == 275 || lpTarget->Class == 295 || lpTarget->Map == MAP_CRYWOLF)
			{
				gObjAddMsgSendDelay(lpTarget, 1, SummonIndex, 500, 0);
			}
			else
			{
				gObjAddMsgSendDelay(lpTarget, 1, SummonIndex, 500, 0);
			}

			gCGHuntingGrounds.AddMonsterKillCount(lpObj->Index, lpTarget);

			/*if (g_Labyrinth.IsLabyrinthMapNumber(lpObj->Map) == 1 && lpObj->Type == OBJECT_USER)
			{
				lpObj->m_cLabyrinthInfo->CheckPlayMission(lpObj->Index, 1, LAB_MISSION_MONSTER_KILL, -1);
				lpObj->m_cLabyrinthInfo->AddEntireKillMonCnt(1);
			}*/

			gQuestObjective.MonsterKill(lpTarget);

			gQuestWorldObjective.MonsterKill(lpTarget);

			if (lpTarget->isBoss)
			{
				gCustomMonster.MonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

			gMonsterSpawner.KillMonster(&gObj[SummonIndex], lpTarget);

			if (BC_MAP_RANGE(lpTarget->Map) != 0)
			{
				gBloodCastle.MonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

			if (CC_MAP_RANGE(lpTarget->Map) != 0)
			{
				gChaosCastle.MonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

			if (DS_MAP_RANGE(lpTarget->Map) != 0)
			{
				gDevilSquare.MonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

			if (DG_MAP_RANGE(lpTarget->Map) != 0)
			{
				gDoubleGoer.MonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

			if (IG_MAP_RANGE(lpTarget->Map) != 0)
			{
				gImperialGuardian.MonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

			if (lpTarget->Map == MAP_CASTLE_SIEGE)
			{
				gCastleDeep.MonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

#if(GAMESERVER_TYPE==1)
			if (lpTarget->Map == MAP_CRYWOLF)
			{
				gCrywolf.CrywolfMonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}
#endif
			if (lpTarget->Map == MAP_KANTURU3)
			{
				gKanturu.KanturuMonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

			if (lpTarget->Map == MAP_RAKLION2)
			{
				gRaklion.RaklionMonsterDieProc(lpTarget, &gObj[SummonIndex]);
			}

			if (gObj[SummonIndex].Type == OBJECT_USER)
			{
				gObjPKDownCheckTime(&gObj[SummonIndex], lpTarget->Level);
				gObjAddMsgSendDelay(&gObj[SummonIndex], 3, lpTarget->Index, 2000, 0);
			}

			/*if (gSummonScroll.CheckSummon(lpTarget->Class) != 0)
			{
				gSummonScroll.CreateSummonMonster(lpObj->Index, lpTarget->Class, lpObj->Map, lpTarget->X, lpTarget->Y);
			}*/

			/*if (gNewQuestWorld.GetTagetNumber(lpTarget->Class, lpObj->Index, KILL))
			{
				lpObj->NewQuestWorldList->TagetNumber += 1;

				gNewQuestWorld.GCKillMonster(lpObj->Index);
			}*/

			gNewQuestWorld.GCKillMonster(lpObj->Index, lpTarget);
		}

		if (lpTarget->Type == OBJECT_USER)
		{
			gObjUserDie(lpTarget, &gObj[SummonIndex]);

			if (lpTarget->AttackerKilled == 0)
			{
				gObjPlayerKiller(&gObj[SummonIndex], lpTarget);
			}

			lpTarget->AttackerKilled = 0;

			if (gObjGuildWarCheck(&gObj[SummonIndex], lpTarget) == 0)
			{
				lpTarget->KillerType = 0;
			}
			else
			{
				lpTarget->KillerType = 2;
			}

			gDuel.CheckDuelScore(&gObj[SummonIndex], lpTarget);

			if (OBJECT_RANGE(lpTarget->SummonIndex) != 0)
			{
				gObjSummonKill(lpTarget->Index);
			}

			gFourthQuest.CharacterDied(lpTarget);

			if (lpObj->Type == OBJECT_USER)
			{
				/* MUFC RULES START */
				if (gMUFC.Status == MUFC_STARTED)
				{
					if (lpObj->Index == gMUFC.FighterID[0] || lpObj->Index == gMUFC.FighterID[1])
					{
						if (lpTarget->Index == gMUFC.FighterID[0] || lpTarget->Index == gMUFC.FighterID[1])
						{
							gMUFC.FighterKilled(lpObj, lpTarget);
						}
					}
				}
				/* MUFC RULES END*/

				if (IsPvPTestOn && PvPTimer != 0)
				{
					gNotice.GCNoticeSendToAll(0, 0, 0, 0, 0, 0, "Morreu em %d ms", (GetTickCount() - PvPTimer));
					PvPTimer = 0;
				}

				int topDamage = 0;
				int topDamagePerc = 0;
				int topDamageUser = this->PlayerGetTopHitDamageUser(lpTarget, &topDamage, &topDamagePerc);

				gNotice.SendMapServerGroupMsg(3, "%s matou %s (%d%% dmg)", gObj[topDamageUser].Name, lpTarget->Name, topDamagePerc);

				int damageCounter = this->PlayerGetTopHitDamageUser(lpTarget, this->CountPlayerHitDamage(lpTarget));
				int totalDamage = this->PlayerGetTotalDamageUser(lpTarget);

				GDPKSave(&gObj[topDamageUser], lpTarget);

				lpTarget->LastBackSpring = 0;

				//Mapa da temporada, roubo de ruud
				if (lpTarget->Map == MAP_TEMPORADA) // && lpTarget->X >= 2 && lpTarget->X <= 62 && lpTarget->Y >= 2 && lpTarget->Y <= 62)
				{
					/*PMSG_CLOSE_CLIENT_RECV pMsg;
					pMsg.header.set(0xF3, 0xE8, sizeof(pMsg));
					DataSend(topDamageUser, (BYTE*)&pMsg, pMsg.header.size);*/

					if (lpTarget->Ruud >= gServerInfo.m_PKRuudDrop) //ROUBA RUUD DO COLEGUINHA
					{
						lpTarget->Ruud -= gServerInfo.m_PKRuudDrop;
						gRheaGold.GC_Notify_RuudUpdate(lpTarget->Index, lpTarget->Ruud, gServerInfo.m_PKRuudDrop, 0);
						gNotice.GCNoticeSend(lpTarget->Index, 3, 0 , 0, 0, 0, 0, "Voce perdeu %d Ruud para %s", gServerInfo.m_PKRuudDrop, gObj[topDamageUser].Name);

						gObj[topDamageUser].Ruud += (gServerInfo.m_PKRuudDrop - gServerInfo.m_PKRuudTax);
						gRheaGold.GC_Notify_RuudUpdate(gObj[topDamageUser].Index, gObj[topDamageUser].Ruud, (gServerInfo.m_PKRuudDrop - gServerInfo.m_PKRuudTax), 0);
						gNotice.GCNoticeSend(topDamageUser, 1, 0, 0, 0, 0, 0, "Voce roubou %d Ruud de %s", (gServerInfo.m_PKRuudDrop - gServerInfo.m_PKRuudTax), lpTarget->Name);

						gNotice.SendMapServerGroupMsg(1, "%s roubou %d Ruud de %s", gObj[topDamageUser].Name, gServerInfo.m_PKRuudDrop, lpTarget->Name);
					}
					/*else
					{
						if (gServerInfo.m_PKItemDrop != 0)
						{
							//DROP DO COLEGUINHA
							gItemManager.DropPKItem(lpTarget,&gObj[topDamageUser]);
						}
					}*/
				}

#if(GAMESERVER_TYPE==1)
				if (gCastleSiege.GetCastleState() == CASTLESIEGE_STATE_STARTSIEGE && lpObj->Map == MAP_CASTLE_SIEGE &&
					lpObj->Guild && lpTarget->Guild && lpObj->Guild->GuildUnion != lpTarget->Guild->GuildUnion &&
					lpObj->CsJoinSide != 0 && lpTarget->CsJoinSide != 0)
				{
					//gObjSetKillCount(lpObj->Index, 1);
					gObjSetKillCount(topDamageUser, 1);

					//lpObj->SiegeTotalKillCount++;
					gObj[topDamageUser].SiegeTotalKillCount++;
					lpTarget->SiegeTotalDeathCount++;

					gNotice.GCNoticeSend(topDamageUser, 1, 0, 0, 0, 0, 0, "Siege Total Kill Count: %02d", gObj[topDamageUser].SiegeTotalKillCount);
					gNotice.GCNoticeSend(lpTarget->Index, 1, 0, 0, 0, 0, 0, "Siege Total Death Count: %02d", lpTarget->SiegeTotalDeathCount);

					for (int p = 0; p < damageCounter; p++)
					{
						if (lpTarget->HitDamage[p].damage > 0)
						{
							int perc = (int)((float)((float)lpTarget->HitDamage[p].damage / (float)totalDamage) * 100.0f);
							
							if (perc < 1 || perc > 100) { perc = 1; }
							//LogAdd(LOG_DEBUG, "Char %s | Dmg %d | Perc %d", gObj[lpTarget->HitDamage[p].index].Name, lpTarget->HitDamage[p].damage, perc);
							gCastleSiege.SaveSiegeCharInfo(&gObj[lpTarget->HitDamage[p].index], 1, perc);
						}
					}

					gCastleSiege.SaveSiegeCharInfo(lpTarget, 2);

					/*PMSG_CLOSE_CLIENT_RECV pMsg;
					pMsg.header.set(0xF3, 0xE8, sizeof(pMsg));
					DataSend(topDamageUser, (BYTE*)&pMsg, pMsg.header.size);*/
				}
#endif
				this->PlayerInitHitDamage(lpTarget);
			}
		}

		lpTarget->Live = 0;
		lpTarget->State = OBJECT_DYING;
		lpTarget->RegenTime = GetTickCount();
		lpTarget->DieRegen = 1;
		lpTarget->PathCount = 0;
		lpTarget->Teleport = ((lpTarget->Teleport == 1) ? 0 : lpTarget->Teleport);

		GCUserDieSend(lpTarget, lpTarget->Index, skill, lpObj->Index);

		if (lpObj->isBoss)
		{
			switch (GetLargeRand() % 4)
			{
			case 0:
				gNpcTalk.SendNPCMessageToViewPort(lpObj, "GG, morreu, problema seu! kkkkkk %s", lpTarget->Name);
				break;
			case 1:
				gNpcTalk.SendNPCMessageToViewPort(lpObj, "kkkkkk VOOOOOOA %s LIXO!", lpTarget->Name);
				break;
			case 2:
				gNpcTalk.SendNPCMessageToViewPort(lpObj, "Ihhh, chama o IML pro %s kkkkkk", lpTarget->Name);
				break;
			case 3:
				gNpcTalk.SendNPCMessageToViewPort(lpObj, "No ceu tem pao? E morreu... kkkkkk %s", lpTarget->Name);
				break;
			}
		}

		if (lpTarget->Type == OBJECT_MONSTER)
		{
			if (OBJECT_RANGE(lpTarget->SummonIndex) != 0)
			{
				return;
			}

			if (lpTarget->Class == 275 || lpTarget->Class == 277 || lpTarget->Class == 283 || lpTarget->Class == 286 || lpTarget->Class == 287 || lpTarget->Class == 288 || lpTarget->Class == 295 || lpTarget->Class == 340 || lpTarget->Class == 348 || lpTarget->Class == 349 || lpTarget->Class == 361 || lpTarget->Class == 362 || lpTarget->Class == 363 || lpTarget->Class == 524 || lpTarget->Class == 525 || lpTarget->Class == 527 || lpTarget->Class == 528 || lpTarget->Class == 605 || lpTarget->Class == 606 || lpTarget->Class == 607)
			{
				return;
			}
		}

		if (gObj[SummonIndex].Type == OBJECT_USER && lpTarget->Type == OBJECT_MONSTER)
		{
			if (gParty.IsParty(gObj[SummonIndex].PartyNumber) == 0)
			{
				this->CharacterCalcExperienceSplit(&gObj[SummonIndex], lpTarget, damage, flag);
			}
			else
			{
				this->CharacterCalcExperienceParty(&gObj[SummonIndex], lpTarget, damage, flag);
			}
		}
	}
	else
	{
	/*
	DAMAGE_TYPE_NORMAL				= 0,
	DAMAGE_TYPE_IGNORE				= 1,
	DAMAGE_TYPE_EXE					= 2,
	DAMAGE_TYPE_CRITICAL			= 3,
	DAMAGE_TYPE_REFLECT				= 4,
	DAMAGE_TYPE_POISON				= 5,
	DAMAGE_TYPE_DEBUFF				= 6,
	DAMAGE_TYPE_WHITE				= 7,

	DAMAGE_PROP_RIGHT				= 0x10,
	DAMAGE_PROP_LEFT				= 0x20,
	DAMAGE_PROP_DOUBLE				= 0x40,
	DAMAGE_PROP_COMBO				= 0x80,
	DAMAGE_PROP_TRIPLE				= 0x100,

	MISS_TYPE_MISS					= 0,
	MISS_TYPE_RESIST				= 7, // Stun & Knockback Resist
	MISS_TYPE_BLOCK					= 8, // Shield Damage Block
	MISS_TYPE_PARRY					= 9,
	MISS_TYPE_ABSORB				= 10, // Shield Damage Absorb

	ELEMENTAL_DAMAGE_TYPE_PUNISH = 6,
	ELEMENTAL_DAMAGE_TYPE_CRITICAL = 7,
	ELEMENTAL_DAMAGE_TYPE_AVOID = 8,
	*/
		if (DamageType == 0)
		{
			GCDamageSend(SummonIndex, lpTarget->Index, flag, damage, type, ShieldDamage);
		}
		else if (DamageType == 1)
		{
			GCMonsterDamageSend(lpTarget->Index, damage, ShieldDamage);
		}
		else if (DamageType == 2)
		{
			GCDamageSend(SummonIndex, lpTarget->Index, flag, damage, 5, ShieldDamage);
		}
		else if (DamageType == 3)
		{
			GCDamageSend(SummonIndex, lpTarget->Index, flag, damage, 6, ShieldDamage);
		}
		else if (DamageType == 4)
		{
			GCElementalDamageSend(SummonIndex, lpTarget->Index, type, damage);
		}

		if (lpTarget->Class == 746)
		{
			for (int j = 0; j < MAX_VIEWPORT; ++j)
			{
				if (lpTarget->VpPlayer2[j].type == 1)
				{
					GCLifeUpdateSend(&gObj[lpTarget->VpPlayer2[j].index]);
				}
			}
		}

		GCLifeUpdateSend(lpTarget);
	}
}

void CObjectManager::PlayerInitHitDamage(LPOBJ lpObj) // OK
{
	for (int n = 0; n < MAX_HIT_DAMAGE; n++)
	{
		lpObj->HitDamage[n].index = -1;
		lpObj->HitDamage[n].damage = 0;
		lpObj->HitDamage[n].time = 0;
	}
}

int CObjectManager::CountPlayerHitDamage(LPOBJ lpObj) // OK
{
	int count = 0;

	for (int n = 0; n < MAX_HIT_DAMAGE; n++)
	{
		if (lpObj->HitDamage[n].index > -1 && lpObj->HitDamage[n].damage > 0)
		{
			count++;
		}
	}

	return count;
}

void CObjectManager::PlayerSetHitDamage(LPOBJ lpObj, int aIndex, int damage) // OK
{
	for (int n = 0; n < MAX_HIT_DAMAGE; n++)
	{
		if (lpObj->HitDamage[n].index == aIndex)
		{
			lpObj->HitDamage[n].damage += damage;
			lpObj->HitDamage[n].time = GetTickCount();
			//LogAdd(LOG_DEBUG, "Dano em %s por %s [%d][%d]", lpObj->Name, gObj[aIndex].Name, damage, lpObj->HitDamage[n].damage);
			return;
		}
	}

	int HitDamageIndex = -1;

	for (int n = 0; n < MAX_HIT_DAMAGE; n++)
	{
		if (OBJECT_RANGE(lpObj->HitDamage[n].index) == 0)
		{
			HitDamageIndex = n;
			break;
		}
	}

	if (CHECK_RANGE(HitDamageIndex, MAX_HIT_DAMAGE) != 0/* || OBJECT_RANGE(HitDamageIndex = this->PlayerDelHitDamageUser(lpObj)) != 0*/)
	{
		lpObj->HitDamage[HitDamageIndex].index = aIndex;
		lpObj->HitDamage[HitDamageIndex].damage = ((damage > lpObj->MaxLife) ? (int)lpObj->MaxLife : damage);
		lpObj->HitDamage[HitDamageIndex].time = GetTickCount();
		//LogAdd(LOG_DEBUG, "INICIAL em %s por %s [%d][%d]", lpObj->Name, gObj[aIndex].Name, damage, lpObj->HitDamage[HitDamageIndex].damage);
	}
}

int CObjectManager::PlayerDelHitDamageUser(LPOBJ lpObj) // OK
{
	int HitDamageIndex = -1;

	for (int n = 0; n < MAX_HIT_DAMAGE; n++)
	{
		if (OBJECT_RANGE(lpObj->HitDamage[n].index) == 0)
		{
			continue;
		}

		int result = 0;

		if (gObjIsConnected(lpObj->HitDamage[n].index) == 0)
		{
			result = 1;
		}
		else if ((GetTickCount() - lpObj->HitDamage[n].time) > 1000)
		{
			result = 1;
		}
		else if (lpObj->Map != gObj[lpObj->HitDamage[n].index].Map)
		{
			result = 1;
		}
		else if (gObjCalcDistance(lpObj, &gObj[lpObj->HitDamage[n].index]) > 10)
		{
			result = 1;
		}

		if (result != 0)
		{
			//LogAdd(LOG_DEBUG, "Removendo %s da lista de dano de %s", gObj[lpObj->HitDamage[n].index].Name, lpObj->Name);
			//LogAdd(LOG_DEBUG, "Tinha %d de dano guardado", lpObj->HitDamage[n].damage);
			lpObj->HitDamage[n].index = -1;
			HitDamageIndex = n;
		}
	}

	return HitDamageIndex;
}

int CObjectManager::PlayerGetTopHitDamageUser(LPOBJ lpObj, int quant)
{
	int sortedCount = 0;

	for (int i = 0; i < MAX_HIT_DAMAGE; i++)
	{
		HIT_DAMAGE_STRUCT* firstPlayer = &lpObj->HitDamage[i];

		if (lpObj->HitDamage[i].index < 0 || (gObjIsConnected(lpObj->HitDamage[i].index) == 0))
		{
			HIT_DAMAGE_STRUCT temp;

			temp.damage = firstPlayer->damage;
			temp.index = firstPlayer->index;
			temp.time = firstPlayer->time;

			for (int j = i; j < MAX_HIT_DAMAGE - 1; j++)
			{
				lpObj->HitDamage[j].damage = lpObj->HitDamage[j + 1].damage;
				lpObj->HitDamage[j].index = lpObj->HitDamage[j + 1].index;
				lpObj->HitDamage[j].time = lpObj->HitDamage[j + 1].time;
			}

			lpObj->HitDamage[MAX_HIT_DAMAGE - 1].damage = temp.damage;
			lpObj->HitDamage[MAX_HIT_DAMAGE - 1].index = temp.index;
			lpObj->HitDamage[MAX_HIT_DAMAGE - 1].time = temp.time;

			continue;
		}

		for (int j = i; j < MAX_HIT_DAMAGE; j++)
		{
			if (lpObj->HitDamage[j].index < 0 || (gObjIsConnected(lpObj->HitDamage[i].index) == 0))
			{
				continue;
			}

			HIT_DAMAGE_STRUCT* secondPlayer = &lpObj->HitDamage[j];

			if (firstPlayer->damage < secondPlayer->damage)
			{
				HIT_DAMAGE_STRUCT temp;

				temp.damage = firstPlayer->damage;
				temp.index = firstPlayer->index;
				temp.time = firstPlayer->time;

				firstPlayer->damage = secondPlayer->damage;
				firstPlayer->index = secondPlayer->index;
				firstPlayer->time = secondPlayer->time;

				secondPlayer->damage = temp.damage;
				secondPlayer->index = temp.index;
				secondPlayer->time = temp.time;
			}
		}

		sortedCount++;
	}

	return sortedCount <= quant ? sortedCount : quant;
}

int CObjectManager::PlayerGetTopHitDamageUser(LPOBJ lpObj, int* damage, int* perc)
{
	int TopHitDamageUser = -1;
	int TopHitDamage = 0;
	float totalDamage = 0.0f;

	for (int n = 0; n < MAX_HIT_DAMAGE; n++)
	{
		if (gObjIsConnected(lpObj->HitDamage[n].index) == 0)
		{
			continue;
		}

		if ((GetTickCount() - lpObj->HitDamage[n].time) > 1000)
		{
			continue;
		}

		if (lpObj->Map != gObj[lpObj->HitDamage[n].index].Map)
		{
			continue;
		}

		if (gObjCalcDistance(lpObj, &gObj[lpObj->HitDamage[n].index]) > 10)
		{
			continue;
		}

		totalDamage += lpObj->HitDamage[n].damage;

		if (lpObj->HitDamage[n].damage > TopHitDamage)
		{
			TopHitDamageUser = lpObj->HitDamage[n].index;
			TopHitDamage = lpObj->HitDamage[n].damage;
			(*damage) = TopHitDamage;
		}
	}

	(*perc) = (int)((TopHitDamage / totalDamage) * 100.0f);

	return TopHitDamageUser;
}

int CObjectManager::PlayerGetTotalDamageUser(LPOBJ lpObj)
{
	int totalDamage = 0;

	for (int n = 0; n < MAX_HIT_DAMAGE; n++)
	{
		if (gObjIsConnected(lpObj->HitDamage[n].index) == 0)
		{
			continue;
		}

		if ((GetTickCount() - lpObj->HitDamage[n].time) > 1000)
		{
			continue;
		}

		if (lpObj->Map != gObj[lpObj->HitDamage[n].index].Map)
		{
			continue;
		}

		if (gObjCalcDistance(lpObj, &gObj[lpObj->HitDamage[n].index]) > 10)
		{
			continue;
		}

		totalDamage += lpObj->HitDamage[n].damage;
	}

	return totalDamage;
}