#include "stdafx.h"
#include "ServerInfo.h"
#include "380ItemOption.h"
#include "380ItemType.h"
#include "BloodCastle.h"
#include "BonusManager.h"
#include "CashShop.h"
#include "CastleDeep.h"
#include "CastleSiege.h"
#include "ChaosCastle.h"
#include "Crywolf.h"
#include "CrywolfSync.h"
#include "CustomArena.h"
#include "CustomAttack.h"
#include "CustomEffectManager.h"
#include "CustomEventDrop.h"
#include "CustomPVPtime.h"
#include "CustomJewel.h"
#include "CustomMonster.h"
#include "CustomStore.h"
#include "CustomWing.h"
#include "DefaultClassInfo.h"
#include "DevilSquare.h"
#include "DoubleGoer.h"
#include "EffectManager.h"
#include "ExperienceTable.h"
#include "Filter.h"
#include "GameMaster.h"
#include "Gate.h"
#include "HackPacketCheck.h"
#include "IllusionTemple.h"
#include "ImperialGuardian.h"
#include "ItemBagManager.h"
#include "ItemDrop.h"
#include "ItemMove.h"
#include "ItemOption.h"
#include "ItemOptionRate.h"
#include "ItemStack.h"
#include "ItemValue.h"
#include "JewelOfHarmonyOption.h"
#include "JewelOfHarmonyType.h"
#include "Kanturu.h"
#include "KanturuMonsterMng.h"
#include "LuckyItem.h"
#include "MapManager.h"
#include "MapServerManager.h"
#include "MasterSkillTree.h"
#include "Message.h"
#include "MiniMap.h"
#include "MiningSystem.h"
#include "MonsterAIAutomata.h"
#include "MonsterAIElement.h"
#include "MonsterAIGroup.h"
#include "MonsterAIRule.h"
#include "MonsterAIUnit.h"
#include "MonsterManager.h"
#include "MonsterSetBase.h"
#include "MonsterSkillElement.h"
#include "MonsterSkillManager.h"
#include "MonsterSkillUnit.h"
#include "MossMerchant.h"
#include "Move.h"
#include "MoveSummon.h"
#include "MUFC.h"
#include "MuunSystem.h"
#include "Notice.h"
#include "PacketManager.h"
#include "Path.h"
#include "PcPoint.h"
#include "PentagramSystem.h"
#include "Quest.h"
#include "QuestObjective.h"
#include "QuestReward.h"
#include "QuestWorld.h"
#include "QuestWorldObjective.h"
#include "QuestWorldReward.h"
#include "Raklion.h"
#include "ResetTable.h"
#include "SetItemOption.h"
#include "SetItemType.h"
#include "ShopManager.h"
#include "SkillHitBox.h"
#include "SkillManager.h"
#include "SocketItemOption.h"
#include "SocketItemType.h"
#include "SummonScroll.h"
#include "Util.h"
#include "Warehouse.h"
#include "RheaGold.h"
#include "SocketChaos.h"
#include "mmItemSlot.h"
#include "NewQuestWorld.h"

#include "UnityBattleField.h"
#include "StatSpecialize.h"
#include "ComboSkillPath.h"
#include "MasterSkillTree_4th.h"
#include "CalFormula.h"
#include "HuntingGrounds.h"
#include "CNixiesLakeBossZone.h"
//#include "LabyrinthMission.h"
//#include "Labyrinth.h"
//#include "InstanceSystemInfo.h"
//#include "InstanceSystemMgr.h"
#include "RuudTokenRewardProbability.h"
#include "RestoreSoldItem.h"
#include "MasteryItemExtOptionSet.h"
#include "SpeedTable.h"
#include "SpeedFila.h"
#include "CommandManager.h"
#include "MonsterSpawner.h"
#include "Wings4thOption.h"
#include "Oficina.h"

CServerInfo gServerInfo;

CServerInfo::CServerInfo() // OK
{

}

CServerInfo::~CServerInfo() // OK
{

}

void CServerInfo::ReadInit() // OK
{
	gPath.SetMainPath(MAIN_PATH);
	gPath.SetGsPath(GS_PATH);

	this->ReadCashShopInfo();
	this->ReadChaosMixInfo();
	this->ReadCharacterInfo();
	this->ReadCommandInfo();
	this->ReadCommonInfo();
	this->ReadCustomInfo();
	this->ReadEventInfo();
	this->ReadEventItemBagInfo();
	this->ReadHackInfo();
	this->ReadItemInfo();
	this->ReadMapInfo();
	this->ReadMonsterInfo();
	this->ReadMonsterSetBase();
	this->ReadMoveInfo();
	this->ReadQuestInfo();
	this->ReadShopInfo();
	this->ReadSkillInfo();
	this->ReadUtilInfo();
}

void CServerInfo::ReadCashShopInfo() // OK
{
	this->ReadCashShopInfo("GameServerInfo", ".\\Data\\GameServerInfo - Common.dat");

	gCashShop.LoadPackage(gPath.GetRightPath("CashShop\\CashShopPackage.txt"));
	gCashShop.LoadProduct(gPath.GetRightPath("CashShop\\CashShopProduct.txt"));

	LogAdd(LOG_BLUE, "[ServerInfo] CashShop loaded successfully");
}

void CServerInfo::ReadChaosMixInfo() // OK
{
	this->ReadChaosMixInfo("GameServerInfo", ".\\Data\\GameServerInfo - ChaosMix.dat");

	LogAdd(LOG_BLUE, "[ServerInfo] ChaosMix loaded successfully");
}

void CServerInfo::ReadCharacterInfo() // OK
{
	this->ReadCharacterInfo("GameServerInfo", ".\\Data\\GameServerInfo - Character.dat");
	
	this->ReadCharacterElementalInfo("GameServerInfo", ".\\Data\\GameServerInfo - Elemental.dat");

	gDefaultClassInfo.Load(gPath.GetRightPath("Character\\DefaultClassInfo.txt"));
	g_StatSpec.Load(gPath.GetRightPath("Character\\StatSpecialize.txt"));
	g_StatSpec.ReadCharacterSpecialize(gPath.GetRightPath("Character\\StatSpecializeOption.dat"));

	LogAdd(LOG_BLUE, "[ServerInfo] Character loaded successfully");
}

void CServerInfo::ReadCommandInfo() // OK
{
	gGameMaster.Load(gPath.GetRightPath("Commands\\GameMaster.txt"));
	gCommandManager.LoadCommands(gPath.GetRightPath("Commands\\Commands.txt"));
	gResetTable.Load(gPath.GetRightPath("Commands\\ResetTable.txt"));

	this->ReadCommandConfig();

	LogAdd(LOG_BLUE, "[ServerInfo] Commands config loaded successfully");
}

void CServerInfo::ReadCommonInfo() // OK
{
	this->ReadCommonInfo("GameServerInfo", ".\\Data\\GameServerInfo - Common.dat");

	gEffectManager.Load(gPath.GetRightPath("Effect.txt"));
	
	gMapManager.Load(gPath.GetRightPath("MapManager.txt"));
	gMapServerManager.Load(gPath.GetRightPath("MapServerInfo.dat"));
	gMessage.Load(gPath.GetRightPath("Message.txt"));
	gMiniMap.Load(gPath.GetRightPath("MiniMap.txt"));
	gMiningSystem.Load(gPath.GetRightPath("Mining.txt"));

	gCRestoreSoldItem.LoadRestoreItemFlag();

	gCGHuntingGrounds.LoadHuntingRecordScript(gPath.GetRightPath("HuntingRecord.txt"));
	g_RuudTokenRewardProbability.Load_RuudBoxProbability(gPath.GetRightPath("RuudProbability.txt"));

	/*g_InstanceSystemMgr = new InstanceSystemMgr;
	g_InstanceSystemInfo.LoadInstanceSystemScript(gPath.GetRightPath("InstanceSystem.txt"));
	*/

	LogAdd(LOG_BLUE, "[ServerInfo] Common loaded successfully");
}

void CServerInfo::ReadCustomInfo() // OK
{
	this->ReadCustomInfo("GameServerInfo", ".\\Data\\GameServerInfo - Custom.dat");
	gCustomArena.ReadCustomArenaInfo("GameServerInfo", ".\\Data\\GameServerInfo - Custom.dat");
	gCustomAttack.ReadCustomAttackInfo("GameServerInfo", ".\\Data\\GameServerInfo - Custom.dat");
	gCustomEventDrop.ReadCustomEventDropInfo("GameServerInfo", ".\\Data\\GameServerInfo - Custom.dat");
	gCustomStore.ReadCustomStoreInfo("GameServerInfo", ".\\Data\\GameServerInfo - Custom.dat");
	gCustomArena.Load(gPath.GetRightPath("Custom\\CustomArena.txt"));
	gCustomEventDrop.Load(gPath.GetRightPath("Custom\\CustomEventDrop.txt"));
	gCustomPvPTime.Load(gPath.GetRightPath("Custom\\CustomPvPTime.txt"));
	gCustomJewel.Load(gPath.GetRightPath("Custom\\CustomJewel.txt"));
	gCustomMonster.Load(gPath.GetRightPath("Monster\\CustomMonster.txt"));
	gCustomWing.Load(gPath.GetRightPath("Custom\\CustomWing.txt"));
	LogAdd(LOG_BLUE, "[ServerInfo] Custom loaded successfully");
}

void CServerInfo::ReadEventInfo() // OK
{
	char* fileName;

	this->ReadEventInfo("GameServerInfo", ".\\Data\\GameServerInfo - Event.dat");

	gBloodCastle.Load(gPath.GetRightPath("Event\\BloodCastle.dat"));

	gBonusManager.Load(gPath.GetRightPath("Event\\BonusManager.dat"));

	gCastleDeep.Load(gPath.GetRightPath("Event\\CastleDeepEvent.dat"));

	gChaosCastle.Load(gPath.GetRightPath("Event\\ChaosCastle.dat"));

#if(GAMESERVER_TYPE==1)

	gCrywolf.Load(gPath.GetRightPath("Event\\Crywolf.dat"));

#endif

	gDevilSquare.Load(gPath.GetRightPath("Event\\DevilSquare.dat"));

	gDoubleGoer.Load(gPath.GetRightPath("Event\\DoubleGoer.dat"));

	gIllusionTemple.Load(gPath.GetRightPath("Event\\IllusionTemple.dat"));

	gImperialGuardian.Load(gPath.GetRightPath("Event\\ImperialGuardian.dat"));

	gMonsterSpawner.Load(gPath.GetRightPath("Monster\\MonsterSpawner.txt"));

	gKanturu.Load(gPath.GetRightPath("Event\\Kanturu.dat"));

	gMossMerchant.Load(gPath.GetRightPath("Event\\MossMerchant.dat"));

	gRaklion.Load(gPath.GetRightPath("Event\\Raklion.dat"));

	gSummonScroll.Load(gPath.GetRightPath("Event\\SummonScroll.dat"));

	g_NixiesLakeBossZone.InitNixiesBossZone(0);

	//g_Labyrinth.LoadScript(gPath.GetRightPath("Event\\LabyrinthOfDimensionInfo.dat"));//2018/6/1

	g_UnityBattleField.Load("BattleCore", gPath.GetRightPath("Event\\BattleCore.dat"));

#if(GAMESERVER_TYPE==1)

	if (gCastleSiege.Ready(gMapServerManager.GetMapServerGroup()) != 0)
	{
		if (gCastleSiege.LoadData(gPath.GetRightPath("Event\\MuCastleData.dat")) != 0)
		{
			gCastleSiege.LoadPreFixData(".\\Data\\GameServerInfo - Event.dat");
			gCastleSiege.SetDataLoadState(CASTLESIEGE_DATALOAD_2);
		}
	}

#endif

	/* MUFC */
	fileName = gPath.GetRightPath("Event\\MUFCDamageIncrease.txt");
	if (gPath.CheckFileExists(".\\Data\\Event\\MUFCDamageIncrease.txt"))
	{
		fileName = ".\\Data\\Event\\MUFCDamageIncrease.txt";
	}
	gMUFC.Load(fileName);

	this->MUFC_Map = GetPrivateProfileInt("MUFC", "Map", 0, gPath.GetRightPath("Event\\MUFCConfig.ini"));
	this->MUFC_1_X = GetPrivateProfileInt("MUFC", "Fighter_1_X", 128, gPath.GetRightPath("Event\\MUFCConfig.ini"));
	this->MUFC_1_Y = GetPrivateProfileInt("MUFC", "Fighter_1_Y", 128, gPath.GetRightPath("Event\\MUFCConfig.ini"));
	this->MUFC_2_X = GetPrivateProfileInt("MUFC", "Fighter_2_X", 129, gPath.GetRightPath("Event\\MUFCConfig.ini"));
	this->MUFC_2_Y = GetPrivateProfileInt("MUFC", "Fighter_2_Y", 129, gPath.GetRightPath("Event\\MUFCConfig.ini"));

	this->MUFC_TimerToStart = GetPrivateProfileInt("MUFC", "TimerToStart", 3, gPath.GetRightPath("Event\\MUFCConfig.ini"));
	this->MUFC_TimerRound = GetPrivateProfileInt("MUFC", "TimerToReStart", 8, gPath.GetRightPath("Event\\MUFCConfig.ini"));

	LogAdd(LOG_BLUE, "[ServerInfo] Event loaded successfully");
}

void CServerInfo::ReadEventItemBagInfo() // OK
{
	gItemBagManager.Load(gPath.GetRightPath("EventItemBagManager.txt"));

	gItemBagManager.LoadEventItemBag();

	LogAdd(LOG_BLUE, "[ServerInfo] EventItemBag loaded successfully");
}

void CServerInfo::ReadHackInfo() // OK
{
	this->ReadHackInfo("GameServerInfo", ".\\Data\\GameServerInfo - Common.dat");

	gHackPacketCheck.Load(gPath.GetRightPath("Hack\\HackPacketCheck.txt"));

	gPacketManager.LoadEncryptionKey(gPath.GetRightPath("Hack\\Enc2.dat"));

	gPacketManager.LoadDecryptionKey(gPath.GetRightPath("Hack\\Dec1.dat"));

	LogAdd(LOG_BLUE, "[ServerInfo] Hack loaded successfully");
}

void CServerInfo::ReadItemInfo() // OK
{
	g380ItemOption.Load(gPath.GetRightPath("Item\\380ItemOption.txt"));

	g380ItemType.Load(gPath.GetRightPath("Item\\380ItemType.txt"));

	gItemManager.Load(gPath.GetRightPath("Item\\Item.txt"));

	gItemManager.LoadDamageRate(gPath.GetRightPath("Item\\ItemDamageRate.txt"));

	gItemMove.Load(gPath.GetRightPath("Item\\ItemMove.txt"));

	gItemOption.Load(gPath.GetRightPath("Item\\ItemOption.txt"));

	gItemOptionRate.Load(gPath.GetRightPath("Item\\ItemOptionRate.txt"));

	gItemStack.Load(gPath.GetRightPath("Item\\ItemStack.txt"));

	gItemValue.Load(gPath.GetRightPath("Item\\ItemValue.txt"));

	gGItemSlot.Load(gPath.GetRightPath("Item\\ItemSlot.txt"));

	gJewelOfHarmonyOption.Load(gPath.GetRightPath("Item\\JewelOfHarmonyOption.txt"));

	gJewelOfHarmonyType.Load(gPath.GetRightPath("Item\\JewelOfHarmonyType.txt"));

	gLuckyItem.Load(gPath.GetRightPath("Item\\LuckyItem.txt"));

	gMuunSystem.Load(gPath.GetRightPath("Item\\MuunOption.txt"));

	gPentagramSystem.Load(gPath.GetRightPath("Item\\PentagramOption.txt"));

	gPentagramSystem.LoadJewel(gPath.GetRightPath("Item\\PentagramJewelOption.txt"));

	gPentagramSystem.LoadMixRate(gPath.GetRightPath("Item\\PentagramJewelMixRate.txt"));

	gSetItemOption.Load(gPath.GetRightPath("Item\\SetItemOption.txt"));

	gSetItemType.Load(gPath.GetRightPath("Item\\SetItemType.txt"));

	gSocketItemOption.Load(gPath.GetRightPath("Item\\SocketItemOption.txt"));

	gSocketItemType.Load(gPath.GetRightPath("Item\\SocketItemType.txt"));

	gRheaGold.Load(gPath.GetRightPath("Item\\RuudShop.txt"));

	gMasteryItemExtOptionSet.Load(gPath.GetRightPath("Item\\MasteryItemExtOptionSet.txt"));

	gSocketChaos.Load(gPath.GetRightPath("Item\\SocketItemUp.txt"));

	gWarehouse.LoadDynamicVault(gPath.GetRightPath("Item\\MultiVault.txt"));

	gWings4thOption.Load();

	LogAdd(LOG_BLUE, "[ServerInfo] Item loaded successfully");
}

void CServerInfo::ReadMapInfo() // OK
{
	FILE* file;

	char path[256] = { 0 };

	char temp[256] = { 0 };

	for (int n = 0; n < MAX_MAP; n++)
	{
		wsprintf(temp, "Terrain\\terrain%d.att", (n + 1));

		if (fopen_s(&file, gPath.GetRightPath(temp), "r") == 0)
		{
			strcpy_s(path, temp);
			fclose(file);
		}

		gMap[n].Load(gPath.GetRightPath(path), n);
	}

	gCrywolf.LoadCrywolfMapAttr(gPath.GetRightPath("Terrain\\terrain35_PEACE.att"), 0);

	gCrywolf.LoadCrywolfMapAttr(gPath.GetRightPath("Terrain\\terrain35_OCCUPIED.att"), 1);

	gCrywolf.LoadCrywolfMapAttr(gPath.GetRightPath("Terrain\\terrain35_WAR.att"), 2);

	gKanturu.LoadKanturuMapAttr(gPath.GetRightPath("Terrain\\terrain40_CLOSE.att"), 0);

	gKanturu.LoadKanturuMapAttr(gPath.GetRightPath("Terrain\\terrain40_OPEN.att"), 1);
}

void CServerInfo::ReadMonsterInfo() // OK
{
	CMonsterAIAutomata::LoadData(gPath.GetRightPath("Monster\\MonsterAIAutomata.txt"));
	CMonsterAIElement::LoadData(gPath.GetRightPath("Monster\\MonsterAIElement.txt"));
	CMonsterAIGroup::LoadData(gPath.GetRightPath("Monster\\MonsterAIGroup.txt"));
	CMonsterAIRule::LoadData(gPath.GetRightPath("Monster\\MonsterAIRule.txt"));
	CMonsterAIUnit::LoadData(gPath.GetRightPath("Monster\\MonsterAIUnit.txt"));	
	gMonsterManager.Load(gPath.GetRightPath("Monster\\Monster.txt"));
	CMonsterSkillElement::LoadData(gPath.GetRightPath("Monster\\MonsterSkillElement.txt"));
	CMonsterSkillUnit::LoadData(gPath.GetRightPath("Monster\\MonsterSkillUnit.txt"));
	CMonsterSkillManager::LoadData(gPath.GetRightPath("Monster\\MonsterSkill.txt"));

	LogAdd(LOG_BLUE, "[ServerInfo] Monster loaded successfully");
}

void CServerInfo::ReadMonsterSetBase() // OK
{
	gKanturuMonsterMng.Load(gPath.GetRightPath("Monster\\KanturuMonsterSetBase.txt"));
	gMonsterSetBase.Load(gPath.GetRightPath("Monster\\MonsterSetBase.txt"));
}

void CServerInfo::ReadMoveInfo() // OK
{
	gGate.Load(gPath.GetRightPath("Move\\Gate.txt"));
	gMove.Load(gPath.GetRightPath("Move\\Move.txt"));
	gMoveSummon.Load(gPath.GetRightPath("Move\\MoveSummon.txt"));
	gMapManager.LoadPvPZone(gPath.GetRightPath("Move\\PvPZone.txt"));

	LogAdd(LOG_BLUE, "[ServerInfo] Move loaded successfully");
}

void CServerInfo::ReadQuestInfo() // OK
{
	gQuest.Load(gPath.GetRightPath("Quest\\Quest.txt"));
	gQuestObjective.Load(gPath.GetRightPath("Quest\\QuestObjective.txt"));
	gQuestReward.Load(gPath.GetRightPath("Quest\\QuestReward.txt"));
	gQuestWorld.Load(gPath.GetRightPath("QuestWorld\\QuestWorld.txt"));
	gQuestWorldObjective.Load(gPath.GetRightPath("QuestWorld\\QuestWorldObjective.txt"));
	gQuestWorldReward.Load(gPath.GetRightPath("QuestWorld\\QuestWorldReward.txt"));
	gNewQuestWorld.Load(gPath.GetRightPath("QuestWorld\\GuideQuest.txt"));

	gItemDrop.Load(gPath.GetRightPath("Item\\ItemDrop.txt"));

	LogAdd(LOG_BLUE, "[ServerInfo] Quest loaded successfully");
}

void CServerInfo::ReadShopInfo() // OK
{
	gShopManager.Load(gPath.GetRightPath("ShopManager.txt"));
	gRheaGold.Load(gPath.GetRightPath("Item\\RuudShop.txt"));

	gShopManager.LoadShop();
	gShopManager.ReloadShopInterface();	

	LogAdd(LOG_BLUE, "[ServerInfo] Shop loaded successfully");
}

void CServerInfo::ReadSkillInfo() // OK
{
	this->ReadSkillInfo("GameServerInfo", ".\\Data\\GameServerInfo - Skill.dat");

	gMasterSkillTree.Load(gPath.GetRightPath("Skill\\MasterSkillTree.txt"));

	gSkillHitBox.Load(gPath.GetRightPath("Skill\\SkillElect.hit"));

	gSkillManager.Load(gPath.GetRightPath("Skill\\Skill.txt"));

	gSkillManager.LoadSkillDamageRate(gPath.GetRightPath("Skill\\SkillDamageRate.txt"));

	gSkillManager.LoadSkillBlock(gPath.GetRightPath("Skill\\SkillBlock.txt"));

	g_ComboSkillPath.ReadSkillInfo("GameServerInfo", ".\\Data\\GameServerInfo - Skill.dat");

	gCalFormula.Load(gPath.GetRightPath("Skill\\FormulaData.txt"));

	gMasterSkillTree_4th.Load(gPath.GetRightPath("Skill\\ForSkillTree.txt"));

	LogAdd(LOG_BLUE, "[ServerInfo] Skill loaded successfully");
}

void CServerInfo::ReadUtilInfo() // OK
{
	gExperienceTable.Load(gPath.GetRightPath("Util\\ExperienceTable.txt"));
	gFilter.Load(gPath.GetRightPath("Util\\Filter.txt"));
	gOficina.LoadDescriptions(gPath.GetRightPath("Oficina\\description.txt"));
	gOficina.LoadOptions(gPath.GetRightPath("Oficina\\options.txt"));

	gNotice.Load(gPath.GetRightPath("Util\\Notice.txt"));

	char* section = "GameServerInfo";
	char* path = ".\\Data\\GameServerInfo - Event.dat";

	this->m_CastleSiegeDecayAccumulatedTimeValue = GetPrivateProfileInt(section, "CastleSiegeDecayAccumulatedTimeValue", 0, path);
	this->m_CastleSiegeLowerAccumulatedTimeValue = GetPrivateProfileInt(section, "CastleSiegeLowerAccumulatedTimeValue", 0, path);
	this->m_CastleSiegeLowerAccumulatedTimeFixed = GetPrivateProfileInt(section, "CastleSiegeLowerAccumulatedTimeFixed", 0, path);

	this->m_CastleSiegeCrownIdleTimeout = GetPrivateProfileInt(section, "CastleSiegeCrownIdleTimeout", 0, path);
	this->m_CastleSiegeMaxMembersInTower = GetPrivateProfileInt(section, "CastleSiegeMaxMembersInTower", 999, path);

	this->m_CastleSiegeExtend			= GetPrivateProfileInt(section, "CastleSiegeExtend", 0, path);
	this->m_CastleSiegeExtendTime		= GetPrivateProfileInt(section, "CastleSiegeExtendTime", 0, path);
	this->m_CastleSiegeExtendCondition	= GetPrivateProfileInt(section, "CastleSiegeExtendCondition", 0, path);
	this->m_CastleSiegeTimeToRegister	= GetPrivateProfileInt(section, "CastleSiegeTimeToRegister", 60000, path);
	this->m_CastleSiegeWinningMode		= GetPrivateProfileInt(section, "CastleSiegeWinningMode", 1, path);

	LogAdd(LOG_BLUE, "[ServerInfo] Util loaded successfully");
}

void CServerInfo::ReloadMonsterInfo() // OK
{
	this->ReadMonsterInfo();
}

void CServerInfo::ReloadMonsterSetBase() // OK
{
	LogAdd(LOG_RED, "[MonsterSetBase] Reloading...");

	for (int n = 0; n < MAX_OBJECT_MONSTER; n++)
	{
		if (gObj[n].Type != OBJECT_MONSTER && gObj[n].Type != OBJECT_NPC)
		{
			continue;
		}

#if(GAMESERVER_TYPE==1)

		if (gObj[n].CsNpcType != 0)
		{
			continue;
		}

#endif

		gObjDel(n);
	}

	gObjMonCount = 0;
	gCrywolf.m_ObjCommonNPC.Reset();
	gCrywolf.m_ObjSpecialNPC.Reset();
	gCrywolf.m_ObjCommonMonster.Reset();
	gCrywolf.m_ObjSpecialMonster.Reset();

	this->ReadMonsterSetBase();

	gMonsterManager.SetMonsterData();

	LogAdd(LOG_BLUE, "[MonsterSetBase] Reloaded.");
}

void CServerInfo::ReadStartupInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	GetPrivateProfileString(section, "ServerName", "", this->m_ServerName, sizeof(this->m_ServerName), path);

	this->m_ServerCode = GetPrivateProfileInt(section, "ServerCode", 0, path);

	this->m_ServerLock = GetPrivateProfileInt(section, "ServerLock", 0, path);

	this->m_ServerPort = GetPrivateProfileInt(section, "ServerPort", 0, path);

	wsprintf(this->m_ServerMutex, "WZ_MU_GS_MUTEX_%d", this->m_ServerCode);

	GetPrivateProfileString(section, "ServerVersion", "", GameServerInfo, sizeof(GameServerInfo), path);

	gServerInfo.m_ServerVersion[0] = GameServerInfo[0];

	gServerInfo.m_ServerVersion[1] = GameServerInfo[2];

	gServerInfo.m_ServerVersion[2] = GameServerInfo[3];

	gServerInfo.m_ServerVersion[3] = GameServerInfo[5];

	gServerInfo.m_ServerVersion[4] = GameServerInfo[6];

	gServerInfo.m_ServerVersion[5] = 0;

	GetPrivateProfileString(section, "ServerSerial", "", this->m_ServerSerial, sizeof(this->m_ServerSerial), path);

	this->m_ServerMaxUserNumber = GetPrivateProfileInt(section, "ServerMaxUserNumber", 0, path);

	this->m_ServerMaxUserNumber = ((this->m_ServerMaxUserNumber > MAX_OBJECT_USER) ? MAX_OBJECT_USER : this->m_ServerMaxUserNumber);

	GetPrivateProfileString(section, "DataServerAddress", "", this->m_DataServerAddress, sizeof(this->m_DataServerAddress), path);

	this->m_DataServerPort = GetPrivateProfileInt(section, "DataServerPort", 0, path);

	GetPrivateProfileString(section, "JoinServerAddress", "", this->m_JoinServerAddress, sizeof(this->m_JoinServerAddress), path);

	this->m_JoinServerPort = GetPrivateProfileInt(section, "JoinServerPort", 0, path);

	GetPrivateProfileString(section, "ConnectServerAddress", "", this->m_ConnectServerAddress, sizeof(this->m_ConnectServerAddress), path);

	this->m_ConnectServerPort = GetPrivateProfileInt(section, "ConnectServerPort", 0, path);

	this->m_WriteChatLog = GetPrivateProfileInt(section, "WriteChatLog", 0, path);
	this->m_WriteCommandLog = GetPrivateProfileInt(section, "WriteCommandLog", 0, path);
	this->m_WriteTradeLog = GetPrivateProfileInt(section, "WriteTradeLog", 0, path);
	this->m_WriteConnectLog = GetPrivateProfileInt(section, "WriteConnectLog", 0, path);
	this->m_WriteHackLog = GetPrivateProfileInt(section, "WriteHackLog", 0, path);
	this->m_WriteCashShopLog = GetPrivateProfileInt(section, "WriteCashShopLog", 0, path);
	this->m_WriteChaosMixLog = GetPrivateProfileInt(section, "WriteChaosMixLog", 0, path);
	this->m_WriteItemDropLog = GetPrivateProfileInt(section, "WriteItemDropLog", 0, path);
	this->m_WriteItemBagLog = GetPrivateProfileInt(section, "WriteItemBagLog", 0, path);
	this->m_WriteItemUpgradeLog = GetPrivateProfileInt(section, "WriteItemUpgradeLog", 0, path);
	this->m_WriteStalkLog = GetPrivateProfileInt(section, "WriteStalkLog", 0, path);
	this->m_WriteHitQueueLog = GetPrivateProfileInt(section, "WriteHitQueueLog", 0, path);
	this->m_WriteMonsterSpawnerLog = GetPrivateProfileInt(section, "WriteMonsterSpawnerLog", 0, path);
}

void CServerInfo::ReadCashShopInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	this->m_CashShopSwitch = GetPrivateProfileInt(section, "CashShopSwitch", 0, path);

	this->m_CashShopScriptVersion1 = GetPrivateProfileInt(section, "CashShopScriptVersion1", 0, path);

	this->m_CashShopScriptVersion2 = GetPrivateProfileInt(section, "CashShopScriptVersion2", 0, path);

	this->m_CashShopScriptVersion3 = GetPrivateProfileInt(section, "CashShopScriptVersion3", 0, path);

	this->m_CashShopBannerVersion1 = GetPrivateProfileInt(section, "CashShopBannerVersion1", 0, path);

	this->m_CashShopBannerVersion2 = GetPrivateProfileInt(section, "CashShopBannerVersion2", 0, path);

	this->m_CashShopBannerVersion3 = GetPrivateProfileInt(section, "CashShopBannerVersion3", 0, path);

	this->m_CashShopGoblinPointDelay = GetPrivateProfileInt(section, "CashShopGoblinPointDelay", 0, path);

	this->m_CashShopGoblinPointValue[0] = GetPrivateProfileInt(section, "CashShopGoblinPointValue_AL0", 0, path);

	this->m_CashShopGoblinPointValue[1] = GetPrivateProfileInt(section, "CashShopGoblinPointValue_AL1", 0, path);

	this->m_CashShopGoblinPointValue[2] = GetPrivateProfileInt(section, "CashShopGoblinPointValue_AL2", 0, path);

	this->m_CashShopGoblinPointValue[3] = GetPrivateProfileInt(section, "CashShopGoblinPointValue_AL3", 0, path);

	gCashShop.ReloadVersionToAll();

}

void CServerInfo::ReadChaosMixInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };
	this->m_FEAngelMixRate = GetPrivateProfileInt(section, "FEAngelMixRate", 0, path);	//
	this->m_MGAngelMixRate = GetPrivateProfileInt(section, "MGAngelMixRate", 0, path);	//

	this->m_SocketItemUpRate = GetPrivateProfileInt(section, "SocketItemUpRate", 0, path);	//
	this->m_SocketItemExtractSeedSphereRate = GetPrivateProfileInt(section, "SocketItemExtractSeedSphereRate", 0, path);	//

	this->m_ChaosDarkAngelLuckRate = GetPrivateProfileInt(section, "ChaosDarkAngelLuckRate", 0, path);	//ʹװϳ˸
	this->m_ChaosDarkAngelSet = GetPrivateProfileInt(section, "ChaosDarkAngelSet", 0, path);			//ʹװϳ+15ȫԼ
	this->m_ChaosAngelEcxMaxRate = GetPrivateProfileInt(section, "ChaosAngelEcxMaxRate", 0, path);			//ȫԸ
	this->m_ChaosAngelLuckRate = GetPrivateProfileInt(section, "ChaosAngelLuckRate", 0, path);			//˸
	this->m_ChaosDrakAngelInheritBloodAngelEcx = GetPrivateProfileInt(section, "ChaosDrakAngelInheritBloodAngelEcx", 0, path);

	this->m_AngelEcxAddSwitch = GetPrivateProfileInt(section, "AngelEcxAddSwitch", 0, path);			//Ƿ׿Խ[]:0[]:1
	this->m_AngelEcxMaxOption = GetPrivateProfileInt(section, "AngelEcxMaxOption", 0, path);			//׿Խ
	this->m_AngelSetOptionRate = GetPrivateProfileInt(section, "AngelSetOptionRate", 0, path);

	this->m_ChaosItemMixRate[0] = GetPrivateProfileInt(section, "ChaosItemMixRate_AL0", 0, path);
	this->m_ChaosItemMixRate[1] = GetPrivateProfileInt(section, "ChaosItemMixRate_AL1", 0, path);
	this->m_ChaosItemMixRate[2] = GetPrivateProfileInt(section, "ChaosItemMixRate_AL2", 0, path);
	this->m_ChaosItemMixRate[3] = GetPrivateProfileInt(section, "ChaosItemMixRate_AL3", 0, path);

	this->m_DevilSquareMixRate1[0] = GetPrivateProfileInt(section, "DevilSquareMixRate1_AL0", 0, path);
	this->m_DevilSquareMixRate1[1] = GetPrivateProfileInt(section, "DevilSquareMixRate1_AL1", 0, path);
	this->m_DevilSquareMixRate1[2] = GetPrivateProfileInt(section, "DevilSquareMixRate1_AL2", 0, path);
	this->m_DevilSquareMixRate1[3] = GetPrivateProfileInt(section, "DevilSquareMixRate1_AL3", 0, path);

	this->m_DevilSquareMixRate2[0] = GetPrivateProfileInt(section, "DevilSquareMixRate2_AL0", 0, path);
	this->m_DevilSquareMixRate2[1] = GetPrivateProfileInt(section, "DevilSquareMixRate2_AL1", 0, path);
	this->m_DevilSquareMixRate2[2] = GetPrivateProfileInt(section, "DevilSquareMixRate2_AL2", 0, path);
	this->m_DevilSquareMixRate2[3] = GetPrivateProfileInt(section, "DevilSquareMixRate2_AL3", 0, path);

	this->m_DevilSquareMixRate3[0] = GetPrivateProfileInt(section, "DevilSquareMixRate3_AL0", 0, path);
	this->m_DevilSquareMixRate3[1] = GetPrivateProfileInt(section, "DevilSquareMixRate3_AL1", 0, path);
	this->m_DevilSquareMixRate3[2] = GetPrivateProfileInt(section, "DevilSquareMixRate3_AL2", 0, path);
	this->m_DevilSquareMixRate3[3] = GetPrivateProfileInt(section, "DevilSquareMixRate3_AL3", 0, path);

	this->m_DevilSquareMixRate4[0] = GetPrivateProfileInt(section, "DevilSquareMixRate4_AL0", 0, path);
	this->m_DevilSquareMixRate4[1] = GetPrivateProfileInt(section, "DevilSquareMixRate4_AL1", 0, path);
	this->m_DevilSquareMixRate4[2] = GetPrivateProfileInt(section, "DevilSquareMixRate4_AL2", 0, path);
	this->m_DevilSquareMixRate4[3] = GetPrivateProfileInt(section, "DevilSquareMixRate4_AL3", 0, path);

	this->m_DevilSquareMixRate5[0] = GetPrivateProfileInt(section, "DevilSquareMixRate5_AL0", 0, path);

	this->m_DevilSquareMixRate5[1] = GetPrivateProfileInt(section, "DevilSquareMixRate5_AL1", 0, path);

	this->m_DevilSquareMixRate5[2] = GetPrivateProfileInt(section, "DevilSquareMixRate5_AL2", 0, path);

	this->m_DevilSquareMixRate5[3] = GetPrivateProfileInt(section, "DevilSquareMixRate5_AL3", 0, path);

	this->m_DevilSquareMixRate6[0] = GetPrivateProfileInt(section, "DevilSquareMixRate6_AL0", 0, path);

	this->m_DevilSquareMixRate6[1] = GetPrivateProfileInt(section, "DevilSquareMixRate6_AL1", 0, path);

	this->m_DevilSquareMixRate6[2] = GetPrivateProfileInt(section, "DevilSquareMixRate6_AL2", 0, path);

	this->m_DevilSquareMixRate6[3] = GetPrivateProfileInt(section, "DevilSquareMixRate6_AL3", 0, path);

	this->m_DevilSquareMixRate7[0] = GetPrivateProfileInt(section, "DevilSquareMixRate7_AL0", 0, path);

	this->m_DevilSquareMixRate7[1] = GetPrivateProfileInt(section, "DevilSquareMixRate7_AL1", 0, path);

	this->m_DevilSquareMixRate7[2] = GetPrivateProfileInt(section, "DevilSquareMixRate7_AL2", 0, path);

	this->m_DevilSquareMixRate7[3] = GetPrivateProfileInt(section, "DevilSquareMixRate7_AL3", 0, path);

	this->m_PlusItemLevelMixRate1[0] = GetPrivateProfileInt(section, "PlusItemLevelMixRate1_AL0", 0, path);

	this->m_PlusItemLevelMixRate1[1] = GetPrivateProfileInt(section, "PlusItemLevelMixRate1_AL1", 0, path);

	this->m_PlusItemLevelMixRate1[2] = GetPrivateProfileInt(section, "PlusItemLevelMixRate1_AL2", 0, path);

	this->m_PlusItemLevelMixRate1[3] = GetPrivateProfileInt(section, "PlusItemLevelMixRate1_AL3", 0, path);

	this->m_PlusItemLevelMixRate2[0] = GetPrivateProfileInt(section, "PlusItemLevelMixRate2_AL0", 0, path);

	this->m_PlusItemLevelMixRate2[1] = GetPrivateProfileInt(section, "PlusItemLevelMixRate2_AL1", 0, path);

	this->m_PlusItemLevelMixRate2[2] = GetPrivateProfileInt(section, "PlusItemLevelMixRate2_AL2", 0, path);

	this->m_PlusItemLevelMixRate2[3] = GetPrivateProfileInt(section, "PlusItemLevelMixRate2_AL3", 0, path);

	this->m_PlusItemLevelMixRate3[0] = GetPrivateProfileInt(section, "PlusItemLevelMixRate3_AL0", 0, path);

	this->m_PlusItemLevelMixRate3[1] = GetPrivateProfileInt(section, "PlusItemLevelMixRate3_AL1", 0, path);

	this->m_PlusItemLevelMixRate3[2] = GetPrivateProfileInt(section, "PlusItemLevelMixRate3_AL2", 0, path);

	this->m_PlusItemLevelMixRate3[3] = GetPrivateProfileInt(section, "PlusItemLevelMixRate3_AL3", 0, path);

	this->m_PlusItemLevelMixRate4[0] = GetPrivateProfileInt(section, "PlusItemLevelMixRate4_AL0", 0, path);

	this->m_PlusItemLevelMixRate4[1] = GetPrivateProfileInt(section, "PlusItemLevelMixRate4_AL1", 0, path);

	this->m_PlusItemLevelMixRate4[2] = GetPrivateProfileInt(section, "PlusItemLevelMixRate4_AL2", 0, path);

	this->m_PlusItemLevelMixRate4[3] = GetPrivateProfileInt(section, "PlusItemLevelMixRate4_AL3", 0, path);

#if(GAMESERVER_UPDATE>=501)

	this->m_PlusItemLevelMixRate5[0] = GetPrivateProfileInt(section, "PlusItemLevelMixRate5_AL0", 0, path);

	this->m_PlusItemLevelMixRate5[1] = GetPrivateProfileInt(section, "PlusItemLevelMixRate5_AL1", 0, path);

	this->m_PlusItemLevelMixRate5[2] = GetPrivateProfileInt(section, "PlusItemLevelMixRate5_AL2", 0, path);

	this->m_PlusItemLevelMixRate5[3] = GetPrivateProfileInt(section, "PlusItemLevelMixRate5_AL3", 0, path);

	this->m_PlusItemLevelMixRate6[0] = GetPrivateProfileInt(section, "PlusItemLevelMixRate6_AL0", 0, path);

	this->m_PlusItemLevelMixRate6[1] = GetPrivateProfileInt(section, "PlusItemLevelMixRate6_AL1", 0, path);

	this->m_PlusItemLevelMixRate6[2] = GetPrivateProfileInt(section, "PlusItemLevelMixRate6_AL2", 0, path);

	this->m_PlusItemLevelMixRate6[3] = GetPrivateProfileInt(section, "PlusItemLevelMixRate6_AL3", 0, path);

#endif

	this->m_DinorantMixRate[0] = GetPrivateProfileInt(section, "DinorantMixRate_AL0", 0, path);

	this->m_DinorantMixRate[1] = GetPrivateProfileInt(section, "DinorantMixRate_AL1", 0, path);

	this->m_DinorantMixRate[2] = GetPrivateProfileInt(section, "DinorantMixRate_AL2", 0, path);

	this->m_DinorantMixRate[3] = GetPrivateProfileInt(section, "DinorantMixRate_AL3", 0, path);

	this->m_FruitMixRate[0] = GetPrivateProfileInt(section, "FruitMixRate_AL0", 0, path);

	this->m_FruitMixRate[1] = GetPrivateProfileInt(section, "FruitMixRate_AL1", 0, path);

	this->m_FruitMixRate[2] = GetPrivateProfileInt(section, "FruitMixRate_AL2", 0, path);

	this->m_FruitMixRate[3] = GetPrivateProfileInt(section, "FruitMixRate_AL3", 0, path);

	this->m_Wing2MixRate[0] = GetPrivateProfileInt(section, "Wing2MixRate_AL0", 0, path);

	this->m_Wing2MixRate[1] = GetPrivateProfileInt(section, "Wing2MixRate_AL1", 0, path);

	this->m_Wing2MixRate[2] = GetPrivateProfileInt(section, "Wing2MixRate_AL2", 0, path);

	this->m_Wing2MixRate[3] = GetPrivateProfileInt(section, "Wing2MixRate_AL3", 0, path);

	this->m_BloodCastleMixRate1[0] = GetPrivateProfileInt(section, "BloodCastleMixRate1_AL0", 0, path);

	this->m_BloodCastleMixRate1[1] = GetPrivateProfileInt(section, "BloodCastleMixRate1_AL1", 0, path);

	this->m_BloodCastleMixRate1[2] = GetPrivateProfileInt(section, "BloodCastleMixRate1_AL2", 0, path);

	this->m_BloodCastleMixRate1[3] = GetPrivateProfileInt(section, "BloodCastleMixRate1_AL3", 0, path);

	this->m_BloodCastleMixRate2[0] = GetPrivateProfileInt(section, "BloodCastleMixRate2_AL0", 0, path);

	this->m_BloodCastleMixRate2[1] = GetPrivateProfileInt(section, "BloodCastleMixRate2_AL1", 0, path);

	this->m_BloodCastleMixRate2[2] = GetPrivateProfileInt(section, "BloodCastleMixRate2_AL2", 0, path);

	this->m_BloodCastleMixRate2[3] = GetPrivateProfileInt(section, "BloodCastleMixRate2_AL3", 0, path);

	this->m_BloodCastleMixRate3[0] = GetPrivateProfileInt(section, "BloodCastleMixRate3_AL0", 0, path);

	this->m_BloodCastleMixRate3[1] = GetPrivateProfileInt(section, "BloodCastleMixRate3_AL1", 0, path);

	this->m_BloodCastleMixRate3[2] = GetPrivateProfileInt(section, "BloodCastleMixRate3_AL2", 0, path);

	this->m_BloodCastleMixRate3[3] = GetPrivateProfileInt(section, "BloodCastleMixRate3_AL3", 0, path);

	this->m_BloodCastleMixRate4[0] = GetPrivateProfileInt(section, "BloodCastleMixRate4_AL0", 0, path);

	this->m_BloodCastleMixRate4[1] = GetPrivateProfileInt(section, "BloodCastleMixRate4_AL1", 0, path);

	this->m_BloodCastleMixRate4[2] = GetPrivateProfileInt(section, "BloodCastleMixRate4_AL2", 0, path);

	this->m_BloodCastleMixRate4[3] = GetPrivateProfileInt(section, "BloodCastleMixRate4_AL3", 0, path);

	this->m_BloodCastleMixRate5[0] = GetPrivateProfileInt(section, "BloodCastleMixRate5_AL0", 0, path);

	this->m_BloodCastleMixRate5[1] = GetPrivateProfileInt(section, "BloodCastleMixRate5_AL1", 0, path);

	this->m_BloodCastleMixRate5[2] = GetPrivateProfileInt(section, "BloodCastleMixRate5_AL2", 0, path);

	this->m_BloodCastleMixRate5[3] = GetPrivateProfileInt(section, "BloodCastleMixRate5_AL3", 0, path);

	this->m_BloodCastleMixRate6[0] = GetPrivateProfileInt(section, "BloodCastleMixRate6_AL0", 0, path);

	this->m_BloodCastleMixRate6[1] = GetPrivateProfileInt(section, "BloodCastleMixRate6_AL1", 0, path);

	this->m_BloodCastleMixRate6[2] = GetPrivateProfileInt(section, "BloodCastleMixRate6_AL2", 0, path);

	this->m_BloodCastleMixRate6[3] = GetPrivateProfileInt(section, "BloodCastleMixRate6_AL3", 0, path);

	this->m_BloodCastleMixRate7[0] = GetPrivateProfileInt(section, "BloodCastleMixRate7_AL0", 0, path);

	this->m_BloodCastleMixRate7[1] = GetPrivateProfileInt(section, "BloodCastleMixRate7_AL1", 0, path);

	this->m_BloodCastleMixRate7[2] = GetPrivateProfileInt(section, "BloodCastleMixRate7_AL2", 0, path);

	this->m_BloodCastleMixRate7[3] = GetPrivateProfileInt(section, "BloodCastleMixRate7_AL3", 0, path);

	this->m_BloodCastleMixRate8[0] = GetPrivateProfileInt(section, "BloodCastleMixRate8_AL0", 0, path);

	this->m_BloodCastleMixRate8[1] = GetPrivateProfileInt(section, "BloodCastleMixRate8_AL1", 0, path);

	this->m_BloodCastleMixRate8[2] = GetPrivateProfileInt(section, "BloodCastleMixRate8_AL2", 0, path);

	this->m_BloodCastleMixRate8[3] = GetPrivateProfileInt(section, "BloodCastleMixRate8_AL3", 0, path);

	this->m_Wing1MixRate[0] = GetPrivateProfileInt(section, "Wing1MixRate_AL0", 0, path);

	this->m_Wing1MixRate[1] = GetPrivateProfileInt(section, "Wing1MixRate_AL1", 0, path);

	this->m_Wing1MixRate[2] = GetPrivateProfileInt(section, "Wing1MixRate_AL2", 0, path);

	this->m_Wing1MixRate[3] = GetPrivateProfileInt(section, "Wing1MixRate_AL3", 0, path);

	this->m_PetMixRate[0] = GetPrivateProfileInt(section, "PetMixRate_AL0", 0, path);

	this->m_PetMixRate[1] = GetPrivateProfileInt(section, "PetMixRate_AL1", 0, path);

	this->m_PetMixRate[2] = GetPrivateProfileInt(section, "PetMixRate_AL2", 0, path);

	this->m_PetMixRate[3] = GetPrivateProfileInt(section, "PetMixRate_AL3", 0, path);

	this->m_PieceOfHornMixRate[0] = GetPrivateProfileInt(section, "PieceOfHornMixRate_AL0", 0, path);

	this->m_PieceOfHornMixRate[1] = GetPrivateProfileInt(section, "PieceOfHornMixRate_AL1", 0, path);

	this->m_PieceOfHornMixRate[2] = GetPrivateProfileInt(section, "PieceOfHornMixRate_AL2", 0, path);

	this->m_PieceOfHornMixRate[3] = GetPrivateProfileInt(section, "PieceOfHornMixRate_AL3", 0, path);

	this->m_BrokenHornMixRate[0] = GetPrivateProfileInt(section, "BrokenHornMixRate_AL0", 0, path);

	this->m_BrokenHornMixRate[1] = GetPrivateProfileInt(section, "BrokenHornMixRate_AL1", 0, path);

	this->m_BrokenHornMixRate[2] = GetPrivateProfileInt(section, "BrokenHornMixRate_AL2", 0, path);

	this->m_BrokenHornMixRate[3] = GetPrivateProfileInt(section, "BrokenHornMixRate_AL3", 0, path);

	this->m_HornOfFenrirMixRate[0] = GetPrivateProfileInt(section, "HornOfFenrirMixRate_AL0", 0, path);

	this->m_HornOfFenrirMixRate[1] = GetPrivateProfileInt(section, "HornOfFenrirMixRate_AL1", 0, path);

	this->m_HornOfFenrirMixRate[2] = GetPrivateProfileInt(section, "HornOfFenrirMixRate_AL2", 0, path);

	this->m_HornOfFenrirMixRate[3] = GetPrivateProfileInt(section, "HornOfFenrirMixRate_AL3", 0, path);

	this->m_HornOfFenrirUpgradeMixRate[0] = GetPrivateProfileInt(section, "HornOfFenrirUpgradeMixRate_AL0", 0, path);

	this->m_HornOfFenrirUpgradeMixRate[1] = GetPrivateProfileInt(section, "HornOfFenrirUpgradeMixRate_AL1", 0, path);

	this->m_HornOfFenrirUpgradeMixRate[2] = GetPrivateProfileInt(section, "HornOfFenrirUpgradeMixRate_AL2", 0, path);

	this->m_HornOfFenrirUpgradeMixRate[3] = GetPrivateProfileInt(section, "HornOfFenrirUpgradeMixRate_AL3", 0, path);

	this->m_ShieldPotionMixRate1[0] = GetPrivateProfileInt(section, "ShieldPotionMixRate1_AL0", 0, path);

	this->m_ShieldPotionMixRate1[1] = GetPrivateProfileInt(section, "ShieldPotionMixRate1_AL1", 0, path);

	this->m_ShieldPotionMixRate1[2] = GetPrivateProfileInt(section, "ShieldPotionMixRate1_AL2", 0, path);

	this->m_ShieldPotionMixRate1[3] = GetPrivateProfileInt(section, "ShieldPotionMixRate1_AL3", 0, path);

	this->m_ShieldPotionMixRate2[0] = GetPrivateProfileInt(section, "ShieldPotionMixRate2_AL0", 0, path);

	this->m_ShieldPotionMixRate2[1] = GetPrivateProfileInt(section, "ShieldPotionMixRate2_AL1", 0, path);

	this->m_ShieldPotionMixRate2[2] = GetPrivateProfileInt(section, "ShieldPotionMixRate2_AL2", 0, path);

	this->m_ShieldPotionMixRate2[3] = GetPrivateProfileInt(section, "ShieldPotionMixRate2_AL3", 0, path);

	this->m_ShieldPotionMixRate3[0] = GetPrivateProfileInt(section, "ShieldPotionMixRate3_AL0", 0, path);

	this->m_ShieldPotionMixRate3[1] = GetPrivateProfileInt(section, "ShieldPotionMixRate3_AL1", 0, path);

	this->m_ShieldPotionMixRate3[2] = GetPrivateProfileInt(section, "ShieldPotionMixRate3_AL2", 0, path);

	this->m_ShieldPotionMixRate3[3] = GetPrivateProfileInt(section, "ShieldPotionMixRate3_AL3", 0, path);

	this->m_JewelOfHarmonyItemPurityMixRate[0] = GetPrivateProfileInt(section, "JewelOfHarmonyItemPurityMixRate_AL0", 0, path);

	this->m_JewelOfHarmonyItemPurityMixRate[1] = GetPrivateProfileInt(section, "JewelOfHarmonyItemPurityMixRate_AL1", 0, path);

	this->m_JewelOfHarmonyItemPurityMixRate[2] = GetPrivateProfileInt(section, "JewelOfHarmonyItemPurityMixRate_AL2", 0, path);

	this->m_JewelOfHarmonyItemPurityMixRate[3] = GetPrivateProfileInt(section, "JewelOfHarmonyItemPurityMixRate_AL3", 0, path);

	this->m_JewelOfHarmonyItemSmeltMixRate1[0] = GetPrivateProfileInt(section, "JewelOfHarmonyItemSmeltMixRate1_AL0", 0, path);

	this->m_JewelOfHarmonyItemSmeltMixRate1[1] = GetPrivateProfileInt(section, "JewelOfHarmonyItemSmeltMixRate1_AL1", 0, path);

	this->m_JewelOfHarmonyItemSmeltMixRate1[2] = GetPrivateProfileInt(section, "JewelOfHarmonyItemSmeltMixRate1_AL2", 0, path);

	this->m_JewelOfHarmonyItemSmeltMixRate1[3] = GetPrivateProfileInt(section, "JewelOfHarmonyItemSmeltMixRate1_AL3", 0, path);

	this->m_JewelOfHarmonyItemSmeltMixRate2[0] = GetPrivateProfileInt(section, "JewelOfHarmonyItemSmeltMixRate2_AL0", 0, path);

	this->m_JewelOfHarmonyItemSmeltMixRate2[1] = GetPrivateProfileInt(section, "JewelOfHarmonyItemSmeltMixRate2_AL1", 0, path);

	this->m_JewelOfHarmonyItemSmeltMixRate2[2] = GetPrivateProfileInt(section, "JewelOfHarmonyItemSmeltMixRate2_AL2", 0, path);

	this->m_JewelOfHarmonyItemSmeltMixRate2[3] = GetPrivateProfileInt(section, "JewelOfHarmonyItemSmeltMixRate2_AL3", 0, path);

	this->m_JewelOfHarmonyItemRestoreMixRate[0] = GetPrivateProfileInt(section, "JewelOfHarmonyItemRestoreMixRate_AL0", 0, path);

	this->m_JewelOfHarmonyItemRestoreMixRate[1] = GetPrivateProfileInt(section, "JewelOfHarmonyItemRestoreMixRate_AL1", 0, path);

	this->m_JewelOfHarmonyItemRestoreMixRate[2] = GetPrivateProfileInt(section, "JewelOfHarmonyItemRestoreMixRate_AL2", 0, path);

	this->m_JewelOfHarmonyItemRestoreMixRate[3] = GetPrivateProfileInt(section, "JewelOfHarmonyItemRestoreMixRate_AL3", 0, path);

	this->m_Item380MixRate1[0] = GetPrivateProfileInt(section, "Item380MixRate1_AL0", 0, path);

	this->m_Item380MixRate1[1] = GetPrivateProfileInt(section, "Item380MixRate1_AL1", 0, path);

	this->m_Item380MixRate1[2] = GetPrivateProfileInt(section, "Item380MixRate1_AL2", 0, path);

	this->m_Item380MixRate1[3] = GetPrivateProfileInt(section, "Item380MixRate1_AL3", 0, path);

	this->m_Item380MixRate2[0] = GetPrivateProfileInt(section, "Item380MixRate2_AL0", 0, path);

	this->m_Item380MixRate2[1] = GetPrivateProfileInt(section, "Item380MixRate2_AL1", 0, path);

	this->m_Item380MixRate2[2] = GetPrivateProfileInt(section, "Item380MixRate2_AL2", 0, path);

	this->m_Item380MixRate2[3] = GetPrivateProfileInt(section, "Item380MixRate2_AL3", 0, path);

	this->m_IllusionTempleMixRate1[0] = GetPrivateProfileInt(section, "IllusionTempleMixRate1_AL0", 0, path);

	this->m_IllusionTempleMixRate1[1] = GetPrivateProfileInt(section, "IllusionTempleMixRate1_AL1", 0, path);

	this->m_IllusionTempleMixRate1[2] = GetPrivateProfileInt(section, "IllusionTempleMixRate1_AL2", 0, path);

	this->m_IllusionTempleMixRate1[3] = GetPrivateProfileInt(section, "IllusionTempleMixRate1_AL3", 0, path);

	this->m_IllusionTempleMixRate2[0] = GetPrivateProfileInt(section, "IllusionTempleMixRate2_AL0", 0, path);

	this->m_IllusionTempleMixRate2[1] = GetPrivateProfileInt(section, "IllusionTempleMixRate2_AL1", 0, path);

	this->m_IllusionTempleMixRate2[2] = GetPrivateProfileInt(section, "IllusionTempleMixRate2_AL2", 0, path);

	this->m_IllusionTempleMixRate2[3] = GetPrivateProfileInt(section, "IllusionTempleMixRate2_AL3", 0, path);

	this->m_IllusionTempleMixRate3[0] = GetPrivateProfileInt(section, "IllusionTempleMixRate3_AL0", 0, path);

	this->m_IllusionTempleMixRate3[1] = GetPrivateProfileInt(section, "IllusionTempleMixRate3_AL1", 0, path);

	this->m_IllusionTempleMixRate3[2] = GetPrivateProfileInt(section, "IllusionTempleMixRate3_AL2", 0, path);

	this->m_IllusionTempleMixRate3[3] = GetPrivateProfileInt(section, "IllusionTempleMixRate3_AL3", 0, path);

	this->m_IllusionTempleMixRate4[0] = GetPrivateProfileInt(section, "IllusionTempleMixRate4_AL0", 0, path);

	this->m_IllusionTempleMixRate4[1] = GetPrivateProfileInt(section, "IllusionTempleMixRate4_AL1", 0, path);

	this->m_IllusionTempleMixRate4[2] = GetPrivateProfileInt(section, "IllusionTempleMixRate4_AL2", 0, path);

	this->m_IllusionTempleMixRate4[3] = GetPrivateProfileInt(section, "IllusionTempleMixRate4_AL3", 0, path);

	this->m_IllusionTempleMixRate5[0] = GetPrivateProfileInt(section, "IllusionTempleMixRate5_AL0", 0, path);

	this->m_IllusionTempleMixRate5[1] = GetPrivateProfileInt(section, "IllusionTempleMixRate5_AL1", 0, path);

	this->m_IllusionTempleMixRate5[2] = GetPrivateProfileInt(section, "IllusionTempleMixRate5_AL2", 0, path);

	this->m_IllusionTempleMixRate5[3] = GetPrivateProfileInt(section, "IllusionTempleMixRate5_AL3", 0, path);

	this->m_IllusionTempleMixRate6[0] = GetPrivateProfileInt(section, "IllusionTempleMixRate6_AL0", 0, path);

	this->m_IllusionTempleMixRate6[1] = GetPrivateProfileInt(section, "IllusionTempleMixRate6_AL1", 0, path);

	this->m_IllusionTempleMixRate6[2] = GetPrivateProfileInt(section, "IllusionTempleMixRate6_AL2", 0, path);

	this->m_IllusionTempleMixRate6[3] = GetPrivateProfileInt(section, "IllusionTempleMixRate6_AL3", 0, path);

	this->m_FeatherOfCondorMixRate[0] = GetPrivateProfileInt(section, "FeatherOfCondorMixRate_AL0", -1, path);

	this->m_FeatherOfCondorMixRate[1] = GetPrivateProfileInt(section, "FeatherOfCondorMixRate_AL1", -1, path);

	this->m_FeatherOfCondorMixRate[2] = GetPrivateProfileInt(section, "FeatherOfCondorMixRate_AL2", -1, path);

	this->m_FeatherOfCondorMixRate[3] = GetPrivateProfileInt(section, "FeatherOfCondorMixRate_AL3", -1, path);

	this->m_Wing3MixRate[0] = GetPrivateProfileInt(section, "Wing3MixRate_AL0", -1, path);
	this->m_Wing3MixRate[1] = GetPrivateProfileInt(section, "Wing3MixRate_AL1", -1, path);
	this->m_Wing3MixRate[2] = GetPrivateProfileInt(section, "Wing3MixRate_AL2", -1, path);
	this->m_Wing3MixRate[3] = GetPrivateProfileInt(section, "Wing3MixRate_AL3", -1, path);

	this->m_Wing4MixRate[0] = GetPrivateProfileInt(section, "Wing4MixRate_AL0", -1, path);
	this->m_Wing4MixRate[1] = GetPrivateProfileInt(section, "Wing4MixRate_AL1", -1, path);
	this->m_Wing4MixRate[2] = GetPrivateProfileInt(section, "Wing4MixRate_AL2", -1, path);
	this->m_Wing4MixRate[3] = GetPrivateProfileInt(section, "Wing4MixRate_AL3", -1, path);

	this->m_SocketItemCreateSeedMixRate[0] = GetPrivateProfileInt(section, "SocketItemCreateSeedMixRate_AL0", 0, path);
	this->m_SocketItemCreateSeedMixRate[1] = GetPrivateProfileInt(section, "SocketItemCreateSeedMixRate_AL1", 0, path);
	this->m_SocketItemCreateSeedMixRate[2] = GetPrivateProfileInt(section, "SocketItemCreateSeedMixRate_AL2", 0, path);
	this->m_SocketItemCreateSeedMixRate[3] = GetPrivateProfileInt(section, "SocketItemCreateSeedMixRate_AL3", 0, path);

	this->m_SocketItemCreateSeedSphereMixRate[0] = GetPrivateProfileInt(section, "SocketItemCreateSeedSphereMixRate_AL0", 0, path);
	this->m_SocketItemCreateSeedSphereMixRate[1] = GetPrivateProfileInt(section, "SocketItemCreateSeedSphereMixRate_AL1", 0, path);
	this->m_SocketItemCreateSeedSphereMixRate[2] = GetPrivateProfileInt(section, "SocketItemCreateSeedSphereMixRate_AL2", 0, path);
	this->m_SocketItemCreateSeedSphereMixRate[3] = GetPrivateProfileInt(section, "SocketItemCreateSeedSphereMixRate_AL3", 0, path);

	this->m_SummonScrollMixRate1[0] = GetPrivateProfileInt(section, "SummonScrollMixRate1_AL0", 0, path);
	this->m_SummonScrollMixRate1[1] = GetPrivateProfileInt(section, "SummonScrollMixRate1_AL1", 0, path);
	this->m_SummonScrollMixRate1[2] = GetPrivateProfileInt(section, "SummonScrollMixRate1_AL2", 0, path);
	this->m_SummonScrollMixRate1[3] = GetPrivateProfileInt(section, "SummonScrollMixRate1_AL3", 0, path);
	this->m_SummonScrollMixRate2[0] = GetPrivateProfileInt(section, "SummonScrollMixRate2_AL0", 0, path);
	this->m_SummonScrollMixRate2[1] = GetPrivateProfileInt(section, "SummonScrollMixRate2_AL1", 0, path);
	this->m_SummonScrollMixRate2[2] = GetPrivateProfileInt(section, "SummonScrollMixRate2_AL2", 0, path);
	this->m_SummonScrollMixRate2[3] = GetPrivateProfileInt(section, "SummonScrollMixRate2_AL3", 0, path);
	this->m_SummonScrollMixRate3[0] = GetPrivateProfileInt(section, "SummonScrollMixRate3_AL0", 0, path);
	this->m_SummonScrollMixRate3[1] = GetPrivateProfileInt(section, "SummonScrollMixRate3_AL1", 0, path);
	this->m_SummonScrollMixRate3[2] = GetPrivateProfileInt(section, "SummonScrollMixRate3_AL2", 0, path);
	this->m_SummonScrollMixRate3[3] = GetPrivateProfileInt(section, "SummonScrollMixRate3_AL3", 0, path);

	this->m_LuckyItemRefineMixRate1[0] = GetPrivateProfileInt(section, "LuckyItemRefineMixRate1_AL0", 0, path);
	this->m_LuckyItemRefineMixRate1[1] = GetPrivateProfileInt(section, "LuckyItemRefineMixRate1_AL1", 0, path);
	this->m_LuckyItemRefineMixRate1[2] = GetPrivateProfileInt(section, "LuckyItemRefineMixRate1_AL2", 0, path);
	this->m_LuckyItemRefineMixRate1[3] = GetPrivateProfileInt(section, "LuckyItemRefineMixRate1_AL3", 0, path);
	this->m_LuckyItemRefineMixRate2[0] = GetPrivateProfileInt(section, "LuckyItemRefineMixRate2_AL0", 0, path);
	this->m_LuckyItemRefineMixRate2[1] = GetPrivateProfileInt(section, "LuckyItemRefineMixRate2_AL1", 0, path);
	this->m_LuckyItemRefineMixRate2[2] = GetPrivateProfileInt(section, "LuckyItemRefineMixRate2_AL2", 0, path);
	this->m_LuckyItemRefineMixRate2[3] = GetPrivateProfileInt(section, "LuckyItemRefineMixRate2_AL3", 0, path);

	this->m_MonsterWingMixRate[0] = GetPrivateProfileInt(section, "MonsterWingMixRate_AL0", 0, path);
	this->m_MonsterWingMixRate[1] = GetPrivateProfileInt(section, "MonsterWingMixRate_AL1", 0, path);
	this->m_MonsterWingMixRate[2] = GetPrivateProfileInt(section, "MonsterWingMixRate_AL2", 0, path);
	this->m_MonsterWingMixRate[3] = GetPrivateProfileInt(section, "MonsterWingMixRate_AL3", 0, path);

	this->m_SocketWeaponMixRate[0] = GetPrivateProfileInt(section, "SocketWeaponMixRate_AL0", 0, path);
	this->m_SocketWeaponMixRate[1] = GetPrivateProfileInt(section, "SocketWeaponMixRate_AL1", 0, path);
	this->m_SocketWeaponMixRate[2] = GetPrivateProfileInt(section, "SocketWeaponMixRate_AL2", 0, path);
	this->m_SocketWeaponMixRate[3] = GetPrivateProfileInt(section, "SocketWeaponMixRate_AL3", 0, path);

	this->m_PentagramMithrilMixRate[0] = GetPrivateProfileInt(section, "PentagramMithrilMixRate_AL0", 0, path);
	this->m_PentagramMithrilMixRate[1] = GetPrivateProfileInt(section, "PentagramMithrilMixRate_AL1", 0, path);
	this->m_PentagramMithrilMixRate[2] = GetPrivateProfileInt(section, "PentagramMithrilMixRate_AL2", 0, path);
	this->m_PentagramMithrilMixRate[3] = GetPrivateProfileInt(section, "PentagramMithrilMixRate_AL3", 0, path);

	this->m_PentagramElixirMixRate[0] = GetPrivateProfileInt(section, "PentagramElixirMixRate_AL0", 0, path);
	this->m_PentagramElixirMixRate[1] = GetPrivateProfileInt(section, "PentagramElixirMixRate_AL1", 0, path);
	this->m_PentagramElixirMixRate[2] = GetPrivateProfileInt(section, "PentagramElixirMixRate_AL2", 0, path);
	this->m_PentagramElixirMixRate[3] = GetPrivateProfileInt(section, "PentagramElixirMixRate_AL3", 0, path);

	this->m_PentagramJewelMixRate[0] = GetPrivateProfileInt(section, "PentagramJewelMixRate_AL0", 0, path);
	this->m_PentagramJewelMixRate[1] = GetPrivateProfileInt(section, "PentagramJewelMixRate_AL1", 0, path);
	this->m_PentagramJewelMixRate[2] = GetPrivateProfileInt(section, "PentagramJewelMixRate_AL2", 0, path);
	this->m_PentagramJewelMixRate[3] = GetPrivateProfileInt(section, "PentagramJewelMixRate_AL3", 0, path);

	this->m_PentagramDecompositeMixRate[0] = GetPrivateProfileInt(section, "PentagramDecompositeMixRate_AL0", 0, path);
	this->m_PentagramDecompositeMixRate[1] = GetPrivateProfileInt(section, "PentagramDecompositeMixRate_AL1", 0, path);
	this->m_PentagramDecompositeMixRate[2] = GetPrivateProfileInt(section, "PentagramDecompositeMixRate_AL2", 0, path);
	this->m_PentagramDecompositeMixRate[3] = GetPrivateProfileInt(section, "PentagramDecompositeMixRate_AL3", 0, path);
}

void CServerInfo::ReadCharacterInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	this->m_CriticalDamageRate = GetPrivateProfileInt(section, "CriticalDamageRate", 0, path);
	this->m_ExcellentDamageRate = GetPrivateProfileInt(section, "ExcellentDamageRate", 0, path);
	this->m_DamageReflect = GetPrivateProfileInt(section, "DamageReflect", 0, path);
	this->m_DamageReduction = GetPrivateProfileInt(section, "DamageReduction", 0, path);
	this->m_ShieldDamageReduction = GetPrivateProfileInt(section, "ShieldDamageReduction", 0, path);

	this->m_DuelDamageRate = GetPrivateProfileInt(section, "DuelDamageRate", 0, path);
	this->m_GensDamageRate = GetPrivateProfileInt(section, "GensDamageRate", 0, path);
	this->m_CustomArenaDamageRate = GetPrivateProfileInt(section, "CustomArenaDamageRate", 100, path);
	this->m_ChaosCastleDamageRate = GetPrivateProfileInt(section, "ChaosCastleDamageRate", 100, path);
	this->m_IllusionTempleDamageRate = GetPrivateProfileInt(section, "IllusionTempleDamageRate", 100, path);
	this->m_CastleSiegeDamageRate = GetPrivateProfileInt(section, "CastleSiegeDamageRate", 100, path);
	this->m_MUFCDamageRate = GetPrivateProfileInt(section, "MUFCDamageRate", 80, path);
	this->m_GeneralDamageRatePvP = GetPrivateProfileInt(section, "GeneralDamageRatePvP", 1000, path);
	this->m_GeneralDamageRatePvM = GetPrivateProfileInt(section, "GeneralDamageRatePvM", 100, path);
	this->m_ReflectDamageRatePvP = GetPrivateProfileInt(section, "ReflectDamageRatePvP", 100, path);
	this->m_CastleSiegeReflectRatePvP = GetPrivateProfileInt(section, "CastleSiegeReflectRate", 100, path);
	this->m_ReflectDamageRatePvM = GetPrivateProfileInt(section, "ReflectDamageRatePvM", 100, path);

	this->m_DamageRateByDistance[0] = GetPrivateProfileInt(section, "DamageRateByDistance0", 0, path);
	this->m_DamageRateByDistance[1] = GetPrivateProfileInt(section, "DamageRateByDistance1", 0, path);
	this->m_DamageRateByDistance[2] = GetPrivateProfileInt(section, "DamageRateByDistance2", 0, path);
	this->m_DamageRateByDistance[3] = GetPrivateProfileInt(section, "DamageRateByDistance3", 0, path);
	this->m_DamageRateByDistance[4] = GetPrivateProfileInt(section, "DamageRateByDistance4", 0, path);
	this->m_DamageRateByDistance[5] = GetPrivateProfileInt(section, "DamageRateByDistance5", 0, path);
	this->m_DamageRateByDistance[6] = GetPrivateProfileInt(section, "DamageRateByDistance6", 0, path);
	this->m_DamageRateByDistance[7] = GetPrivateProfileInt(section, "DamageRateByDistance7", 0, path);
	this->m_DamageRateByDistance[8] = GetPrivateProfileInt(section, "DamageRateByDistance8", 0, path);
	this->m_DamageRateByDistance[9] = GetPrivateProfileInt(section, "DamageRateByDistance9", 0, path);
	this->m_DamageRateByDistance[10] = GetPrivateProfileInt(section, "DamageRateByDistance10", 0, path);
	this->m_DamageRateByDistance[11] = GetPrivateProfileInt(section, "DamageRateByDistance11", 0, path);
	this->m_DamageRateByDistance[12] = GetPrivateProfileInt(section, "DamageRateByDistance12", 0, path);

	this->m_DamageRatePvP[0] = GetPrivateProfileInt(section, "DWDamageRatePvP", 100, path);
	this->m_DamageRatePvP[1] = GetPrivateProfileInt(section, "DKDamageRatePvP", 100, path);
	this->m_DamageRatePvP[2] = GetPrivateProfileInt(section, "FEDamageRatePvP", 100, path);
	this->m_DamageRatePvP[3] = GetPrivateProfileInt(section, "MGDamageRatePvP", 100, path);
	this->m_DamageRatePvP[4] = GetPrivateProfileInt(section, "DLDamageRatePvP", 100, path);
	this->m_DamageRatePvP[5] = GetPrivateProfileInt(section, "SUDamageRatePvP", 100, path);
	this->m_DamageRatePvP[6] = GetPrivateProfileInt(section, "RFDamageRatePvP", 100, path);
	this->m_DamageRatePvP[7] = GetPrivateProfileInt(section, "GLDamageRatePvP", 100, path);

	this->m_DamageRatePvM[0] = GetPrivateProfileInt(section, "DWDamageRatePvM", 100, path);
	this->m_DamageRatePvM[1] = GetPrivateProfileInt(section, "DKDamageRatePvM", 100, path);
	this->m_DamageRatePvM[2] = GetPrivateProfileInt(section, "FEDamageRatePvM", 100, path);
	this->m_DamageRatePvM[3] = GetPrivateProfileInt(section, "MGDamageRatePvM", 100, path);
	this->m_DamageRatePvM[4] = GetPrivateProfileInt(section, "DLDamageRatePvM", 100, path);
	this->m_DamageRatePvM[5] = GetPrivateProfileInt(section, "SUDamageRatePvM", 100, path);
	this->m_DamageRatePvM[6] = GetPrivateProfileInt(section, "RFDamageRatePvM", 100, path);
	this->m_DamageRatePvM[7] = GetPrivateProfileInt(section, "GLDamageRatePvM", 100, path);

	this->m_DamageRateTo[0][0] = GetPrivateProfileInt(section, "DWDamageRateToDW", 0, path);
	this->m_DamageRateTo[0][1] = GetPrivateProfileInt(section, "DWDamageRateToDK", 0, path);
	this->m_DamageRateTo[0][2] = GetPrivateProfileInt(section, "DWDamageRateToFE", 0, path);
	this->m_DamageRateTo[0][3] = GetPrivateProfileInt(section, "DWDamageRateToMG", 0, path);
	this->m_DamageRateTo[0][4] = GetPrivateProfileInt(section, "DWDamageRateToDL", 0, path);
	this->m_DamageRateTo[0][5] = GetPrivateProfileInt(section, "DWDamageRateToSU", 0, path);
	this->m_DamageRateTo[0][6] = GetPrivateProfileInt(section, "DWDamageRateToRF", 0, path);
	this->m_DamageRateTo[0][7] = GetPrivateProfileInt(section, "DWDamageRateToGL", 0, path);
	this->m_DamageRateTo[1][0] = GetPrivateProfileInt(section, "DKDamageRateToDW", 0, path);
	this->m_DamageRateTo[1][1] = GetPrivateProfileInt(section, "DKDamageRateToDK", 0, path);
	this->m_DamageRateTo[1][2] = GetPrivateProfileInt(section, "DKDamageRateToFE", 0, path);
	this->m_DamageRateTo[1][3] = GetPrivateProfileInt(section, "DKDamageRateToMG", 0, path);
	this->m_DamageRateTo[1][4] = GetPrivateProfileInt(section, "DKDamageRateToDL", 0, path);
	this->m_DamageRateTo[1][5] = GetPrivateProfileInt(section, "DKDamageRateToSU", 0, path);
	this->m_DamageRateTo[1][6] = GetPrivateProfileInt(section, "DKDamageRateToRF", 0, path);
	this->m_DamageRateTo[1][7] = GetPrivateProfileInt(section, "DKDamageRateToGL", 0, path);
	this->m_DamageRateTo[2][0] = GetPrivateProfileInt(section, "FEDamageRateToDW", 0, path);
	this->m_DamageRateTo[2][1] = GetPrivateProfileInt(section, "FEDamageRateToDK", 0, path);
	this->m_DamageRateTo[2][2] = GetPrivateProfileInt(section, "FEDamageRateToFE", 0, path);
	this->m_DamageRateTo[2][3] = GetPrivateProfileInt(section, "FEDamageRateToMG", 0, path);
	this->m_DamageRateTo[2][4] = GetPrivateProfileInt(section, "FEDamageRateToDL", 0, path);
	this->m_DamageRateTo[2][5] = GetPrivateProfileInt(section, "FEDamageRateToSU", 0, path);
	this->m_DamageRateTo[2][6] = GetPrivateProfileInt(section, "FEDamageRateToRF", 0, path);
	this->m_DamageRateTo[2][7] = GetPrivateProfileInt(section, "FEDamageRateToGL", 0, path);
	this->m_DamageRateTo[3][0] = GetPrivateProfileInt(section, "MGDamageRateToDW", 0, path);
	this->m_DamageRateTo[3][1] = GetPrivateProfileInt(section, "MGDamageRateToDK", 0, path);
	this->m_DamageRateTo[3][2] = GetPrivateProfileInt(section, "MGDamageRateToFE", 0, path);
	this->m_DamageRateTo[3][3] = GetPrivateProfileInt(section, "MGDamageRateToMG", 0, path);
	this->m_DamageRateTo[3][4] = GetPrivateProfileInt(section, "MGDamageRateToDL", 0, path);
	this->m_DamageRateTo[3][5] = GetPrivateProfileInt(section, "MGDamageRateToSU", 0, path);
	this->m_DamageRateTo[3][6] = GetPrivateProfileInt(section, "MGDamageRateToRF", 0, path);
	this->m_DamageRateTo[3][7] = GetPrivateProfileInt(section, "MGDamageRateToGL", 0, path);
	this->m_DamageRateTo[4][0] = GetPrivateProfileInt(section, "DLDamageRateToDW", 0, path);
	this->m_DamageRateTo[4][1] = GetPrivateProfileInt(section, "DLDamageRateToDK", 0, path);
	this->m_DamageRateTo[4][2] = GetPrivateProfileInt(section, "DLDamageRateToFE", 0, path);
	this->m_DamageRateTo[4][3] = GetPrivateProfileInt(section, "DLDamageRateToMG", 0, path);
	this->m_DamageRateTo[4][4] = GetPrivateProfileInt(section, "DLDamageRateToDL", 0, path);
	this->m_DamageRateTo[4][5] = GetPrivateProfileInt(section, "DLDamageRateToSU", 0, path);
	this->m_DamageRateTo[4][6] = GetPrivateProfileInt(section, "DLDamageRateToRF", 0, path);
	this->m_DamageRateTo[4][7] = GetPrivateProfileInt(section, "DLDamageRateToGL", 0, path);
	this->m_DamageRateTo[5][0] = GetPrivateProfileInt(section, "SUDamageRateToDW", 0, path);
	this->m_DamageRateTo[5][1] = GetPrivateProfileInt(section, "SUDamageRateToDK", 0, path);
	this->m_DamageRateTo[5][2] = GetPrivateProfileInt(section, "SUDamageRateToFE", 0, path);
	this->m_DamageRateTo[5][3] = GetPrivateProfileInt(section, "SUDamageRateToMG", 0, path);
	this->m_DamageRateTo[5][4] = GetPrivateProfileInt(section, "SUDamageRateToDL", 0, path);
	this->m_DamageRateTo[5][5] = GetPrivateProfileInt(section, "SUDamageRateToSU", 0, path);
	this->m_DamageRateTo[5][6] = GetPrivateProfileInt(section, "SUDamageRateToRF", 0, path);
	this->m_DamageRateTo[5][7] = GetPrivateProfileInt(section, "SUDamageRateToGL", 0, path);
	this->m_DamageRateTo[6][0] = GetPrivateProfileInt(section, "RFDamageRateToDW", 0, path);
	this->m_DamageRateTo[6][1] = GetPrivateProfileInt(section, "RFDamageRateToDK", 0, path);
	this->m_DamageRateTo[6][2] = GetPrivateProfileInt(section, "RFDamageRateToFE", 0, path);
	this->m_DamageRateTo[6][3] = GetPrivateProfileInt(section, "RFDamageRateToMG", 0, path);
	this->m_DamageRateTo[6][4] = GetPrivateProfileInt(section, "RFDamageRateToDL", 0, path);
	this->m_DamageRateTo[6][5] = GetPrivateProfileInt(section, "RFDamageRateToSU", 0, path);
	this->m_DamageRateTo[6][6] = GetPrivateProfileInt(section, "RFDamageRateToRF", 0, path);
	this->m_DamageRateTo[6][7] = GetPrivateProfileInt(section, "RFDamageRateToGL", 0, path);
	this->m_DamageRateTo[7][0] = GetPrivateProfileInt(section, "GLDamageRateToDW", 0, path);
	this->m_DamageRateTo[7][1] = GetPrivateProfileInt(section, "GLDamageRateToDK", 0, path);
	this->m_DamageRateTo[7][2] = GetPrivateProfileInt(section, "GLDamageRateToFE", 0, path);
	this->m_DamageRateTo[7][3] = GetPrivateProfileInt(section, "GLDamageRateToMG", 0, path);
	this->m_DamageRateTo[7][4] = GetPrivateProfileInt(section, "GLDamageRateToDL", 0, path);
	this->m_DamageRateTo[7][5] = GetPrivateProfileInt(section, "GLDamageRateToSU", 0, path);
	this->m_DamageRateTo[7][6] = GetPrivateProfileInt(section, "GLDamageRateToRF", 0, path);
	this->m_DamageRateTo[7][7] = GetPrivateProfileInt(section, "GLDamageRateToGL", 0, path);

	this->m_X_DamageRateTo[0][0] = GetPrivateProfileInt(section, "X_DWDamageRateToDW", 0, path);
	this->m_X_DamageRateTo[0][1] = GetPrivateProfileInt(section, "X_DWDamageRateToDK", 0, path);
	this->m_X_DamageRateTo[0][2] = GetPrivateProfileInt(section, "X_DWDamageRateToFE", 0, path);
	this->m_X_DamageRateTo[0][3] = GetPrivateProfileInt(section, "X_DWDamageRateToMG", 0, path);
	this->m_X_DamageRateTo[0][4] = GetPrivateProfileInt(section, "X_DWDamageRateToDL", 0, path);
	this->m_X_DamageRateTo[0][5] = GetPrivateProfileInt(section, "X_DWDamageRateToSU", 0, path);
	this->m_X_DamageRateTo[0][6] = GetPrivateProfileInt(section, "X_DWDamageRateToRF", 0, path);
	this->m_X_DamageRateTo[0][7] = GetPrivateProfileInt(section, "X_DWDamageRateToGL", 0, path);
	this->m_X_DamageRateTo[1][0] = GetPrivateProfileInt(section, "X_DKDamageRateToDW", 0, path);
	this->m_X_DamageRateTo[1][1] = GetPrivateProfileInt(section, "X_DKDamageRateToDK", 0, path);
	this->m_X_DamageRateTo[1][2] = GetPrivateProfileInt(section, "X_DKDamageRateToFE", 0, path);
	this->m_X_DamageRateTo[1][3] = GetPrivateProfileInt(section, "X_DKDamageRateToMG", 0, path);
	this->m_X_DamageRateTo[1][4] = GetPrivateProfileInt(section, "X_DKDamageRateToDL", 0, path);
	this->m_X_DamageRateTo[1][5] = GetPrivateProfileInt(section, "X_DKDamageRateToSU", 0, path);
	this->m_X_DamageRateTo[1][6] = GetPrivateProfileInt(section, "X_DKDamageRateToRF", 0, path);
	this->m_X_DamageRateTo[1][7] = GetPrivateProfileInt(section, "X_DKDamageRateToGL", 0, path);
	this->m_X_DamageRateTo[2][0] = GetPrivateProfileInt(section, "X_FEDamageRateToDW", 0, path);
	this->m_X_DamageRateTo[2][1] = GetPrivateProfileInt(section, "X_FEDamageRateToDK", 0, path);
	this->m_X_DamageRateTo[2][2] = GetPrivateProfileInt(section, "X_FEDamageRateToFE", 0, path);
	this->m_X_DamageRateTo[2][3] = GetPrivateProfileInt(section, "X_FEDamageRateToMG", 0, path);
	this->m_X_DamageRateTo[2][4] = GetPrivateProfileInt(section, "X_FEDamageRateToDL", 0, path);
	this->m_X_DamageRateTo[2][5] = GetPrivateProfileInt(section, "X_FEDamageRateToSU", 0, path);
	this->m_X_DamageRateTo[2][6] = GetPrivateProfileInt(section, "X_FEDamageRateToRF", 0, path);
	this->m_X_DamageRateTo[2][7] = GetPrivateProfileInt(section, "X_FEDamageRateToGL", 0, path);
	this->m_X_DamageRateTo[3][0] = GetPrivateProfileInt(section, "X_MGDamageRateToDW", 0, path);
	this->m_X_DamageRateTo[3][1] = GetPrivateProfileInt(section, "X_MGDamageRateToDK", 0, path);
	this->m_X_DamageRateTo[3][2] = GetPrivateProfileInt(section, "X_MGDamageRateToFE", 0, path);
	this->m_X_DamageRateTo[3][3] = GetPrivateProfileInt(section, "X_MGDamageRateToMG", 0, path);
	this->m_X_DamageRateTo[3][4] = GetPrivateProfileInt(section, "X_MGDamageRateToDL", 0, path);
	this->m_X_DamageRateTo[3][5] = GetPrivateProfileInt(section, "X_MGDamageRateToSU", 0, path);
	this->m_X_DamageRateTo[3][6] = GetPrivateProfileInt(section, "X_MGDamageRateToRF", 0, path);
	this->m_X_DamageRateTo[3][7] = GetPrivateProfileInt(section, "X_MGDamageRateToGL", 0, path);
	this->m_X_DamageRateTo[4][0] = GetPrivateProfileInt(section, "X_DLDamageRateToDW", 0, path);
	this->m_X_DamageRateTo[4][1] = GetPrivateProfileInt(section, "X_DLDamageRateToDK", 0, path);
	this->m_X_DamageRateTo[4][2] = GetPrivateProfileInt(section, "X_DLDamageRateToFE", 0, path);
	this->m_X_DamageRateTo[4][3] = GetPrivateProfileInt(section, "X_DLDamageRateToMG", 0, path);
	this->m_X_DamageRateTo[4][4] = GetPrivateProfileInt(section, "X_DLDamageRateToDL", 0, path);
	this->m_X_DamageRateTo[4][5] = GetPrivateProfileInt(section, "X_DLDamageRateToSU", 0, path);
	this->m_X_DamageRateTo[4][6] = GetPrivateProfileInt(section, "X_DLDamageRateToRF", 0, path);
	this->m_X_DamageRateTo[4][7] = GetPrivateProfileInt(section, "X_DLDamageRateToGL", 0, path);
	this->m_X_DamageRateTo[5][0] = GetPrivateProfileInt(section, "X_SUDamageRateToDW", 0, path);
	this->m_X_DamageRateTo[5][1] = GetPrivateProfileInt(section, "X_SUDamageRateToDK", 0, path);
	this->m_X_DamageRateTo[5][2] = GetPrivateProfileInt(section, "X_SUDamageRateToFE", 0, path);
	this->m_X_DamageRateTo[5][3] = GetPrivateProfileInt(section, "X_SUDamageRateToMG", 0, path);
	this->m_X_DamageRateTo[5][4] = GetPrivateProfileInt(section, "X_SUDamageRateToDL", 0, path);
	this->m_X_DamageRateTo[5][5] = GetPrivateProfileInt(section, "X_SUDamageRateToSU", 0, path);
	this->m_X_DamageRateTo[5][6] = GetPrivateProfileInt(section, "X_SUDamageRateToRF", 0, path);
	this->m_X_DamageRateTo[5][7] = GetPrivateProfileInt(section, "X_SUDamageRateToGL", 0, path);
	this->m_X_DamageRateTo[6][0] = GetPrivateProfileInt(section, "X_RFDamageRateToDW", 0, path);
	this->m_X_DamageRateTo[6][1] = GetPrivateProfileInt(section, "X_RFDamageRateToDK", 0, path);
	this->m_X_DamageRateTo[6][2] = GetPrivateProfileInt(section, "X_RFDamageRateToFE", 0, path);
	this->m_X_DamageRateTo[6][3] = GetPrivateProfileInt(section, "X_RFDamageRateToMG", 0, path);
	this->m_X_DamageRateTo[6][4] = GetPrivateProfileInt(section, "X_RFDamageRateToDL", 0, path);
	this->m_X_DamageRateTo[6][5] = GetPrivateProfileInt(section, "X_RFDamageRateToSU", 0, path);
	this->m_X_DamageRateTo[6][6] = GetPrivateProfileInt(section, "X_RFDamageRateToRF", 0, path);
	this->m_X_DamageRateTo[6][7] = GetPrivateProfileInt(section, "X_RFDamageRateToGL", 0, path);
	this->m_X_DamageRateTo[7][0] = GetPrivateProfileInt(section, "X_GLDamageRateToDW", 0, path);
	this->m_X_DamageRateTo[7][1] = GetPrivateProfileInt(section, "X_GLDamageRateToDK", 0, path);
	this->m_X_DamageRateTo[7][2] = GetPrivateProfileInt(section, "X_GLDamageRateToFE", 0, path);
	this->m_X_DamageRateTo[7][3] = GetPrivateProfileInt(section, "X_GLDamageRateToMG", 0, path);
	this->m_X_DamageRateTo[7][4] = GetPrivateProfileInt(section, "X_GLDamageRateToDL", 0, path);
	this->m_X_DamageRateTo[7][5] = GetPrivateProfileInt(section, "X_GLDamageRateToSU", 0, path);
	this->m_X_DamageRateTo[7][6] = GetPrivateProfileInt(section, "X_GLDamageRateToRF", 0, path);
	this->m_X_DamageRateTo[7][7] = GetPrivateProfileInt(section, "X_GLDamageRateToGL", 0, path);

	/*this->m_DamageStuckRate[0] = GetPrivateProfileInt(section, "DWDamageStuckRate", 0, path);
	this->m_DamageStuckRate[1] = GetPrivateProfileInt(section, "DKDamageStuckRate", 0, path);
	this->m_DamageStuckRate[2] = GetPrivateProfileInt(section, "FEDamageStuckRate", 0, path);
	this->m_DamageStuckRate[3] = GetPrivateProfileInt(section, "MGDamageStuckRate", 0, path);
	this->m_DamageStuckRate[4] = GetPrivateProfileInt(section, "DLDamageStuckRate", 0, path);
	this->m_DamageStuckRate[5] = GetPrivateProfileInt(section, "SUDamageStuckRate", 0, path);
	this->m_DamageStuckRate[6] = GetPrivateProfileInt(section, "RFDamageStuckRate", 0, path);
	this->m_DamageStuckRate[7] = GetPrivateProfileInt(section, "GLDamageStuckRate", 0, path);*/

	this->m_DKDamageMultiplierConstA = GetPrivateProfileInt(section, "DKDamageMultiplierConstA", 0, path);
	this->m_DLDamageMultiplierConstA = GetPrivateProfileInt(section, "DLDamageMultiplierConstA", 0, path);
	this->m_RFDamageMultiplierConstA = GetPrivateProfileInt(section, "RFDamageMultiplierConstA", 0, path);
	this->m_RFDamageMultiplierConstB = GetPrivateProfileInt(section, "RFDamageMultiplierConstB", 0, path);
	this->m_RFDamageMultiplierConstC = GetPrivateProfileInt(section, "RFDamageMultiplierConstC", 0, path);
	this->m_FKDamageMultiplierConstA = GetPrivateProfileInt(section, "GLDamageMultiplierConstA", 0, path);
	this->m_FKDamageMultiplierConstB = GetPrivateProfileInt(section, "GLDamageMultiplierConstB", 0, path);
	this->m_FKDamageMultiplierMaxRate = GetPrivateProfileInt(section, "GLDamageMultiplierMaxRate", 0, path);
	this->m_DKDamageMultiplierMaxRate = GetPrivateProfileInt(section, "DKDamageMultiplierMaxRate", 0, path);
	this->m_DLDamageMultiplierMaxRate = GetPrivateProfileInt(section, "DLDamageMultiplierMaxRate", 0, path);
	this->m_RFDamageMultiplierMaxRate = GetPrivateProfileInt(section, "RFDamageMultiplierMaxRate", 0, path);

	this->m_DarkSpiritRangeAttackRate = GetPrivateProfileInt(section, "DarkSpiritRangeAttackRate", 0, path);
	this->m_DarkSpiritCriticalDamageRate = GetPrivateProfileInt(section, "DarkSpiritCriticalDamageRate", 0, path);
	this->m_DarkSpiritExcellentDamageRate = GetPrivateProfileInt(section, "DarkSpiritExcellentDamageRate", 0, path);
	this->m_DarkSpiritAttackDamageMinConstA = GetPrivateProfileInt(section, "DarkSpiritAttackDamageMinConstA", 0, path);
	this->m_DarkSpiritAttackDamageMinConstB = GetPrivateProfileInt(section, "DarkSpiritAttackDamageMinConstB", 0, path);
	this->m_DarkSpiritAttackDamageMinConstC = GetPrivateProfileInt(section, "DarkSpiritAttackDamageMinConstC", 0, path);
	this->m_DarkSpiritAttackDamageMaxConstA = GetPrivateProfileInt(section, "DarkSpiritAttackDamageMaxConstA", 0, path);
	this->m_DarkSpiritAttackDamageMaxConstB = GetPrivateProfileInt(section, "DarkSpiritAttackDamageMaxConstB", 0, path);
	this->m_DarkSpiritAttackDamageMaxConstC = GetPrivateProfileInt(section, "DarkSpiritAttackDamageMaxConstC", 0, path);
	this->m_DarkSpiritAttackSpeedConstA = GetPrivateProfileInt(section, "DarkSpiritAttackSpeedConstA", 0, path);
	this->m_DarkSpiritAttackSpeedConstB = GetPrivateProfileInt(section, "DarkSpiritAttackSpeedConstB", 0, path);
	this->m_DarkSpiritAttackSpeedConstC = GetPrivateProfileInt(section, "DarkSpiritAttackSpeedConstC", 0, path);
	this->m_DarkSpiritAttackSpeedConstD = GetPrivateProfileInt(section, "DarkSpiritAttackSpeedConstD", 0, path);
	this->m_DarkSpiritAttackSuccessRateConstA = GetPrivateProfileInt(section, "DarkSpiritAttackSuccessRateConstA", 0, path);
	this->m_DarkSpiritAttackSuccessRateConstB = GetPrivateProfileInt(section, "DarkSpiritAttackSuccessRateConstB", 0, path);
	this->m_DarkSpiritAttackSuccessRateConstC = GetPrivateProfileInt(section, "DarkSpiritAttackSuccessRateConstC", 0, path);

	this->m_SatanIncDamageConstA = GetPrivateProfileInt(section, "SatanIncDamageConstA", 0, path);
	this->m_DinorantIncDamageConstA = GetPrivateProfileInt(section, "DinorantIncDamageConstA", 0, path);
	this->m_BlackFenrirIncDamageConstA = GetPrivateProfileInt(section, "BlackFenrirIncDamageConstA", 0, path);
	this->m_DemonIncDamageConstA = GetPrivateProfileInt(section, "DemonIncDamageConstA", 0, path);
	this->m_SkeletonIncDamageConstA = GetPrivateProfileInt(section, "SkeletonIncDamageConstA", 0, path);
	this->m_AngelDecDamageConstA = GetPrivateProfileInt(section, "AngelDecDamageConstA", 0, path);
	this->m_DinorantDecDamageConstA = GetPrivateProfileInt(section, "DinorantDecDamageConstA", 0, path);
	this->m_DinorantDecDamageConstB = GetPrivateProfileInt(section, "DinorantDecDamageConstB", 0, path);
	this->m_DarkHorseDecDamageConstA = GetPrivateProfileInt(section, "DarkHorseDecDamageConstA", 0, path);
	this->m_DarkHorseDecDamageConstB = GetPrivateProfileInt(section, "DarkHorseDecDamageConstB", 0, path);
	this->m_BlueFenrirDecDamageConstA = GetPrivateProfileInt(section, "BlueFenrirDecDamageConstA", 0, path);
	this->m_MariaDecDamageConstA = GetPrivateProfileInt(section, "MariaDecDamageConstA", 0, path);

	this->m_ComboDamageConstA = GetPrivateProfileInt(section, "ComboDamageConstA", 0, path);
	this->m_ComboDamageConstB = GetPrivateProfileInt(section, "ComboDamageConstB", 0, path);

	this->m_EarthquakeDamageConstA = GetPrivateProfileInt(section, "EarthquakeDamageConstA", 0, path);
	this->m_EarthquakeDamageConstB = GetPrivateProfileInt(section, "EarthquakeDamageConstB", 0, path);
	this->m_EarthquakeDamageConstC = GetPrivateProfileInt(section, "EarthquakeDamageConstC", 0, path);

	this->m_ElectricSparkDamageConstA = GetPrivateProfileInt(section, "ElectricSparkDamageConstA", 0, path);
	this->m_ElectricSparkDamageConstB = GetPrivateProfileInt(section, "ElectricSparkDamageConstB", 0, path);

	this->m_DLSkillDamageConstA = GetPrivateProfileInt(section, "DLSkillDamageConstA", 0, path);
	this->m_DLSkillDamageConstB = GetPrivateProfileInt(section, "DLSkillDamageConstB", 0, path);

	this->m_NovaDamageConstA = GetPrivateProfileInt(section, "NovaDamageConstA", 0, path);
	this->m_NovaDamageConstB = GetPrivateProfileInt(section, "NovaDamageConstB", 0, path);
	this->m_NovaDamageConstC = GetPrivateProfileInt(section, "NovaDamageConstC", 0, path);

	this->m_HPRecoveryRate[0] = GetPrivateProfileInt(section, "DWHPRecoveryRate", 0, path);
	this->m_HPRecoveryRate[1] = GetPrivateProfileInt(section, "DKHPRecoveryRate", 0, path);
	this->m_HPRecoveryRate[2] = GetPrivateProfileInt(section, "FEHPRecoveryRate", 0, path);
	this->m_HPRecoveryRate[3] = GetPrivateProfileInt(section, "MGHPRecoveryRate", 0, path);
	this->m_HPRecoveryRate[4] = GetPrivateProfileInt(section, "DLHPRecoveryRate", 0, path);
	this->m_HPRecoveryRate[5] = GetPrivateProfileInt(section, "SUHPRecoveryRate", 0, path);
	this->m_HPRecoveryRate[6] = GetPrivateProfileInt(section, "RFHPRecoveryRate", 0, path);
	this->m_HPRecoveryRate[7] = GetPrivateProfileInt(section, "GLHPRecoveryRate", 0, path);

	this->m_MPRecoveryRate[0] = GetPrivateProfileInt(section, "DWMPRecoveryRate", 0, path);
	this->m_MPRecoveryRate[1] = GetPrivateProfileInt(section, "DKMPRecoveryRate", 0, path);
	this->m_MPRecoveryRate[2] = GetPrivateProfileInt(section, "FEMPRecoveryRate", 0, path);
	this->m_MPRecoveryRate[3] = GetPrivateProfileInt(section, "MGMPRecoveryRate", 0, path);
	this->m_MPRecoveryRate[4] = GetPrivateProfileInt(section, "DLMPRecoveryRate", 0, path);
	this->m_MPRecoveryRate[5] = GetPrivateProfileInt(section, "SUMPRecoveryRate", 0, path);
	this->m_MPRecoveryRate[6] = GetPrivateProfileInt(section, "RFMPRecoveryRate", 0, path);
	this->m_MPRecoveryRate[7] = GetPrivateProfileInt(section, "GLMPRecoveryRate", 0, path);

	this->m_BPRecoveryRate[0] = GetPrivateProfileInt(section, "DWBPRecoveryRate", 0, path);
	this->m_BPRecoveryRate[1] = GetPrivateProfileInt(section, "DKBPRecoveryRate", 0, path);
	this->m_BPRecoveryRate[2] = GetPrivateProfileInt(section, "FEBPRecoveryRate", 0, path);
	this->m_BPRecoveryRate[3] = GetPrivateProfileInt(section, "MGBPRecoveryRate", 0, path);
	this->m_BPRecoveryRate[4] = GetPrivateProfileInt(section, "DLBPRecoveryRate", 0, path);
	this->m_BPRecoveryRate[5] = GetPrivateProfileInt(section, "SUBPRecoveryRate", 0, path);
	this->m_BPRecoveryRate[6] = GetPrivateProfileInt(section, "RFBPRecoveryRate", 0, path);
	this->m_BPRecoveryRate[7] = GetPrivateProfileInt(section, "GLBPRecoveryRate", 0, path);

	this->m_SDRecoveryRate[0] = GetPrivateProfileInt(section, "DWSDRecoveryRate", 0, path);
	this->m_SDRecoveryRate[1] = GetPrivateProfileInt(section, "DKSDRecoveryRate", 0, path);
	this->m_SDRecoveryRate[2] = GetPrivateProfileInt(section, "FESDRecoveryRate", 0, path);
	this->m_SDRecoveryRate[3] = GetPrivateProfileInt(section, "MGSDRecoveryRate", 0, path);
	this->m_SDRecoveryRate[4] = GetPrivateProfileInt(section, "DLSDRecoveryRate", 0, path);
	this->m_SDRecoveryRate[5] = GetPrivateProfileInt(section, "SUSDRecoveryRate", 0, path);
	this->m_SDRecoveryRate[6] = GetPrivateProfileInt(section, "RFSDRecoveryRate", 0, path);
	this->m_SDRecoveryRate[0] = GetPrivateProfileInt(section, "GLSDRecoveryRate", 0, path);

	this->m_DWPlasmaStormDamageConstA = GetPrivateProfileInt(section, "DWPlasmaStormDamageConstA", 0, path);
	this->m_DWPlasmaStormDamageConstB = GetPrivateProfileInt(section, "DWPlasmaStormDamageConstB", 0, path);
	this->m_DWPlasmaStormDamageConstC = GetPrivateProfileInt(section, "DWPlasmaStormDamageConstC", 0, path);
	this->m_DWPlasmaStormDamageConstD = GetPrivateProfileInt(section, "DWPlasmaStormDamageConstD", 0, path);

	this->m_DKPlasmaStormDamageConstA = GetPrivateProfileInt(section, "DKPlasmaStormDamageConstA", 0, path);
	this->m_DKPlasmaStormDamageConstB = GetPrivateProfileInt(section, "DKPlasmaStormDamageConstB", 0, path);
	this->m_DKPlasmaStormDamageConstC = GetPrivateProfileInt(section, "DKPlasmaStormDamageConstC", 0, path);
	this->m_DKPlasmaStormDamageConstD = GetPrivateProfileInt(section, "DKPlasmaStormDamageConstD", 0, path);

	this->m_FEPlasmaStormDamageConstA = GetPrivateProfileInt(section, "FEPlasmaStormDamageConstA", 0, path);
	this->m_FEPlasmaStormDamageConstB = GetPrivateProfileInt(section, "FEPlasmaStormDamageConstB", 0, path);
	this->m_FEPlasmaStormDamageConstC = GetPrivateProfileInt(section, "FEPlasmaStormDamageConstC", 0, path);
	this->m_FEPlasmaStormDamageConstD = GetPrivateProfileInt(section, "FEPlasmaStormDamageConstD", 0, path);

	this->m_MGPlasmaStormDamageConstA = GetPrivateProfileInt(section, "MGPlasmaStormDamageConstA", 0, path);
	this->m_MGPlasmaStormDamageConstB = GetPrivateProfileInt(section, "MGPlasmaStormDamageConstB", 0, path);
	this->m_MGPlasmaStormDamageConstC = GetPrivateProfileInt(section, "MGPlasmaStormDamageConstC", 0, path);
	this->m_MGPlasmaStormDamageConstD = GetPrivateProfileInt(section, "MGPlasmaStormDamageConstD", 0, path);

	this->m_DLPlasmaStormDamageConstA = GetPrivateProfileInt(section, "DLPlasmaStormDamageConstA", 0, path);
	this->m_DLPlasmaStormDamageConstB = GetPrivateProfileInt(section, "DLPlasmaStormDamageConstB", 0, path);
	this->m_DLPlasmaStormDamageConstC = GetPrivateProfileInt(section, "DLPlasmaStormDamageConstC", 0, path);
	this->m_DLPlasmaStormDamageConstD = GetPrivateProfileInt(section, "DLPlasmaStormDamageConstD", 0, path);
	this->m_DLPlasmaStormDamageConstE = GetPrivateProfileInt(section, "DLPlasmaStormDamageConstE", 0, path);

	this->m_SUPlasmaStormDamageConstA = GetPrivateProfileInt(section, "SUPlasmaStormDamageConstA", 0, path);
	this->m_SUPlasmaStormDamageConstB = GetPrivateProfileInt(section, "SUPlasmaStormDamageConstB", 0, path);
	this->m_SUPlasmaStormDamageConstC = GetPrivateProfileInt(section, "SUPlasmaStormDamageConstC", 0, path);
	this->m_SUPlasmaStormDamageConstD = GetPrivateProfileInt(section, "SUPlasmaStormDamageConstD", 0, path);

	this->m_RFPlasmaStormDamageConstA = GetPrivateProfileInt(section, "RFPlasmaStormDamageConstA", 0, path);
	this->m_RFPlasmaStormDamageConstB = GetPrivateProfileInt(section, "RFPlasmaStormDamageConstB", 0, path);
	this->m_RFPlasmaStormDamageConstC = GetPrivateProfileInt(section, "RFPlasmaStormDamageConstC", 0, path);
	this->m_RFPlasmaStormDamageConstD = GetPrivateProfileInt(section, "RFPlasmaStormDamageConstD", 0, path);

	this->m_FKPlasmaStormDamageConstA = GetPrivateProfileInt(section, "GLPlasmaStormDamageConstA", 0, path);
	this->m_FKPlasmaStormDamageConstB = GetPrivateProfileInt(section, "GLPlasmaStormDamageConstB", 0, path);
	this->m_FKPlasmaStormDamageConstC = GetPrivateProfileInt(section, "GLPlasmaStormDamageConstC", 0, path);
	this->m_FKPlasmaStormDamageConstD = GetPrivateProfileInt(section, "GLPlasmaStormDamageConstD", 0, path);

	this->m_DWPhysiDamageMinConstA = GetPrivateProfileInt(section, "DWPhysiDamageMinConstA", 0, path);
	this->m_DWPhysiDamageMaxConstA = GetPrivateProfileInt(section, "DWPhysiDamageMaxConstA", 0, path);
	this->m_DWMagicDamageMinConstA = GetPrivateProfileInt(section, "DWMagicDamageMinConstA", 0, path);
	this->m_DWMagicDamageMaxConstA = GetPrivateProfileInt(section, "DWMagicDamageMaxConstA", 0, path);

	this->m_DKPhysiDamageMinConstA = GetPrivateProfileInt(section, "DKPhysiDamageMinConstA", 0, path);
	this->m_DKPhysiDamageMaxConstA = GetPrivateProfileInt(section, "DKPhysiDamageMaxConstA", 0, path);
	this->m_DKMagicDamageMinConstA = GetPrivateProfileInt(section, "DKMagicDamageMinConstA", 0, path);
	this->m_DKMagicDamageMaxConstA = GetPrivateProfileInt(section, "DKMagicDamageMaxConstA", 0, path);

	this->m_FEPhysiDamageMinConstA = GetPrivateProfileInt(section, "FEPhysiDamageMinConstA", 0, path);
	this->m_FEPhysiDamageMaxConstA = GetPrivateProfileInt(section, "FEPhysiDamageMaxConstA", 0, path);

	this->m_FEPhysiDamageMinBowConstA = GetPrivateProfileInt(section, "FEPhysiDamageMinBowConstA", 0, path);
	this->m_FEPhysiDamageMinBowConstB = GetPrivateProfileInt(section, "FEPhysiDamageMinBowConstB", 0, path);
	this->m_FEPhysiDamageMaxBowConstA = GetPrivateProfileInt(section, "FEPhysiDamageMaxBowConstA", 0, path);
	this->m_FEPhysiDamageMaxBowConstB = GetPrivateProfileInt(section, "FEPhysiDamageMaxBowConstB", 0, path);
	this->m_FEMagicDamageMinConstA = GetPrivateProfileInt(section, "FEMagicDamageMinConstA", 0, path);
	this->m_FEMagicDamageMaxConstA = GetPrivateProfileInt(section, "FEMagicDamageMaxConstA", 0, path);

	this->m_MGPhysiDamageMinConstA = GetPrivateProfileInt(section, "MGPhysiDamageMinConstA", 0, path);
	this->m_MGPhysiDamageMinConstB = GetPrivateProfileInt(section, "MGPhysiDamageMinConstB", 0, path);
	this->m_MGPhysiDamageMaxConstA = GetPrivateProfileInt(section, "MGPhysiDamageMaxConstA", 0, path);
	this->m_MGPhysiDamageMaxConstB = GetPrivateProfileInt(section, "MGPhysiDamageMaxConstB", 0, path);
	this->m_MGMagicDamageMinConstA = GetPrivateProfileInt(section, "MGMagicDamageMinConstA", 0, path);
	this->m_MGMagicDamageMaxConstA = GetPrivateProfileInt(section, "MGMagicDamageMaxConstA", 0, path);

	this->m_DLPhysiDamageMinConstA = GetPrivateProfileInt(section, "DLPhysiDamageMinConstA", 0, path);
	this->m_DLPhysiDamageMinConstB = GetPrivateProfileInt(section, "DLPhysiDamageMinConstB", 0, path);
	this->m_DLPhysiDamageMaxConstA = GetPrivateProfileInt(section, "DLPhysiDamageMaxConstA", 0, path);
	this->m_DLPhysiDamageMaxConstB = GetPrivateProfileInt(section, "DLPhysiDamageMaxConstB", 0, path);
	this->m_DLMagicDamageMinConstA = GetPrivateProfileInt(section, "DLMagicDamageMinConstA", 0, path);
	this->m_DLMagicDamageMaxConstA = GetPrivateProfileInt(section, "DLMagicDamageMaxConstA", 0, path);

	this->m_SUPhysiDamageMinConstA = GetPrivateProfileInt(section, "SUPhysiDamageMinConstA", 0, path);
	this->m_SUPhysiDamageMaxConstA = GetPrivateProfileInt(section, "SUPhysiDamageMaxConstA", 0, path);
	this->m_SUMagicDamageMinConstA = GetPrivateProfileInt(section, "SUMagicDamageMinConstA", 0, path);
	this->m_SUMagicDamageMaxConstA = GetPrivateProfileInt(section, "SUMagicDamageMaxConstA", 0, path);

	this->m_RFPhysiDamageMinConstA = GetPrivateProfileInt(section, "RFPhysiDamageMinConstA", 0, path);
	this->m_RFPhysiDamageMinConstB = GetPrivateProfileInt(section, "RFPhysiDamageMinConstB", 0, path);
	this->m_RFPhysiDamageMaxConstA = GetPrivateProfileInt(section, "RFPhysiDamageMaxConstA", 0, path);
	this->m_RFPhysiDamageMaxConstB = GetPrivateProfileInt(section, "RFPhysiDamageMaxConstB", 0, path);
	this->m_RFMagicDamageMinConstA = GetPrivateProfileInt(section, "RFMagicDamageMinConstA", 0, path);
	this->m_RFMagicDamageMaxConstA = GetPrivateProfileInt(section, "RFMagicDamageMaxConstA", 0, path);

	this->m_FKPhysiDamageMinConstA = GetPrivateProfileInt(section, "GLPhysiDamageMinConstA", 0, path);
	this->m_FKPhysiDamageMaxConstA = GetPrivateProfileInt(section, "GLPhysiDamageMaxConstA", 0, path);
	this->m_FKPhysiDamageMinConstB = GetPrivateProfileInt(section, "GLPhysiDamageMinConstB", 0, path);
	this->m_FKPhysiDamageMaxConstB = GetPrivateProfileInt(section, "GLPhysiDamageMaxConstB", 0, path);
	this->m_FKMagicDamageMinConstA = GetPrivateProfileInt(section, "GLMagicDamageMinConstA", 0, path);
	this->m_FKMagicDamageMaxConstA = GetPrivateProfileInt(section, "GLMagicDamageMaxConstA", 0, path);

	this->m_DWAttackSuccessRateConstA = GetPrivateProfileInt(section, "DWAttackSuccessRateConstA", 0, path);
	this->m_DWAttackSuccessRateConstB = GetPrivateProfileInt(section, "DWAttackSuccessRateConstB", 0, path);
	this->m_DWAttackSuccessRateConstC = GetPrivateProfileInt(section, "DWAttackSuccessRateConstC", 0, path);
	this->m_DWAttackSuccessRateConstD = GetPrivateProfileInt(section, "DWAttackSuccessRateConstD", 0, path);

	this->m_DKAttackSuccessRateConstA = GetPrivateProfileInt(section, "DKAttackSuccessRateConstA", 0, path);
	this->m_DKAttackSuccessRateConstB = GetPrivateProfileInt(section, "DKAttackSuccessRateConstB", 0, path);
	this->m_DKAttackSuccessRateConstC = GetPrivateProfileInt(section, "DKAttackSuccessRateConstC", 0, path);
	this->m_DKAttackSuccessRateConstD = GetPrivateProfileInt(section, "DKAttackSuccessRateConstD", 0, path);

	this->m_FEAttackSuccessRateConstA = GetPrivateProfileInt(section, "FEAttackSuccessRateConstA", 0, path);
	this->m_FEAttackSuccessRateConstB = GetPrivateProfileInt(section, "FEAttackSuccessRateConstB", 0, path);
	this->m_FEAttackSuccessRateConstC = GetPrivateProfileInt(section, "FEAttackSuccessRateConstC", 0, path);
	this->m_FEAttackSuccessRateConstD = GetPrivateProfileInt(section, "FEAttackSuccessRateConstD", 0, path);

	this->m_MGAttackSuccessRateConstA = GetPrivateProfileInt(section, "MGAttackSuccessRateConstA", 0, path);
	this->m_MGAttackSuccessRateConstB = GetPrivateProfileInt(section, "MGAttackSuccessRateConstB", 0, path);
	this->m_MGAttackSuccessRateConstC = GetPrivateProfileInt(section, "MGAttackSuccessRateConstC", 0, path);
	this->m_MGAttackSuccessRateConstD = GetPrivateProfileInt(section, "MGAttackSuccessRateConstD", 0, path);

	this->m_DLAttackSuccessRateConstA = GetPrivateProfileInt(section, "DLAttackSuccessRateConstA", 0, path);
	this->m_DLAttackSuccessRateConstB = GetPrivateProfileInt(section, "DLAttackSuccessRateConstB", 0, path);
	this->m_DLAttackSuccessRateConstC = GetPrivateProfileInt(section, "DLAttackSuccessRateConstC", 0, path);
	this->m_DLAttackSuccessRateConstD = GetPrivateProfileInt(section, "DLAttackSuccessRateConstD", 0, path);
	this->m_DLAttackSuccessRateConstE = GetPrivateProfileInt(section, "DLAttackSuccessRateConstE", 0, path);

	this->m_SUAttackSuccessRateConstA = GetPrivateProfileInt(section, "SUAttackSuccessRateConstA", 0, path);
	this->m_SUAttackSuccessRateConstB = GetPrivateProfileInt(section, "SUAttackSuccessRateConstB", 0, path);
	this->m_SUAttackSuccessRateConstC = GetPrivateProfileInt(section, "SUAttackSuccessRateConstC", 0, path);
	this->m_SUAttackSuccessRateConstD = GetPrivateProfileInt(section, "SUAttackSuccessRateConstD", 0, path);

	this->m_RFAttackSuccessRateConstA = GetPrivateProfileInt(section, "RFAttackSuccessRateConstA", 0, path);
	this->m_RFAttackSuccessRateConstB = GetPrivateProfileInt(section, "RFAttackSuccessRateConstB", 0, path);
	this->m_RFAttackSuccessRateConstC = GetPrivateProfileInt(section, "RFAttackSuccessRateConstC", 0, path);
	this->m_RFAttackSuccessRateConstD = GetPrivateProfileInt(section, "RFAttackSuccessRateConstD", 0, path);

	this->m_FKAttackSuccessRateConstA = GetPrivateProfileInt(section, "GLAttackSuccessRateConstA", 0, path);
	this->m_FKAttackSuccessRateConstB = GetPrivateProfileInt(section, "GLAttackSuccessRateConstB", 0, path);
	this->m_FKAttackSuccessRateConstC = GetPrivateProfileInt(section, "GLAttackSuccessRateConstC", 0, path);
	this->m_FKAttackSuccessRateConstD = GetPrivateProfileInt(section, "GLAttackSuccessRateConstD", 0, path);

	this->m_DWAttackSuccessRatePvPConstA = GetPrivateProfileInt(section, "DWAttackSuccessRatePvPConstA", 0, path);
	this->m_DWAttackSuccessRatePvPConstB = GetPrivateProfileInt(section, "DWAttackSuccessRatePvPConstB", 0, path);
	this->m_DWAttackSuccessRatePvPConstC = GetPrivateProfileInt(section, "DWAttackSuccessRatePvPConstC", 0, path);
	this->m_DWAttackSuccessRatePvPConstD = GetPrivateProfileInt(section, "DWAttackSuccessRatePvPConstD", 0, path);

	this->m_DKAttackSuccessRatePvPConstA = GetPrivateProfileInt(section, "DKAttackSuccessRatePvPConstA", 0, path);
	this->m_DKAttackSuccessRatePvPConstB = GetPrivateProfileInt(section, "DKAttackSuccessRatePvPConstB", 0, path);
	this->m_DKAttackSuccessRatePvPConstC = GetPrivateProfileInt(section, "DKAttackSuccessRatePvPConstC", 0, path);
	this->m_DKAttackSuccessRatePvPConstD = GetPrivateProfileInt(section, "DKAttackSuccessRatePvPConstD", 0, path);

	this->m_FEAttackSuccessRatePvPConstA = GetPrivateProfileInt(section, "FEAttackSuccessRatePvPConstA", 0, path);
	this->m_FEAttackSuccessRatePvPConstB = GetPrivateProfileInt(section, "FEAttackSuccessRatePvPConstB", 0, path);
	this->m_FEAttackSuccessRatePvPConstC = GetPrivateProfileInt(section, "FEAttackSuccessRatePvPConstC", 0, path);
	this->m_FEAttackSuccessRatePvPConstD = GetPrivateProfileInt(section, "FEAttackSuccessRatePvPConstD", 0, path);

	this->m_MGAttackSuccessRatePvPConstA = GetPrivateProfileInt(section, "MGAttackSuccessRatePvPConstA", 0, path);
	this->m_MGAttackSuccessRatePvPConstB = GetPrivateProfileInt(section, "MGAttackSuccessRatePvPConstB", 0, path);
	this->m_MGAttackSuccessRatePvPConstC = GetPrivateProfileInt(section, "MGAttackSuccessRatePvPConstC", 0, path);
	this->m_MGAttackSuccessRatePvPConstD = GetPrivateProfileInt(section, "MGAttackSuccessRatePvPConstD", 0, path);

	this->m_DLAttackSuccessRatePvPConstA = GetPrivateProfileInt(section, "DLAttackSuccessRatePvPConstA", 0, path);
	this->m_DLAttackSuccessRatePvPConstB = GetPrivateProfileInt(section, "DLAttackSuccessRatePvPConstB", 0, path);
	this->m_DLAttackSuccessRatePvPConstC = GetPrivateProfileInt(section, "DLAttackSuccessRatePvPConstC", 0, path);
	this->m_DLAttackSuccessRatePvPConstD = GetPrivateProfileInt(section, "DLAttackSuccessRatePvPConstD", 0, path);

	this->m_SUAttackSuccessRatePvPConstA = GetPrivateProfileInt(section, "SUAttackSuccessRatePvPConstA", 0, path);
	this->m_SUAttackSuccessRatePvPConstB = GetPrivateProfileInt(section, "SUAttackSuccessRatePvPConstB", 0, path);
	this->m_SUAttackSuccessRatePvPConstC = GetPrivateProfileInt(section, "SUAttackSuccessRatePvPConstC", 0, path);
	this->m_SUAttackSuccessRatePvPConstD = GetPrivateProfileInt(section, "SUAttackSuccessRatePvPConstD", 0, path);

	this->m_RFAttackSuccessRatePvPConstA = GetPrivateProfileInt(section, "RFAttackSuccessRatePvPConstA", 0, path);
	this->m_RFAttackSuccessRatePvPConstB = GetPrivateProfileInt(section, "RFAttackSuccessRatePvPConstB", 0, path);
	this->m_RFAttackSuccessRatePvPConstC = GetPrivateProfileInt(section, "RFAttackSuccessRatePvPConstC", 0, path);
	this->m_RFAttackSuccessRatePvPConstD = GetPrivateProfileInt(section, "RFAttackSuccessRatePvPConstD", 0, path);

	this->m_FKAttackSuccessRatePvPConstA = GetPrivateProfileInt(section, "GLAttackSuccessRatePvPConstA", 0, path);
	this->m_FKAttackSuccessRatePvPConstB = GetPrivateProfileInt(section, "GLAttackSuccessRatePvPConstB", 0, path);
	this->m_FKAttackSuccessRatePvPConstC = GetPrivateProfileInt(section, "GLAttackSuccessRatePvPConstC", 0, path);
	this->m_FKAttackSuccessRatePvPConstD = GetPrivateProfileInt(section, "GLAttackSuccessRatePvPConstD", 0, path);

	this->m_DWPhysiSpeedConstA = GetPrivateProfileInt(section, "DWPhysiSpeedConstA", 0, path);
	this->m_DWMagicSpeedConstA = GetPrivateProfileInt(section, "DWMagicSpeedConstA", 0, path);
	this->m_DKPhysiSpeedConstA = GetPrivateProfileInt(section, "DKPhysiSpeedConstA", 0, path);
	this->m_DKMagicSpeedConstA = GetPrivateProfileInt(section, "DKMagicSpeedConstA", 0, path);
	this->m_FEPhysiSpeedConstA = GetPrivateProfileInt(section, "FEPhysiSpeedConstA", 0, path);
	this->m_FEMagicSpeedConstA = GetPrivateProfileInt(section, "FEMagicSpeedConstA", 0, path);
	this->m_MGPhysiSpeedConstA = GetPrivateProfileInt(section, "MGPhysiSpeedConstA", 0, path);
	this->m_MGMagicSpeedConstA = GetPrivateProfileInt(section, "MGMagicSpeedConstA", 0, path);
	this->m_DLPhysiSpeedConstA = GetPrivateProfileInt(section, "DLPhysiSpeedConstA", 0, path);
	this->m_DLMagicSpeedConstA = GetPrivateProfileInt(section, "DLMagicSpeedConstA", 0, path);
	this->m_SUPhysiSpeedConstA = GetPrivateProfileInt(section, "SUPhysiSpeedConstA", 0, path);
	this->m_SUMagicSpeedConstA = GetPrivateProfileInt(section, "SUMagicSpeedConstA", 0, path);
	this->m_RFPhysiSpeedConstA = GetPrivateProfileInt(section, "RFPhysiSpeedConstA", 0, path);
	this->m_RFMagicSpeedConstA = GetPrivateProfileInt(section, "RFMagicSpeedConstA", 0, path);
	this->m_FKPhysiSpeedConstA = GetPrivateProfileInt(section, "GLPhysiSpeedConstA", 0, path);
	this->m_FKMagicSpeedConstA = GetPrivateProfileInt(section, "GLMagicSpeedConstA", 0, path);

	this->m_DWDefenseSuccessRateConstA = GetPrivateProfileInt(section, "DWDefenseSuccessRateConstA", 0, path);
	this->m_DKDefenseSuccessRateConstA = GetPrivateProfileInt(section, "DKDefenseSuccessRateConstA", 0, path);
	this->m_FEDefenseSuccessRateConstA = GetPrivateProfileInt(section, "FEDefenseSuccessRateConstA", 0, path);
	this->m_MGDefenseSuccessRateConstA = GetPrivateProfileInt(section, "MGDefenseSuccessRateConstA", 0, path);
	this->m_DLDefenseSuccessRateConstA = GetPrivateProfileInt(section, "DLDefenseSuccessRateConstA", 0, path);
	this->m_SUDefenseSuccessRateConstA = GetPrivateProfileInt(section, "SUDefenseSuccessRateConstA", 0, path);
	this->m_RFDefenseSuccessRateConstA = GetPrivateProfileInt(section, "RFDefenseSuccessRateConstA", 0, path);
	this->m_FKDefenseSuccessRateConstA = GetPrivateProfileInt(section, "GLDefenseSuccessRateConstA", 0, path);

	this->m_DWDefenseSuccessRatePvPConstA = GetPrivateProfileInt(section, "DWDefenseSuccessRatePvPConstA", 0, path);
	this->m_DWDefenseSuccessRatePvPConstB = GetPrivateProfileInt(section, "DWDefenseSuccessRatePvPConstB", 0, path);
	this->m_DWDefenseSuccessRatePvPConstC = GetPrivateProfileInt(section, "DWDefenseSuccessRatePvPConstC", 0, path);

	this->m_DKDefenseSuccessRatePvPConstA = GetPrivateProfileInt(section, "DKDefenseSuccessRatePvPConstA", 0, path);
	this->m_DKDefenseSuccessRatePvPConstB = GetPrivateProfileInt(section, "DKDefenseSuccessRatePvPConstB", 0, path);
	this->m_DKDefenseSuccessRatePvPConstC = GetPrivateProfileInt(section, "DKDefenseSuccessRatePvPConstC", 0, path);

	this->m_FEDefenseSuccessRatePvPConstA = GetPrivateProfileInt(section, "FEDefenseSuccessRatePvPConstA", 0, path);
	this->m_FEDefenseSuccessRatePvPConstB = GetPrivateProfileInt(section, "FEDefenseSuccessRatePvPConstB", 0, path);
	this->m_FEDefenseSuccessRatePvPConstC = GetPrivateProfileInt(section, "FEDefenseSuccessRatePvPConstC", 0, path);

	this->m_MGDefenseSuccessRatePvPConstA = GetPrivateProfileInt(section, "MGDefenseSuccessRatePvPConstA", 0, path);
	this->m_MGDefenseSuccessRatePvPConstB = GetPrivateProfileInt(section, "MGDefenseSuccessRatePvPConstB", 0, path);
	this->m_MGDefenseSuccessRatePvPConstC = GetPrivateProfileInt(section, "MGDefenseSuccessRatePvPConstC", 0, path);

	this->m_DLDefenseSuccessRatePvPConstA = GetPrivateProfileInt(section, "DLDefenseSuccessRatePvPConstA", 0, path);
	this->m_DLDefenseSuccessRatePvPConstB = GetPrivateProfileInt(section, "DLDefenseSuccessRatePvPConstB", 0, path);
	this->m_DLDefenseSuccessRatePvPConstC = GetPrivateProfileInt(section, "DLDefenseSuccessRatePvPConstC", 0, path);

	this->m_SUDefenseSuccessRatePvPConstA = GetPrivateProfileInt(section, "SUDefenseSuccessRatePvPConstA", 0, path);
	this->m_SUDefenseSuccessRatePvPConstB = GetPrivateProfileInt(section, "SUDefenseSuccessRatePvPConstB", 0, path);
	this->m_SUDefenseSuccessRatePvPConstC = GetPrivateProfileInt(section, "SUDefenseSuccessRatePvPConstC", 0, path);

	this->m_RFDefenseSuccessRatePvPConstA = GetPrivateProfileInt(section, "RFDefenseSuccessRatePvPConstA", 0, path);
	this->m_RFDefenseSuccessRatePvPConstB = GetPrivateProfileInt(section, "RFDefenseSuccessRatePvPConstB", 0, path);
	this->m_RFDefenseSuccessRatePvPConstC = GetPrivateProfileInt(section, "RFDefenseSuccessRatePvPConstC", 0, path);

	this->m_FKDefenseSuccessRatePvPConstA = GetPrivateProfileInt(section, "GLDefenseSuccessRatePvPConstA", 0, path);
	this->m_FKDefenseSuccessRatePvPConstB = GetPrivateProfileInt(section, "GLDefenseSuccessRatePvPConstB", 0, path);
	this->m_FKDefenseSuccessRatePvPConstC = GetPrivateProfileInt(section, "GLDefenseSuccessRatePvPConstC", 0, path);

	this->m_ClassDefenseConst[CLASS_DW] = GetPrivateProfileInt(section, "DWDefenseConstA", 10, path);
	this->m_ClassDefenseConst[CLASS_DK] = GetPrivateProfileInt(section, "DKDefenseConstA", 10, path);
	this->m_ClassDefenseConst[CLASS_FE] = GetPrivateProfileInt(section, "FEDefenseConstA", 10, path);
	this->m_ClassDefenseConst[CLASS_MG] = GetPrivateProfileInt(section, "MGDefenseConstA", 10, path);
	this->m_ClassDefenseConst[CLASS_DL] = GetPrivateProfileInt(section, "DLDefenseConstA", 10, path);
	this->m_ClassDefenseConst[CLASS_SU] = GetPrivateProfileInt(section, "SUDefenseConstA", 10, path);
	this->m_ClassDefenseConst[CLASS_RF] = GetPrivateProfileInt(section, "RFDefenseConstA", 10, path);
	this->m_ClassDefenseConst[CLASS_GL] = GetPrivateProfileInt(section, "GLDefenseConstA", 10, path);

	this->MASTERY_OPTION_DAMAGE_AGAINST_[CLASS_DW] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DW", 10, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_[CLASS_DK] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DK", 10, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_[CLASS_FE] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_ELF", 10, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_[CLASS_MG] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_MG", 10, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_[CLASS_DL] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DL", 10, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_[CLASS_SU] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_SUM", 10, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_[CLASS_RF] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_RF", 10, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_[CLASS_GL] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_GL", 10, path);

	this->MASTERY_OPTION_DAMAGE_AGAINST_2[CLASS_DW] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DW2", 12, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_2[CLASS_DK] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DK2", 12, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_2[CLASS_FE] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_ELF2", 12, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_2[CLASS_MG] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_MG2", 12, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_2[CLASS_DL] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DL2", 12, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_2[CLASS_SU] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_SUM2", 12, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_2[CLASS_RF] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_RF2", 12, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_2[CLASS_GL] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_GL2", 12, path);

	this->MASTERY_OPTION_DAMAGE_AGAINST_3[CLASS_DW] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DW3", 15, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_3[CLASS_DK] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DK3", 15, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_3[CLASS_FE] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_ELF3", 15, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_3[CLASS_MG] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_MG3", 15, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_3[CLASS_DL] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_DL3", 15, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_3[CLASS_SU] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_SUM3", 15, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_3[CLASS_RF] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_RF3", 15, path);
	this->MASTERY_OPTION_DAMAGE_AGAINST_3[CLASS_GL] = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_GL3", 15, path);
	
	this->MASTERY_OPTION_DAMAGE_AGAINST_MAX = GetPrivateProfileInt(section, "MASTERY_OPTION_DAMAGE_AGAINST_MAX", 30, path);

	this->MASTERY_OPTION_INCREASE_BOSS_DAMAGE		= GetPrivateProfileInt(section, "MASTERY_OPTION_INCREASE_BOSS_DAMAGE", 15, path);
	this->MASTERY_OPTION_INCREASE_BOSS_DAMAGE2 = GetPrivateProfileInt(section, "MASTERY_OPTION_INCREASE_BOSS_DAMAGE2", 20, path);
	this->MASTERY_OPTION_INCREASE_BOSS_DAMAGE3 = GetPrivateProfileInt(section, "MASTERY_OPTION_INCREASE_BOSS_DAMAGE3", 25, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE	= GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE", 15, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE2 = GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE2", 20, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE3 = GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE3", 25, path);

	this->MASTERY_BONUS_TRIPLE_DAMAGE_RATE	= GetPrivateProfileInt(section, "MASTERY_BONUS_TRIPLE_DAMAGE_RATE", 2, path);
	this->MASTERY_BONUS_FINAL_DAMAGE		= GetPrivateProfileInt(section, "MASTERY_BONUS_FINAL_DAMAGE", 10, path);
	this->MASTERY_BONUS_ULTRAHIT_50			= GetPrivateProfileInt(section, "MASTERY_BONUS_ULTRAHIT_50", 1, path);
	this->MASTERY_BONUS_DOUBLE_DAMAGE_BOSS	= GetPrivateProfileInt(section, "MASTERY_BONUS_DOUBLE_DAMAGE_BOSS", 5, path);

	this->MASTERY_BONUS_TRIPLE_DAMAGE_RATE2 = GetPrivateProfileInt(section, "MASTERY_BONUS_TRIPLE_DAMAGE_RATE2", 3, path);
	this->MASTERY_BONUS_FINAL_DAMAGE2 = GetPrivateProfileInt(section, "MASTERY_BONUS_FINAL_DAMAGE2", 17, path);
	this->MASTERY_BONUS_ULTRAHIT_502 = GetPrivateProfileInt(section, "MASTERY_BONUS_ULTRAHIT_502", 2, path);
	this->MASTERY_BONUS_DOUBLE_DAMAGE_BOSS2 = GetPrivateProfileInt(section, "MASTERY_BONUS_DOUBLE_DAMAGE_BOSS2", 7, path);

	//shield
	this->MASTERY_OPTION_PVP_DAMAGE_REDUCTION = GetPrivateProfileInt(section, "MASTERY_OPTION_PVP_DAMAGE_REDUCTION", 25, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION = GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION", 30, path);
	this->MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION", 10, path);
	this->MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION", 3, path);
	this->MASTERY_OPTION_TRUE_DAMAGE_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_TRUE_DAMAGE_PROTECTION", 1, path);
	this->MASTERY_OPTION_ULTRAHIT_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_ULTRAHIT_PROTECTION", 1, path);
	//shield blue eye
	this->MASTERY_OPTION_PVP_DAMAGE_REDUCTION_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_PVP_DAMAGE_REDUCTION_2", 30, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION_2", 35, path);
	this->MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION_2", 13, path);
	this->MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION_2", 4, path);
	this->MASTERY_OPTION_TRUE_DAMAGE_PROTECTION_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_TRUE_DAMAGE_PROTECTION_2", 2, path);
	this->MASTERY_OPTION_ULTRAHIT_PROTECTION_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_ULTRAHIT_PROTECTION_2", 2, path);	
	//shield Silver Heart
	this->MASTERY_OPTION_PVP_DAMAGE_REDUCTION_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_PVP_DAMAGE_REDUCTION_3", 35, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_REDUCTION_3", 40, path);
	this->MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_DOUBLE_DAMAGE_PROTECTION_3", 15, path);
	this->MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_TRIPLE_DAMAGE_PROTECTION_3", 5, path);
	this->MASTERY_OPTION_TRUE_DAMAGE_PROTECTION_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_TRUE_DAMAGE_PROTECTION_3", 3, path);
	this->MASTERY_OPTION_ULTRAHIT_PROTECTION_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_ULTRAHIT_PROTECTION_3", 3, path);
	//shield bonus
	this->MASTERY_BONUS_HP_DAMAGE_PROTECTION = GetPrivateProfileInt(section, "MASTERY_BONUS_HP_DAMAGE_PROTECTION", 2, path);
	this->MASTERY_BONUS_REFLECT_INCREASE = GetPrivateProfileInt(section, "MASTERY_BONUS_REFLECT_INCREASE", 40, path);
	this->MASTERY_BONUS_BOSS_POWER_PROTECTION = GetPrivateProfileInt(section, "MASTERY_BONUS_BOSS_POWER_PROTECTION", 15, path);
	//shield blue eye bonus
	this->MASTERY_BONUS_HP_DAMAGE_PROTECTION_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_HP_DAMAGE_PROTECTION_2", 3, path);
	this->MASTERY_BONUS_REFLECT_INCREASE_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_REFLECT_INCREASE_2", 50, path);
	this->MASTERY_BONUS_BOSS_POWER_PROTECTION_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_BOSS_POWER_PROTECTION_2", 30, path);
	//shield silver heart bonus
	this->MASTERY_BONUS_HP_DAMAGE_PROTECTION_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_HP_DAMAGE_PROTECTION_3", 4, path);
	this->MASTERY_BONUS_REFLECT_INCREASE_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_REFLECT_INCREASE_3", 60, path);
	this->MASTERY_BONUS_BOSS_POWER_PROTECTION_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_BOSS_POWER_PROTECTION_3", 40, path);

	//armas at soul
	this->MASTERY_OPTION_BOSS_DECREASE_DELAY = GetPrivateProfileInt(section, "MASTERY_OPTION_BOSS_DECREASE_DELAY", 25, path);
	this->MASTERY_OPTION_30P_HP_ULTRAHIT = GetPrivateProfileInt(section, "MASTERY_OPTION_30P_HP_ULTRAHIT", 1, path);
	this->MASTERY_OPTION_TRUE_DAMAGE_RATE = GetPrivateProfileInt(section, "MASTERY_OPTION_TRUE_DAMAGE_RATE", 2, path);
	this->MASTERY_OPTION_TRIPLE_DAMAGE_RATE = GetPrivateProfileInt(section, "MASTERY_OPTION_TRIPLE_DAMAGE_RATE", 3, path);
	this->MASTERY_OPTION_DOUBLE_DAMAGE_RATE = GetPrivateProfileInt(section, "MASTERY_OPTION_DOUBLE_DAMAGE_RATE", 10, path);
	this->MASTERY_OPTION_PVP_DAMAGE_INCREASE = GetPrivateProfileInt(section, "MASTERY_OPTION_PVP_DAMAGE_INCREASE", 25, path);
	this->MASTERY_OPTION_BOSS_DAMAGE_INCREASE = GetPrivateProfileInt(section, "MASTERY_OPTION_BOSS_DAMAGE_INCREASE", 25, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON = GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON", 30, path);
	//Armas blue eye
	this->MASTERY_OPTION_BOSS_DECREASE_DELAY_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_BOSS_DECREASE_DELAY_2", 30, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON_2", 35, path);
	this->MASTERY_OPTION_BOSS_DAMAGE_INCREASE_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_BOSS_DAMAGE_INCREASE_2", 35, path);
	this->MASTERY_OPTION_PVP_DAMAGE_INCREASE_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_PVP_DAMAGE_INCREASE_2", 30, path);
	this->MASTERY_OPTION_DOUBLE_DAMAGE_RATE_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_DOUBLE_DAMAGE_RATE_2", 13, path);
	this->MASTERY_OPTION_TRIPLE_DAMAGE_RATE_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_TRIPLE_DAMAGE_RATE_2", 4, path);
	this->MASTERY_OPTION_TRUE_DAMAGE_RATE_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_TRUE_DAMAGE_RATE_2", 3, path);
	this->MASTERY_OPTION_30P_HP_ULTRAHIT_2 = GetPrivateProfileInt(section, "MASTERY_OPTION_30P_HP_ULTRAHIT_2", 2, path);
	
	//Armas Silver Heart
	this->MASTERY_OPTION_BOSS_DECREASE_DELAY_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_BOSS_DECREASE_DELAY_3", 35, path);
	this->MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_ELEMENTAL_DAMAGE_INCREASE_WEAPON_3", 40, path);
	this->MASTERY_OPTION_BOSS_DAMAGE_INCREASE_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_BOSS_DAMAGE_INCREASE_3", 40, path);
	this->MASTERY_OPTION_PVP_DAMAGE_INCREASE_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_PVP_DAMAGE_INCREASE_3", 35, path);
	this->MASTERY_OPTION_DOUBLE_DAMAGE_RATE_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_DOUBLE_DAMAGE_RATE_3", 15, path);
	this->MASTERY_OPTION_TRIPLE_DAMAGE_RATE_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_TRIPLE_DAMAGE_RATE_3", 5, path);
	this->MASTERY_OPTION_TRUE_DAMAGE_RATE_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_TRUE_DAMAGE_RATE_3", 4, path);
	this->MASTERY_OPTION_30P_HP_ULTRAHIT_3 = GetPrivateProfileInt(section, "MASTERY_OPTION_30P_HP_ULTRAHIT_3", 3, path);

	this->MASTERY_OPTION_PENDANT_PVP_DMG = GetPrivateProfileInt(section, "MASTERY_OPTION_PENDANT_PVP_DMG", 10, path);
	this->MASTERY_OPTION_PENDANT_TRIPLE_DMG = GetPrivateProfileInt(section, "MASTERY_OPTION_PENDANT_TRIPLE_DMG", 1, path);
	this->MASTERY_OPTION_PENDANT_TRUE_DMG = GetPrivateProfileInt(section, "MASTERY_OPTION_PENDANT_TRUE_DMG", 1, path);
	this->MASTERY_OPTION_PENDANT_DOUBLE_DMG = GetPrivateProfileInt(section, "MASTERY_OPTION_PENDANT_DOUBLE_DMG", 10, path);
	this->MASTERY_OPTION_PENDANT_BOSS_DMG = GetPrivateProfileInt(section, "MASTERY_OPTION_PENDANT_BOSS_DMG", 10, path);
	this->MASTERY_OPTION_PENDANT_BOSS_DECREASE_DELAY = GetPrivateProfileInt(section, "MASTERY_OPTION_PENDANT_BOSS_DECREASE_DELAY", 10, path);
	this->MASTERY_OPTION_PENDANT_ELEMENTAL_DAMAGE_INCREASE = GetPrivateProfileInt(section, "MASTERY_OPTION_PENDANT_ELEMENTAL_DAMAGE_INCREASE", 15, path);
	this->MASTERY_OPTION_PENDANT_BACKSPRING_INCREASE = GetPrivateProfileInt(section, "MASTERY_OPTION_PENDANT_BACKSPRING_INCREASE", 15, path);

	this->MASTERY_BONUS_PENDANT_CURE_HARM = GetPrivateProfileInt(section, "MASTERY_BONUS_PENDANT_CURE_HARM", 1, path);
	this->MASTERY_BONUS_PENDANT_STERN = GetPrivateProfileInt(section, "MASTERY_BONUS_PENDANT_STERN", 1, path);
	this->MASTERY_BONUS_PENDANT_BLEEDING = GetPrivateProfileInt(section, "MASTERY_BONUS_PENDANT_BLEEDING", 1, path);
	this->MASTERY_BONUS_PENDANT_SHIELD_SKILL_IGNORE = GetPrivateProfileInt(section, "MASTERY_BONUS_PENDANT_SHIELD_SKILL_IGNORE", 1, path);
	this->MASTERY_BONUS_PENDANT_ULTRAHIT_50 = GetPrivateProfileInt(section, "MASTERY_BONUS_PENDANT_ULTRAHIT_50", 1, path);
	this->MASTERY_BONUS_PENDANT_FREEZING = GetPrivateProfileInt(section, "MASTERY_BONUS_PENDANT_FREEZING", 1, path); 

	this->MASTERY_OPTION_RING_BACKSPRING_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_BACKSPRING_PROTECTION", 15, path);
	this->MASTERY_OPTION_RING_DROP_BOSS_INC = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_DROP_BOSS_INC", 10, path);
	this->MASTERY_OPTION_RING_MAX_HP_INC = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_MAX_HP_INC", 5, path);
	this->MASTERY_OPTION_RING_BLOCK_CHANCE_INC = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_BLOCK_CHANCE_INC", 2, path);
	this->MASTERY_OPTION_RING_BOSS_SKILL_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_BOSS_SKILL_PROTECTION", 10, path);
	this->MASTERY_OPTION_RING_ELEMENTAL_DMG_REDUCE = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_ELEMENTAL_DMG_REDUCE", 10, path);
	this->MASTERY_OPTION_RING_PVP_DAMAGE_REDUCE = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_PVP_DAMAGE_REDUCE", 5, path);
	this->MASTERY_OPTION_RING_BOSS_DAMAGE_REDUCE = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_BOSS_DAMAGE_REDUCE", 5, path);
	this->MASTERY_OPTION_RING_TRIPLE_DMG_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_TRIPLE_DMG_PROTECTION", 1, path);
	this->MASTERY_OPTION_RING_TRUE_DMG_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_TRUE_DMG_PROTECTION", 1, path);
	this->MASTERY_OPTION_RING_ULTRAHIT_PROTECTION = GetPrivateProfileInt(section, "MASTERY_OPTION_RING_ULTRAHIT_PROTECTION", 3, path);

	this->MASTERY_BONUS_RING_STERN_RESIST = GetPrivateProfileInt(section, "MASTERY_BONUS_RING_STERN_RESIST", 50, path);
	this->MASTERY_BONUS_RING_BLEEDING_RESIST = GetPrivateProfileInt(section, "MASTERY_BONUS_RING_BLEEDING_RESIST", 50, path);
	this->MASTERY_BONUS_RING_CURE_HARM_RESIST = GetPrivateProfileInt(section, "MASTERY_BONUS_RING_CURE_HARM_RESIST", 50, path);
	this->MASTERY_BONUS_RING_CURE_IMPROVE = GetPrivateProfileInt(section, "MASTERY_BONUS_RING_CURE_IMPROVE", 10, path);
	this->MASTERY_BONUS_RING_FULL_REFLECT_INC = GetPrivateProfileInt(section, "MASTERY_BONUS_RING_FULL_REFLECT_INC", 2, path);
	this->MASTERY_BONUS_RING_MASTERY_REVERT = GetPrivateProfileInt(section, "MASTERY_BONUS_RING_MASTERY_REVERT", 20, path);
	this->MASTERY_BONUS_RING_FREEZING_DAMAGE_RESIST = GetPrivateProfileInt(section, "MASTERY_BONUS_RING_FREEZING_DAMAGE_RESIST", 50, path);
	this->MASTERY_BONUS_RING_FIREING_DAMAGE_RESIST = GetPrivateProfileInt(section, "MASTERY_BONUS_RING_FIREING_DAMAGE_RESIST", 50, path);

	//Armas at soul bonus
	this->MASTERY_BONUS_ULTRAHIT_50_WEAPON = GetPrivateProfileInt(section, "MASTERY_BONUS_ULTRAHIT_50_WEAPON", 1, path);
	this->MASTERY_BONUS_REFLECT_DECREASE = GetPrivateProfileInt(section, "MASTERY_BONUS_REFLECT_DECREASE", 40, path);
	this->MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON = GetPrivateProfileInt(section, "MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON", 5, path);
	this->MASTERY_BONUS_BLEEDING = GetPrivateProfileInt(section, "MASTERY_BONUS_BLEEDING", 1, path);
	this->MASTERY_BONUS_STERN_RATE = GetPrivateProfileInt(section, "MASTERY_BONUS_STERN_RATE", 1, path);
	this->MASTERY_BONUS_CURE_HARM = GetPrivateProfileInt(section, "MASTERY_BONUS_CURE_HARM", 1, path);
	this->MASTERY_BONUS_CURE_HARM_FACTOR = GetPrivateProfileInt(section, "MASTERY_BONUS_CURE_HARM_FACTOR", 15, path);
	//armas blue eye bonus
	this->MASTERY_BONUS_ULTRAHIT_50_WEAPON_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_ULTRAHIT_50_WEAPON_2", 1, path);
	this->MASTERY_BONUS_REFLECT_DECREASE_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_REFLECT_DECREASE_2", 50, path);	
	this->MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON_2", 5, path);
	this->MASTERY_BONUS_BLEEDING_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_BLEEDING_2", 1, path);
	this->MASTERY_BONUS_STERN_RATE_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_STERN_RATE_2", 1, path);
	this->MASTERY_BONUS_CURE_HARM_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_CURE_HARM_2", 1, path);
	this->MASTERY_BONUS_FREEZING_DAMAGE = GetPrivateProfileInt(section, "MASTERY_BONUS_FREEZING_DAMAGE", 2, path);
	//armas silver heart bonus
	this->MASTERY_BONUS_ULTRAHIT_50_WEAPON_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_ULTRAHIT_50_WEAPON_3", 3, path);
	this->MASTERY_BONUS_REFLECT_DECREASE_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_REFLECT_DECREASE_3", 60, path);
	this->MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_DOUBLE_DAMAGE_BOSS_WEAPON_3", 10, path);
	this->MASTERY_BONUS_BLEEDING_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_BLEEDING_3", 3, path);
	this->MASTERY_BONUS_STERN_RATE_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_STERN_RATE_3", 3, path);
	this->MASTERY_BONUS_CURE_HARM_3 = GetPrivateProfileInt(section, "MASTERY_BONUS_CURE_HARM_3", 3, path);
	this->MASTERY_BONUS_FREEZING_DAMAGE_2 = GetPrivateProfileInt(section, "MASTERY_BONUS_FREEZING_DAMAGE_2", 3, path);
	this->MASTERY_BONUS_FIREING_DAMAGE = GetPrivateProfileInt(section, "MASTERY_BONUS_FIREING_DAMAGE", 2, path);
}

void CServerInfo::ReadCharacterElementalInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	this->m_DuelElementalDamageRate = GetPrivateProfileInt(section, "DuelElementalDamageRate", 0, path);
	this->m_GensElementalDamageRate = GetPrivateProfileInt(section, "GensElementalDamageRate", 0, path);
	this->m_CustomArenaElementalDamageRate = GetPrivateProfileInt(section, "CustomArenaElementalDamageRate", 0, path);
	this->m_ChaosCastleElementalDamageRate = GetPrivateProfileInt(section, "ChaosCastleElementalDamageRate", 0, path);
	this->m_IllusionTempleElementalDamageRate = GetPrivateProfileInt(section, "IllusionTempleElementalDamageRate", 0, path);
	this->m_CastleSiegeElementalDamageRate = GetPrivateProfileInt(section, "CastleSiegeElementalDamageRate", 0, path);

	this->m_GeneralElementalDamageRatePvP = GetPrivateProfileInt(section, "GeneralElementalDamageRatePvP", 0, path);
	this->m_GeneralElementalDamageRatePvM = GetPrivateProfileInt(section, "GeneralElementalDamageRatePvM", 0, path);

	this->m_ElementalDamageRatePvP[0] = GetPrivateProfileInt(section, "DWElementalDamageRatePvP", 0, path);
	this->m_ElementalDamageRatePvP[1] = GetPrivateProfileInt(section, "DKElementalDamageRatePvP", 0, path);
	this->m_ElementalDamageRatePvP[2] = GetPrivateProfileInt(section, "FEElementalDamageRatePvP", 0, path);
	this->m_ElementalDamageRatePvP[3] = GetPrivateProfileInt(section, "MGElementalDamageRatePvP", 0, path);
	this->m_ElementalDamageRatePvP[4] = GetPrivateProfileInt(section, "DLElementalDamageRatePvP", 0, path);
	this->m_ElementalDamageRatePvP[5] = GetPrivateProfileInt(section, "SUElementalDamageRatePvP", 0, path);
	this->m_ElementalDamageRatePvP[6] = GetPrivateProfileInt(section, "RFElementalDamageRatePvP", 0, path);
	this->m_ElementalDamageRatePvP[7] = GetPrivateProfileInt(section, "GLElementalDamageRatePvP", 0, path);

	this->m_ElementalDamageRatePvM[0] = GetPrivateProfileInt(section, "DWElementalDamageRatePvM", 100, path);
	this->m_ElementalDamageRatePvM[1] = GetPrivateProfileInt(section, "DKElementalDamageRatePvM", 100, path);
	this->m_ElementalDamageRatePvM[2] = GetPrivateProfileInt(section, "FEElementalDamageRatePvM", 100, path);
	this->m_ElementalDamageRatePvM[3] = GetPrivateProfileInt(section, "MGElementalDamageRatePvM", 100, path);
	this->m_ElementalDamageRatePvM[4] = GetPrivateProfileInt(section, "DLElementalDamageRatePvM", 100, path);
	this->m_ElementalDamageRatePvM[5] = GetPrivateProfileInt(section, "SUElementalDamageRatePvM", 100, path);
	this->m_ElementalDamageRatePvM[6] = GetPrivateProfileInt(section, "RFElementalDamageRatePvM", 100, path);
	this->m_ElementalDamageRatePvM[7] = GetPrivateProfileInt(section, "GLElementalDamageRatePvM", 100, path);

	this->m_ElementalDamageRateTo[0][0] = GetPrivateProfileInt(section, "DWElementalDamageRateToDW", 0, path);
	this->m_ElementalDamageRateTo[0][1] = GetPrivateProfileInt(section, "DWElementalDamageRateToDK", 0, path);
	this->m_ElementalDamageRateTo[0][2] = GetPrivateProfileInt(section, "DWElementalDamageRateToFE", 0, path);
	this->m_ElementalDamageRateTo[0][3] = GetPrivateProfileInt(section, "DWElementalDamageRateToMG", 0, path);
	this->m_ElementalDamageRateTo[0][4] = GetPrivateProfileInt(section, "DWElementalDamageRateToDL", 0, path);
	this->m_ElementalDamageRateTo[0][5] = GetPrivateProfileInt(section, "DWElementalDamageRateToSU", 0, path);
	this->m_ElementalDamageRateTo[0][6] = GetPrivateProfileInt(section, "DWElementalDamageRateToRF", 0, path);
	this->m_ElementalDamageRateTo[0][7] = GetPrivateProfileInt(section, "DWElementalDamageRateToGL", 0, path);

	this->m_ElementalDamageRateTo[1][0] = GetPrivateProfileInt(section, "DKElementalDamageRateToDW", 0, path);
	this->m_ElementalDamageRateTo[1][1] = GetPrivateProfileInt(section, "DKElementalDamageRateToDK", 0, path);
	this->m_ElementalDamageRateTo[1][2] = GetPrivateProfileInt(section, "DKElementalDamageRateToFE", 0, path);
	this->m_ElementalDamageRateTo[1][3] = GetPrivateProfileInt(section, "DKElementalDamageRateToMG", 0, path);
	this->m_ElementalDamageRateTo[1][4] = GetPrivateProfileInt(section, "DKElementalDamageRateToDL", 0, path);
	this->m_ElementalDamageRateTo[1][5] = GetPrivateProfileInt(section, "DKElementalDamageRateToSU", 0, path);
	this->m_ElementalDamageRateTo[1][6] = GetPrivateProfileInt(section, "DKElementalDamageRateToRF", 0, path);
	this->m_ElementalDamageRateTo[1][7] = GetPrivateProfileInt(section, "DKElementalDamageRateToGL", 0, path);

	this->m_ElementalDamageRateTo[2][0] = GetPrivateProfileInt(section, "FEElementalDamageRateToDW", 0, path);
	this->m_ElementalDamageRateTo[2][1] = GetPrivateProfileInt(section, "FEElementalDamageRateToDK", 0, path);
	this->m_ElementalDamageRateTo[2][2] = GetPrivateProfileInt(section, "FEElementalDamageRateToFE", 0, path);
	this->m_ElementalDamageRateTo[2][3] = GetPrivateProfileInt(section, "FEElementalDamageRateToMG", 0, path);
	this->m_ElementalDamageRateTo[2][4] = GetPrivateProfileInt(section, "FEElementalDamageRateToDL", 0, path);
	this->m_ElementalDamageRateTo[2][5] = GetPrivateProfileInt(section, "FEElementalDamageRateToSU", 0, path);
	this->m_ElementalDamageRateTo[2][6] = GetPrivateProfileInt(section, "FEElementalDamageRateToRF", 0, path);
	this->m_ElementalDamageRateTo[2][7] = GetPrivateProfileInt(section, "FEElementalDamageRateToGL", 0, path);

	this->m_ElementalDamageRateTo[3][0] = GetPrivateProfileInt(section, "MGElementalDamageRateToDW", 0, path);
	this->m_ElementalDamageRateTo[3][1] = GetPrivateProfileInt(section, "MGElementalDamageRateToDK", 0, path);
	this->m_ElementalDamageRateTo[3][2] = GetPrivateProfileInt(section, "MGElementalDamageRateToFE", 0, path);
	this->m_ElementalDamageRateTo[3][3] = GetPrivateProfileInt(section, "MGElementalDamageRateToMG", 0, path);
	this->m_ElementalDamageRateTo[3][4] = GetPrivateProfileInt(section, "MGElementalDamageRateToDL", 0, path);
	this->m_ElementalDamageRateTo[3][5] = GetPrivateProfileInt(section, "MGElementalDamageRateToSU", 0, path);
	this->m_ElementalDamageRateTo[3][6] = GetPrivateProfileInt(section, "MGElementalDamageRateToRF", 0, path);
	this->m_ElementalDamageRateTo[3][7] = GetPrivateProfileInt(section, "MGElementalDamageRateToGL", 0, path);

	this->m_ElementalDamageRateTo[4][0] = GetPrivateProfileInt(section, "DLElementalDamageRateToDW", 0, path);
	this->m_ElementalDamageRateTo[4][1] = GetPrivateProfileInt(section, "DLElementalDamageRateToDK", 0, path);
	this->m_ElementalDamageRateTo[4][2] = GetPrivateProfileInt(section, "DLElementalDamageRateToFE", 0, path);
	this->m_ElementalDamageRateTo[4][3] = GetPrivateProfileInt(section, "DLElementalDamageRateToMG", 0, path);
	this->m_ElementalDamageRateTo[4][4] = GetPrivateProfileInt(section, "DLElementalDamageRateToDL", 0, path);
	this->m_ElementalDamageRateTo[4][5] = GetPrivateProfileInt(section, "DLElementalDamageRateToSU", 0, path);
	this->m_ElementalDamageRateTo[4][6] = GetPrivateProfileInt(section, "DLElementalDamageRateToRF", 0, path);
	this->m_ElementalDamageRateTo[4][7] = GetPrivateProfileInt(section, "DLElementalDamageRateToGL", 0, path);

	this->m_ElementalDamageRateTo[5][0] = GetPrivateProfileInt(section, "SUElementalDamageRateToDW", 0, path);
	this->m_ElementalDamageRateTo[5][1] = GetPrivateProfileInt(section, "SUElementalDamageRateToDK", 0, path);
	this->m_ElementalDamageRateTo[5][2] = GetPrivateProfileInt(section, "SUElementalDamageRateToFE", 0, path);
	this->m_ElementalDamageRateTo[5][3] = GetPrivateProfileInt(section, "SUElementalDamageRateToMG", 0, path);
	this->m_ElementalDamageRateTo[5][4] = GetPrivateProfileInt(section, "SUElementalDamageRateToDL", 0, path);
	this->m_ElementalDamageRateTo[5][5] = GetPrivateProfileInt(section, "SUElementalDamageRateToSU", 0, path);
	this->m_ElementalDamageRateTo[5][6] = GetPrivateProfileInt(section, "SUElementalDamageRateToRF", 0, path);
	this->m_ElementalDamageRateTo[5][7] = GetPrivateProfileInt(section, "SUElementalDamageRateToGL", 0, path);

	this->m_ElementalDamageRateTo[6][0] = GetPrivateProfileInt(section, "RFElementalDamageRateToDW", 0, path);
	this->m_ElementalDamageRateTo[6][1] = GetPrivateProfileInt(section, "RFElementalDamageRateToDK", 0, path);
	this->m_ElementalDamageRateTo[6][2] = GetPrivateProfileInt(section, "RFElementalDamageRateToFE", 0, path);
	this->m_ElementalDamageRateTo[6][3] = GetPrivateProfileInt(section, "RFElementalDamageRateToMG", 0, path);
	this->m_ElementalDamageRateTo[6][4] = GetPrivateProfileInt(section, "RFElementalDamageRateToDL", 0, path);
	this->m_ElementalDamageRateTo[6][5] = GetPrivateProfileInt(section, "RFElementalDamageRateToSU", 0, path);
	this->m_ElementalDamageRateTo[6][6] = GetPrivateProfileInt(section, "RFElementalDamageRateToRF", 0, path);
	this->m_ElementalDamageRateTo[6][7] = GetPrivateProfileInt(section, "RFElementalDamageRateToGL", 0, path);

	this->m_ElementalDamageRateTo[7][0] = GetPrivateProfileInt(section, "GLElementalDamageRateToDW", 0, path);
	this->m_ElementalDamageRateTo[7][1] = GetPrivateProfileInt(section, "GLElementalDamageRateToDK", 0, path);
	this->m_ElementalDamageRateTo[7][2] = GetPrivateProfileInt(section, "GLElementalDamageRateToFE", 0, path);
	this->m_ElementalDamageRateTo[7][3] = GetPrivateProfileInt(section, "GLElementalDamageRateToMG", 0, path);
	this->m_ElementalDamageRateTo[7][4] = GetPrivateProfileInt(section, "GLElementalDamageRateToDL", 0, path);
	this->m_ElementalDamageRateTo[7][5] = GetPrivateProfileInt(section, "GLElementalDamageRateToSU", 0, path);
	this->m_ElementalDamageRateTo[7][6] = GetPrivateProfileInt(section, "GLElementalDamageRateToRF", 0, path);
	this->m_ElementalDamageRateTo[7][7] = GetPrivateProfileInt(section, "GLElementalDamageRateToGL", 0, path);

	this->m_DWElementalDefenseConstA = GetPrivateProfileInt(section, "DWElementalDefenseConstA", 0, path);
	this->m_DKElementalDefenseConstA = GetPrivateProfileInt(section, "DKElementalDefenseConstA", 0, path);
	this->m_FEElementalDefenseConstA = GetPrivateProfileInt(section, "FEElementalDefenseConstA", 0, path);
	this->m_MGElementalDefenseConstA = GetPrivateProfileInt(section, "MGElementalDefenseConstA", 0, path);
	this->m_DLElementalDefenseConstA = GetPrivateProfileInt(section, "DLElementalDefenseConstA", 0, path);
	this->m_SUElementalDefenseConstA = GetPrivateProfileInt(section, "SUElementalDefenseConstA", 0, path);
	this->m_RFElementalDefenseConstA = GetPrivateProfileInt(section, "RFElementalDefenseConstA", 0, path);
	this->m_FKElementalDefenseConstA = GetPrivateProfileInt(section, "GLElementalDefenseConstA", 0, path);

	this->m_DWElementalDamageMinConstA = GetPrivateProfileInt(section, "DWElementalDamageMinConstA", 0, path);
	this->m_DWElementalDamageMaxConstA = GetPrivateProfileInt(section, "DWElementalDamageMaxConstA", 0, path);

	this->m_DKElementalDamageMinConstA = GetPrivateProfileInt(section, "DKElementalDamageMinConstA", 0, path);
	this->m_DKElementalDamageMaxConstA = GetPrivateProfileInt(section, "DKElementalDamageMaxConstA", 0, path);

	this->m_FEElementalDamageMinConstA = GetPrivateProfileInt(section, "FEElementalDamageMinConstA", 0, path);
	this->m_FEElementalDamageMinConstB = GetPrivateProfileInt(section, "FEElementalDamageMinConstB", 0, path);
	this->m_FEElementalDamageMaxConstA = GetPrivateProfileInt(section, "FEElementalDamageMaxConstA", 0, path);
	this->m_FEElementalDamageMaxConstB = GetPrivateProfileInt(section, "FEElementalDamageMaxConstB", 0, path);

	this->m_MGElementalDamageMinConstA = GetPrivateProfileInt(section, "MGElementalDamageMinConstA", 0, path);
	this->m_MGElementalDamageMinConstB = GetPrivateProfileInt(section, "MGElementalDamageMinConstB", 0, path);
	this->m_MGElementalDamageMaxConstA = GetPrivateProfileInt(section, "MGElementalDamageMaxConstA", 0, path);
	this->m_MGElementalDamageMaxConstB = GetPrivateProfileInt(section, "MGElementalDamageMaxConstB", 0, path);

	this->m_DLElementalDamageMinConstA = GetPrivateProfileInt(section, "DLElementalDamageMinConstA", 0, path);
	this->m_DLElementalDamageMinConstB = GetPrivateProfileInt(section, "DLElementalDamageMinConstB", 0, path);
	this->m_DLElementalDamageMaxConstA = GetPrivateProfileInt(section, "DLElementalDamageMaxConstA", 0, path);
	this->m_DLElementalDamageMaxConstB = GetPrivateProfileInt(section, "DLElementalDamageMaxConstB", 0, path);

	this->m_SUElementalDamageMinConstA = GetPrivateProfileInt(section, "SUElementalDamageMinConstA", 0, path);
	this->m_SUElementalDamageMaxConstA = GetPrivateProfileInt(section, "SUElementalDamageMaxConstA", 0, path);

	this->m_RFElementalDamageMinConstA = GetPrivateProfileInt(section, "RFElementalDamageMinConstA", 0, path);
	this->m_RFElementalDamageMinConstB = GetPrivateProfileInt(section, "RFElementalDamageMinConstB", 0, path);
	this->m_RFElementalDamageMaxConstA = GetPrivateProfileInt(section, "RFElementalDamageMaxConstA", 0, path);
	this->m_RFElementalDamageMaxConstB = GetPrivateProfileInt(section, "RFElementalDamageMaxConstB", 0, path);

	this->m_FKElementalDamageMinConstA = GetPrivateProfileInt(section, "GLElementalDamageMinConstA", 0, path);
	this->m_FKElementalDamageMaxConstA = GetPrivateProfileInt(section, "GLElementalDamageMaxConstA", 0, path);

	this->m_DWElementalAttackSuccessRateConstA = GetPrivateProfileInt(section, "DWElementalAttackSuccessRateConstA", 0, path);
	this->m_DWElementalAttackSuccessRateConstB = GetPrivateProfileInt(section, "DWElementalAttackSuccessRateConstB", 0, path);
	this->m_DWElementalAttackSuccessRateConstC = GetPrivateProfileInt(section, "DWElementalAttackSuccessRateConstC", 0, path);
	this->m_DWElementalAttackSuccessRateConstD = GetPrivateProfileInt(section, "DWElementalAttackSuccessRateConstD", 0, path);

	this->m_DKElementalAttackSuccessRateConstA = GetPrivateProfileInt(section, "DKElementalAttackSuccessRateConstA", 0, path);
	this->m_DKElementalAttackSuccessRateConstB = GetPrivateProfileInt(section, "DKElementalAttackSuccessRateConstB", 0, path);
	this->m_DKElementalAttackSuccessRateConstC = GetPrivateProfileInt(section, "DKElementalAttackSuccessRateConstC", 0, path);
	this->m_DKElementalAttackSuccessRateConstD = GetPrivateProfileInt(section, "DKElementalAttackSuccessRateConstD", 0, path);

	this->m_FEElementalAttackSuccessRateConstA = GetPrivateProfileInt(section, "FEElementalAttackSuccessRateConstA", 0, path);
	this->m_FEElementalAttackSuccessRateConstB = GetPrivateProfileInt(section, "FEElementalAttackSuccessRateConstB", 0, path);
	this->m_FEElementalAttackSuccessRateConstC = GetPrivateProfileInt(section, "FEElementalAttackSuccessRateConstC", 0, path);
	this->m_FEElementalAttackSuccessRateConstD = GetPrivateProfileInt(section, "FEElementalAttackSuccessRateConstD", 0, path);

	this->m_MGElementalAttackSuccessRateConstA = GetPrivateProfileInt(section, "MGElementalAttackSuccessRateConstA", 0, path);
	this->m_MGElementalAttackSuccessRateConstB = GetPrivateProfileInt(section, "MGElementalAttackSuccessRateConstB", 0, path);
	this->m_MGElementalAttackSuccessRateConstC = GetPrivateProfileInt(section, "MGElementalAttackSuccessRateConstC", 0, path);
	this->m_MGElementalAttackSuccessRateConstD = GetPrivateProfileInt(section, "MGElementalAttackSuccessRateConstD", 0, path);

	this->m_DLElementalAttackSuccessRateConstA = GetPrivateProfileInt(section, "DLElementalAttackSuccessRateConstA", 0, path);
	this->m_DLElementalAttackSuccessRateConstB = GetPrivateProfileInt(section, "DLElementalAttackSuccessRateConstB", 0, path);
	this->m_DLElementalAttackSuccessRateConstC = GetPrivateProfileInt(section, "DLElementalAttackSuccessRateConstC", 0, path);
	this->m_DLElementalAttackSuccessRateConstD = GetPrivateProfileInt(section, "DLElementalAttackSuccessRateConstD", 0, path);

	this->m_SUElementalAttackSuccessRateConstA = GetPrivateProfileInt(section, "SUElementalAttackSuccessRateConstA", 0, path);
	this->m_SUElementalAttackSuccessRateConstB = GetPrivateProfileInt(section, "SUElementalAttackSuccessRateConstB", 0, path);
	this->m_SUElementalAttackSuccessRateConstC = GetPrivateProfileInt(section, "SUElementalAttackSuccessRateConstC", 0, path);
	this->m_SUElementalAttackSuccessRateConstD = GetPrivateProfileInt(section, "SUElementalAttackSuccessRateConstD", 0, path);

	this->m_RFElementalAttackSuccessRateConstA = GetPrivateProfileInt(section, "RFElementalAttackSuccessRateConstA", 0, path);
	this->m_RFElementalAttackSuccessRateConstB = GetPrivateProfileInt(section, "RFElementalAttackSuccessRateConstB", 0, path);
	this->m_RFElementalAttackSuccessRateConstC = GetPrivateProfileInt(section, "RFElementalAttackSuccessRateConstC", 0, path);
	this->m_RFElementalAttackSuccessRateConstD = GetPrivateProfileInt(section, "RFElementalAttackSuccessRateConstD", 0, path);

	this->m_FKElementalAttackSuccessRateConstA = GetPrivateProfileInt(section, "GLElementalAttackSuccessRateConstA", 0, path);
	this->m_FKElementalAttackSuccessRateConstB = GetPrivateProfileInt(section, "GLElementalAttackSuccessRateConstB", 0, path);
	this->m_FKElementalAttackSuccessRateConstC = GetPrivateProfileInt(section, "GLElementalAttackSuccessRateConstC", 0, path);
	this->m_FKElementalAttackSuccessRateConstD = GetPrivateProfileInt(section, "GLElementalAttackSuccessRateConstD", 0, path);

	this->m_DWElementalDefenseSuccessRateConstA = GetPrivateProfileInt(section, "DWElementalDefenseSuccessRateConstA", 0, path);
	this->m_DKElementalDefenseSuccessRateConstA = GetPrivateProfileInt(section, "DKElementalDefenseSuccessRateConstA", 0, path);
	this->m_FEElementalDefenseSuccessRateConstA = GetPrivateProfileInt(section, "FEElementalDefenseSuccessRateConstA", 0, path);
	this->m_MGElementalDefenseSuccessRateConstA = GetPrivateProfileInt(section, "MGElementalDefenseSuccessRateConstA", 0, path);
	this->m_DLElementalDefenseSuccessRateConstA = GetPrivateProfileInt(section, "DLElementalDefenseSuccessRateConstA", 0, path);
	this->m_SUElementalDefenseSuccessRateConstA = GetPrivateProfileInt(section, "SUElementalDefenseSuccessRateConstA", 0, path);
	this->m_RFElementalDefenseSuccessRateConstA = GetPrivateProfileInt(section, "RFElementalDefenseSuccessRateConstA", 0, path);
	this->m_FKElementalDefenseSuccessRateConstA = GetPrivateProfileInt(section, "GLElementalDefenseSuccessRateConstA", 0, path);
}

void CServerInfo::ReadCommandConfig()
{
	this->m_CommandPostEnable[0] = GetPrivateProfileInt("POST", "Enable_AL0", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostEnable[1] = GetPrivateProfileInt("POST", "Enable_AL1", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostEnable[2] = GetPrivateProfileInt("POST", "Enable_AL2", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostEnable[3] = GetPrivateProfileInt("POST", "Enable_AL3", 0, gPath.GetRightPath("Commands\\Post.ini"));

	this->m_CommandPostLevel[0] = GetPrivateProfileInt("POST", "Level_AL0", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostLevel[1] = GetPrivateProfileInt("POST", "Level_AL1", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostLevel[2] = GetPrivateProfileInt("POST", "Level_AL2", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostLevel[3] = GetPrivateProfileInt("POST", "Level_AL3", 0, gPath.GetRightPath("Commands\\Post.ini"));

	this->m_CommandPostReset[0] = GetPrivateProfileInt("POST", "Reset_AL0", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostReset[1] = GetPrivateProfileInt("POST", "Reset_AL1", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostReset[2] = GetPrivateProfileInt("POST", "Reset_AL2", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostReset[3] = GetPrivateProfileInt("POST", "Reset_AL3", 0, gPath.GetRightPath("Commands\\Post.ini"));

	this->m_CommandPostMoney[0] = GetPrivateProfileInt("POST", "MoneyTax_AL0", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostMoney[1] = GetPrivateProfileInt("POST", "MoneyTax_AL1", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostMoney[2] = GetPrivateProfileInt("POST", "MoneyTax_AL2", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostMoney[3] = GetPrivateProfileInt("POST", "MoneyTax_AL3", 0, gPath.GetRightPath("Commands\\Post.ini"));

	this->m_CommandPostDelay[0] = GetPrivateProfileInt("POST", "Delay_AL0", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostDelay[1] = GetPrivateProfileInt("POST", "Delay_AL1", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostDelay[2] = GetPrivateProfileInt("POST", "Delay_AL2", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostDelay[3] = GetPrivateProfileInt("POST", "Delay_AL3", 0, gPath.GetRightPath("Commands\\Post.ini"));

	this->m_CommandPostGlobal[0] = GetPrivateProfileInt("POST", "Global_AL0", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostGlobal[1] = GetPrivateProfileInt("POST", "Global_AL1", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostGlobal[2] = GetPrivateProfileInt("POST", "Global_AL2", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostGlobal[3] = GetPrivateProfileInt("POST", "Global_AL3", 0, gPath.GetRightPath("Commands\\Post.ini"));

	this->m_CommandPostType[0] = GetPrivateProfileInt("POST", "Type_AL0", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostType[1] = GetPrivateProfileInt("POST", "Type_AL1", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostType[2] = GetPrivateProfileInt("POST", "Type_AL2", 0, gPath.GetRightPath("Commands\\Post.ini"));
	this->m_CommandPostType[3] = GetPrivateProfileInt("POST", "Type_AL3", 0, gPath.GetRightPath("Commands\\Post.ini"));

	/************************************************************************************************************************************/

	this->m_CommandAddPointEnable[0] = GetPrivateProfileInt("ADD", "Enable_AL0", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointEnable[1] = GetPrivateProfileInt("ADD", "Enable_AL1", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointEnable[2] = GetPrivateProfileInt("ADD", "Enable_AL2", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointEnable[3] = GetPrivateProfileInt("ADD", "Enable_AL3", 0, gPath.GetRightPath("Commands\\Add.ini"));

	this->m_CommandAddPointAutoEnable[0] = GetPrivateProfileInt("ADD", "AutoAddEnable_AL0", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointAutoEnable[1] = GetPrivateProfileInt("ADD", "AutoAddEnable_AL1", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointAutoEnable[2] = GetPrivateProfileInt("ADD", "AutoAddEnable_AL2", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointAutoEnable[3] = GetPrivateProfileInt("ADD", "AutoAddEnable_AL3", 0, gPath.GetRightPath("Commands\\Add.ini"));

	this->m_CommandAddPointMoney[0] = GetPrivateProfileInt("ADD", "MoneyTax_AL0", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointMoney[1] = GetPrivateProfileInt("ADD", "MoneyTax_AL1", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointMoney[2] = GetPrivateProfileInt("ADD", "MoneyTax_AL2", 0, gPath.GetRightPath("Commands\\Add.ini"));
	this->m_CommandAddPointMoney[3] = GetPrivateProfileInt("ADD", "MoneyTax_AL3", 0, gPath.GetRightPath("Commands\\Add.ini"));

	/**********************************************************************************************************************************/
	
	this->m_CommandPKClearEnable[0] = GetPrivateProfileInt("PKCLEAR", "Enable_AL0", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearEnable[1] = GetPrivateProfileInt("PKCLEAR", "Enable_AL1", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearEnable[2] = GetPrivateProfileInt("PKCLEAR", "Enable_AL2", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearEnable[3] = GetPrivateProfileInt("PKCLEAR", "Enable_AL3", 0, gPath.GetRightPath("Commands\\PkClear.ini"));

	this->m_CommandPKClearMoney[0] = GetPrivateProfileInt("PKCLEAR", "MoneyTax_AL0", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearMoney[1] = GetPrivateProfileInt("PKCLEAR", "MoneyTax_AL1", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearMoney[2] = GetPrivateProfileInt("PKCLEAR", "MoneyTax_AL2", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearMoney[3] = GetPrivateProfileInt("PKCLEAR", "MoneyTax_AL3", 0, gPath.GetRightPath("Commands\\PkClear.ini"));

	this->m_CommandPKClearGoblinPoint[0] = GetPrivateProfileInt("PKCLEAR", "GoblinPointTax_AL0", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearGoblinPoint[1] = GetPrivateProfileInt("PKCLEAR", "GoblinPointTax_AL1", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearGoblinPoint[2] = GetPrivateProfileInt("PKCLEAR", "GoblinPointTax_AL2", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearGoblinPoint[3] = GetPrivateProfileInt("PKCLEAR", "GoblinPointTax_AL3", 0, gPath.GetRightPath("Commands\\PkClear.ini"));

	this->m_CommandPKClearWCoinP[0] = GetPrivateProfileInt("PKCLEAR", "WCoinPTax_AL0", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearWCoinP[1] = GetPrivateProfileInt("PKCLEAR", "WCoinPTax_AL1", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearWCoinP[2] = GetPrivateProfileInt("PKCLEAR", "WCoinPTax_AL2", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearWCoinP[3] = GetPrivateProfileInt("PKCLEAR", "WCoinPTax_AL3", 0, gPath.GetRightPath("Commands\\PkClear.ini"));

	this->m_CommandPKClearWCoinC[0] = GetPrivateProfileInt("PKCLEAR", "WCoinCTax_AL0", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearWCoinC[1] = GetPrivateProfileInt("PKCLEAR", "WCoinCTax_AL1", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearWCoinC[2] = GetPrivateProfileInt("PKCLEAR", "WCoinCTax_AL2", 0, gPath.GetRightPath("Commands\\PkClear.ini"));
	this->m_CommandPKClearWCoinC[3] = GetPrivateProfileInt("PKCLEAR", "WCoinCTax_AL3", 0, gPath.GetRightPath("Commands\\PkClear.ini"));

	/**************************************************************************************************************************************/

	this->m_CommandRebuildEnable[0] = GetPrivateProfileInt("REBUILD", "Enable_AL0", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildEnable[1] = GetPrivateProfileInt("REBUILD", "Enable_AL1", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildEnable[2] = GetPrivateProfileInt("REBUILD", "Enable_AL2", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildEnable[3] = GetPrivateProfileInt("REBUILD", "Enable_AL3", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));

	this->m_CommandRebuildMoney[0] = GetPrivateProfileInt("REBUILD", "MoneyTax_AL0", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildMoney[1] = GetPrivateProfileInt("REBUILD", "MoneyTax_AL1", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildMoney[2] = GetPrivateProfileInt("REBUILD", "MoneyTax_AL2", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildMoney[3] = GetPrivateProfileInt("REBUILD", "MoneyTax_AL3", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));

	this->m_CommandRebuildGP[0] = GetPrivateProfileInt("REBUILD", "GoblinPoint_AL0", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildGP[1] = GetPrivateProfileInt("REBUILD", "GoblinPoint_AL1", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildGP[2] = GetPrivateProfileInt("REBUILD", "GoblinPoint_AL2", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildGP[3] = GetPrivateProfileInt("REBUILD", "GoblinPoint_AL3", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));

	this->m_CommandRebuildWP[0] = GetPrivateProfileInt("REBUILD", "WCoinPTax_AL0", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildWP[1] = GetPrivateProfileInt("REBUILD", "WCoinPTax_AL1", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildWP[2] = GetPrivateProfileInt("REBUILD", "WCoinPTax_AL2", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildWP[3] = GetPrivateProfileInt("REBUILD", "WCoinPTax_AL3", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));

	this->m_CommandRebuildWC[0] = GetPrivateProfileInt("REBUILD", "WCoinCTax_AL0", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildWC[1] = GetPrivateProfileInt("REBUILD", "WCoinCTax_AL1", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildWC[2] = GetPrivateProfileInt("REBUILD", "WCoinCTax_AL2", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));
	this->m_CommandRebuildWC[3] = GetPrivateProfileInt("REBUILD", "WCoinCTax_AL3", 0, gPath.GetRightPath("Commands\\Rebuild.ini"));

	/************************************************************************************************************************************/

	this->m_CommandChangeEnable[0] = GetPrivateProfileInt("EVO", "Enable_AL0", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeEnable[1] = GetPrivateProfileInt("EVO", "Enable_AL1", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeEnable[2] = GetPrivateProfileInt("EVO", "Enable_AL2", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeEnable[3] = GetPrivateProfileInt("EVO", "Enable_AL3", 0, gPath.GetRightPath("Commands\\Evo.ini"));

	this->m_CommandChangeMoney[0] = GetPrivateProfileInt("EVO", "MoneyTax_AL0", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeMoney[1] = GetPrivateProfileInt("EVO", "MoneyTax_AL1", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeMoney[2] = GetPrivateProfileInt("EVO", "MoneyTax_AL2", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeMoney[3] = GetPrivateProfileInt("EVO", "MoneyTax_AL3", 0, gPath.GetRightPath("Commands\\Evo.ini"));

	this->m_CommandChangeGP[0] = GetPrivateProfileInt("EVO", "GoblinPoint_AL0", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeGP[1] = GetPrivateProfileInt("EVO", "GoblinPoint_AL1", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeGP[2] = GetPrivateProfileInt("EVO", "GoblinPoint_AL2", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeGP[3] = GetPrivateProfileInt("EVO", "GoblinPoint_AL3", 0, gPath.GetRightPath("Commands\\Evo.ini"));

	this->m_CommandChangeWP[0] = GetPrivateProfileInt("EVO", "WCoinPTax_AL0", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeWP[1] = GetPrivateProfileInt("EVO", "WCoinPTax_AL1", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeWP[2] = GetPrivateProfileInt("EVO", "WCoinPTax_AL2", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeWP[3] = GetPrivateProfileInt("EVO", "WCoinPTax_AL3", 0, gPath.GetRightPath("Commands\\Evo.ini"));

	this->m_CommandChangeWC[0] = GetPrivateProfileInt("EVO", "WCoinCTax_AL0", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeWC[1] = GetPrivateProfileInt("EVO", "WCoinCTax_AL1", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeWC[2] = GetPrivateProfileInt("EVO", "WCoinCTax_AL2", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeWC[3] = GetPrivateProfileInt("EVO", "WCoinCTax_AL3", 0, gPath.GetRightPath("Commands\\Evo.ini"));

	this->m_CommandChangeLimit[0] = GetPrivateProfileInt("EVO", "CommandChangeLimit_AL0", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeLimit[1] = GetPrivateProfileInt("EVO", "CommandChangeLimit_AL1", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeLimit[2] = GetPrivateProfileInt("EVO", "CommandChangeLimit_AL2", 0, gPath.GetRightPath("Commands\\Evo.ini"));
	this->m_CommandChangeLimit[3] = GetPrivateProfileInt("EVO", "CommandChangeLimit_AL3", 0, gPath.GetRightPath("Commands\\Evo.ini"));

	/***********************************************************************************************************************************/

	this->m_CommandWareEnable[0] = GetPrivateProfileInt("WARE", "Enable_AL0", 0, gPath.GetRightPath("Commands\\Ware.ini"));
	this->m_CommandWareEnable[1] = GetPrivateProfileInt("WARE", "Enable_AL1", 0, gPath.GetRightPath("Commands\\Ware.ini"));
	this->m_CommandWareEnable[2] = GetPrivateProfileInt("WARE", "Enable_AL2", 0, gPath.GetRightPath("Commands\\Ware.ini"));
	this->m_CommandWareEnable[3] = GetPrivateProfileInt("WARE", "Enable_AL3", 0, gPath.GetRightPath("Commands\\Ware.ini"));

	this->m_CommandWareNumber[0] = GetPrivateProfileInt("WARE", "Limit_AL0", 0, gPath.GetRightPath("Commands\\Ware.ini"));
	this->m_CommandWareNumber[1] = GetPrivateProfileInt("WARE", "Limit_AL1", 0, gPath.GetRightPath("Commands\\Ware.ini"));
	this->m_CommandWareNumber[2] = GetPrivateProfileInt("WARE", "Limit_AL2", 0, gPath.GetRightPath("Commands\\Ware.ini"));
	this->m_CommandWareNumber[3] = GetPrivateProfileInt("WARE", "Limit_AL3", 0, gPath.GetRightPath("Commands\\Ware.ini"));

	/************************************************************************************************************************************/

	this->m_CommandResetType = GetPrivateProfileInt("RESET", "Type", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetEnable[0] = GetPrivateProfileInt("RESET", "Enable_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetEnable[1] = GetPrivateProfileInt("RESET", "Enable_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetEnable[2] = GetPrivateProfileInt("RESET", "Enable_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetEnable[3] = GetPrivateProfileInt("RESET", "Enable_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetAutoEnable[0] = GetPrivateProfileInt("RESET", "AutoResetEnable_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetAutoEnable[1] = GetPrivateProfileInt("RESET", "AutoResetEnable_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetAutoEnable[2] = GetPrivateProfileInt("RESET", "AutoResetEnable_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetAutoEnable[3] = GetPrivateProfileInt("RESET", "AutoResetEnable_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetCheckItem[0] = GetPrivateProfileInt("RESET", "CheckItem_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetCheckItem[1] = GetPrivateProfileInt("RESET", "CheckItem_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetCheckItem[2] = GetPrivateProfileInt("RESET", "CheckItem_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetCheckItem[3] = GetPrivateProfileInt("RESET", "CheckItem_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetMove[0] = GetPrivateProfileInt("RESET", "Move_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetMove[1] = GetPrivateProfileInt("RESET", "Move_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetMove[2] = GetPrivateProfileInt("RESET", "Move_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetMove[3] = GetPrivateProfileInt("RESET", "Move_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetQuest[0] = GetPrivateProfileInt("RESET", "Quest_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetQuest[1] = GetPrivateProfileInt("RESET", "Quest_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetQuest[2] = GetPrivateProfileInt("RESET", "Quest_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetQuest[3] = GetPrivateProfileInt("RESET", "Quest_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetSkill[0] = GetPrivateProfileInt("RESET", "Skill_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetSkill[1] = GetPrivateProfileInt("RESET", "Skill_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetSkill[2] = GetPrivateProfileInt("RESET", "Skill_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetSkill[3] = GetPrivateProfileInt("RESET", "Skill_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetLevel[0] = GetPrivateProfileInt("RESET", "Level_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLevel[1] = GetPrivateProfileInt("RESET", "Level_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLevel[2] = GetPrivateProfileInt("RESET", "Level_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLevel[3] = GetPrivateProfileInt("RESET", "Level_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetMoney[0] = GetPrivateProfileInt("RESET", "MoneyTax_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetMoney[1] = GetPrivateProfileInt("RESET", "MoneyTax_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetMoney[2] = GetPrivateProfileInt("RESET", "MoneyTax_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetMoney[3] = GetPrivateProfileInt("RESET", "MoneyTax_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetCount[0] = GetPrivateProfileInt("RESET", "Count_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetCount[1] = GetPrivateProfileInt("RESET", "Count_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetCount[2] = GetPrivateProfileInt("RESET", "Count_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetCount[3] = GetPrivateProfileInt("RESET", "Count_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetLimit[0] = GetPrivateProfileInt("RESET", "Limit_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimit[1] = GetPrivateProfileInt("RESET", "Limit_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimit[2] = GetPrivateProfileInt("RESET", "Limit_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimit[3] = GetPrivateProfileInt("RESET", "Limit_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetLimitDay[0] = GetPrivateProfileInt("RESET", "LimitDay_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitDay[1] = GetPrivateProfileInt("RESET", "LimitDay_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitDay[2] = GetPrivateProfileInt("RESET", "LimitDay_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitDay[3] = GetPrivateProfileInt("RESET", "LimitDay_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetLimitWek[0] = GetPrivateProfileInt("RESET", "LimitWek_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitWek[1] = GetPrivateProfileInt("RESET", "LimitWek_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitWek[2] = GetPrivateProfileInt("RESET", "LimitWek_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitWek[3] = GetPrivateProfileInt("RESET", "LimitWek_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetLimitMon[0] = GetPrivateProfileInt("RESET", "LimitMon_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitMon[1] = GetPrivateProfileInt("RESET", "LimitMon_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitMon[2] = GetPrivateProfileInt("RESET", "LimitMon_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetLimitMon[3] = GetPrivateProfileInt("RESET", "LimitMon_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetStartLevel[0] = GetPrivateProfileInt("RESET", "StartLevel_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetStartLevel[1] = GetPrivateProfileInt("RESET", "StartLevel_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetStartLevel[2] = GetPrivateProfileInt("RESET", "StartLevel_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetStartLevel[3] = GetPrivateProfileInt("RESET", "StartLevel_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetStartMasterLevel[0] = GetPrivateProfileInt("RESET", "StartMasterLevel_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetStartMasterLevel[1] = GetPrivateProfileInt("RESET", "StartMasterLevel_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetStartMasterLevel[2] = GetPrivateProfileInt("RESET", "StartMasterLevel_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetStartMasterLevel[3] = GetPrivateProfileInt("RESET", "StartMasterLevel_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetPoint[0] = GetPrivateProfileInt("RESET", "Point_AL0", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPoint[1] = GetPrivateProfileInt("RESET", "Point_AL1", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPoint[2] = GetPrivateProfileInt("RESET", "Point_AL2", 0, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPoint[3] = GetPrivateProfileInt("RESET", "Point_AL3", 0, gPath.GetRightPath("Commands\\Reset.ini"));

	this->m_CommandResetPointRate[0] = GetPrivateProfileInt("RESET", "PointRateDW", 100, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPointRate[1] = GetPrivateProfileInt("RESET", "PointRateDK", 100, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPointRate[2] = GetPrivateProfileInt("RESET", "PointRateFE", 100, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPointRate[3] = GetPrivateProfileInt("RESET", "PointRateMG", 100, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPointRate[4] = GetPrivateProfileInt("RESET", "PointRateDL", 100, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPointRate[5] = GetPrivateProfileInt("RESET", "PointRateSU", 100, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPointRate[6] = GetPrivateProfileInt("RESET", "PointRateRF", 100, gPath.GetRightPath("Commands\\Reset.ini"));
	this->m_CommandResetPointRate[7] = GetPrivateProfileInt("RESET", "PointRateGL", 100, gPath.GetRightPath("Commands\\Reset.ini"));

	/*************************************************************************************************************************************/

	this->m_CommandMasterResetType = GetPrivateProfileInt("MASTERRESET", "Type", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetEnable[0] = GetPrivateProfileInt("MASTERRESET", "Enable_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetEnable[1] = GetPrivateProfileInt("MASTERRESET", "Enable_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetEnable[2] = GetPrivateProfileInt("MASTERRESET", "Enable_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetEnable[3] = GetPrivateProfileInt("MASTERRESET", "Enable_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetCheckItem[0] = GetPrivateProfileInt("MASTERRESET", "CheckItem_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetCheckItem[1] = GetPrivateProfileInt("MASTERRESET", "CheckItem_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetCheckItem[2] = GetPrivateProfileInt("MASTERRESET", "CheckItem_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetCheckItem[3] = GetPrivateProfileInt("MASTERRESET", "CheckItem_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetMove[0] = GetPrivateProfileInt("MASTERRESET", "Move_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetMove[1] = GetPrivateProfileInt("MASTERRESET", "Move_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetMove[2] = GetPrivateProfileInt("MASTERRESET", "Move_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetMove[3] = GetPrivateProfileInt("MASTERRESET", "Move_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetQuest[0] = GetPrivateProfileInt("MASTERRESET", "Quest_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetQuest[1] = GetPrivateProfileInt("MASTERRESET", "Quest_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetQuest[2] = GetPrivateProfileInt("MASTERRESET", "Quest_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetQuest[3] = GetPrivateProfileInt("MASTERRESET", "Quest_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetSkill[0] = GetPrivateProfileInt("MASTERRESET", "Skill_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetSkill[1] = GetPrivateProfileInt("MASTERRESET", "Skill_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetSkill[2] = GetPrivateProfileInt("MASTERRESET", "Skill_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetSkill[3] = GetPrivateProfileInt("MASTERRESET", "Skill_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetLevel[0] = GetPrivateProfileInt("MASTERRESET", "Level_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLevel[1] = GetPrivateProfileInt("MASTERRESET", "Level_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLevel[2] = GetPrivateProfileInt("MASTERRESET", "Level_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLevel[3] = GetPrivateProfileInt("MASTERRESET", "Level_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetReset[0] = GetPrivateProfileInt("MASTERRESET", "Reset_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetReset[1] = GetPrivateProfileInt("MASTERRESET", "Reset_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetReset[2] = GetPrivateProfileInt("MASTERRESET", "Reset_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetReset[3] = GetPrivateProfileInt("MASTERRESET", "Reset_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetMoney[0] = GetPrivateProfileInt("MASTERRESET", "MoneyTax_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetMoney[1] = GetPrivateProfileInt("MASTERRESET", "MoneyTax_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetMoney[2] = GetPrivateProfileInt("MASTERRESET", "MoneyTax_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetMoney[3] = GetPrivateProfileInt("MASTERRESET", "MoneyTax_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetCount[0] = GetPrivateProfileInt("MASTERRESET", "Count_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetCount[1] = GetPrivateProfileInt("MASTERRESET", "Count_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetCount[2] = GetPrivateProfileInt("MASTERRESET", "Count_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetCount[3] = GetPrivateProfileInt("MASTERRESET", "Count_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetLimit[0] = GetPrivateProfileInt("MASTERRESET", "Limit_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimit[1] = GetPrivateProfileInt("MASTERRESET", "Limit_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimit[2] = GetPrivateProfileInt("MASTERRESET", "Limit_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimit[3] = GetPrivateProfileInt("MASTERRESET", "Limit_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetLimitDay[0] = GetPrivateProfileInt("MASTERRESET", "LimitDay_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitDay[1] = GetPrivateProfileInt("MASTERRESET", "LimitDay_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitDay[2] = GetPrivateProfileInt("MASTERRESET", "LimitDay_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitDay[3] = GetPrivateProfileInt("MASTERRESET", "LimitDay_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetLimitWek[0] = GetPrivateProfileInt("MASTERRESET", "LimitWek_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitWek[1] = GetPrivateProfileInt("MASTERRESET", "LimitWek_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitWek[2] = GetPrivateProfileInt("MASTERRESET", "LimitWek_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitWek[3] = GetPrivateProfileInt("MASTERRESET", "LimitWek_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetLimitMon[0] = GetPrivateProfileInt("MASTERRESET", "LimitMon_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitMon[1] = GetPrivateProfileInt("MASTERRESET", "LimitMon_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitMon[2] = GetPrivateProfileInt("MASTERRESET", "LimitMon_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetLimitMon[3] = GetPrivateProfileInt("MASTERRESET", "LimitMon_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetStartLevel[0] = GetPrivateProfileInt("MASTERRESET", "StartLevel_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetStartLevel[1] = GetPrivateProfileInt("MASTERRESET", "StartLevel_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetStartLevel[2] = GetPrivateProfileInt("MASTERRESET", "StartLevel_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetStartLevel[3] = GetPrivateProfileInt("MASTERRESET", "StartLevel_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetStartReset[0] = GetPrivateProfileInt("MASTERRESET", "StartReset_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetStartReset[1] = GetPrivateProfileInt("MASTERRESET", "StartReset_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetStartReset[2] = GetPrivateProfileInt("MASTERRESET", "StartReset_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetStartReset[3] = GetPrivateProfileInt("MASTERRESET", "StartReset_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetPoint[0] = GetPrivateProfileInt("MASTERRESET", "Point_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPoint[1] = GetPrivateProfileInt("MASTERRESET", "Point_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPoint[2] = GetPrivateProfileInt("MASTERRESET", "Point_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPoint[3] = GetPrivateProfileInt("MASTERRESET", "Point_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetPointRate[0] = GetPrivateProfileInt("MASTERRESET", "PointRateDW", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPointRate[1] = GetPrivateProfileInt("MASTERRESET", "PointRateDK", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPointRate[2] = GetPrivateProfileInt("MASTERRESET", "PointRateFE", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPointRate[3] = GetPrivateProfileInt("MASTERRESET", "PointRateMG", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPointRate[4] = GetPrivateProfileInt("MASTERRESET", "PointRateDL", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPointRate[5] = GetPrivateProfileInt("MASTERRESET", "PointRateSU", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPointRate[6] = GetPrivateProfileInt("MASTERRESET", "PointRateRF", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetPointRate[7] = GetPrivateProfileInt("MASTERRESET", "PointRateGL", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));

	this->m_CommandMasterResetRuudBonus[0] = GetPrivateProfileInt("MASTERRESET", "RuudBonus_AL0", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetRuudBonus[1] = GetPrivateProfileInt("MASTERRESET", "RuudBonus_AL1", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetRuudBonus[2] = GetPrivateProfileInt("MASTERRESET", "RuudBonus_AL2", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	this->m_CommandMasterResetRuudBonus[3] = GetPrivateProfileInt("MASTERRESET", "RuudBonus_AL3", 0, gPath.GetRightPath("Commands\\MasterReset.ini"));
	

	/************************************************************************************************************************************************/

	this->m_CommandClearInventoryEnable[0] = GetPrivateProfileInt("CLEARINVENTORY", "Enable_AL0", 0, gPath.GetRightPath("Commands\\ClearInventory.ini"));
	this->m_CommandClearInventoryEnable[1] = GetPrivateProfileInt("CLEARINVENTORY", "Enable_AL1", 0, gPath.GetRightPath("Commands\\ClearInventory.ini"));
	this->m_CommandClearInventoryEnable[2] = GetPrivateProfileInt("CLEARINVENTORY", "Enable_AL2", 0, gPath.GetRightPath("Commands\\ClearInventory.ini"));
	this->m_CommandClearInventoryEnable[3] = GetPrivateProfileInt("CLEARINVENTORY", "Enable_AL3", 0, gPath.GetRightPath("Commands\\ClearInventory.ini"));

	/**************************************************************************************************************************************************/

	GetPrivateProfileString("COIN", "ZenType", "", this->m_CommandCoinSyntaxZen, sizeof(this->m_CommandCoinSyntaxZen), gPath.GetRightPath("Commands\\Coin.ini"));
	GetPrivateProfileString("COIN", "GoblinPointType", "", this->m_CommandCoinSyntaxGP, sizeof(this->m_CommandCoinSyntaxGP), gPath.GetRightPath("Commands\\Coin.ini"));
	GetPrivateProfileString("COIN", "WCoinCType", "", this->m_CommandCoinSyntaxWC, sizeof(this->m_CommandCoinSyntaxWC), gPath.GetRightPath("Commands\\Coin.ini"));
	GetPrivateProfileString("COIN", "WCoinPType", "", this->m_CommandCoinSyntaxWP, sizeof(this->m_CommandCoinSyntaxWP), gPath.GetRightPath("Commands\\Coin.ini"));
	GetPrivateProfileString("COIN", "RuudType", "", this->m_CommandCoinSyntaxRuud, sizeof(this->m_CommandCoinSyntaxRuud), gPath.GetRightPath("Commands\\Coin.ini"));

	this->m_CommandRemoveWingOptionRuud = GetPrivateProfileInt("COIN", "RuudRemoveWingOption", 1000000, gPath.GetRightPath("Commands\\Coin.ini"));

	/*********************************************************************************************************************************************/

	this->m_CommandFillPotionEnable[0] = GetPrivateProfileInt("POTIONFILL", "Enable_AL0", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionEnable[1] = GetPrivateProfileInt("POTIONFILL", "Enable_AL1", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionEnable[2] = GetPrivateProfileInt("POTIONFILL", "Enable_AL2", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionEnable[3] = GetPrivateProfileInt("POTIONFILL", "Enable_AL3", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));

	this->m_CommandFillPotionMoney[0] = GetPrivateProfileInt("POTIONFILL", "MoneyTax_AL0", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionMoney[1] = GetPrivateProfileInt("POTIONFILL", "MoneyTax_AL1", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionMoney[2] = GetPrivateProfileInt("POTIONFILL", "MoneyTax_AL2", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionMoney[3] = GetPrivateProfileInt("POTIONFILL", "MoneyTax_AL3", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));

	this->m_CommandFillPotionGP[0] = GetPrivateProfileInt("POTIONFILL", "GoblinPoint_AL0", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionGP[1] = GetPrivateProfileInt("POTIONFILL", "GoblinPoint_AL1", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionGP[2] = GetPrivateProfileInt("POTIONFILL", "GoblinPoint_AL2", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionGP[3] = GetPrivateProfileInt("POTIONFILL", "GoblinPoint_AL3", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));

	this->m_CommandFillPotionWP[0] = GetPrivateProfileInt("POTIONFILL", "WCoinPTax_AL0", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionWP[1] = GetPrivateProfileInt("POTIONFILL", "WCoinPTax_AL1", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionWP[2] = GetPrivateProfileInt("POTIONFILL", "WCoinPTax_AL2", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionWP[3] = GetPrivateProfileInt("POTIONFILL", "WCoinPTax_AL3", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));

	this->m_CommandFillPotionWC[0] = GetPrivateProfileInt("POTIONFILL", "WCoinCTax_AL0", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionWC[1] = GetPrivateProfileInt("POTIONFILL", "WCoinCTax_AL1", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionWC[2] = GetPrivateProfileInt("POTIONFILL", "WCoinCTax_AL2", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionWC[2] = GetPrivateProfileInt("POTIONFILL", "WCoinCTax_AL2", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionWC[3] = GetPrivateProfileInt("POTIONFILL", "WCoinCTax_AL3", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));

	this->m_CommandFillPotionMaxAmount[0] = GetPrivateProfileInt("POTIONFILL", "MaxPotion_AL0", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionMaxAmount[1] = GetPrivateProfileInt("POTIONFILL", "MaxPotion_AL1", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionMaxAmount[2] = GetPrivateProfileInt("POTIONFILL", "MaxPotion_AL2", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
	this->m_CommandFillPotionMaxAmount[3] = GetPrivateProfileInt("POTIONFILL", "MaxPotion_AL3", 0, gPath.GetRightPath("Commands\\FillPotion.ini"));
}

void CServerInfo::ReadCommonInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	this->m_ServerMaxUserNumber = GetPrivateProfileInt(section, "ServerMaxUserNumber", 0, path);

	this->m_MainChecksum = GetPrivateProfileInt(section, "MainChecksum", 0, path);

	this->m_MaxItemOption = GetPrivateProfileInt(section, "MaxItemOption", 0, path);

	this->m_MaxIpConnection = GetPrivateProfileInt(section, "MaxIpConnection", 0, path);

	this->m_PersonalCodeCheck = GetPrivateProfileInt(section, "PersonalCodeCheck", 0, path);

	this->m_SetItemAcceptHarmonySwitch = GetPrivateProfileInt(section, "SetItemAcceptHarmonySwitch", 0, path);

	this->m_MonsterLifeRate = GetPrivateProfileInt(section, "MonsterLifeRate", 0, path);
	this->m_MonsterHealthBarSwitch = GetPrivateProfileInt(section, "MonsterHealthBarSwitch", 0, path);

	this->m_NonPK = GetPrivateProfileInt(section, "NonPK", 0, path);
	this->m_PKDownTime1 = GetPrivateProfileInt(section, "PKDownTime1", 0, path);
	this->m_PKDownTime2 = GetPrivateProfileInt(section, "PKDownTime2", 0, path);
	this->m_PKRuudDrop = GetPrivateProfileInt(section, "PKRuud", 0, path);
	this->m_PKRuudTax = GetPrivateProfileInt(section, "PKTax", 0, path);
	this->m_PKItemDrop = GetPrivateProfileInt(section, "PKItem", 0, path);

	this->m_PartyTeleportDelay = GetPrivateProfileInt(section, "PartyTeleportDelay", 20000, path);

	this->m_TradeSwitch = GetPrivateProfileInt(section, "TradeSwitch", 0, path);

	this->m_OficinaSwitch = GetPrivateProfileInt(section, "OficinaSwitch", 0, path);

	this->m_PersonalShopSwitch = GetPrivateProfileInt(section, "PersonalShopSwitch", 0, path);

	this->m_PersonalShopMoneyCommisionRate = GetPrivateProfileInt(section, "PersonalShopMoneyCommisionRate", 0, path);

	this->m_PersonalShopJewelCommisionRate = GetPrivateProfileInt(section, "PersonalShopJewelCommisionRate", 0, path);

	this->m_DuelSwitch = GetPrivateProfileInt(section, "DuelSwitch", 0, path);

#if(GAMESERVER_UPDATE>=402)

	this->m_DuelArenaAnnounceSwitch = GetPrivateProfileInt(section, "DuelArenaAnnounceSwitch", 0, path);

#endif

	this->m_GuildCreateSwitch = GetPrivateProfileInt(section, "GuildCreateSwitch", 0, path);
	this->m_GuildDeleteSwitch = GetPrivateProfileInt(section, "GuildDeleteSwitch", 0, path);
	this->m_GuildCreateMinLevel = GetPrivateProfileInt(section, "GuildCreateMinLevel", 0, path);
	this->m_GuildInsertMaxUser1 = GetPrivateProfileInt(section, "GuildInsertMaxUser1", 0, path);
	this->m_GuildInsertMaxUser2 = GetPrivateProfileInt(section, "GuildInsertMaxUser2", 0, path);
	this->m_GuildAllianceMinUser = GetPrivateProfileInt(section, "GuildAllianceMinUser", 0, path);
	this->m_GuildAllianceMaxCount = GetPrivateProfileInt(section, "GuildAllianceMaxCount", 0, path);
	this->m_GuildOwnerDestroyLimit = GetPrivateProfileInt(section, "GuildOwnerDestroyLimit", 0, path);
	this->m_GuildBattleMasterLimit = GetPrivateProfileInt(section, "GuildBattleMasterLimit", 5, path);
	this->m_GuildAssistentLimit = GetPrivateProfileInt(section, "GuildAssistentLimit", 1, path);



	this->m_ElfBufferMaxLevel[0] = GetPrivateProfileInt(section, "ElfBufferMaxLevel_AL0", 0, path);

	this->m_ElfBufferMaxLevel[1] = GetPrivateProfileInt(section, "ElfBufferMaxLevel_AL1", 0, path);

	this->m_ElfBufferMaxLevel[2] = GetPrivateProfileInt(section, "ElfBufferMaxLevel_AL2", 0, path);

	this->m_ElfBufferMaxLevel[3] = GetPrivateProfileInt(section, "ElfBufferMaxLevel_AL3", 0, path);

	this->m_ElfBufferMaxReset[0] = GetPrivateProfileInt(section, "ElfBufferMaxReset_AL0", 0, path);

	this->m_ElfBufferMaxReset[1] = GetPrivateProfileInt(section, "ElfBufferMaxReset_AL1", 0, path);

	this->m_ElfBufferMaxReset[2] = GetPrivateProfileInt(section, "ElfBufferMaxReset_AL2", 0, path);

	this->m_ElfBufferMaxReset[3] = GetPrivateProfileInt(section, "ElfBufferMaxReset_AL3", 0, path);

	this->m_ElfBufferDamageConstA = GetPrivateProfileInt(section, "ElfBufferDamageConstA", 0, path);

	this->m_ElfBufferDamageConstB = GetPrivateProfileInt(section, "ElfBufferDamageConstB", 0, path);

	this->m_ElfBufferDefenseConstA = GetPrivateProfileInt(section, "ElfBufferDefenseConstA", 0, path);

	this->m_ElfBufferDefenseConstB = GetPrivateProfileInt(section, "ElfBufferDefenseConstB", 0, path);

	this->m_AddExperienceRate[0] = GetPrivateProfileInt(section, "AddExperienceRate_AL0", 0, path);

	this->m_AddExperienceRate[1] = GetPrivateProfileInt(section, "AddExperienceRate_AL1", 0, path);

	this->m_AddExperienceRate[2] = GetPrivateProfileInt(section, "AddExperienceRate_AL2", 0, path);

	this->m_AddExperienceRate[3] = GetPrivateProfileInt(section, "AddExperienceRate_AL3", 0, path);

#if(GAMESERVER_UPDATE>=401)

	this->m_AddMasterExperienceRate[0] = GetPrivateProfileInt(section, "AddMasterExperienceRate_AL0", 0, path);

	this->m_AddMasterExperienceRate[1] = GetPrivateProfileInt(section, "AddMasterExperienceRate_AL1", 0, path);

	this->m_AddMasterExperienceRate[2] = GetPrivateProfileInt(section, "AddMasterExperienceRate_AL2", 0, path);

	this->m_AddMasterExperienceRate[3] = GetPrivateProfileInt(section, "AddMasterExperienceRate_AL3", 0, path);

	this->m_MinMasterExperienceMonsterLevel[0] = GetPrivateProfileInt(section, "MinMasterExperienceMonsterLevel_AL0", 0, path);

	this->m_MinMasterExperienceMonsterLevel[1] = GetPrivateProfileInt(section, "MinMasterExperienceMonsterLevel_AL1", 0, path);

	this->m_MinMasterExperienceMonsterLevel[2] = GetPrivateProfileInt(section, "MinMasterExperienceMonsterLevel_AL2", 0, path);

	this->m_MinMasterExperienceMonsterLevel[3] = GetPrivateProfileInt(section, "MinMasterExperienceMonsterLevel_AL3", 0, path);

#endif

	this->m_AddEventExperienceRate[0] = GetPrivateProfileInt(section, "AddEventExperienceRate_AL0", 0, path);

	this->m_AddEventExperienceRate[1] = GetPrivateProfileInt(section, "AddEventExperienceRate_AL1", 0, path);

	this->m_AddEventExperienceRate[2] = GetPrivateProfileInt(section, "AddEventExperienceRate_AL2", 0, path);

	this->m_AddEventExperienceRate[3] = GetPrivateProfileInt(section, "AddEventExperienceRate_AL3", 0, path);

#if(GAMESERVER_UPDATE>=501)

	this->m_AddQuestExperienceRate[0] = GetPrivateProfileInt(section, "AddQuestExperienceRate_AL0", 0, path);

	this->m_AddQuestExperienceRate[1] = GetPrivateProfileInt(section, "AddQuestExperienceRate_AL1", 0, path);

	this->m_AddQuestExperienceRate[2] = GetPrivateProfileInt(section, "AddQuestExperienceRate_AL2", 0, path);

	this->m_AddQuestExperienceRate[3] = GetPrivateProfileInt(section, "AddQuestExperienceRate_AL3", 0, path);

#endif

	this->m_ItemDropTime = GetPrivateProfileInt(section, "ItemDropTime", 0, path);

	this->m_ItemDropRate[0] = GetPrivateProfileInt(section, "ItemDropRate_AL0", 0, path);

	this->m_ItemDropRate[1] = GetPrivateProfileInt(section, "ItemDropRate_AL1", 0, path);

	this->m_ItemDropRate[2] = GetPrivateProfileInt(section, "ItemDropRate_AL2", 0, path);

	this->m_ItemDropRate[3] = GetPrivateProfileInt(section, "ItemDropRate_AL3", 0, path);

	this->m_MoneyDropTime = GetPrivateProfileInt(section, "MoneyDropTime", 0, path);

	this->m_MoneyAmountDropRate[0] = GetPrivateProfileInt(section, "MoneyAmountDropRate_AL0", 0, path);

	this->m_MoneyAmountDropRate[1] = GetPrivateProfileInt(section, "MoneyAmountDropRate_AL1", 0, path);

	this->m_MoneyAmountDropRate[2] = GetPrivateProfileInt(section, "MoneyAmountDropRate_AL2", 0, path);

	this->m_MoneyAmountDropRate[3] = GetPrivateProfileInt(section, "MoneyAmountDropRate_AL3", 0, path);

	this->m_WeaponDurabilityRate = GetPrivateProfileInt(section, "WeaponDurabilityRate", 0, path);

	this->m_ArmorDurabilityRate = GetPrivateProfileInt(section, "ArmorDurabilityRate", 0, path);

	this->m_WingDurabilityRate = GetPrivateProfileInt(section, "WingDurabilityRate", 0, path);

	this->m_GuardianDurabilityRate = GetPrivateProfileInt(section, "GuardianDurabilityRate", 0, path);

	this->m_PendantDurabilityRate = GetPrivateProfileInt(section, "PendantDurabilityRate", 0, path);

	this->m_RingDurabilityRate = GetPrivateProfileInt(section, "RingDurabilityRate", 0, path);

	this->m_PetDurabilityRate = GetPrivateProfileInt(section, "PetDurabilityRate", 0, path);

#if(GAMESERVER_UPDATE>=803)

	this->m_MuunDurabilityRate = GetPrivateProfileInt(section, "MuunDurabilityRate", 0, path);

#endif

	this->m_TradeItemBlock = GetPrivateProfileInt(section, "TradeItemBlock", 0, path);

	this->m_TradeItemBlockExc = GetPrivateProfileInt(section, "TradeItemBlockExc", 0, path);

	this->m_TradeItemBlockSet = GetPrivateProfileInt(section, "TradeItemBlockSet", 0, path);

	this->m_TradeItemBlockHarmony = GetPrivateProfileInt(section, "TradeItemBlockHarmony", 0, path);

	this->m_TradeItemBlockSell = GetPrivateProfileInt(section, "TradeItemBlockSell", 0, path);

	this->m_MaxLevelUp = GetPrivateProfileInt(section, "MaxLevelUp", 0, path);

	this->m_MaxLevelUpEvent = GetPrivateProfileInt(section, "MaxLevelUpEvent", 0, path);

	this->m_MaxLevelUpQuest = GetPrivateProfileInt(section, "MaxLevelUpQuest", 0, path);

	this->m_MaxStatPoint[0] = GetPrivateProfileInt(section, "MaxStatPoint_AL0", 0, path);
	this->m_MaxStatPoint[1] = GetPrivateProfileInt(section, "MaxStatPoint_AL1", 0, path);
	this->m_MaxStatPoint[2] = GetPrivateProfileInt(section, "MaxStatPoint_AL2", 0, path);
	this->m_MaxStatPoint[3] = GetPrivateProfileInt(section, "MaxStatPoint_AL3", 0, path);

	this->m_LevelUpPoint[0] = GetPrivateProfileInt(section, "DWLevelUpPoint", 0, path);
	this->m_LevelUpPoint[1] = GetPrivateProfileInt(section, "DKLevelUpPoint", 0, path);
	this->m_LevelUpPoint[2] = GetPrivateProfileInt(section, "FELevelUpPoint", 0, path);
	this->m_LevelUpPoint[3] = GetPrivateProfileInt(section, "MGLevelUpPoint", 0, path);
	this->m_LevelUpPoint[4] = GetPrivateProfileInt(section, "DLLevelUpPoint", 0, path);
	this->m_LevelUpPoint[5] = GetPrivateProfileInt(section, "SULevelUpPoint", 0, path);
	this->m_LevelUpPoint[6] = GetPrivateProfileInt(section, "RFLevelUpPoint", 0, path);
	this->m_LevelUpPoint[7] = GetPrivateProfileInt(section, "GLLevelUpPoint", 0, path);

	this->m_PlusStatPoint = GetPrivateProfileInt(section, "PlusStatPoint", 0, path);

	this->m_CharacterCreateSwitch = GetPrivateProfileInt(section, "CharacterCreateSwitch", 0, path);

	this->m_MGCreateType = GetPrivateProfileInt(section, "MGCreateType", 0, path);

	this->m_DLCreateType = GetPrivateProfileInt(section, "DLCreateType", 0, path);

#if(GAMESERVER_UPDATE>=301)

	this->m_SUCreateType = GetPrivateProfileInt(section, "SUCreateType", 0, path);

#endif

#if(GAMESERVER_UPDATE>=601)

	this->m_RFCreateType = GetPrivateProfileInt(section, "RFCreateType", 0, path);

#endif

	this->m_MGCreateLevel[0] = GetPrivateProfileInt(section, "MGCreateLevel_AL0", 0, path);

	this->m_MGCreateLevel[1] = GetPrivateProfileInt(section, "MGCreateLevel_AL1", 0, path);

	this->m_MGCreateLevel[2] = GetPrivateProfileInt(section, "MGCreateLevel_AL2", 0, path);

	this->m_MGCreateLevel[3] = GetPrivateProfileInt(section, "MGCreateLevel_AL3", 0, path);

	this->m_DLCreateLevel[0] = GetPrivateProfileInt(section, "DLCreateLevel_AL0", 0, path);

	this->m_DLCreateLevel[1] = GetPrivateProfileInt(section, "DLCreateLevel_AL1", 0, path);

	this->m_DLCreateLevel[2] = GetPrivateProfileInt(section, "DLCreateLevel_AL2", 0, path);

	this->m_DLCreateLevel[3] = GetPrivateProfileInt(section, "DLCreateLevel_AL3", 0, path);

#if(GAMESERVER_UPDATE>=301)

	this->m_SUCreateLevel[0] = GetPrivateProfileInt(section, "SUCreateLevel_AL0", 0, path);

	this->m_SUCreateLevel[1] = GetPrivateProfileInt(section, "SUCreateLevel_AL1", 0, path);

	this->m_SUCreateLevel[2] = GetPrivateProfileInt(section, "SUCreateLevel_AL2", 0, path);

	this->m_SUCreateLevel[3] = GetPrivateProfileInt(section, "SUCreateLevel_AL3", 0, path);

#endif

	this->m_RFCreateLevel[0] = GetPrivateProfileInt(section, "RFCreateLevel_AL0", 0, path);
	this->m_RFCreateLevel[1] = GetPrivateProfileInt(section, "RFCreateLevel_AL1", 0, path);
	this->m_RFCreateLevel[2] = GetPrivateProfileInt(section, "RFCreateLevel_AL2", 0, path);
	this->m_RFCreateLevel[3] = GetPrivateProfileInt(section, "RFCreateLevel_AL3", 0, path);


	this->m_GLCreateLevel[0] = GetPrivateProfileInt(section, "GLCreateLevel_AL0", 0, path);
	this->m_GLCreateLevel[1] = GetPrivateProfileInt(section, "GLCreateLevel_AL1", 0, path);
	this->m_GLCreateLevel[2] = GetPrivateProfileInt(section, "GLCreateLevel_AL2", 0, path);
	this->m_GLCreateLevel[3] = GetPrivateProfileInt(section, "GLCreateLevel_AL3", 0, path);

	this->m_ShieldGaugeRate = GetPrivateProfileInt(section, "ShieldGaugeRate", 0, path);
	this->m_ShieldGaugeConstA = GetPrivateProfileInt(section, "ShieldGaugeConstA", 0, path);
	this->m_ShieldGaugeConstB = GetPrivateProfileInt(section, "ShieldGaugeConstB", 0, path);

	this->m_ShieldGaugeAttackRate = GetPrivateProfileInt(section, "ShieldGaugeAttackRate", 0, path);

	this->m_ShieldGaugeAttackComboMiss = GetPrivateProfileInt(section, "ShieldGaugeAttackComboMiss", 0, path);

	this->m_MasterSkillTree = GetPrivateProfileInt(section, "MasterSkillTree", 0, path);
	this->m_MasterSkillTreePoint = GetPrivateProfileInt(section, "MasterSkillTreePoint", 0, path);
	this->m_MasterSkillTreeMinClass = GetPrivateProfileInt(section, "MasterSkillTreeMinClass", 0, path);
	this->m_MasterSkillTreeMaxLevel = GetPrivateProfileInt(section, "MasterSkillTreeMaxLevel", 0, path);


	this->m_ForMasterSkillTree = GetPrivateProfileInt(section, "ForMasterSkillTree", 0, path);
	this->m_ForMasterSkillTreePoint = GetPrivateProfileInt(section, "ForMasterSkillTreePoint", 0, path);
	this->m_ForMasterTreeMaxLevel = GetPrivateProfileInt(section, "ForMasterSkillTreeMaxLevel", 0, path);

	this->m_AddForMasterExperienceRate[0] = GetPrivateProfileInt(section, "AddForMasterExperienceRate_AL0", 0, path);
	this->m_AddForMasterExperienceRate[1] = GetPrivateProfileInt(section, "AddForMasterExperienceRate_AL1", 0, path);
	this->m_AddForMasterExperienceRate[2] = GetPrivateProfileInt(section, "AddForMasterExperienceRate_AL2", 0, path);
	this->m_AddForMasterExperienceRate[3] = GetPrivateProfileInt(section, "AddForMasterExperienceRate_AL3", 0, path);

	this->m_MinForMasterExperienceMonsterLevel[0] = GetPrivateProfileInt(section, "MinForMasterExperienceMonsterLevel_AL0", 0, path);
	this->m_MinForMasterExperienceMonsterLevel[1] = GetPrivateProfileInt(section, "MinForMasterExperienceMonsterLevel_AL1", 0, path);
	this->m_MinForMasterExperienceMonsterLevel[2] = GetPrivateProfileInt(section, "MinForMasterExperienceMonsterLevel_AL2", 0, path);
	this->m_MinForMasterExperienceMonsterLevel[3] = GetPrivateProfileInt(section, "MinForMasterExperienceMonsterLevel_AL3", 0, path);

	this->m_GensSystemSwitch = GetPrivateProfileInt(section, "GensSystemSwitch", 0, path);
	this->m_GensSystemGuildLock = GetPrivateProfileInt(section, "GensSystemGuildLock", 0, path);
	this->m_GensSystemPartyLock = GetPrivateProfileInt(section, "GensSystemPartyLock", 0, path);
	this->m_GensSystemInsertMinLevel = GetPrivateProfileInt(section, "GensSystemInsertMinLevel", 0, path);
	this->m_GensSystemContributionFloodTime = GetPrivateProfileInt(section, "GensSystemContributionFloodTime", 0, path);
	this->m_GensSystemVictimContributionDecrease = GetPrivateProfileInt(section, "GensSystemVictimContributionDecrease", 0, path);
	this->m_GensSystemKillerContributionIncrease = GetPrivateProfileInt(section, "GensSystemKillerContributionIncrease", 0, path);
	this->m_GensSystemVictimMinContributionDecrease = GetPrivateProfileInt(section, "GensSystemVictimMinContributionDecrease", 0, path);
	this->m_GensSystemVictimMaxContributionDecrease = GetPrivateProfileInt(section, "GensSystemVictimMaxContributionDecrease", 0, path);
	this->m_GensSystemKillerMinContributionIncrease = GetPrivateProfileInt(section, "GensSystemKillerMinContributionIncrease", 0, path);
	this->m_GensSystemKillerMaxContributionIncrease = GetPrivateProfileInt(section, "GensSystemKillerMaxContributionIncrease", 0, path);
	this->m_GensSystemStartRewardDay = GetPrivateProfileInt(section, "GensSystemStartRewardDay", 0, path);
	this->m_GensSystemFinalRewardDay = GetPrivateProfileInt(section, "GensSystemFinalRewardDay", 0, path);

	this->m_HelperSwitch = GetPrivateProfileInt(section, "HelperSwitch", 0, path);
	this->m_HelperActiveLevel = GetPrivateProfileInt(section, "HelperActiveLevel", 0, path);
	this->m_HelperActiveDelay = GetPrivateProfileInt(section, "HelperActiveDelay", 0, path);
	this->m_HelperActiveMoney[0] = GetPrivateProfileInt(section, "HelperActiveMoney1", 0, path);
	this->m_HelperActiveMoney[1] = GetPrivateProfileInt(section, "HelperActiveMoney2", 0, path);
	this->m_HelperActiveMoney[2] = GetPrivateProfileInt(section, "HelperActiveMoney3", 0, path);
	this->m_HelperActiveMoney[3] = GetPrivateProfileInt(section, "HelperActiveMoney4", 0, path);
	this->m_HelperActiveMoney[4] = GetPrivateProfileInt(section, "HelperActiveMoney5", 0, path);

	this->m_EventInventorySwitch = GetPrivateProfileInt(section, "EventInventorySwitch", 0, path);
	this->m_EventInventoryExpireYear = GetPrivateProfileInt(section, "EventInventoryExpireYear", 0, path);
	this->m_EventInventoryExpireMonth = GetPrivateProfileInt(section, "EventInventoryExpireMonth", 0, path);
	this->m_EventInventoryExpireDay = GetPrivateProfileInt(section, "EventInventoryExpireDay", 0, path);

	this->m_MuRummySwitch = GetPrivateProfileInt(section, "MuRummySwitch", 0, path);
	this->m_MuRummyRewardScore1 = GetPrivateProfileInt(section, "MuRummyRewardScore1", 0, path);
	this->m_MuRummyRewardScore2 = GetPrivateProfileInt(section, "MuRummyRewardScore2", 0, path);
	this->m_MuRummyRewardMoneyAmount = GetPrivateProfileInt(section, "MuRummyRewardMoneyAmount", 0, path);

	this->m_BombHuntEventOn = GetPrivateProfileInt(section, "BombHuntEventOn", 0, path);

	this->m_PartyReconnectTime = GetPrivateProfileInt(section, "PartyReconnectTime", 0, path);
	this->m_PartyGeneralExperience[0] = GetPrivateProfileInt(section, "PartyGeneralExperience1", 0, path);
	this->m_PartyGeneralExperience[1] = GetPrivateProfileInt(section, "PartyGeneralExperience2", 0, path);
	this->m_PartyGeneralExperience[2] = GetPrivateProfileInt(section, "PartyGeneralExperience3", 0, path);
	this->m_PartyGeneralExperience[3] = GetPrivateProfileInt(section, "PartyGeneralExperience4", 0, path);
	this->m_PartyGeneralExperience[4] = GetPrivateProfileInt(section, "PartyGeneralExperience5", 0, path);
	this->m_PartySpecialExperience[0] = GetPrivateProfileInt(section, "PartySpecialExperience1", 0, path);
	this->m_PartySpecialExperience[1] = GetPrivateProfileInt(section, "PartySpecialExperience2", 0, path);
	this->m_PartySpecialExperience[2] = GetPrivateProfileInt(section, "PartySpecialExperience3", 0, path);
	this->m_PartySpecialExperience[3] = GetPrivateProfileInt(section, "PartySpecialExperience4", 0, path);
	this->m_PartySpecialExperience[4] = GetPrivateProfileInt(section, "PartySpecialExperience5", 0, path);

	this->m_ApplePotionRate = GetPrivateProfileInt(section, "ApplePotionRate", 0, path);
	this->m_SmallLifePotionRate = GetPrivateProfileInt(section, "SmallLifePotionRate", 0, path);
	this->m_MidleLifePotionRate = GetPrivateProfileInt(section, "MidleLifePotionRate", 0, path);
	this->m_LargeLifePotionRate = GetPrivateProfileInt(section, "LargeLifePotionRate", 0, path);
	this->m_SmallManaPotionRate = GetPrivateProfileInt(section, "SmallManaPotionRate", 0, path);
	this->m_MidleManaPotionRate = GetPrivateProfileInt(section, "MidleManaPotionRate", 0, path);
	this->m_LargeManaPotionRate = GetPrivateProfileInt(section, "LargeManaPotionRate", 0, path);
	this->m_SmallShieldPotionRate = GetPrivateProfileInt(section, "SmallShieldPotionRate", 0, path);
	this->m_MidleShieldPotionRate = GetPrivateProfileInt(section, "MidleShieldPotionRate", 0, path);
	this->m_LargeShieldPotionRate = GetPrivateProfileInt(section, "LargeShieldPotionRate", 0, path);
	this->m_SmallCompoundPotionRate1 = GetPrivateProfileInt(section, "SmallCompoundPotionRate1", 0, path);
	this->m_SmallCompoundPotionRate2 = GetPrivateProfileInt(section, "SmallCompoundPotionRate2", 0, path);
	this->m_MidleCompoundPotionRate1 = GetPrivateProfileInt(section, "MidleCompoundPotionRate1", 0, path);
	this->m_MidleCompoundPotionRate2 = GetPrivateProfileInt(section, "MidleCompoundPotionRate2", 0, path);
	this->m_LargeCompoundPotionRate1 = GetPrivateProfileInt(section, "LargeCompoundPotionRate1", 0, path);
	this->m_LargeCompoundPotionRate2 = GetPrivateProfileInt(section, "LargeCompoundPotionRate2", 0, path);

	this->m_EliteLifePotionRate = GetPrivateProfileInt(section, "EliteLifePotionRate", 0, path);
	this->m_EliteManaPotionRate = GetPrivateProfileInt(section, "EliteManaPotionRate", 0, path);
	this->m_EliteShieldPotionRate = GetPrivateProfileInt(section, "EliteShieldPotionRate", 0, path);

	this->m_PotionMode = GetPrivateProfileInt(section, "PotionMode", 0, path);
	this->m_PotionModeDelay = GetPrivateProfileInt(section, "PotionModeDelay", 500, path);

	this->m_TransformationRing1 = GetPrivateProfileInt(section, "TransformationRing1", 0, path);
	this->m_TransformationRing2 = GetPrivateProfileInt(section, "TransformationRing2", 0, path);
	this->m_TransformationRing3 = GetPrivateProfileInt(section, "TransformationRing3", 0, path);
	this->m_TransformationRing4 = GetPrivateProfileInt(section, "TransformationRing4", 0, path);
	this->m_TransformationRing5 = GetPrivateProfileInt(section, "TransformationRing5", 0, path);
	this->m_TransformationRing6 = GetPrivateProfileInt(section, "TransformationRing6", 0, path);

	this->m_SoulSuccessRate[0] = GetPrivateProfileInt(section, "SoulSuccessRate_AL0", 0, path);
	this->m_SoulSuccessRate[1] = GetPrivateProfileInt(section, "SoulSuccessRate_AL1", 0, path);
	this->m_SoulSuccessRate[2] = GetPrivateProfileInt(section, "SoulSuccessRate_AL2", 0, path);
	this->m_SoulSuccessRate[3] = GetPrivateProfileInt(section, "SoulSuccessRate_AL3", 0, path);

	this->m_LifeSuccessRate[0] = GetPrivateProfileInt(section, "LifeSuccessRate_AL0", 0, path);
	this->m_LifeSuccessRate[1] = GetPrivateProfileInt(section, "LifeSuccessRate_AL1", 0, path);
	this->m_LifeSuccessRate[2] = GetPrivateProfileInt(section, "LifeSuccessRate_AL2", 0, path);
	this->m_LifeSuccessRate[3] = GetPrivateProfileInt(section, "LifeSuccessRate_AL3", 0, path);

	this->m_LifeSuccessRateLuck[0] = GetPrivateProfileInt(section, "LifeSuccessRateLuck_AL0", 0, path);
	this->m_LifeSuccessRateLuck[1] = GetPrivateProfileInt(section, "LifeSuccessRateLuck_AL1", 0, path);
	this->m_LifeSuccessRateLuck[2] = GetPrivateProfileInt(section, "LifeSuccessRateLuck_AL2", 0, path);
	this->m_LifeSuccessRateLuck[3] = GetPrivateProfileInt(section, "LifeSuccessRateLuck_AL3", 0, path);

	this->m_HarmonySuccessRate[0] = GetPrivateProfileInt(section, "HarmonySuccessRate_AL0", 0, path);
	this->m_HarmonySuccessRate[1] = GetPrivateProfileInt(section, "HarmonySuccessRate_AL1", 0, path);
	this->m_HarmonySuccessRate[2] = GetPrivateProfileInt(section, "HarmonySuccessRate_AL2", 0, path);
	this->m_HarmonySuccessRate[3] = GetPrivateProfileInt(section, "HarmonySuccessRate_AL3", 0, path);

	this->m_SmeltStoneSuccessRate1[0] = GetPrivateProfileInt(section, "SmeltStoneSuccessRate1_AL0", 0, path);
	this->m_SmeltStoneSuccessRate1[1] = GetPrivateProfileInt(section, "SmeltStoneSuccessRate1_AL1", 0, path);
	this->m_SmeltStoneSuccessRate1[2] = GetPrivateProfileInt(section, "SmeltStoneSuccessRate1_AL2", 0, path);
	this->m_SmeltStoneSuccessRate1[3] = GetPrivateProfileInt(section, "SmeltStoneSuccessRate1_AL3", 0, path);

	this->m_SmeltStoneSuccessRate2[0] = GetPrivateProfileInt(section, "SmeltStoneSuccessRate2_AL0", 0, path);
	this->m_SmeltStoneSuccessRate2[1] = GetPrivateProfileInt(section, "SmeltStoneSuccessRate2_AL1", 0, path);
	this->m_SmeltStoneSuccessRate2[2] = GetPrivateProfileInt(section, "SmeltStoneSuccessRate2_AL2", 0, path);
	this->m_SmeltStoneSuccessRate2[3] = GetPrivateProfileInt(section, "SmeltStoneSuccessRate2_AL3", 0, path);

	this->m_AddLuckSuccessRate1[0] = GetPrivateProfileInt(section, "AddLuckSuccessRate1_AL0", 0, path);
	this->m_AddLuckSuccessRate1[1] = GetPrivateProfileInt(section, "AddLuckSuccessRate1_AL1", 0, path);
	this->m_AddLuckSuccessRate1[2] = GetPrivateProfileInt(section, "AddLuckSuccessRate1_AL2", 0, path);
	this->m_AddLuckSuccessRate1[3] = GetPrivateProfileInt(section, "AddLuckSuccessRate1_AL3", 0, path);

	this->m_AddLuckSuccessRate2[0] = GetPrivateProfileInt(section, "AddLuckSuccessRate2_AL0", 0, path);
	this->m_AddLuckSuccessRate2[1] = GetPrivateProfileInt(section, "AddLuckSuccessRate2_AL1", 0, path);
	this->m_AddLuckSuccessRate2[2] = GetPrivateProfileInt(section, "AddLuckSuccessRate2_AL2", 0, path);
	this->m_AddLuckSuccessRate2[3] = GetPrivateProfileInt(section, "AddLuckSuccessRate2_AL3", 0, path);

	this->m_FruitAddPointMin = GetPrivateProfileInt(section, "FruitAddPointMin", 0, path);
	this->m_FruitAddPointMax = GetPrivateProfileInt(section, "FruitAddPointMax", 0, path);

	this->m_FruitAddPointSuccessRate[0] = GetPrivateProfileInt(section, "FruitAddPointSuccessRate_AL0", 0, path);
	this->m_FruitAddPointSuccessRate[1] = GetPrivateProfileInt(section, "FruitAddPointSuccessRate_AL1", 0, path);
	this->m_FruitAddPointSuccessRate[2] = GetPrivateProfileInt(section, "FruitAddPointSuccessRate_AL2", 0, path);
	this->m_FruitAddPointSuccessRate[3] = GetPrivateProfileInt(section, "FruitAddPointSuccessRate_AL3", 0, path);

	this->m_FruitSubPointMin = GetPrivateProfileInt(section, "FruitSubPointMin", 0, path);
	this->m_FruitSubPointMax = GetPrivateProfileInt(section, "FruitSubPointMax", 0, path);

	this->m_FruitSubPointSuccessRate[0] = GetPrivateProfileInt(section, "FruitSubPointSuccessRate_AL0", 0, path);
	this->m_FruitSubPointSuccessRate[1] = GetPrivateProfileInt(section, "FruitSubPointSuccessRate_AL1", 0, path);
	this->m_FruitSubPointSuccessRate[2] = GetPrivateProfileInt(section, "FruitSubPointSuccessRate_AL2", 0, path);
	this->m_FruitSubPointSuccessRate[3] = GetPrivateProfileInt(section, "FruitSubPointSuccessRate_AL3", 0, path);

	this->m_MysteriouStoneSetApplyRate			= GetPrivateProfileInt(section, "MysteriouStoneSetApplyRate", 0, path);
	this->m_MysteriouStoneBlueEyeSetApplyRate	= GetPrivateProfileInt(section, "MysteriouStoneBlueEyeSetApplyRate", 0, path);
	this->m_MysteriouStoneSilverHeartSetApplyRate = GetPrivateProfileInt(section, "MysteriouStoneSilverHeartSetApplyRate", 0, path);
	this->m_MysteriouStoneWeaponApplyRate		= GetPrivateProfileInt(section, "MysteriouStoneWeaponApplyRate", 0, path);
	this->m_MysteriouStoneBlueEyeWeaponApplyRate= GetPrivateProfileInt(section, "MysteriouStoneBlueEyeWeaponApplyRate", 0, path);
	this->m_MysteriouStoneSilverHeartWeaponApplyRate = GetPrivateProfileInt(section, "MysteriouStoneSilverHeartWeaponApplyRate", 0, path);
	this->m_MysteriouStoneShieldApplyRate		= GetPrivateProfileInt(section, "MysteriouStoneShieldApplyRate", 0, path);
	this->m_MysteriouStoneRingApplyRate			= GetPrivateProfileInt(section, "MysteriouStoneRingApplyRate", 0, path);
	this->m_MysteriouStonePendantApplyRate		= GetPrivateProfileInt(section, "MysteriouStonePendantApplyRate", 0, path);	
}

void CServerInfo::ReadCustomInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	this->m_AnnounceChaosMix = GetPrivateProfileInt(section, "AnnounceChaosMix", 0, path);

	GetPrivateProfileString(section, "AnnounceChaosMixText", "", this->m_AnnounceChaosMixText, sizeof(this->m_AnnounceChaosMixText), path);
}

void CServerInfo::ReadEventInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	this->m_BloodCastleEvent		= GetPrivateProfileInt(section, "BloodCastleEvent", 0, path);
	this->m_BloodCastleMaxUser		= GetPrivateProfileInt(section, "BloodCastleMaxUser", 0, path);
	this->m_BloodCastleRewardParty	= GetPrivateProfileInt(section, "BloodCastleRewardParty", 1, path);

	this->m_BonusManagerSwitch = GetPrivateProfileInt(section, "BonusManagerSwitch", 0, path);

	this->m_CastleDeepEvent = GetPrivateProfileInt(section, "CastleDeepEvent", 0, path);
	this->m_CastleDeepEventTime = GetPrivateProfileInt(section, "CastleDeepEventTime", 0, path);

	this->m_CastleSiegeEvent = GetPrivateProfileInt(section, "CastleSiegeEvent", 0, path);
	this->m_CastleSiegeCycleStartYear = GetPrivateProfileInt(section, "CastleSiegeCycleStartYear", 0, path);
	this->m_CastleSiegeCycleStartMonth = GetPrivateProfileInt(section, "CastleSiegeCycleStartMonth", 0, path);
	this->m_CastleSiegeCycleStartDay = GetPrivateProfileInt(section, "CastleSiegeCycleStartDay", 0, path);
	this->m_CastleSiegeSpecificState = GetPrivateProfileInt(section, "CastleSiegeSpecificState", 0, path);
	this->m_CastleSiegeStateStartYear = GetPrivateProfileInt(section, "CastleSiegeStateStartYear", 0, path);
	this->m_CastleSiegeStateStartMonth = GetPrivateProfileInt(section, "CastleSiegeStateStartMonth", 0, path);
	this->m_CastleSiegeStateStartDay = GetPrivateProfileInt(section, "CastleSiegeStateStartDay", 0, path);
	this->m_CastleSiegeStateStartHour = GetPrivateProfileInt(section, "CastleSiegeStateStartHour", 0, path);
	this->m_CastleSiegeStateStartMinute = GetPrivateProfileInt(section, "CastleSiegeStateStartMinute", 0, path);
	this->m_CastleSiegeOffensiveWeaponDamage = GetPrivateProfileInt(section, "CastleSiegeOffensiveWeaponDamage", 0, path);
	this->m_CastleSiegeDefensiveWeaponDamage = GetPrivateProfileInt(section, "CastleSiegeDefensiveWeaponDamage", 0, path);
	

	this->m_ChaosCastleEvent = GetPrivateProfileInt(section, "ChaosCastleEvent", 0, path);
	this->m_ChaosCastleMinUser = GetPrivateProfileInt(section, "ChaosCastleMinUser", 0, path);
	this->m_ChaosCastleBlowUserRate = GetPrivateProfileInt(section, "ChaosCastleBlowUserRate", 0, path);

	gCrywolfSync.SetEnableCrywolf((this->m_CrywolfEvent = GetPrivateProfileInt(section, "CrywolfEvent", 0, path)));
	gCrywolfSync.SetApplyBenefit((this->m_CrywolfBenefitSwitch = GetPrivateProfileInt(section, "CrywolfBenefitSwitch", 0, path)));

	gCrywolfSync.SetPlusChaosRate((this->m_CrywolfBenefitChaosRate = GetPrivateProfileInt(section, "CrywolfBenefitChaosRate", 0, path)));

	gCrywolfSync.SetMonHPBenefitRate((this->m_CrywolfBenefitMonsterLife = GetPrivateProfileInt(section, "CrywolfBenefitMonsterLife", 0, path)));

	gCrywolfSync.SetApplyPenalty((this->m_CrywolfPenaltySwitch = GetPrivateProfileInt(section, "CrywolfPenaltySwitch", 0, path)));

	gCrywolfSync.SetGemDropPenaltiyRate((this->m_CrywolfPenaltyJewelDrop = GetPrivateProfileInt(section, "CrywolfPenaltyJewelDrop", 0, path)));

	gCrywolfSync.SetGettingExpPenaltyRate((this->m_CrywolfPenaltyExperience = GetPrivateProfileInt(section, "CrywolfPenaltyExperience", 0, path)));

	this->m_DevilSquareEvent = GetPrivateProfileInt(section, "DevilSquareEvent", 0, path);
	this->m_DevilSquareMaxUser = GetPrivateProfileInt(section, "DevilSquareMaxUser", 0, path);
	   
	this->m_DoubleGoerEvent = GetPrivateProfileInt(section, "DoubleGoerEvent", 0, path);
	this->m_DoubleGoerDifficultRate = GetPrivateProfileInt(section, "DoubleGoerDifficultRate", 0, path);
	   
	this->m_IllusionTempleEvent			= GetPrivateProfileInt(section, "IllusionTempleEvent", 0, path);
	this->m_IllusionTempleMinUser		= GetPrivateProfileInt(section, "IllusionTempleMinUser", 0, path);
	this->m_IllusionTempleRestrictPC	= GetPrivateProfileInt(section, "IllusionTempleMaxDailyEnter", 0, path);
	this->m_IllusionTempleMaxDailyEnter	= GetPrivateProfileInt(section, "IllusionTempleMaxDailyEnter", 0, path);
	this->m_IllusionTempleMaxDailyWins	= GetPrivateProfileInt(section, "IllusionTempleMaxDailyWins", 0, path);

	this->m_ImperialGuardianEvent = GetPrivateProfileInt(section, "ImperialGuardianEvent", 0, path);
	this->m_ImperialGuardianDifficultRate = GetPrivateProfileInt(section, "ImperialGuardianDifficultRate", 0, path);

	this->m_KanturuEvent = GetPrivateProfileInt(section, "KanturuEvent", 0, path);

	this->m_MossMerchantEvent = GetPrivateProfileInt(section, "MossMerchantEvent", 0, path);
	this->m_MossMerchantEventTime = GetPrivateProfileInt(section, "MossMerchantEventTime", 0, path);

	this->m_RaklionEvent = GetPrivateProfileInt(section, "RaklionEvent", 0, path);

	this->m_SilvesterMaxPlayers = GetPrivateProfileInt(section, "SilvesterMaxPlayers", 5, path);

	this->m_GodOfDarknessMaxPlayers = GetPrivateProfileInt(section, "GodOfDarknessMaxPlayers", 5, path);
	this->m_GodOfDarknessWarningTime = GetPrivateProfileInt(section, "GodOfDarknessWarningTime", 5, path);

	this->m_NixDevilIceDelay = GetPrivateProfileInt(section, "NixDevilIceDelay", 60, path);
	this->m_NixRegenTime = GetPrivateProfileInt(section, "NixRegenTime", 30, path);
	this->m_NixDieTime = GetPrivateProfileInt(section, "NixDieTime", 5, path);
	this->m_NixRestrictPC = GetPrivateProfileInt(section, "NixRestrictPC", 0, path);

	this->m_MagicMazeEvent = GetPrivateProfileInt(section, "MagicMazeEvent", 0, path);

	this->OrdnaelEggDropRate = GetPrivateProfileInt(section, "OrdnaelEggDropRate", 3, path);
}

void CServerInfo::ReadHackInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	this->m_CheckSpeedHack = GetPrivateProfileInt(section, "CheckSpeedHack", 0, path);

	this->m_CheckSpeedHackTolerance = GetPrivateProfileInt(section, "CheckSpeedHackTolerance", 0, path);

	this->m_CheckLatencyHack = GetPrivateProfileInt(section, "CheckLatencyHack", 0, path);

	this->m_CheckLatencyHackTolerance = GetPrivateProfileInt(section, "CheckLatencyHackTolerance", 0, path);

	this->m_CheckAutoPotionHack = GetPrivateProfileInt(section, "CheckAutoPotionHack", 0, path);

	this->m_CheckAutoPotionHackTolerance = GetPrivateProfileInt(section, "CheckAutoPotionHackTolerance", 200, path);
	this->m_CheckAutoAntidoteHackTolerance = GetPrivateProfileInt(section, "CheckAutoAntidoteHackTolerance", 500, path);

	this->m_CheckAutoComboHack = GetPrivateProfileInt(section, "CheckAutoComboHack", 0, path);

	this->m_CheckAutoComboHackTolerance = GetPrivateProfileInt(section, "CheckAutoComboHackTolerance", 0, path);

	this->SpeedGenerateConfig = GetPrivateProfileInt(section, "AntiSpeedGenerateConfig", 0, path);
	GetPrivateProfileString(section, "AntiSpeedConfigCharacterToTest", "", this->CharacterToTest, sizeof(this->CharacterToTest), path); ;
	this->AntiSpeedEnable = GetPrivateProfileInt(section, "AntiSpeedEnable", 0, path);
	this->GenerateConfigTimer = GetPrivateProfileInt(section, "AntiSpeedConfigTimer", 1000, path);
	this->AgilityAutoIncrement = GetPrivateProfileInt(section, "AntiSpeedAgilityAutoIncrement", 10, path);

	this->FilaHit = GetPrivateProfileInt(section, "HitQueueEnable", 1, path);
	this->FilaHitGenerateConfig = GetPrivateProfileInt(section, "HitQueueGenerateConfig", 0, path);
	this->FilaHitAgiInc = GetPrivateProfileInt(section, "HitQueueAgilityAutoIncrement", 0, path);
	this->FilaHitCleanTime = GetPrivateProfileInt(section, "HitQueueCleanTime", 10, path);
	this->FilaHitLogProcesso = GetPrivateProfileInt(section, "HitQueueProcessLog", 0, path);
	GetPrivateProfileString(section, "HitQueueStalk", "x", this->FilaHitLogStalk, sizeof(this->FilaHitLogStalk), path);

	gSpeedFila.Load();

	this->BackSpringCheck = GetPrivateProfileInt(section, "BackSpringCheck", 0, path);
	this->BackSpringTolerance = GetPrivateProfileInt(section, "BackSpringTolerance", 0, path);
	this->BackSpringBlockTime = GetPrivateProfileInt(section, "BackSpringBlockTime", 0, path);
}

void CServerInfo::ReadSkillInfo(char* section, char* path) // OK
{
	char GameServerInfo[100] = { 0 };

	this->m_DefenseAbs = GetPrivateProfileInt(section, "DefenseAbs", 0, path);
	this->m_LifeAbs = GetPrivateProfileInt(section, "LifeAbs", 0, path);
	this->m_BastionConstA = GetPrivateProfileInt(section, "BastionConstA", 0, path);
	this->m_BastionConstB = GetPrivateProfileInt(section, "BastionConstB", 0, path);
	this->m_BleedingConst = GetPrivateProfileInt(section, "BleedingConst", 0, path);
	this->m_ParalyzingConst = GetPrivateProfileInt(section, "ParalyzingConst", 0, path);
	this->m_PunishConst = GetPrivateProfileInt(section, "PunishConst", 0, path);
	this->m_BlindingConst = GetPrivateProfileInt(section, "BlindingConst", 0, path);

	this->m_ManaShieldConstA = GetPrivateProfileInt(section, "ManaShieldConstA", 0, path);
	this->m_ManaShieldConstB = GetPrivateProfileInt(section, "ManaShieldConstB", 0, path);
	this->m_ManaShieldConstC = GetPrivateProfileInt(section, "ManaShieldConstC", 0, path);

	this->m_ManaShieldRate[0] = GetPrivateProfileInt(section, "ManaShieldRateDW", 0, path);
	this->m_ManaShieldRate[1] = GetPrivateProfileInt(section, "ManaShieldRateDK", 0, path);
	this->m_ManaShieldRate[2] = GetPrivateProfileInt(section, "ManaShieldRateFE", 0, path);
	this->m_ManaShieldRate[3] = GetPrivateProfileInt(section, "ManaShieldRateMG", 0, path);
	this->m_ManaShieldRate[4] = GetPrivateProfileInt(section, "ManaShieldRateDL", 0, path);
	this->m_ManaShieldRate[5] = GetPrivateProfileInt(section, "ManaShieldRateSU", 0, path);
	this->m_ManaShieldRate[6] = GetPrivateProfileInt(section, "ManaShieldRateRF", 0, path);
	this->m_ManaShieldRate[7] = GetPrivateProfileInt(section, "ManaShieldRateGL", 0, path);

	this->m_ManaShieldTimeConstA = GetPrivateProfileInt(section, "ManaShieldTimeConstA", 0, path);
	this->m_ManaShieldTimeConstB = GetPrivateProfileInt(section, "ManaShieldTimeConstB", 0, path);

	this->m_ManaShieldMaxRate = GetPrivateProfileInt(section, "ManaShieldMaxRate", 0, path);

	this->m_DefenseConstA		= GetPrivateProfileInt(section, "DefenseConstA", 0, path);
	this->m_DefenseTimeConstA	= GetPrivateProfileInt(section, "DefenseTimeConstA", 0, path);

	this->m_HealConstA = GetPrivateProfileInt(section, "HealConstA", 0, path);
	this->m_HealConstB = GetPrivateProfileInt(section, "HealConstB", 0, path);

	this->m_GreaterDefenseConstA = GetPrivateProfileInt(section, "GreaterDefenseConstA", 0, path);
	this->m_GreaterDefenseConstB = GetPrivateProfileInt(section, "GreaterDefenseConstB", 0, path);

	this->m_GreaterDefenseRate[0] = GetPrivateProfileInt(section, "GreaterDefenseRateDW", 0, path);
	this->m_GreaterDefenseRate[1] = GetPrivateProfileInt(section, "GreaterDefenseRateDK", 0, path);
	this->m_GreaterDefenseRate[2] = GetPrivateProfileInt(section, "GreaterDefenseRateFE", 0, path);
	this->m_GreaterDefenseRate[3] = GetPrivateProfileInt(section, "GreaterDefenseRateMG", 0, path);
	this->m_GreaterDefenseRate[4] = GetPrivateProfileInt(section, "GreaterDefenseRateDL", 0, path);
	this->m_GreaterDefenseRate[5] = GetPrivateProfileInt(section, "GreaterDefenseRateSU", 0, path);
	this->m_GreaterDefenseRate[6] = GetPrivateProfileInt(section, "GreaterDefenseRateRF", 0, path);
	this->m_GreaterDefenseRate[7] = GetPrivateProfileInt(section, "GreaterDefenseRateGL", 0, path);

	this->m_GreaterDefenseTimeConstA = GetPrivateProfileInt(section, "GreaterDefenseTimeConstA", 0, path);

	this->m_GreaterDefenseMax = GetPrivateProfileInt(section, "GreaterDefenseMax", 90, path);

	this->m_GreaterDamageConstA = GetPrivateProfileInt(section, "GreaterDamageConstA", 0, path);
	this->m_GreaterDamageConstB = GetPrivateProfileInt(section, "GreaterDamageConstB", 0, path);

	this->m_GreaterDamageRate[0] = GetPrivateProfileInt(section, "GreaterDamageRateDW", 0, path);
	this->m_GreaterDamageRate[1] = GetPrivateProfileInt(section, "GreaterDamageRateDK", 0, path);
	this->m_GreaterDamageRate[2] = GetPrivateProfileInt(section, "GreaterDamageRateFE", 0, path);
	this->m_GreaterDamageRate[3] = GetPrivateProfileInt(section, "GreaterDamageRateMG", 0, path);
	this->m_GreaterDamageRate[4] = GetPrivateProfileInt(section, "GreaterDamageRateDL", 0, path);
	this->m_GreaterDamageRate[5] = GetPrivateProfileInt(section, "GreaterDamageRateSU", 0, path);
	this->m_GreaterDamageRate[6] = GetPrivateProfileInt(section, "GreaterDamageRateRF", 0, path);
	this->m_GreaterDamageRate[7] = GetPrivateProfileInt(section, "GreaterDamageRateGL", 0, path);

	this->m_GreaterDamageTimeConstA = GetPrivateProfileInt(section, "GreaterDamageTimeConstA", 0, path);

	this->m_GreaterDamageMax = GetPrivateProfileInt(section, "GreaterDamageMax", 90, path);

	this->m_SummonMonster1 = GetPrivateProfileInt(section, "SummonMonster1", 0, path);
	this->m_SummonMonster2 = GetPrivateProfileInt(section, "SummonMonster2", 0, path);
	this->m_SummonMonster3 = GetPrivateProfileInt(section, "SummonMonster3", 0, path);
	this->m_SummonMonster4 = GetPrivateProfileInt(section, "SummonMonster4", 0, path);
	this->m_SummonMonster5 = GetPrivateProfileInt(section, "SummonMonster5", 0, path);
	this->m_SummonMonster6 = GetPrivateProfileInt(section, "SummonMonster6", 0, path);
	this->m_SummonMonster7 = GetPrivateProfileInt(section, "SummonMonster7", 0, path);
	this->m_SummonMonster8 = GetPrivateProfileInt(section, "SummonMonster8", 0, path);

	this->m_GreaterLifeConstA = GetPrivateProfileInt(section, "GreaterLifeConstA", 0, path);
	this->m_GreaterLifeConstB = GetPrivateProfileInt(section, "GreaterLifeConstB", 0, path);
	this->m_GreaterLifeConstC = GetPrivateProfileInt(section, "GreaterLifeConstC", 0, path);
	this->m_GreaterLifeRate[0] = GetPrivateProfileInt(section, "GreaterLifeRateDW", 0, path);
	this->m_GreaterLifeRate[1] = GetPrivateProfileInt(section, "GreaterLifeRateDK", 0, path);
	this->m_GreaterLifeRate[2] = GetPrivateProfileInt(section, "GreaterLifeRateFE", 0, path);
	this->m_GreaterLifeRate[3] = GetPrivateProfileInt(section, "GreaterLifeRateMG", 0, path);
	this->m_GreaterLifeRate[4] = GetPrivateProfileInt(section, "GreaterLifeRateDL", 0, path);
	this->m_GreaterLifeRate[5] = GetPrivateProfileInt(section, "GreaterLifeRateSU", 0, path);
	this->m_GreaterLifeRate[6] = GetPrivateProfileInt(section, "GreaterLifeRateRF", 0, path);
	this->m_GreaterLifeRate[7] = GetPrivateProfileInt(section, "GreaterLifeRateGL", 0, path);
	this->m_GreaterLifeTimeConstA = GetPrivateProfileInt(section, "GreaterLifeTimeConstA", 0, path);
	this->m_GreaterLifeTimeConstB = GetPrivateProfileInt(section, "GreaterLifeTimeConstB", 0, path);
	this->m_GreaterLifeMaxRate = GetPrivateProfileInt(section, "GreaterLifeMaxRate", 0, path);

	this->m_FireSlashConstA		= GetPrivateProfileInt(section, "FireSlashConstA", 0, path);
	this->m_FireSlashConstB		= GetPrivateProfileInt(section, "FireSlashConstB", 0, path);
	this->m_FireSlashTimeConstA	= GetPrivateProfileInt(section, "FireSlashTimeConstA", 0, path);
	this->m_FireSlashMaxRate	= GetPrivateProfileInt(section, "FireSlashMaxRate", 0, path);

	this->m_GreaterCriticalDamageConstA = GetPrivateProfileInt(section, "GreaterCriticalDamageConstA", 0, path);
	this->m_GreaterCriticalDamageConstB = GetPrivateProfileInt(section, "GreaterCriticalDamageConstB", 0, path);

	this->m_GreaterCriticalDamageTimeConstA = GetPrivateProfileInt(section, "GreaterCriticalDamageTimeConstA", 0, path);
	this->m_GreaterCriticalDamageTimeConstB = GetPrivateProfileInt(section, "GreaterCriticalDamageTimeConstB", 0, path);

	this->m_GreaterCriticalDamageMax = GetPrivateProfileInt(section, "GreaterCriticalDamageMax", 90, path);

	this->m_SternTimeConstA = GetPrivateProfileInt(section, "SternTimeConstA", 0, path);

	this->m_GreaterManaConstA = GetPrivateProfileInt(section, "GreaterManaConstA", 0, path);

	this->m_GreaterManaTimeConstA = GetPrivateProfileInt(section, "GreaterManaTimeConstA", 0, path);

	this->m_InvisibilityTimeConstA = GetPrivateProfileInt(section, "InvisibilityTimeConstA", 0, path);

	this->m_BrandTimeConstA = GetPrivateProfileInt(section, "BrandTimeConstA", 0, path);

	this->m_InfinityArrowTimeConstA = GetPrivateProfileInt(section, "InfinityArrowTimeConstA", 0, path);

	this->m_MagicDamageImmunityTimeConstA = GetPrivateProfileInt(section, "MagicDamageImmunityTimeConstA", 0, path);
	this->m_PhysiDamageImmunityTimeConstA = GetPrivateProfileInt(section, "PhysiDamageImmunityTimeConstA", 0, path);

	this->m_DrainLifeConstA = GetPrivateProfileInt(section, "DrainLifeConstA", 0, path);

	this->m_DrainLifeConstB = GetPrivateProfileInt(section, "DrainLifeConstB", 0, path);

	this->m_ReflectDamageConstA = GetPrivateProfileInt(section, "ReflectDamageConstA", 0, path);
	this->m_ReflectDamageConstB = GetPrivateProfileInt(section, "ReflectDamageConstB", 0, path);

	this->m_ReflectDamageRate[0] = GetPrivateProfileInt(section, "ReflectDamageRateDW", 0, path);
	this->m_ReflectDamageRate[1] = GetPrivateProfileInt(section, "ReflectDamageRateDK", 0, path);
	this->m_ReflectDamageRate[2] = GetPrivateProfileInt(section, "ReflectDamageRateFE", 0, path);
	this->m_ReflectDamageRate[3] = GetPrivateProfileInt(section, "ReflectDamageRateMG", 0, path);
	this->m_ReflectDamageRate[4] = GetPrivateProfileInt(section, "ReflectDamageRateDL", 0, path);
	this->m_ReflectDamageRate[5] = GetPrivateProfileInt(section, "ReflectDamageRateSU", 0, path);
	this->m_ReflectDamageRate[6] = GetPrivateProfileInt(section, "ReflectDamageRateRF", 0, path);
	this->m_ReflectDamageRate[7] = GetPrivateProfileInt(section, "ReflectDamageRateGL", 0, path);

	this->m_ReflectDamageTimeConstA = GetPrivateProfileInt(section, "ReflectDamageTimeConstA", 0, path);
	this->m_ReflectDamageTimeConstB = GetPrivateProfileInt(section, "ReflectDamageTimeConstB", 0, path);

	this->m_ReflectDamageMaxRate = GetPrivateProfileInt(section, "ReflectDamageMaxRate", 0, path);

	this->m_SwordPowerConstA = GetPrivateProfileInt(section, "SwordPowerConstA", 0, path);

	this->m_SwordPowerConstB = GetPrivateProfileInt(section, "SwordPowerConstB", 0, path);

	this->m_SwordPowerTimeConstA = GetPrivateProfileInt(section, "SwordPowerTimeConstA", 0, path);
	this->m_SwordPowerTimeConstB = GetPrivateProfileInt(section, "SwordPowerTimeConstB", 0, path);

	this->m_SwordPowerMaxRate = GetPrivateProfileInt(section, "SwordPowerMaxRate", 0, path);

	this->m_SleepConstA = GetPrivateProfileInt(section, "SleepConstA", 0, path);

	this->m_SleepConstB = GetPrivateProfileInt(section, "SleepConstB", 0, path);

	this->m_SleepTimeConstA = GetPrivateProfileInt(section, "SleepTimeConstA", 0, path);

	this->m_SleepTimeConstB = GetPrivateProfileInt(section, "SleepTimeConstB", 0, path);

	this->m_SleepMaxTime = GetPrivateProfileInt(section, "SleepMaxTime", 0, path);

	this->m_LesserDefenseConstA = GetPrivateProfileInt(section, "LesserDefenseConstA", 0, path);
	this->m_LesserDefenseConstB = GetPrivateProfileInt(section, "LesserDefenseConstB", 0, path);
	this->m_LesserDefenseConstC = GetPrivateProfileInt(section, "LesserDefenseConstC", 0, path);
	this->m_LesserDefenseConstD = GetPrivateProfileInt(section, "LesserDefenseConstD", 0, path);

	this->m_LesserDefenseTimeConstA = GetPrivateProfileInt(section, "LesserDefenseTimeConstA", 0, path);
	this->m_LesserDefenseTimeConstB = GetPrivateProfileInt(section, "LesserDefenseTimeConstB", 0, path);

	this->m_LesserDefenseMaxRate = GetPrivateProfileInt(section, "LesserDefenseMaxRate", 0, path);

	this->m_LesserDamageConstA = GetPrivateProfileInt(section, "LesserDamageConstA", 0, path);
	this->m_LesserDamageConstB = GetPrivateProfileInt(section, "LesserDamageConstB", 0, path);
	this->m_LesserDamageConstC = GetPrivateProfileInt(section, "LesserDamageConstC", 0, path);
	this->m_LesserDamageConstD = GetPrivateProfileInt(section, "LesserDamageConstD", 0, path);

	this->m_LesserDamageTimeConstA = GetPrivateProfileInt(section, "LesserDamageTimeConstA", 0, path);
	this->m_LesserDamageTimeConstB = GetPrivateProfileInt(section, "LesserDamageTimeConstB", 0, path);

	this->m_LesserDamageMaxRate = GetPrivateProfileInt(section, "LesserDamageMaxRate", 0, path);

	this->m_SahamuttConstA = GetPrivateProfileInt(section, "SahamuttConstA", 0, path);

	this->m_NeilConstA = GetPrivateProfileInt(section, "NeilConstA", 0, path);

	this->m_MagicCircleConstA = GetPrivateProfileInt(section, "MagicCircleConstA", 0, path);

	this->m_MagicCircleTimeConstA = GetPrivateProfileInt(section, "MagicCircleTimeConstA", 0, path);

	this->m_ShieldRecoverConstA = GetPrivateProfileInt(section, "ShieldRecoverConstA", 0, path);

	this->m_ShieldRecoverConstB = GetPrivateProfileInt(section, "ShieldRecoverConstB", 0, path);

	this->m_DragonSlayerConstA = GetPrivateProfileInt(section, "DragonSlayerConstA", 0, path);
	this->m_DragonSlayerConstB = GetPrivateProfileInt(section, "DragonSlayerConstB", 0, path);
	this->m_DragonSlayerConstC = GetPrivateProfileInt(section, "DragonSlayerConstC", 0, path);
	this->m_DragonSlayerConstD = GetPrivateProfileInt(section, "DragonSlayerConstD", 0, path);
	this->m_DragonSlayerMaxRate = GetPrivateProfileInt(section, "DragonSlayerMaxRate", 0, path);

	this->m_GreaterIgnoreDefenseRateConstA		= GetPrivateProfileInt(section, "GreaterIgnoreDefenseRateConstA", 0, path);
	this->m_GreaterIgnoreDefenseRateConstB		= GetPrivateProfileInt(section, "GreaterIgnoreDefenseRateConstB", 0, path);
	this->m_GreaterIgnoreDefenseRateTimeConstA	= GetPrivateProfileInt(section, "GreaterIgnoreDefenseRateTimeConstA", 0, path);
	this->m_GreaterIgnoreDefenseRateTimeConstB	= GetPrivateProfileInt(section, "GreaterIgnoreDefenseRateTimeConstB", 0, path);
	this->m_GreaterIgnoreDefenseMax				= GetPrivateProfileInt(section, "GreaterIgnoreDefenseMax", 10, path);

	this->m_FitnessConstA = GetPrivateProfileInt(section, "FitnessConstA", 0, path);
	this->m_FitnessConstB = GetPrivateProfileInt(section, "FitnessConstB", 0, path);
	this->m_FitnessTimeConstA = GetPrivateProfileInt(section, "FitnessTimeConstA", 0, path);
	this->m_FitnessTimeConstB = GetPrivateProfileInt(section, "FitnessTimeConstB", 0, path);
	this->m_FitnessMax = GetPrivateProfileInt(section, "FitnessMax", 99999, path);

	this->m_GreaterDefenseSuccessRateConstA = GetPrivateProfileInt(section, "GreaterDefenseSuccessRateConstA", 0, path);
	this->m_GreaterDefenseSuccessRateConstB = GetPrivateProfileInt(section, "GreaterDefenseSuccessRateConstB", 0, path);
	this->m_GreaterDefenseSuccessRateTimeConstA = GetPrivateProfileInt(section, "GreaterDefenseSuccessRateTimeConstA", 0, path);
	this->m_GreaterDefenseSuccessRateTimeConstB = GetPrivateProfileInt(section, "GreaterDefenseSuccessRateTimeConstB", 0, path);
	this->m_GreaterDefenseSuccessMax = GetPrivateProfileInt(section, "GreaterDefenseSuccessMax", 99, path);

	this->m_PartyHealConstA = GetPrivateProfileInt(section, "PartyHealConstA", 0, path);
	this->m_PartyHealConstB = GetPrivateProfileInt(section, "PartyHealConstB", 0, path);

	this->m_BlessConstA = GetPrivateProfileInt(section, "BlessConstA", 0, path);
	this->m_BlessTimeConstA = GetPrivateProfileInt(section, "BlessTimeConstA", 0, path);

	this->m_BlindConstA = GetPrivateProfileInt(section, "BlindConstA", 0, path);
	this->m_BlindConstB = GetPrivateProfileInt(section, "BlindConstB", 0, path);
	this->m_BlindConstC = GetPrivateProfileInt(section, "BlindConstC", 0, path);
	this->m_BlindTimeConstA = GetPrivateProfileInt(section, "BlindTimeConstA", 0, path);

	this->m_EarthPrisonConstA = GetPrivateProfileInt(section, "EarthPrisonConstA", 0, path);

	this->m_IronDefenseConstA = GetPrivateProfileInt(section, "IronDefenseConstA", 0, path);
	this->m_IronDefenseConstB = GetPrivateProfileInt(section, "IronDefenseConstB", 0, path);
	this->m_IronDefenseTimeConstA = GetPrivateProfileInt(section, "IronDefenseTimeConstA", 0, path);

	this->m_BloodHowlingConstA = GetPrivateProfileInt(section, "BloodHowlingConstA", 0, path);
	this->m_BloodHowlingConstB = GetPrivateProfileInt(section, "BloodHowlingConstB", 0, path);
	this->m_BloodHowlingTimeConstA = GetPrivateProfileInt(section, "BloodHowlingTimeConstA", 0, path);

	this->m_CircleShieldValue = GetPrivateProfileInt(section, "CircleShieldValue", 50, path);
	this->m_CircleShieldCount = GetPrivateProfileInt(section, "CircleShieldCount", 4, path);

	this->m_BackSpringDelay = GetPrivateProfileInt(section, "BackSpringDelay", 0, path);

	this->m_ObsidianConst = GetPrivateProfileInt(section, "ObsidianConst", 0, path);
	this->m_ObsidianMax = GetPrivateProfileInt(section, "ObsidianMax", 90, path);
	this->m_ObsidianTimeConst = GetPrivateProfileInt(section, "ObsidianTimeConst", 0, path);

	this->m_WrathCutDefConst = GetPrivateProfileInt(section, "WrathCutDefConst", 0, path);
	this->m_WrathConst = GetPrivateProfileInt(section, "WrathConst", 0, path);
	this->m_WrathTimeConst = GetPrivateProfileInt(section, "WrathTimeConst", 0, path);

	this->m_ArchangelWillCount = GetPrivateProfileInt(section, "ArchangelWillCount", 0, path);
	this->m_ArchangelWillValue = GetPrivateProfileInt(section, "ArchangelWillValue", 0, path);

	this->DarkPhoenixShotDexDivisor = GetPrivateProfileInt(section, "DarkPhoenixShotDexDivisor", 10, path);
	this->DarkPhoenixShotDexSum = GetPrivateProfileInt(section, "DarkPhoenixShotDexSum", 50, path);
}
